# QuanEstimation

![GitHub release (latest by date)](https://img.shields.io/github/v/release/QuanEstimation/QuanEstimation)
[![License: BSD-3-Clause](https://img.shields.io/badge/License-BSD--3--Clause-blue.svg)](https://opensource.org/licenses/BSD-3-Clause)
[![CI](https://github.com/QuanEstimation/QuanEstimation/actions/workflows/ci.yml/badge.svg)](https://github.com/QuanEstimation/QuanEstimation/actions/workflows/ci.yml)
[![codecov](https://codecov.io/gh/QuanEstimation/QuanEstimation/branch/main/graph/badge.svg)](https://codecov.io/gh/QuanEstimation/QuanEstimation)
[![Downloads](https://static.pepy.tech/badge/quanestimation)](https://pepy.tech/project/quanestimation)
[![Tutorial](https://img.shields.io/badge/Tutorial-Link-brightgreen)](https://github.com/QuanEstimation/tutorial/tree/main)

QuanEstimation is a Python-Julia-based open-source toolkit for quantum parameter 
estimation. It can be used to perform general evaluations of many metrological 
tools and scheme designs in quantum parameter estimation.

## Documentation

[![Docs](https://github.com/QuanEstimation/QuanEstimation/actions/workflows/gh-deploy.yml/badge.svg)](https://github.com/QuanEstimation/QuanEstimation/actions/workflows/gh-deploy.yml)
[![Stable](https://img.shields.io/badge/docs-stable-blue.svg)](https://quanestimation.github.io/QuanEstimation/)

The documentation of QuanEstimation can be found [here](https://quanestimation.github.io/QuanEstimation/). 
This project uses the [Google Python Style Guide for docstrings](https://google.github.io/styleguide/pyguide.html#38-comments-and-docstrings).


## Installation

![PyPI](https://img.shields.io/pypi/v/QuanEstimation)

1. Install QuanEstimation via PyPI:

~~~
pip install quanestimation
~~~

2. Download the package and install it in the terminal:

~~~
git clone https://github.com/QuanEstimation/QuanEstimation.git
cd QuanEstimation
pip install .
~~~

## Code Style

This project follows the [PEP 8](https://peps.python.org/pep-0008/) Python code 
style guide. It is recommended to use tools such as black and flake8 for code 
formatting and linting.

## Citation

* If you use QuanEstimation in your research, please cite:

  [1] M. Zhang, H.-M. Yu, H. Yuan, X. Wang, R. Demkowicz-Dobrzański, and J. Liu,  
  QuanEstimation: An open-source toolkit for quantum parameter estimation,  
  [Phys. Rev. Res. **4**, 043057 (2022)](https://doi.org/10.1103/PhysRevResearch.4.043057)

  [2] H.-M. Yu and J. Liu, QuanEstimation.jl: An open-source Julia framework for quantum parameter estimation,  
  [Fundam. Res. (2025)](https://doi.org/10.1016/j.fmre.2025.02.020)

* Development of the GRAPE algorithm:

  * **auto-GRAPE**:
  
    M. Zhang, H.-M. Yu, H. Yuan, X. Wang, R. Demkowicz-Dobrzański, and J. Liu,  
    QuanEstimation: An open-source toolkit for quantum parameter estimation,  
    [Phys. Rev. Res. **4**, 043057 (2022)](https://doi.org/10.1103/PhysRevResearch.4.043057)

  * **GRAPE for single-parameter estimation**:
  
    J. Liu and H. Yuan, Quantum parameter estimation with optimal control,  
    [Phys. Rev. A **96**, 012117 (2017)](https://doi.org/10.1103/PhysRevA.96.012117)

  * **GRAPE for multiparameter estimation**:
  
    J. Liu and H. Yuan, Control-enhanced multiparameter quantum estimation,  
    [Phys. Rev. A **96**, 042114 (2017)](https://doi.org/10.1103/PhysRevA.96.042114)

using QuanEstimation
using Random
using StatsBase

# free Hamiltonian
function H0_func(x)
    return 0.5*B*omega0*(sx*cos(x)+sz*sin(x))
end
# derivative of the free Hamiltonian on x
function dH_func(x)
    return [0.5*B*omega0*(-sx*sin(x)+sz*cos(x))]
end

B, omega0 = pi/2.0, 1.0
sx = [0. 1.; 1. 0.0im]
sy = [0. -im; im 0.]
sz = [1. 0.0im; 0. -1.]
# initial state
rho0 = 0.5*ones(2, 2)
# measurement 
M1 = 0.5*[1.0+0.0im  1.; 1.  1.]
M2 = 0.5*[1.0+0.0im -1.; -1.  1.]
M = [M1, M2]
# prior distribution
x = range(0., stop=0.5*pi, length=1000) |>Vector
p = (1.0/(x[end]-x[1]))*ones(length(x))
# time length for the evolution
tspan = range(0., stop=1., length=1000)
# dynamics
rho = Vector{Matrix{ComplexF64}}(undef, length(x))
for i = 1:length(x) 
    H0_tp = H0_func(x[i])
    dH_tp = dH_func(x[i])
    rho_tp, drho_tp = QuanEstimation.expm(tspan, rho0, H0_tp, dH_tp)
    rho[i] = rho_tp[end]
end

# Generation of the experimental results
Random.seed!(1234)
y = [0 for i in 1:500]
res_rand = sample(1:length(y), 125, replace=false)
for i in 1:length(res_rand)
    y[res_rand[i]] = 1
end

#===============Maximum a posteriori estimation===============#
pout, xout = QuanEstimation.Bayes([x], p, rho, y; M=M, estimator="MAP",
                                  savefile=false)

#===============Maximum likelihood estimation===============#
Lout, xout = QuanEstimation.MLE([x], rho, y, M=M; savefile=false)

using QuanEstimation
using Random
using StableRNGs
using LinearAlgebra
using SparseArrays

# dimensions of the system
N = 8
# generation of the coherent spin state
j, theta, phi = N÷2, 0.5pi, 0.5pi
Jp = Matrix(spdiagm(1=>[sqrt(j*(j+1)-m*(m+1)) for m in j:-1:-j][2:end]))
Jm = Jp'
psi0 = exp(0.5*theta*exp(im*phi)*Jm - 0.5*theta*exp(-im*phi)*Jp)*
       QuanEstimation.basis(Int(2*j+1), 1)
dim = length(psi0)
# free Hamiltonian
lambda, g, h = 1.0, 0.5, 0.1
Jx = 0.5*(Jp + Jm)
Jy = -0.5im*(Jp - Jm)
Jz = spdiagm(j:-1:-j)
H0 = -lambda*(Jx*Jx + g*Jy*Jy) / N - h*Jz
# derivative of the free Hamiltonian on g
dH = [-lambda*Jy*Jy/N]
# dissipation
decay = [[Jz, 0.1]]
# time length for the evolution
tspan = range(0., 10., length=2500)
# set the optimization type
opt = QuanEstimation.StateOpt(psi=psi0, seed=1234) 

##================choose the state optimization algorithm===============##
# state optimization algorithm: AD
alg = QuanEstimation.AD(Adam=false, max_episode=300, epsilon=0.01, 
                        beta1=0.90, beta2=0.99)

# # state optimization algorithm: PSO
# alg = QuanEstimation.PSO(p_num=10, max_episode=[1000,100], c0=1.0, 
#                          c1=2.0, c2=2.0)

# # state optimization algorithm: DE
# alg = QuanEstimation.DE(p_num=10, max_episode=1000, c=1.0, cr=0.5)

# # state optimization algorithm: NM
# alg = QuanEstimation.NM(p_num=10, max_episode=1000, ar=1.0, 
#                         ae=2.0, ac=0.5, as0=0.5)


##====================choose the objective function==================##
##-------------objective function: QFI---------------------##
# objective function: QFI
obj = QuanEstimation.QFIM_obj()
# input the dynamics data
dynamics = QuanEstimation.Lindblad(opt, tspan, H0, dH, decay=decay, dyn_method=:Expm) 
# run the state optimization problem
QuanEstimation.run(opt, alg, obj, dynamics; savefile=false)

##-------------objective function: CFI---------------------##
# # objective function: CFI
# obj = QuanEstimation.CFIM_obj()
# # input the dynamics data
# dynamics = QuanEstimation.Lindblad(opt, tspan, H0, dH, decay=decay, dyn_method=:Expm) 
# # run the state optimization problem
# QuanEstimation.run(opt, alg, obj, dynamics; savefile=false)

using QuanEstimation
using LinearAlgebra

# initial state
psi0 = [1., 0., 0., 1.]/sqrt(2)
rho0 = psi0*psi0'
# free Hamiltonian
omega1, omega2, g = 1.0, 1.0, 0.1
sx = [0. 1.; 1. 0.0im]
sy = [0. -im; im 0.]
sz = [1. 0.0im; 0. -1.]
H0 = omega1*kron(sz, I(2)) + omega2*kron(I(2), sz) + g*kron(sx, sx)
# derivatives of the free Hamiltonian with respect to omega2 and g
dH = [kron(I(2), sz), kron(sx, sx)]
# dissipation
decay = [[kron(sz, I(2)), 0.05], [kron(I(2), sz), 0.05]]
# measurement
m1 = [1., 0., 0., 0.]
M1 = 0.85*m1*m1'
M2 = 0.1*ones(4, 4)
M = [M1, M2, I(4)-M1-M2]
# weight matrix
W = one(zeros(2, 2))
# time length for the evolution
tspan = range(0., 5., length=200)
# dynamics
rho, drho = QuanEstimation.expm(tspan, rho0, H0, dH, decay)
# calculation of the CFIM, QFIM and HCRB
f_HCRB, f_NHB = [], []
for ti in 2:length(tspan)
    # HCRB
    f_tp1 = QuanEstimation.HCRB(rho[ti], drho[ti], W)
    append!(f_HCRB, f_tp1)
    # NHB
    f_tp2 = QuanEstimation.NHB(rho[ti], drho[ti], W)
    append!(f_NHB, f_tp2)
end

using QuanEstimation
using Random
using LinearAlgebra

# initial state
rho0 = zeros(ComplexF64, 6, 6)
rho0[1:4:5, 1:4:5] .= 0.5
# Hamiltonian
sx = [0. 1.; 1. 0.]
sy = [0. -im; im 0.]
sz = [1. 0.; 0. -1.]
s1 = [0. 1. 0.; 1. 0. 1.; 0. 1. 0.]/sqrt(2)
s2 = [0. -im 0.; im 0. -im; 0. im 0.]/sqrt(2)
s3 = [1. 0. 0.; 0. 0. 0.; 0. 0. -1.]
Is = I1, I2, I3 = [kron(I(3), sx), kron(I(3), sy), kron(I(3), sz)]
S = S1, S2, S3 = [kron(s1, I(2)), kron(s2, I(2)), kron(s3, I(2))]
B = B1, B2, B3 = [5.0e-4, 5.0e-4, 5.0e-4]
# All numbers are divided by 100 in this example 
# for better calculation accurancy
cons = 100
D = (2pi*2.87*1000)/cons
gS = (2pi*28.03*1000)/cons
gI = (2pi*4.32)/cons
A1 = (2pi*3.65)/cons
A2 = (2pi*3.03)/cons
H0 = sum([D*kron(s3^2, I(2)), sum(gS*B.*S), sum(gI*B.*Is),
          A1*(kron(s1, sx) + kron(s2, sy)), A2*kron(s3, sz)])
# derivatives of the free Hamiltonian on B1, B2 and B3
dH = gS*S+gI*Is
# control Hamiltonians 
Hc = [S1, S2, S3]
# dissipation
decay = [[S3, 2pi/cons]]
# generation of a set of POVM basis
dim = size(rho0, 1)
POVM_basis = [QuanEstimation.basis(dim, i)*QuanEstimation.basis(dim, i)' 
              for i in 1:dim]
# time length for the evolution
tspan = range(0., 2., length=4000)
# find the optimal rotated measurement of an input measurement
opt = QuanEstimation.MeasurementOpt(mtype=:Rotation, POVM_basis=POVM_basis, seed=1234)

##==========choose measurement optimization algorithm==========##
##-------------algorithm: DE---------------------##
alg = QuanEstimation.DE(p_num=10, ini_population=missing, 
                        max_episode=1000, c=1.0, cr=0.5)
# input the dynamics data
dynamics = QuanEstimation.Lindblad(opt, tspan ,rho0, H0, dH, decay=decay, dyn_method=:Expm)
# objective function: tr(WI^{-1})
obj = QuanEstimation.CFIM_obj()
# run the measurement optimization problem
QuanEstimation.run(opt, alg, obj, dynamics; savefile=false)

##-------------algorithm: PSO---------------------##
# alg = QuanEstimation.PSO(p_num=10, ini_particle=missing, 
#                          max_episode=[1000,100], c0=1.0, c1=2.0, 
#                          c2=2.0)
# # input the dynamics data
# dynamics = QuanEstimation.Lindblad(opt, tspan ,rho0, H0, dH, decay=decay, dyn_method=:Expm)
# # objective function: tr(WI^{-1})
# obj = QuanEstimation.CFIM_obj()
# # run the measurement optimization problem
# QuanEstimation.run(opt, alg, obj, dynamics; savefile=false)

##-------------algorithm: AD---------------------##
# alg = QuanEstimation.AD(Adam=false, max_episode=300, epsilon=0.01, 
#                         beta1=0.90, beta2=0.99)
# # input the dynamics data
# dynamics = QuanEstimation.Lindblad(opt, tspan ,rho0, H0, dH, decay=decay, dyn_method=:Expm)
# # objective function: tr(WI^{-1})
# obj = QuanEstimation.CFIM_obj()
# # run the measurement optimization problem
# QuanEstimation.run(opt, alg, obj, dynamics; savefile=false)

using QuanEstimation
using Trapz

# free Hamiltonian
function H0_func(x)
    return 0.5*B*omega0*(sx*cos(x)+sz*sin(x))
end
# derivative of the free Hamiltonian on x
function dH_func(x)
    return [0.5*B*omega0*(-sx*sin(x)+sz*cos(x))]
end
# prior distribution
function p_func(x, mu, eta)
    return exp(-(x-mu)^2/(2*eta^2))/(eta*sqrt(2*pi))
end
function dp_func(x, mu, eta)
    return -(x-mu)*exp(-(x-mu)^2/(2*eta^2))/(eta^3*sqrt(2*pi))
end

B, omega0 = 0.5*pi, 1.0
sx = [0. 1.; 1. 0.0im]
sy = [0. -im; im 0.]
sz = [1. 0.0im; 0. -1.]
# initial state
rho0 = 0.5*ones(2, 2)
# prior distribution
x = range(-0.5*pi, stop=0.5*pi, length=100) |>Vector
mu, eta = 0.0, 0.2
p_tp = [p_func(x[i], mu, eta) for i in 1:length(x)]
dp_tp = [dp_func(x[i], mu, eta) for i in 1:length(x)]
# normalization of the distribution
c = trapz(x, p_tp)
p = p_tp/c
dp = dp_tp/c
# time length for the evolution
tspan = range(0., stop=1., length=1000)
# dynamics
rho = Vector{Matrix{ComplexF64}}(undef, length(x))
drho = Vector{Vector{Matrix{ComplexF64}}}(undef, length(x))
for i = 1:length(x) 
    H0_tp = H0_func(x[i])
    dH_tp = dH_func(x[i])
    rho_tp, drho_tp = QuanEstimation.expm(tspan, rho0, H0_tp, dH_tp)
    rho[i], drho[i] = rho_tp[end], drho_tp[end]
end

# Classical Bayesian bounds
f_BCRB1 = QuanEstimation.BCRB([x], p, [], rho, drho, btype=1)
f_BCRB2 = QuanEstimation.BCRB([x], p, [], rho, drho, btype=2)
f_BCRB3 = QuanEstimation.BCRB([x], p, dp, rho, drho, btype=3)
f_VTB = QuanEstimation.VTB([x], p, dp, rho, drho)

# Quantum Bayesian bounds
f_BQCRB1 = QuanEstimation.BQCRB([x], p, [], rho, drho, btype=1)
f_BQCRB2 = QuanEstimation.BQCRB([x], p, [], rho, drho, btype=2)
f_BQCRB3 = QuanEstimation.BQCRB([x], p, dp, rho, drho, btype=3)
f_QVTB = QuanEstimation.QVTB([x], p, dp, rho, drho)
f_QZZB = QuanEstimation.QZZB([x], p, rho)

using QuanEstimation
using Random
using StatsBase

# free Hamiltonian
function H0_func(x)
    return 0.5*B*omega0*(sx*cos(x[1])+sz*sin(x[1]))
end
# derivative of free Hamiltonian in x
function dH_func(x)
    return [0.5*B*omega0*(-sx*sin(x[1])+sz*cos(x[1]))]
end

B, omega0 = pi/2.0, 1.0
sx = [0. 1.; 1. 0.0im]
sy = [0. -im; im 0.]
sz = [1. 0.0im; 0. -1.]
# initial state
rho0 = 0.5*ones(2, 2)
# measurement 
M1 = 0.5*[1.0+0.0im  1.; 1.  1.]
M2 = 0.5*[1.0+0.0im -1.; -1.  1.]
M = [M1, M2]
# time length for the evolution
tspan = range(0., stop=1., length=1000) |>Vector
# prior distribution
x = range(-0.25*pi+0.1, stop=3.0*pi/4.0-0.1, length=100) |>Vector
p = (1.0/(x[end]-x[1]))*ones(length(x))
# dynamics
rho = Vector{Matrix{ComplexF64}}(undef, length(x))
for i = 1:length(x) 
    H0_tp = H0_func(x[i])
    dH_tp = dH_func(x[i])
    rho_tp, drho_tp = QuanEstimation.expm(tspan, rho0, H0_tp, dH_tp)
    rho[i] = rho_tp[end]
end
# Bayesian estimation
Random.seed!(1234)
y = [0 for i in 1:500]
res_rand = sample(1:length(y), 125, replace=false)
for i in 1:length(res_rand)
    y[res_rand[i]] = 1
end
pout, xout = QuanEstimation.Bayes([x], p, rho, y, M=M, savefile=false)
# generation of H and dH
H, dH = QuanEstimation.BayesInput([x], H0_func, dH_func; 
                                  channel="dynamics")
# adaptive measurement
QuanEstimation.Adapt([x], pout, rho0, tspan, H, dH; M=M, 
                        max_episode=100, dyn_method=:Expm, method="FOP")

using QuanEstimation
using Random
using StableRNGs
using LinearAlgebra

# initial state
rho0 = 0.5*ones(2, 2)
# free Hamiltonian
omega = 1.0
sx = [0. 1.; 1. 0.0im]
sy = [0. -im; im 0.]
sz = [1. 0.0im; 0. -1.]
H0 = 0.5*omega*sz
# derivative of the free Hamiltonian on omega
dH = [0.5*sz]
# dissipation
sp = [0. 1.; 0. 0.0im]
sm = [0. 0.; 1. 0.0im]
decay = [[sp, 0.], [sm, 0.1]]
# generation of a set of POVM basis
dim = size(rho0, 1)
POVM_basis = QuanEstimation.SIC(dim)
# time length for the evolution
tspan = range(0., 10., length=2500)
# find the optimal linear combination of an input measurement
opt = QuanEstimation.MeasurementOpt(mtype=:LC, POVM_basis=POVM_basis, M_num=2, seed=1234)

##==========choose measurement optimization algorithm==========##
##-------------algorithm: DE---------------------##
alg = QuanEstimation.DE(p_num=10, ini_population=missing, 
                        max_episode=1000, c=1.0, cr=0.5)
# input the dynamics data
dynamics = QuanEstimation.Lindblad(opt, tspan ,rho0, H0, dH, decay=decay, dyn_method=:Expm)
# objective function: tr(WI^{-1})
obj = QuanEstimation.CFIM_obj()
# run the measurement optimization problem
QuanEstimation.run(opt, alg, obj, dynamics; savefile=false)

##-------------algorithm: PSO---------------------##
# alg = QuanEstimation.PSO(p_num=10, ini_particle=missing, 
#                          max_episode=[1000,100], c0=1.0, c1=2.0, 
#                          c2=2.0)
# # input the dynamics data
# dynamics = QuanEstimation.Lindblad(opt, tspan ,rho0, H0, dH, decay=decay, dyn_method=:Expm)
# # objective function: tr(WI^{-1})
# obj = QuanEstimation.CFIM_obj()
# # run the measurement optimization problem
# QuanEstimation.run(opt, alg, obj, dynamics; savefile=false)

##-------------algorithm: AD---------------------##
# alg = QuanEstimation.AD(Adam=false, max_episode=300, epsilon=0.01, 
#                         beta1=0.90, beta2=0.99)
# # input the dynamics data
# dynamics = QuanEstimation.Lindblad(opt, tspan ,rho0, H0, dH, decay=decay, dyn_method=:Expm)
# # objective function: tr(WI^{-1})
# obj = QuanEstimation.CFIM_obj()
# # run the measurement optimization problem
# QuanEstimation.run(opt, alg, obj, dynamics; savefile=false)

import Pkg

"""
    is_loaded(mod::AbstractString)

Return `true` if `mod` is loaded.
"""
function is_loaded(mod::AbstractString)
    mods = Base.loaded_modules
    return any(m -> m.name == mod, keys(mods))
end

function module_version(mod::Module)
    toml = Base.parsed_toml(joinpath(dirname(dirname(Pkg.pathof(mod))), "Project.toml"))
    return toml["version"]
end

function pycall_version()
    if isdefined(@__MODULE__, :PyCall)
        return module_version(PyCall)
    end
    return nothing
end

function pythoncall_version()
    if isdefined(@__MODULE__, :PythonCall)
        return module_version(PythonCall)
    end
    return nothing
end


function parse_project()
    return parse_project(Pkg.project().path)
end

function parse_project(path::AbstractString)
    fullpath = nothing
    if ! endswith(path, "Project.toml")
        for f in ("Project.toml", "JuliaProject.toml")
            _fullpath = joinpath(path, f)
            if isfile(_fullpath)
                fullpath = _fullpath
                break
            end
            if isnothing(fullpath)
                error("Can't find project file in $path")
            end
        end
    else
        fullpath = path
    end
    return Base.parsed_toml(fullpath)
end


function  get_pycall_libpython()
    pycall_jl = Base.find_package("PyCall")
    if isnothing(pycall_jl)
        return (nothing, "not installed")
    end
    deps_jl = joinpath(dirname(dirname(Base.find_package("PyCall"))), "deps", "deps.jl")
    if ! isfile(deps_jl)
        return (nothing, "not built")
    end
    include(deps_jl) # not a great way to do this
    return (libpython, "ok")
end

using QuanEstimation
using SparseArrays

# the number of photons
N = 8
# probe state
psi = sum([sin(k*pi/(N+2))*kron(QuanEstimation.basis(N+1,k), 
      QuanEstimation.basis(N+1, N-k+2)) for k in 1:(N+1)]) |> sparse
psi = psi*sqrt(2/(2+N))
rho0 = psi*psi'
# prior distribution
x = range(-pi, pi, length=100)
p = (1.0/(x[end]-x[1]))*ones(length(x))
apt = QuanEstimation.Adapt_MZI(x, p, rho0)

#================online strategy=========================#
QuanEstimation.online(apt, target=:sharpness, output="phi")

#================offline strategy=========================#
# # algorithm: DE
# alg = QuanEstimation.DE(p_num=10, ini_population=missing, 
#                         max_episode=1000, c=1.0, cr=0.5)
# QuanEstimation.offline(apt, alg, target=:sharpness, seed=1234)

# # algorithm: PSO
# alg = QuanEstimation.PSO(p_num=10, ini_particle=missing,  
#                          max_episode=[1000,100], c0=1.0, 
#                          c1=2.0, c2=2.0)
# QuanEstimation.offline(apt, alg, target=:sharpness, seed=1234)

using QuanEstimation
using Random
using LinearAlgebra

# initial state
rho0 = zeros(ComplexF64, 6, 6)
rho0[1:4:5, 1:4:5] .= 0.5
dim = size(rho0, 1)
# Hamiltonian
sx = [0. 1.; 1. 0.]
sy = [0. -im; im 0.]
sz = [1. 0.; 0. -1.]
s1 = [0. 1. 0.; 1. 0. 1.; 0. 1. 0.]/sqrt(2)
s2 = [0. -im 0.; im 0. -im; 0. im 0.]/sqrt(2)
s3 = [1. 0. 0.; 0. 0. 0.; 0. 0. -1.]
Is = I1, I2, I3 = [kron(I(3), sx), kron(I(3), sy), kron(I(3), sz)]
S = S1, S2, S3 = [kron(s1, I(2)), kron(s2, I(2)), kron(s3, I(2))]
B = B1, B2, B3 = [5.0e-4, 5.0e-4, 5.0e-4]
# All numbers are divided by 100 in this example 
# for better calculation accurancy
cons = 100
D = (2pi*2.87*1000)/cons
gS = (2pi*28.03*1000)/cons
gI = (2pi*4.32)/cons
A1 = (2pi*3.65)/cons
A2 = (2pi*3.03)/cons
H0 = sum([D*kron(s3^2, I(2)), sum(gS*B.*S), sum(gI*B.*Is),
          A1*(kron(s1, sx) + kron(s2, sy)), A2*kron(s3, sz)])
# derivatives of the free Hamiltonian on B1, B2 and B3
dH = gS*S+gI*Is
# control Hamiltonians 
Hc = [S1, S2, S3]
# dissipation
decay = [[S3, 2*pi/cons]]
# measurement
M = [QuanEstimation.basis(dim, i)*QuanEstimation.basis(dim, i)' 
     for i in 1:dim]
# time length for the evolution 
tspan = range(0., 2., length=4000)
# guessed control coefficients
cnum = 10
rng = MersenneTwister(1234)
ini_1 = [zeros(cnum) for _ in 1:length(Hc)]
ini_2 = 0.2.*[ones(cnum) for _ in 1:length(Hc)]
ini_3 = -0.2.*[ones(cnum) for _ in 1:length(Hc)]
ini_4 = [[range(-0.2, 0.2, length=cnum)...] for _ in 1:length(Hc)]
ini_5 = [[range(-0.2, 0., length=cnum)...] for _ in 1:length(Hc)]
ini_6 = [[range(0., 0.2, length=cnum)...] for _ in 1:length(Hc)]
ini_7 = [-0.2*ones(cnum)+0.01*rand(rng,cnum) for _ in 1:length(Hc)]
ini_8 = [-0.2*ones(cnum)+0.01*rand(rng,cnum) for _ in 1:length(Hc)]
ini_9 = [-0.2*ones(cnum)+0.05*rand(rng,cnum) for _ in 1:length(Hc)]
ini_10 = [-0.2*ones(cnum)+0.05*rand(rng,cnum) for _ in 1:length(Hc)]
ctrl0 = [Symbol("ini_", i)|>eval for i in 1:10]
# choose the optimization type
opt = QuanEstimation.ControlOpt(ctrl=ini_1, ctrl_bound=[-0.2, 0.2], seed=1234)

##==========choose measurement optimization algorithm==========##
##-------------algorithm: auto-GRAPE---------------------##
alg = QuanEstimation.autoGRAPE(Adam=true, max_episode=300, epsilon=0.01, 
                               beta1=0.90, beta2=0.99)

##-------------algorithm: PSO---------------------##
# alg = QuanEstimation.PSO(p_num=10, ini_particle=(ctrl0,), 
#                          max_episode=[1000,100], c0=1.0, 
#                          c1=2.0, c2=2.0)

##-------------algorithm: DE---------------------##
# alg = QuanEstimation.DE(p_num=10, ini_population=(ctrl0,), 
#                         max_episode=1000, c=1.0, cr=0.5)

##===================choose objective function===================##
##-------------objective function: QFI---------------------##
# # objective function: tr(WF^{-1})
# obj = QuanEstimation.QFIM_obj()
# # input the dynamics data
# dynamics = QuanEstimation.Lindblad(opt, tspan, rho0, H0, dH, Hc, decay, dyn_method=:Expm)
# # run the control optimization problem
# QuanEstimation.run(opt, alg, obj, dynamics; savefile=false)

##-------------objective function: CFI---------------------##
# objective function: tr(WI^{-1})
obj = QuanEstimation.CFIM_obj(M=M)
# input the dynamics data
dynamics = QuanEstimation.Lindblad(opt, tspan, rho0, H0, dH, Hc, decay, dyn_method=:Expm)  
# run the control optimization problem
QuanEstimation.run(opt, alg, obj, dynamics; savefile=false)

##-------------objective function: HCRB---------------------##
# # objective function: HCRB
# obj = QuanEstimation.HCRB_obj()
# # input the dynamics data
# dynamics = QuanEstimation.Lindblad(opt, tspan, rho0, H0, dH, Hc, decay, dyn_method=:Expm)  
# # run the control optimization problem
# QuanEstimation.run(opt, alg, obj, dynamics; savefile=false)

using QuanEstimation

# initial state
rho0 = 0.5*ones(2, 2)
# free Hamiltonian
omega = 1.0
sx = [0. 1.; 1. 0.0im]
sy = [0. -im; im 0.]
sz = [1. 0.0im; 0. -1.]
H0 = 0.5*omega*sz
# derivative of the free Hamiltonian on omega
dH = [0.5*sz]
# control Hamiltonians 
Hc = [sx, sy, sz]
# dissipation
sp = [0. 1.; 0. 0.0im]
sm = [0. 0.; 1. 0.0im]
decay = [[sp, 0.0], [sm, 0.1]]
# measurement
M1 = 0.5*[1.0+0.0im  1.; 1.  1.]
M2 = 0.5*[1.0+0.0im -1.; -1.  1.]
M = [M1, M2]
# time length for the evolution
tspan = range(0., 10., length=2500)
# choose the optimization type
opt = QuanEstimation.SCopt(ctrl_bound=[-2.0,2.0], seed=1234)

##==========choose comprehensive optimization algorithm==========##
##-------------algorithm: DE---------------------##
alg = QuanEstimation.DE(p_num=10, max_episode=1000, c=1.0, cr=0.5)
# input the dynamics data
dynamics = QuanEstimation.Lindblad(opt, tspan, H0, dH, Hc, decay=decay, dyn_method=:Expm) 

##-------------algorithm: PSO---------------------##
# alg = QuanEstimation.PSO(p_num=10, max_episode=[1000,100], c0=1.0, 
#                          c1=2.0, c2=2.0)
# # input the dynamics data
# dynamics = QuanEstimation.Lindblad(opt, tspan, H0, dH, Hc, decay=decay, dyn_method=:Expm) 

##-------------algorithm: AD---------------------##
# alg = QuanEstimation.AD(Adam=true, max_episode=300, epsilon=0.01, 
#                         beta1=0.90, beta2=0.99)
# # input the dynamics data
# dynamics = QuanEstimation.Lindblad(opt, tspan, H0, dH, Hc, decay=decay, dyn_method=:Expm) 

##===================choose objective function===================##
##-------------objective function: QFI---------------------##
obj = QuanEstimation.QFIM_obj()
# run the comprehensive optimization problem
QuanEstimation.run(opt, alg, obj, dynamics; savefile=false)

##-------------objective function: CFI---------------------##
# obj = QuanEstimation.CFIM_obj(M=M)
# # run the comprehensive optimization problem
# QuanEstimation.run(opt, alg, obj, dynamics; savefile=false)

using QuanEstimation

# initial state
rho0 = 0.5*ones(2, 2)
# free Hamiltonian
omega = 1.0
sx = [0. 1.; 1. 0.0im]
sy = [0. -im; im 0.]
sz = [1. 0.0im; 0. -1.]
H0 = 0.5*omega*sz
# derivative of the free Hamiltonian on omega
dH = [0.5*sz]
# dissipation
sp = [0. 1.; 0. 0.0im]
sm = [0. 0.; 1. 0.0im]
decay = [[sp, 0.0], [sm, 0.1]]
# measurement
M1 = 0.5*[1.0+0.0im  1.; 1.  1.]
M2 = 0.5*[1.0+0.0im -1.; -1.  1.]
M = [M1, M2]
# time length for the evolution
tspan = range(0., 50., length=2000)
# dynamics
rho, drho = QuanEstimation.expm(tspan, rho0, H0, dH, decay)
# calculation of the CFI and QFI
Im, F = Float64[], Float64[]
for ti in 2:length(tspan)
    # CFI
    I_tp = QuanEstimation.CFIM(rho[ti], drho[ti], M)
    append!(Im, I_tp)
    # QFI
    F_tp = QuanEstimation.QFIM(rho[ti], drho[ti])
    append!(F, F_tp)
end

using QuanEstimation
using Random

# initial state
rho0 = 0.5*ones(2, 2)
# free Hamiltonian
omega = 1.0
sx = [0. 1.; 1. 0.0im]
sy = [0. -im; im 0.]
sz = [1. 0.0im; 0. -1.]
H0 = 0.5*omega*sz
# derivative of the free Hamiltonian on omega
dH = [0.5*sz]
# control Hamiltonians 
Hc = [sx, sy, sz]
# dissipation
sp = [0. 1.; 0. 0.0im]
sm = [0. 0.; 1. 0.0im]
decay = [[sp, 0.], [sm, 0.1]]
# measurement
M1 = 0.5*[1.0+0.0im  1.; 1.  1.]
M2 = 0.5*[1.0+0.0im -1.; -1.  1.]
M = [M1, M2]
# time length for the evolution
tspan = range(0., 10., length=2500)
# guessed control coefficients
cnum = length(tspan)-1
ctrl = [zeros(cnum) for _ in 1:length(Hc)]
ctrl_bound = [-2., 2.]
# choose the optimization type
opt = QuanEstimation.ControlOpt(ctrl=ctrl, ctrl_bound=ctrl_bound, seed=1234)

##==========choose measurement optimization algorithm==========##
##-------------algorithm: auto-GRAPE---------------------##
alg = QuanEstimation.autoGRAPE(Adam=true, max_episode=300, epsilon=0.01, 
                               beta1=0.90, beta2=0.99)

##-------------algorithm: GRAPE---------------------##
# alg = QuanEstimation.GRAPE(Adam=true, max_episode=300, epsilon=0.01, 
#                            beta1=0.90, beta2=0.99)

##-------------algorithm: PSO---------------------##
# alg = QuanEstimation.PSO(p_num=10, ini_particle=([ctrl],), 
#                          max_episode=[1000,100], c0=1.0, 
#                          c1=2.0, c2=2.0)

##-------------algorithm: DE---------------------##
# alg = QuanEstimation.DE(p_num=10, ini_population=([ctrl],), 
#                         max_episode=1000, c=1.0, cr=0.5)


##===================choose objective function===================##
##-------------objective function: QFI---------------------##
# objective function: QFI
obj = QuanEstimation.QFIM_obj()
# input the dynamics data
dynamics = QuanEstimation.Lindblad(opt, tspan, rho0, H0, dH, Hc, decay, dyn_method=:Expm)  
# run the control optimization problem
QuanEstimation.run(opt, alg, obj, dynamics; savefile=false)

##-------------objective function: CFI---------------------##
# # objective function: CFI
# obj = QuanEstimation.CFIM_obj(M=M)
# # input the dynamics data
# dynamics = QuanEstimation.Lindblad(opt, tspan, rho0, H0, dH, Hc, decay, dyn_method=:Expm)  
# # run the control optimization problem
# QuanEstimation.run(opt, alg, obj, dynamics; savefile=false)

# **State optimization**
For state optimization in QuanEstimation, the probe state is expanded as 
$|\psi\rangle=\sum_i c_i|i\rangle$ in a specific basis $\{|i\rangle\}$. Thus, search of the 
optimal probe states is equal to search of the normalized complex coefficients $\{c_i\}$. In 
QuanEstimation, the state optimization algorithms are the automatic differentiation (AD) 
[[1]](#Baydin2018), reverse iterative (RI)[[2]](#Rafal2011) algorithm, particle swarm optimization (PSO) 
[[3]](#Kennedy1995), differential evolution (DE) [[4]](#Storn1997), and Nelder-Mead (NM) 
[[5]](#Nelder1965). 
Call the following codes to perform state optimizaiton
=== "Python"
    ``` py
    state = StateOpt(savefile=False, method="AD", **kwargs)
    state.dynamics(tspan, H0, dH, Hc=[], ctrl=[], decay=[], 
                   dyn_method="expm")
    ```
    === "QFIM"
        ``` py
        state.QFIM(W=[], LDtype="SLD")
        ```
    === "CFIM"
        ``` py
        state.CFIM(M=[], W=[])
        ```
    === "HCRB"
        ``` py
        state.HCRB(W=[])
        ```
    The variable `savefile` means whether to save all the states. If set `False` (default) the 
    states in the final episode and the values of the objective function in all episodes will 
    be saved. If set `True` then the states and the values of the objective function obtained 
    in all episodes will be saved during the training. `method` represents the algorithm used 
    to optimize the states, options are: "AD", "PSO", "DE", and "NM". `**kwargs` contains 
    the keywords and default values corresponding to the optimization algorithm which will be 
    introduced in detail below.

    `tspan` is the time length for the evolution, `H0` and `dH` are the free Hamiltonian and its
    derivatives with respect to the unknown parameters to be estimated. `H0` accepts both matrix 
    (time-independent evolution) and list of matrices (time-dependent evolution) with the length equal to 
    `tspan`. `dH` should be input as $[\partial_a{H_0}, \partial_b{H_0}, \cdots]$. `Hc` 
    and `ctrl` are two lists represent the control Hamiltonians and the corresponding control 
    coefficients. `decay` contains decay operators $(\Gamma_1, \Gamma_2, \cdots)$ and the 
    corresponding decay rates $(\gamma_1, \gamma_2, \cdots)$ with the input rule 
    decay=[[$\Gamma_1$, $\gamma_1$], [$\Gamma_2$, $\gamma_2$],...]. The default values for 
    `decay`, `Hc` and `ctrl` are empty which means the dynamics is unitary and only governed by 
    the free Hamiltonian. `dyn_method="expm"` represents the method for solving the dynamics is 
    matrix exponential, it can also be set as `dyn_method="ode"` which means the dynamics 
    (differential equation) is directly solved with the ODE solvers.

    The objective functions for state optimization can be chosen as QFI $\left[\mathrm{Tr}
    (W\mathcal{F}^{-1})\right]$, CFI $\left[\mathrm{Tr}(W\mathcal{I}^{-1})\right]$, and HCRB, 
    the corresponding codes for them are `state.QFIM()` (default), `state.CFIM()`, and 
    `state.HCRB()`. Here $\mathcal{F}$ and $\mathcal{I}$ are the QFIM and CFIM, $W$ corresponds 
    to `W` represents the weight matrix, the default value for `W` is the identity matrix. If 
    the users call `state.HCRB()` for single parameter scenario, the program will exit and print 
    `"Program terminated. In the single-parameter scenario, the HCRB is equivalent to the QFI. Please 
    choose 'QFIM' as the objective function"`. `LDtype` in `state.QFIM()` represents the types 
    of the QFIM, it can be set as `LDtype="SLD"` (default), `LDtype="RLD"`, and `LDtype="LLD"`. 
    `M` represents a set of positive operator-valued measure (POVM) with default value `[]`. 
    In the package, a set of rank-one symmetric informationally complete POVM (SIC-POVM) is 
    used when `M=[]`.
=== "Julia"
    ``` jl
    opt = StateOpt(psi=psi, seed=1234)
    alg = AD(kwargs...)
    dynamics = Lindblad(opt, tspan, H0, dH; Hc=missing, 
                        ctrl=missing, decay=missing, dyn_method=:Expm)
    ```
    === "QFIM"
        ``` jl
        obj = QFIM_obj(W=missing, LDtype=:SLD)
        ```
    === "CFIM"
        ``` jl
        obj = CFIM_obj(M=missing, W=missing)
        ```
    === "HCRB"
        ``` jl
        obj = HCRB_obj(W=missing)
        ```
    ``` jl
    run(opt, alg, obj, dynamics; savefile=false)
    ```
    The initial state (optimization variable) can be input via `psi=psi` in `StateOpt()` for 
    constructing a state optimization problem. `psi` is an array representing the state. 
    `Lindblad` accepts the dynamics parameters. `tspan` is the time length for the evolution, 
    `H0` and `dH` are the free Hamiltonian and its derivatives with respect to the unknown 
    parameters to be estimated. `H0` accepts both matrix (time-independent evolution) and list of matrices
    (time-dependent evolution) with the length equal to `tspan`. `dH` should be input as 
    $[\partial_a{H_0}, \partial_b{H_0}, \cdots]$. `Hc` and `ctrl` are two lists represent the 
    control Hamiltonians and the corresponding control coefficients. `decay` contains decay 
    operators $(\Gamma_1, \Gamma_2, \cdots)$ and the corresponding decay rates 
    $(\gamma_1, \gamma_2, \cdots)$ with the input rule 
    decay=[[$\Gamma_1$, $\gamma_1$], [$\Gamma_2$, $\gamma_2$],...]. The default values for 
    `decay`, `Hc`, and `ctrl` are `missing` which means the dynamics is unitary and only governed 
    by the free Hamiltonian. `seed` is the random seed which can ensure the reproducibility of 
    results. `dyn_method=:Expm` represents the method for solving the dynamics is 
    matrix exponential, it can also be set as `dyn_method=:Ode` which means the dynamics 
    (differential equation) is directly solved with the ODE solvers.

    The objective functions for state optimization can be set as QFI ($\mathrm{Tr}(W\mathcal{F}^
    {-1})$), CFI ($\mathrm{Tr}(W\mathcal{I}^{-1})$), and HCRB, the corresponding codes for them are
    `QFIM_obj()` (default), `CFIM_obj()`, and `HCRB_obj()`. Here $\mathcal{F}$ and 
    $\mathcal{I}$ are the QFIM and CFIM, $W$ corresponds to `W` is the weight matrix which 
    defaults to the identity matrix. If the users call `HCRB_obj()` for single parameter 
    scenario, the program will exit and print `"Program terminated. In the single-parameter scenario, 
    the HCRB is equivalent to the QFI. Please choose 'QFIM_obj()' as the objective function"`.
    `LDtype` in `QFIM_obj()` represents the types of the QFIM, it can be set as `LDtype=:SLD` 
    (default), `LDtype=:RLD` and `LDtype=:LLD`. `M` represents a set of positive operator-valued 
    measure (POVM) with default value `missing`. In the package, a set of rank-one symmetric 
    informationally complete POVM (SIC-POVM) is used when `M=missing`.

    `savefile` means whether to save all the states. If set `false` (default) the states in the 
    final episode and the values of the objective function in all episodes will be saved. If set 
    `true` then the states and the values of the objective function obtained in all episodes will 
    be saved during the training. The algorithm used to optimize the states in QuanEstimation 
    are AD, PSO, DE, DDPG, and NM. `kwargs...` contains the keywords and default values corresponding 
    to the optimization algorithm which will be introduced in detail below.

---
## **AD**
The code for state optimization with AD is as follows
=== "Python"
    ``` py
    state = StateOpt(method="GRAPE", **kwargs)
    ```
    where `kwargs` is of the form
    ``` py
    kwargs = {"Adam":False, "psi0":[], "max_episode":300, "epsilon":0.01, 
              "beta1":0.90, "beta2":0.99}
    ```
    The keywords and the default values of AD can be seen in the following 
    table

    | $~~~~~~~~~~$**kwargs$~~~~~~~~~~$ | $~~~~$default values$~~~~$ |
    | :----------:                     | :----------:               |
    | "Adam"                           | False                      |
    | "psi0"                           | [ ]                        |
    | "max_episode"                    | 300                        |
    | "epsilon"                        | 0.01                       |
    | "beta1"                          | 0.90                       |
    | "beta2"                          | 0.99                       |

    In state optimization, the state will update according to the learning rate `"epsilon"`.
    However, Adam algorithm can be introduced to update the states which can be realized by setting 
    `Adam=True`. In this case, the Adam parameters include learning rate, the exponential decay 
    rate for the first moment estimates and the second moment estimates can be set by the user via 
    `epsilon`, `beta1` and `beta2`. `psi0` is a list representing the initial guesses of states and 
    `max_episode` is the number of episodes.
=== "Julia"
    ``` jl
    alg = AD(Adam=false, max_episode=300, epsilon=0.01, beta1=0.90, 
             beta2=0.99)
    ```
    The keywords and the default values of AD can be seen in the following 
    table

    | $~~~~~~~~~~$keywords$~~~~~~~~~~$ | $~~~~$default values$~~~~$ |
    | :----------:                     | :----------:               |
    | "Adam"                           | false                      |
    | "max_episode"                    | 300                        |
    | "epsilon"                        | 0.01                       |
    | "beta1"                          | 0.90                       |
    | "beta2"                          | 0.99                       |

    In state optimization, the state will update according to the learning rate `"epsilon"`.
    However, Adam algorithm can be introduced to update the states which can be realized by setting 
    `Adam=true`. In this case, the Adam parameters include learning rate, the exponential decay 
    rate for the first moment estimates and the second moment estimates can be set by the user via 
    `epsilon`, `beta1`, and `beta2`.

## **RI**
The code for state optimization with RI is as follows
=== "Python"
    ``` py
    state = StateOpt(method="RI", **kwargs)
    ```
    where `kwargs` is of the form
    ``` py
    kwargs = {"psi0":[], "max_episode":300, "seed":1234}
    ```
    The keywords and the default values of RI can be seen in the following table

    | $~~~~~~~~~~$**kwargs$~~~~~~~~~~$ | $~~~~$default values$~~~~$ |
    | :----------:                     | :----------:               |
    | "psi0"                           | [ ]                        |
    | "max_episode"                    | 300                        |
    | "seed"                           | 1234                       |

    `psi0` is a list representing the initial guesses of states and `max_episode` is the number of episodes. `seed` is the random seed. 
=== "Julia"
    ``` jl
    alg = RI(max_episode=300)
    ```
    The keywords and the default values of RI can be seen in the following 
    table

    | $~~~~~~~~~~$keywords$~~~~~~~~~~$ | $~~~~$default values$~~~~$ |
    | :----------:                     | :----------:               |
    | "max_episode"                    | 300                        |

    `max_episode` is the number of episodes.

## **PSO**
The code for state optimization with PSO is as follows
=== "Python"
    ``` py
    state = StateOpt(method="PSO", **kwargs)
    ```
    where `kwargs` is of the form
    ``` py
    kwargs = {"p_num":10, "psi0":[], "max_episode":[1000,100], 
              "c0":1.0, "c1":2.0, "c2":2.0, "seed":1234}
    ```
    The keywords and the default values of PSO can be seen in the following 
    table

    | $~~~~~~~~~~$**kwargs$~~~~~~~~~~$ | $~~~~$default values$~~~~$ |
    | :----------:                     | :----------:               |
    | "p_num"                   | 10                         |
    | "psi0"                           | [ ]                        |
    | "max_episode"                    | [1000,100]                 |
    | "c0"                             | 1.0                        |
    | "c1"                             | 2.0                        |
    | "c2"                             | 2.0                        |
    | "seed"                           | 1234                       |

    `p_num` is the number of particles. Here `max_episode` accepts both integers and 
    arrays with two elements. If it is an integer, for example `max_episode=1000`, it means the 
    program will continuously run 1000 episodes. However, if it is an array, for example 
    `max_episode=[1000,100]`, the program will run 1000 episodes in total but replace states of 
    all the particles with global best every 100 episodes. `c0`, `c1`, and `c2` are the PSO 
    parameters representing the inertia weight, cognitive learning factor, and social learning 
    factor, respectively.  `seed` is the random seed.
=== "Julia"
    ``` jl
    alg = PSO(p_num=10, ini_particle=missing,  max_episode=[1000,100], 
              c0=1.0, c1=2.0, c2=2.0)
    ```
    The keywords and the default values of PSO can be seen in the following 
    table

    | $~~~~~~~~~~$keywords$~~~~~~~~~~$ | $~~~~$default values$~~~~$ |
    | :----------:                     | :----------:               |
    | "p_num"                          | 10                         |
    | "ini_particle"                   | missing                    |
    | "max_episode"                    | [1000,100]                 |
    | "c0"                             | 1.0                        |
    | "c1"                             | 2.0                        |
    | "c2"                             | 2.0                        |

    `p_num` is the number of particles. `ini_particle` is a tuple representing the initial 
    guesses of states and `max_episode` is the number of episodes. Here `max_episode` accepts 
    both integers and arrays with two elements. If it is an integer, for example `max_episode=1000`, 
    it means the program will continuously run 1000 episodes. However, if it is an array, for example 
    `max_episode=[1000,100]`, the program will run 1000 episodes in total but replace states of 
    all the particles with global best every 100 episodes. `c0`, `c1`, and `c2` are the PSO 
    parameters representing the inertia weight, cognitive learning factor, and social learning 
    factor, respectively. 

## **DE**
The code for state optimization with DE is as follows
=== "Python"
    ``` py
    state = StateOpt(method="DE", **kwargs)
    ```
    where `kwargs` is of the form
    ``` py
    kwargs = {"p_num":10, "psi0":[], "max_episode":1000, "c":1.0, 
              "cr":0.5, "seed":1234}
    ```
    The keywords and the default values of DE can be seen in the following 
    table

    | $~~~~~~~~~~$**kwargs$~~~~~~~~~~$ | $~~~~$default values$~~~~$ |
    | :----------:                     | :----------:               |
    | "p_num"                        | 10                         |
    | "psi0"                           | [ ]                        |
    | "max_episode"                    | 1000                       |
    | "c"                              | 1.0                        |
    | "cr"                             | 0.5                        |
    | "seed"                           | 1234                       |

    `p_num` represents the number of populations. `c` and `cr` are the mutation constant and 
    crossover constant.
=== "Julia"
    ``` jl
    alg = DE(p_num=10, ini_population=missing, max_episode=1000, 
             c=1.0, cr=0.5)
    ```
    The keywords and the default values of DE can be seen in the following 
    table

    | $~~~~~~~~~~$keywords$~~~~~~~~~~$ | $~~~~$default values$~~~~$ |
    | :----------:                     | :----------:               |
    | "p_num"                          | 10                         |
    | "ini_population"                 | missing                    |
    | "max_episode"                    | 1000                       |
    | "c"                              | 1.0                        |
    | "cr"                             | 0.5                        |

    `ini_population` is a tuple representing the initial guesses of states , `c` and `cr` 
    are the mutation constant and crossover constant.

## **NM**
The code for state optimization with NM is as follows
=== "Python"
    ``` py
    state = StateOpt(method="NM", **kwargs)
    ```
    where `kwargs` is of the form
    ``` py
    kwargs = {"p_num":10, "psi0":psi0, "max_episode":1000, "ar":1.0, 
              "ae":2.0, "ac":0.5, "as0":0.5, "seed":1234}
    ```
    The keywords and the default values of NM can be seen in the following 
    table

    | $~~~~~~~~~~$**kwargs$~~~~~~~~~~$ | $~~~~$default values$~~~~$ |
    | :----------:                     | :----------:               |
    | "p_num"                      | 10                         |
    | "psi0"                           | [ ]                        |
    | "max_episode"                    | 1000                       |
    | "ar"                             | 1.0                        |
    | "ae"                             | 2.0                        |
    | "ac"                             | 0.5                        |
    | "as0"                            | 0.5                        |
    | "seed"                           | 1234                       |

    `p_num` represents the number of initial states. `ar`, `ae`, `ac`, and `as0` are 
    constants for reflection, expansion, constraction, and shrink, respectively.
=== "Julia"
    ``` jl
    alg = NM(p_num=10, ini_state=missing, max_episode=1000, ar=1.0, 
             ae=2.0, ac=0.5, as0=0.5)
    ```
    The keywords and the default values of NM can be seen in the following 
    table

    | $~~~~~~~~~~$keywords$~~~~~~~~~~$ | $~~~~$default values$~~~~$ |
    | :----------:                     | :----------:               |
    | "p_num"                      | 10                         |
    | "ini_state"                      | missing                    |
    | "max_episode"                    | 1000                       |
    | "ar"                             | 1.0                        |
    | "ae"                             | 2.0                        |
    | "ac"                             | 0.5                        |
    | "as0"                            | 0.5                        |

    `ini_state` represents the number of initial states. `ar`, `ae`, `ac`, and `as0` are 
    constants for reflection, expansion, constraction, and shrink, respectively.



**Example 6.1**  
<a id="example6_1"></a>
The Hamiltonian of the Lipkin–Meshkov–Glick (LMG) model is
\begin{align}
H_{\mathrm{LMG}}=-\frac{\lambda}{N}(J_1^2+gJ_2^2)-hJ_3,
\end{align}

where $N$ is the number of spins of the system, $\lambda$ is the spin–spin interaction strength, 
$h$ is the strength of the external field and $g$ is the anisotropic parameter. 
$J_i=\frac{1}{2}\sum_{j=1}^N \sigma_i^{(j)}$ ($i=1,2,3$) is the collective spin operator with 
$\sigma_i^{(j)}$ the $i$th Pauli matrix for the $j$th spin. In single-parameter scenario, we take 
$g$ as the unknown parameter to be estimated. The states are expanded as 
$|\psi\rangle=\sum^J_{m=-J}c_m|J,m\rangle$ with $|J,m\rangle$ the Dicke state and $c_m$ a complex 
coefficient. Here we fixed $J=N/2$. In this example, the probe state is optimized for both noiseless
scenario and collective dephasing noise. The dynamics under collective dephasing can be expressed as
<center> $\partial_t\rho = -i[H_{\mathrm{LMG}},\rho]+\gamma \left(J_3\rho J_3-\frac{1}{2}\left\{\rho, J^2_3\right\}\right)$ </center>
with $\gamma$ the decay rate.

In this case, all searches with different algorithms start from the coherent spin state defined by
$|\theta=\frac{\pi}{2},\phi=\frac{\pi}{2}\rangle=\exp(-\frac{\theta}{2}e^{-i\phi}J_{+}+\frac{\theta}{2}e^{i\phi}J_{-})|J,J\rangle$ with $J_{\pm}=J_1{\pm}iJ_2$. Here, QuTip [[6,7]](#Johansson2012) is applied
for generation of the spin coherent state.
=== "Python"
    ``` py
    from quanestimation import *
    import numpy as np
    from qutip import *

    # the dimension of the system
    N = 8
    # generation of the coherent spin state
    psi_css = spin_coherent(0.5*N, 0.5*np.pi, 0.5*np.pi, type="ket").full()
    psi_css = psi_css.reshape(1, -1)[0]
    # guessed state
    psi0 = [psi_css]
    # free Hamiltonian
    Lambda, g, h = 1.0, 0.5, 0.1
    Jx, Jy, Jz = jmat(0.5*N)
    Jx, Jy, Jz = Jx.full(), Jy.full(), Jz.full()
    H0 = -Lambda*(np.dot(Jx, Jx) + g*np.dot(Jy, Jy))/N - h*Jz
    # derivative of the free Hamiltonian on g
    dH = [-Lambda*np.dot(Jy, Jy)/N]
    # dissipation
    decay = [[Jz, 0.1]]
    # time length for the evolution
    tspan = np.linspace(0., 10., 2500)
    ```
    === "AD"
		``` py
        # state optimization algorithm: AD
		AD_paras = {"Adam":False, "psi0":psi0, "max_episode":300, \
                    "epsilon":0.01, "beta1":0.90, "beta2":0.99}
        state = StateOpt(savefile=False, method="AD", **AD_paras)
		```
	=== "PSO"
		``` py
        # state optimization algorithm: PSO
		PSO_paras = {"p_num":10, "psi0":psi0, "max_episode":[1000,100], \
					 "c0":1.0, "c1":2.0, "c2":2.0, "seed":1234}
		state = StateOpt(savefile=False, method="PSO", **PSO_paras)
		```
	=== "DE"
		``` py
        # state optimization algorithm: DE
		DE_paras = {"p_num":10, "psi0":psi0, "max_episode":1000, "c":1.0, \
				    "cr":0.5, "seed":1234}
		state = StateOpt(savefile=False, method="DE", **DE_paras)
		```
    === "NM"
		``` py
        # state optimization algorithm: NM
		NM_paras = {"p_num":20, "psi0":psi0, "max_episode":1000, \
                    "ar":1.0, "ae":2.0, "ac":0.5, "as0":0.5, "seed":1234}
        state = StateOpt(savefile=False, method="NM", **NM_paras)
		```
        
    ``` py
    # input the dynamics data
    state.dynamics(tspan, H0, dH, decay=decay, dyn_method="expm")
    ```
    === "QFIM"
        ``` py
        # objective function: QFI
        state.QFIM()
        ```
    === "CFIM"
        ``` py
        # objective function: CFI
        state.CFIM()
        ```
=== "Julia"
    ``` jl
    using QuanEstimation
    using Random
    using StableRNGs
    using LinearAlgebra
    using SparseArrays

    # the dimension of the system
    N = 8
    # generation of the coherent spin state
    j, theta, phi = N÷2, 0.5pi, 0.5pi
    Jp = Matrix(spdiagm(1=>[sqrt(j*(j+1)-m*(m+1)) for m in j:-1:-j][2:end]))
    Jm = Jp'
    psi0 = exp(0.5*theta*exp(im*phi)*Jm - 0.5*theta*exp(-im*phi)*Jp)*
           QuanEstimation.basis(Int(2*j+1), 1)
    dim = length(psi0)
    # free Hamiltonian
    lambda, g, h = 1.0, 0.5, 0.1
    Jx = 0.5*(Jp + Jm)
    Jy = -0.5im*(Jp - Jm)
    Jz = spdiagm(j:-1:-j)
    H0 = -lambda*(Jx*Jx + g*Jy*Jy) / N - h*Jz
    # derivative of the free Hamiltonian on g
    dH = [-lambda*Jy*Jy/N]
    # dissipation
    decay = [[Jz, 0.1]]
    # time length for the evolution
    tspan = range(0., 10., length=2500)
    # set the optimization type
    opt = QuanEstimation.StateOpt(psi=psi0, seed=1234) 
    ```
    === "AD"
        ``` jl
        # state optimization algorithm: AD
        alg = QuanEstimation.AD(Adam=false, max_episode=300, epsilon=0.01, 
                                beta1=0.90, beta2=0.99)
        ```
        === "QFIM"
            ``` jl
            # objective function: QFI
            obj = QuanEstimation.QFIM_obj()
            ```
        === "CFIM"
            ``` jl
            # objective function: CFI
            obj = QuanEstimation.CFIM_obj()
            ```
    === "PSO"
        ``` jl
        # state optimization algorithm: PSO
        alg = QuanEstimation.PSO(p_num=10, max_episode=[1000,100], c0=1.0, 
                                 c1=2.0, c2=2.0)
        ```
        === "QFIM"
            ``` jl
            # objective function: QFI
            obj = QuanEstimation.QFIM_obj()
            ```
        === "CFIM"
            ``` jl
            # objective function: CFI
            obj = QuanEstimation.CFIM_obj()
            ```
    === "DE"
        ``` jl
        # state optimization algorithm: DE
        alg = QuanEstimation.DE(p_num=10, max_episode=1000, c=1.0, cr=0.5)
        ```
        === "QFIM"
            ``` jl
            # objective function: QFI
            obj = QuanEstimation.QFIM_obj()
            ```
        === "CFIM"
            ``` jl
            # objective function: CFI
            obj = QuanEstimation.CFIM_obj()
            ```
    === "NM"
        ``` jl
        # state optimization algorithm: NM
        alg = QuanEstimation.NM(p_num=10, max_episode=1000, ar=1.0, 
                                ae=2.0, ac=0.5, as0=0.5)
        ```
        === "QFIM"
            ``` jl
            # objective function: QFI
            obj = QuanEstimation.QFIM_obj()
            ```
        === "CFIM"
            ``` jl
            # objective function: CFI
            obj = QuanEstimation.CFIM_obj()
            ```
    ``` jl
    # input the dynamics data
    dynamics = QuanEstimation.Lindblad(opt, tspan, H0, dH, decay=decay, 
                                       dyn_method=:Expm) 
    # run the state optimization problem
    QuanEstimation.run(opt, alg, obj, dynamics; savefile=false)
    ```
**Example 6.2**  
<a id="example6_2"></a>
In the multiparameter scenario, $g$ and $h$ are chooen to be the unknown parameters to be estimated.
=== "Python"
    ``` py
    from quanestimation import *
    import numpy as np
    from qutip import *

    # the dimension of the system
    N = 8
    # generation of coherent spin state
    psi_css = spin_coherent(0.5*N, 0.5*np.pi, 0.5*np.pi, type="ket").full()
    psi_css = psi_css.reshape(1, -1)[0]
    # guessed state
    psi0 = [psi_css]
    # free Hamiltonian
    Lambda, g, h = 1.0, 0.5, 0.1
    Jx, Jy, Jz = jmat(0.5*N)
    Jx, Jy, Jz = Jx.full(), Jy.full(), Jz.full()
    H0 = -Lambda*(np.dot(Jx, Jx) + g*np.dot(Jy, Jy))/N - h*Jz
    # derivatives of the free Hamiltonian on the g and h
    dH = [-Lambda*np.dot(Jy, Jy)/N, -Jz]
    # dissipation
    decay = [[Jz, 0.1]]
    # time length for the evolution
    tspan = np.linspace(0., 10., 2500)
    # weight matrix
    W = np.array([[1/3, 0.], [0., 2/3]])
    ```
    === "AD"
		``` py
        # state optimization algorithm: AD
		AD_paras = {"Adam":False, "psi0":psi0, "max_episode":300, \
                    "epsilon":0.01, "beta1":0.90, "beta2":0.99}
        state = StateOpt(savefile=False, method="AD", **AD_paras)
		```
        ``` py
        # input the dynamics data
        state.dynamics(tspan, H0, dH, decay=decay, dyn_method="expm")
        ```
        === "QFIM"
            ``` py
            # objective function: tr(WF^{-1})
            state.QFIM()
            ```
        === "CFIM"
            ``` py
            # objective function: tr(WI^{-1})
            state.CFIM()
            ```
        === "HCRB"
            ``` py
            # objective function: HCRB
            state.HCRB()
            ```
	=== "PSO"
		``` py
        # state optimization algorithm: PSO
		PSO_paras = {"p_num":10, "psi0":psi0, "max_episode":[1000,100], \
					 "c0":1.0, "c1":2.0, "c2":2.0, "seed":1234}
		state = StateOpt(savefile=False, method="PSO", **PSO_paras)
		```
        ``` py
        # input the dynamics data
        state.dynamics(tspan, H0, dH, decay=decay, dyn_method="expm")
        ```
        === "QFIM"
            ``` py
            # objective function: tr(WF^{-1})
            state.QFIM()
            ```
        === "CFIM"
            ``` py
            # objective function: tr(WI^{-1})
            state.CFIM()
            ```
        === "HCRB"
            ``` py
            # objective function: HCRB
            state.HCRB()
            ```
	=== "DE"
		``` py
        # state optimization algorithm: DE
		DE_paras = {"p_num":10, "psi0":psi0, "max_episode":1000, "c":1.0, \
				    "cr":0.5, "seed":1234}
		state = StateOpt(savefile=False, method="DE", **DE_paras)
		```
        ``` py
        # input the dynamics data
        state.dynamics(tspan, H0, dH, decay=decay, dyn_method="expm")
        ```
        === "QFIM"
            ``` py
            # objective function: tr(WF^{-1})
            state.QFIM()
            ```
        === "CFIM"
            ``` py
            # objective function: tr(WI^{-1})
            state.CFIM()
            ```
        === "HCRB"
            ``` py
            # objective function: HCRB
            state.HCRB()
            ```
    === "NM"
		``` py
        # state optimization algorithm: NM
		NM_paras = {"p_num":20, "psi0":psi0, "max_episode":1000, \
                    "ar":1.0, "ae":2.0, "ac":0.5, "as0":0.5, "seed":1234}
        state = StateOpt(savefile=False, method="NM", **NM_paras)
		```
        ``` py
        # input the dynamics data
        state.dynamics(tspan, H0, dH, decay=decay, dyn_method="expm")
        ```
        === "QFIM"
            ``` py
            # objective function: tr(WF^{-1})
            state.QFIM()
            ```
        === "CFIM"
            ``` py
            # objective function: tr(WI^{-1})
            state.CFIM()
            ```
        === "HCRB"
            ``` py
            # objective function: HCRB
            state.HCRB()
            ```
	<!-- === "DDPG"
		``` py
        # state optimization algorithm: DDPG
		DDPG_paras = {"layer_num":4, "layer_dim":250, "max_episode":500, \
		              "seed":1234}
		state = StateOpt(savefile=False, method="DDPG", **DDPG_paras)
		```
        ``` py
        # input the dynamics data
        state.dynamics(tspan, H0, dH, decay=decay, dyn_method="expm")
        ```
        === "QFIM"
            ``` py
            # objective function: tr(WF^{-1})
            state.QFIM()
            ```
        === "CFIM"
            ``` py
            # objective function: tr(WI^{-1})
            state.CFIM()
            ``` -->
=== "Julia"
    ``` jl
    using QuanEstimation
    using Random
    using StableRNGs
    using LinearAlgebra
    using SparseArrays

    # the dimension of the system
    N = 8
    # generation of the coherent spin state
    j, theta, phi = N÷2, 0.5pi, 0.5pi
    Jp = Matrix(spdiagm(1=>[sqrt(j*(j+1)-m*(m+1)) for m in j:-1:-j][2:end]))
    Jm = Jp'
    psi0 = exp(0.5*theta*exp(im*phi)*Jm - 0.5*theta*exp(-im*phi)*Jp)*
               QuanEstimation.basis(Int(2*j+1), 1)
    dim = length(psi0)
    # free Hamiltonian
    lambda, g, h = 1.0, 0.5, 0.1
    Jx = 0.5*(Jp + Jm)
    Jy = -0.5im*(Jp - Jm)
    Jz = spdiagm(j:-1:-j)
    H0 = -lambda*(Jx*Jx + g*Jy*Jy) / N + g * Jy^2 / N - h*Jz
    # derivative of the free Hamiltonian on g
    dH = [-lambda*Jy*Jy/N, -Jz]
    # dissipation
    decay = [[Jz, 0.1]]
    # time length for the evolution
    tspan = range(0., 10., length=2500)
    # weight matrix
    W = [1/3 0.; 0. 2/3]
    # set the optimization type
    opt = QuanEstimation.StateOpt(psi=psi0, seed=1234)
    ```
    === "AD"
        ``` jl
        # state optimization algorithm: AD
        alg = QuanEstimation.AD(Adam=false, max_episode=300, epsilon=0.01, 
                                beta1=0.90, beta2=0.99)
        ```
        === "QFIM"
            ``` jl
            # objective function: tr(WF^{-1})
            obj = QuanEstimation.QFIM_obj()
            ```
        === "CFIM"
            ``` jl
            # objective function: tr(WI^{-1})
            obj = QuanEstimation.CFIM_obj()
            ```
    === "PSO"
        ``` jl
        # state optimization algorithm: PSO
        alg = QuanEstimation.PSO(p_num=10, max_episode=[1000,100], c0=1.0, 
                                 c1=2.0, c2=2.0)
        ```
        === "QFIM"
            ``` jl
            # objective function: tr(WF^{-1})
            obj = QuanEstimation.QFIM_obj()
            ```
        === "CFIM"
            ``` jl
            # objective function: tr(WI^{-1})
            obj = QuanEstimation.CFIM_obj()
            ```
        === "HCRB"
            ``` jl
            # objective function: HCRB
            obj = QuanEstimation.HCRB_obj()
            ```
    === "DE"
        ``` jl
        # state optimization algorithm: DE
        alg = QuanEstimation.DE(p_num=10, max_episode=1000, c=1.0, cr=0.5)
        ```
        === "QFIM"
            ``` jl
            # objective function: tr(WF^{-1})
            obj = QuanEstimation.QFIM_obj()
            ```
        === "CFIM"
            ``` jl
            # objective function: tr(WI^{-1})
            obj = QuanEstimation.CFIM_obj()
            ```
        === "HCRB"
            ``` jl
            # objective function: HCRB
            obj = QuanEstimation.HCRB_obj()
            ```
    === "NM"
        ``` jl
        # state optimization algorithm: NM
        alg = QuanEstimation.NM(p_num=10, max_episode=1000, ar=1.0, 
                                ae=2.0, ac=0.5, as0=0.5)
        ```
        === "QFIM"
            ``` jl
            # objective function: tr(WF^{-1})
            obj = QuanEstimation.QFIM_obj()
            ```
        === "CFIM"
            ``` jl
            # objective function: tr(WI^{-1})
            obj = QuanEstimation.CFIM_obj()
            ```
        === "HCRB"
            ``` jl
            # objective function: HCRB
            obj = QuanEstimation.HCRB_obj()
            ```
    <!-- === "DDPG"
        ``` jl
        # state optimization algorithm: DDPG
        alg = QuanEstimation.DDPG(max_episode=500, layer_num=3, layer_dim=200)
        ```
        === "QFIM"
            ``` jl
            # objective function: tr(WF^{-1})
            obj = QuanEstimation.QFIM_obj()
            ```
        === "CFIM"
            ``` jl
            # objective function: tr(WI^{-1})
            obj = QuanEstimation.CFIM_obj()
            ``` -->
    ``` jl
    # input the dynamics data
    dynamics = QuanEstimation.Lindblad(opt, tspan, H0, dH, decay=decay, 
                                       dyn_method=:Expm) 
    # run the state optimization problem
    QuanEstimation.run(opt, alg, obj, dynamics; savefile=false)
    ```

If the parameterization process is implemented with the Kraus operators, then the corresponding 
codes are
=== "Python"
    ``` py
    state = StateOpt(savefile=False, method="AD", **kwargs)
    state.state.Kraus(K, dK)
    ```
    === "QFIM"
        ``` py
        state.QFIM(W=[], LDtype="SLD")
        ```
    === "CFIM"
        ``` py
        state.CFIM(M=[], W=[])
        ```
    === "HCRB"
        ``` py
        state.HCRB(W=[])
        ```
=== "Julia"
    ``` jl
    opt = StateOpt(psi=psi, seed=1234)
    alg = AD(kwargs...)
    dynamics = Kraus(opt, K, dK)
    ```
    === "QFIM"
        ``` jl
        obj = QFIM_obj(W=missing, LDtype=:SLD)
        ```
    === "CFIM"
        ``` jl
        obj = CFIM_obj(M=missing, W=missing)
        ```
    === "HCRB"
        ``` jl
        obj = HCRB_obj(W=missing)
        ```
    ``` jl
    run(opt, alg, obj, dynamics; savefile=false)
    ```

where `K` and `dK` are the Kraus operators and its derivatives with respect to the 
unknown parameters.

**Example 6.3**  
The Kraus operators for the amplitude damping channel are

\begin{eqnarray}
K_1 = \left(\begin{array}{cc}
1 & 0  \\
0 & \sqrt{1-\gamma}
\end{array}\right),
K_2 = \left(\begin{array}{cc}
0 & \sqrt{\gamma} \\
0 & 0
\end{array}\right), \nonumber
\end{eqnarray}

where $\gamma$ is the unknown parameter to be estimated which represents the decay probability.

=== "Python"
    ``` py
    from quanestimation import *
    import numpy as np

    # initial state
    rho0 = 0.5*np.array([[1., 1.], [1., 1.]])
    # Kraus operators for the amplitude damping channel
    gamma = 0.1
    K1 = np.array([[1., 0.], [0., np.sqrt(1-gamma)]])
    K2 = np.array([[0., np.sqrt(gamma)], [0., 0.]])
    K = [K1, K2]
    # derivatives of Kraus operators on gamma
    dK1 = np.array([[1., 0.], [0., -0.5/np.sqrt(1-gamma)]])
    dK2 = np.array([[0., 0.5/np.sqrt(gamma)], [0., 0.]])
    dK = [[dK1], [dK2]]
    ```
    === "AD"
		``` py
        # state optimization algorithm: AD
		AD_paras = {"Adam":False, "psi0":[], "max_episode":300, \
                    "epsilon":0.01, "beta1":0.90, "beta2":0.99}
        state = StateOpt(savefile=False, method="AD", **AD_paras)
		```
        ``` py
        # input the dynamics data
        state.Kraus(K, dK)
        ```
        === "QFIM"
            ``` py
            # objective function: QFI
            state.QFIM()
            ```
        === "CFIM"
            ``` py
            # objective function: CFI
            state.CFIM()
            ```
    === "RI"
		``` py
        # state optimization algorithm: RI
		RI_paras = {"psi0":[], "max_episode":300, "seed":1234}
        state = StateOpt(savefile=False, method="RI", **RI_paras)
		```
        ``` py
        # input the dynamics data
        state.Kraus(K, dK)
        ```
        === "QFIM"
            ``` py
            # objective function: QFI
            state.QFIM()
            ```
	=== "PSO"
		``` py
        # state optimization algorithm: PSO
		PSO_paras = {"p_num":10, "psi0":[], "max_episode":[1000,100], \
					 "c0":1.0, "c1":2.0, "c2":2.0, "seed":1234}
		state = StateOpt(savefile=False, method="PSO", **PSO_paras)
		```
        ``` py
        # input the dynamics data
        state.Kraus(K, dK)
        ```
        === "QFIM"
            ``` py
            # objective function: QFI
            state.QFIM()
            ```
        === "CFIM"
            ``` py
            # objective function: CFI
            state.CFIM()
            ```
	=== "DE"
		``` py
        # state optimization algorithm: DE
		DE_paras = {"p_num":10, "psi0":[], "max_episode":1000, "c":1.0, \
				    "cr":0.5, "seed":1234}
		state = StateOpt(savefile=False, method="DE", **DE_paras)
		```
        ``` py
        # input the dynamics data
        state.Kraus(K, dK)
        ```
        === "QFIM"
            ``` py
            # objective function: QFI
            state.QFIM()
            ```
        === "CFIM"
            ``` py
            # objective function: CFI
            state.CFIM()
            ```
    === "NM"
		``` py
        # state optimization algorithm: NM
		NM_paras = {"p_num":20, "psi0":[], "max_episode":1000, \
                    "ar":1.0, "ae":2.0, "ac":0.5, "as0":0.5, "seed":1234}
        state = StateOpt(savefile=False, method="NM", **NM_paras)
		```
        ``` py
        # input the dynamics data
        state.Kraus(K, dK)
        ```
        === "QFIM"
            ``` py
            # objective function: QFI
            state.QFIM()
            ```
        === "CFIM"
            ``` py
            # objective function: CFI
            state.CFIM()
            ```
	<!-- === "DDPG"
		``` py
        # state optimization algorithm: DDPG
		DDPG_paras = {"layer_num":4, "layer_dim":250, "max_episode":500, \
		              "seed":1234}
		state = StateOpt(savefile=False, method="DDPG", **DDPG_paras)
		```
        ``` py
        # input the dynamics data
        state.Kraus(K, dK)
        ```
        === "QFIM"
            ``` py
            # objective function: QFI
            state.QFIM()
            ```
        === "CFIM"
            ``` py
            # objective function: CFI
            state.CFIM()
            ``` -->
=== "Julia"
    ``` jl
    using QuanEstimation

    # initial state
    rho0 = 0.5*ones(2, 2)
    # Kraus operators for the amplitude damping channel
    gamma = 0.1
    K1 = [1. 0.; 0. sqrt(1-gamma)]
    K2 = [0. sqrt(gamma); 0. 0.]
    K = [K1, K2]
    # derivatives of Kraus operators on gamma
    dK1 = [1. 0.; 0. -0.5/sqrt(1-gamma)]
    dK2 = [0. 0.5/sqrt(gamma); 0. 0.]
    dK = [[dK1], [dK2]]
    opt = QuanEstimation.Sopt(seed=1234)
    ```
    === "AD"
        ``` jl
        # state optimization algorithm: AD
        alg = QuanEstimation.AD(Adam=false, max_episode=300, epsilon=0.01, 
                                beta1=0.90, beta2=0.99)
        ```
        === "QFIM"
            ``` jl
            # objective function: QFI
            obj = QuanEstimation.QFIM_obj()
            ```
        === "CFIM"
            ``` jl
            # objective function: CFI
            obj = QuanEstimation.CFIM_obj()
            ```
    === "RI"
        ``` jl
        # state optimization algorithm: RI
        alg = QuanEstimation.RI(max_episode=300)
        ```
        === "QFIM"
            ``` jl
            # objective function: QFI
            obj = QuanEstimation.QFIM_obj()
            ```
    === "PSO"
        ``` jl
        # state optimization algorithm: PSO
        alg = QuanEstimation.PSO(p_num=10, max_episode=[1000,100], c0=1.0, 
                                 c1=2.0, c2=2.0)
        ```
        === "QFIM"
            ``` jl
            # objective function: QFI
            obj = QuanEstimation.QFIM_obj()
            ```
        === "CFIM"
            ``` jl
            # objective function: CFI
            obj = QuanEstimation.CFIM_obj()
            ```
    === "DE"
        ``` jl
        # state optimization algorithm: DE
        alg = QuanEstimation.DE(p_num=10, max_episode=1000, c=1.0, cr=0.5)
        ```
                === "QFIM"
            ``` jl
            # objective function: QFI
            obj = QuanEstimation.QFIM_obj()
            ```
        === "CFIM"
            ``` jl
            # objective function: CFI
            obj = QuanEstimation.CFIM_obj()
            ```
    === "NM"
        ``` jl
        # state optimization algorithm: NM
        alg = QuanEstimation.NM(p_num=10, max_episode=1000, ar=1.0, 
                                ae=2.0, ac=0.5, as0=0.5)
        ```        
        === "QFIM"
            ``` jl
            # objective function: QFI
            obj = QuanEstimation.QFIM_obj()
            ```
        === "CFIM"
            ``` jl
            # objective function: CFI
            obj = QuanEstimation.CFIM_obj()
            ```
    <!-- === "DDPG"
        ``` jl
        # state optimization algorithm: DDPG
        alg = QuanEstimation.DDPG(max_episode=500, layer_num=3, layer_dim=200)
        ```
        === "QFIM"
            ``` jl
            # objective function: QFI
            obj = QuanEstimation.QFIM_obj()
            ```
        === "CFIM"
            ``` jl
            # objective function: CFI
            obj = QuanEstimation.CFIM_obj()
            ``` -->
    ``` jl
    # input the dynamics data
    dynamics = QuanEstimation.Kraus(opt, K, dK)
    # run the state optimization problem
    QuanEstimation.run(opt, alg, obj, dynamics; savefile=false)
    ```
---
## **Bibliography**
<a id="Baydin2018">[1]</a>
A. G. Baydin, B. A. Pearlmutter, A. A. Radul, and J. M. Siskind,
Automatic differentiation in machine learning: a survey,
[J. Mach. Learn. Res. **18**, 1-43 (2018).](http://jmlr.org/papers/v18/17-468.html)

<a id="Rafal2011">[2]</a>
R. Demkowicz-Dobrzański,
Optimal phase estimation with arbitrary a priori knowledge,
[Phys. Rev. A **83**, 061802(R) (2011).
](https://doi.org/10.1103/PhysRevA.83.061802)

<a id="Kennedy1995">[3]</a>
J. Kennedy and R. Eberhar,
Particle swarm optimization,
[Proc. 1995 IEEE International Conference on Neural Networks **4**, 1942-1948 (1995).
](https://doi.org/10.1109/ICNN.1995.488968)

<a id="Storn1997">[4]</a>
R. Storn and K. Price,
Differential Evolution-A Simple and Efficient Heuristic for global
Optimization over Continuous Spaces,
[J. Global Optim. **11**, 341 (1997).](https://doi.org/10.1023/A:1008202821328)

<a id="Nelder1965">[5]</a>
J. A. Nelder and R. Mead,
A Simplex Method for Function Minimization,
[Comput. J. **7**, 308–313 (1965).](https://doi.org/10.1093/comjnl/7.4.308)

<a id="Johansson2012">[6]</a>
J. R. Johansson, P. D. Nation, and F. Nori,
QuTiP: An open-source Python framework for the dynamics of open quantum systems,
[Comp. Phys. Comm. **183**, 1760 (2012).](https://doi.org/10.1016/j.cpc.2012.02.021)

<a id="Johansson2013">[7]</a>
J. R. Johansson, P. D. Nation, and F. Nori,
QuTiP 2: A Python framework for the dynamics of open quantum systems,
[Comp. Phys. Comm. **184**, 1234 (2013).](https://doi.org/10.1016/j.cpc.2012.11.019)

# **Output files**
In QuanEstimation, the output data will be saved into files during or after the optimization process. There are currently two types of them: the values of the objective function and the values of variables from corresponding scheme (optimizations for controls, states, or measurements).  

For the objective fucntion, the optimized variables at each optimization step will be used to evaluate the objective function, and then the obtained values will be saved sequentially, each line a value, into a CSV file named `f.csv`. However, for the optimized variables, depending on the choice of algorithm and optimization scenario, the storage format of output data varies accordingly. This guide is intended to help users to understand how the optimized data is saved and how to extract and manipulate them for further research. 

## Control optimization
The control optimization results will be saved into a `.npy` file named `controls.npy`. If the argument `savefile` is set to `False`, the control coefficients after the final round of optimization will be saved, with the first dimension corresponding to the number of control, and the second dimension corresponding to the number of time intervals. Otherwise, all the control coefficients after each round of optimization will be saved. The saved control optimization results can be load with 
``` py
# load the controls
controls = np.load("controls.npy")
```

## State optimization
The state optimization results will be saved into a `.npy` file named `states.npy`. If the argument `savefile` is set to `False`, the final optimized state vectors will be saved. Otherwise, all the state vectors after each round of optimization will be saved. The saved state optimization results can be load with 
``` py
# load the states
states = np.load("states.npy")
```

## Measurement optimization
The measurement optimization results will be saved into a `.npy` file named `measurements.npy`. If the argument `savefile` is set to `False`, the final optimized POVMs will be saved. Otherwise, all the lists of POVMs after each round of optimization will be saved. The saved measurement optimization results can be load with 
``` py
# load the measurements
M = np.load("measurements.npy")
```

# **Metrological resources**
The metrological resources that QuanEstimation can calculate are spin squeezing and the 
minimum time to reach the given target. The spin squeezing can be calculated via the function: 
=== "Python"
    ``` py
    SpinSqueezing(rho, basis="Dicke", output="KU")
    ```
=== "Julia"
    ``` jl
    SpinSqueezing(rho; basis="Dicke", output="KU")
    ```
`rho` represents the density matrix of the state. In this function, the basis of the state can 
be Dicke basis or the original basis of each spin, which can be adjusted by setting 
`basis="Dicke"` or `basis="Pauli"`. The variable `output` represents the type of spin squeezing 
calculation. `output="KU"` represents the spin squeezing defined by Kitagawa and Ueda 
[[1]](#Kitagawa1993) and `output="WBIMH"` calculates the spin squeezing defined by Wineland 
et al. [[2]](#Wineland1992).

**Example 4.1**  
In this example, QuTip [[3,4]](#Johansson2012) is used to generate spin coherent state.
=== "Python"
    ``` py
    from quanestimation import *
    import numpy as np
    from qutip import spin_coherent
    
    # generation of spin coherent state with QuTip
    j = 2
    theta = 0.5*np.pi
    phi = 0.5*np.pi
    rho_CSS = spin_coherent(j, theta, phi, type='dm').full()
    xi = SpinSqueezing(rho_CSS, basis="Dicke", output="KU")
    ```
=== "Julia"
    ``` jl
    using QuanEstimation
    using SparseArrays

    # generation of the coherent spin state
    j, theta, phi = 2, 0.5pi, 0.5pi
    Jp = Matrix(spdiagm(1=>[sqrt(j*(j+1)-m*(m+1)) for m in j:-1:-j][2:end]))
    Jm = Jp'
    psi0 = exp(0.5*theta*exp(im*phi)*Jm - 0.5*theta*exp(-im*phi)*Jp)*
           QuanEstimation.basis(Int(2*j+1), 1)
    rho = psi0*psi0'
    xi = QuanEstimation.SpinSqueezing(rho; basis="Dicke", output="KU")
    ```
Calculation of the minimum time to reach a given precision limit with
=== "Python"
    ``` py
    TargetTime(f, tspan, func, *args, **kwargs)
    ```
    where `f` is the given value of the objective function and `tspan` is the time length for the 
    evolution. `func` represents the function for calculating the objective function, `*args` and 
    `**kwargs` are the corresponding input parameters and the keyword arguments.
=== "Julia"
    ``` jl
    TargetTime(f, tspan, func, args...; kwargs...)
    ```
    where `f` is the given value of the objective function and `tspan` is the time length for the 
    evolution. `func` represents the function for calculating the objective function, `args...` 
    and `kwargs...` are the corresponding input parameters and the keyword arguments.

**Example 4.2**  
In this example, the free evolution Hamiltonian of a single qubit system is $H_0=\frac{1}{2}
\omega \sigma_3$ with $\omega$ the frequency and $\sigma_3$ a Pauli matrix. 
The dynamics of the system is governed by
\begin{align}
\partial_t\rho=-i[H_0, \rho],
\end{align}

where $\rho$ is the parameterized density matrix. The probe state is taken as $|+\rangle\langle+|$ 
with $|+\rangle=\frac{1}{\sqrt{2}}(|0\rangle+|1\rangle)$. Here $|0\rangle$ $(|1\rangle)$ is the 
eigenstate of $\sigma_3$ with respect to the eigenvalue $1$ $(-1)$.
=== "Python"
    ``` py
    from quanestimation import *
    import numpy as np

    # initial state
    rho0 = 0.5*np.array([[1., 1.], [1., 1.]])
    # free Hamiltonian
    omega = 1.0
    sz = np.array([[1., 0.], [0., -1.]])
    H0 = 0.5*omega*sz
    # derivative of the free Hamiltonian on omega
    dH = [0.5*sz]
    # time length for the evolution
    tspan = np.linspace(0., 50., 2000)
    # dynamics
    dynamics = Lindblad(tspan, rho0, H0, dH)
    rho, drho = dynamics.expm()
    # the value of the objective function
    f = 20.0
    t = TargetTime(f, tspan, QFIM, rho, drho)
    ```
=== "Julia"
    ``` jl
    using QuanEstimation

    # initial state
    rho0 = 0.5*ones(2, 2)
    # free Hamiltonian
    omega = 1.0
    sx = [0. 1.; 1. 0.0im]
	sy = [0. -im; im 0.]
	sz = [1. 0.0im; 0. -1.]
	H0 = 0.5*omega*sz
    # derivative of the free Hamiltonian on omega
    dH = [0.5*sz]
    # time length for the evolution
    tspan = range(0., 50., length=2000)
    # dynamics
    rho, drho = QuanEstimation.expm(tspan, rho0, H0, dH)
    drho = [drho[i][1] for i in 1:2000]
    # the value of the objective function
    f = 20
    t = QuanEstimation.TargetTime(f, tspan, QuanEstimation.QFIM, rho, drho)
    ```

---
## **Bibliography**
<a id="Kitagawa1993">[1]</a> 
M. Kitagawa and M. Ueda, Squeezed spin states, 
[Phys. Rev. A **47**, 5138 (1993).](https://doi.org/10.1103/PhysRevA.47.5138)

<a id="Wineland1992">[2]</a>
D. J. Wineland, J. J. Bollinger, W. M. Itano, F. L. Moore, and D. J. Heinzen, 
Spin squeezing and reduced quantum noise in spectroscopy, 
[Phys. Rev. A **46**, R6797(R) (1992).](https://doi.org/10.1103/PhysRevA.46.R6797)

<a id="Johansson2012">[3]</a>
J. R. Johansson, P. D. Nation, and F. Nori,
QuTiP: An open-source Python framework for the dynamics of open quantum systems,
[Comp. Phys. Comm. **183**, 1760 (2012).](https://doi.org/10.1016/j.cpc.2012.02.021)

<a id="Johansson2013">[4]</a>
J. R. Johansson, P. D. Nation, and F. Nori,
QuTiP 2: A Python framework for the dynamics of open quantum systems,
[Comp. Phys. Comm. **184**, 1234 (2013).](https://doi.org/10.1016/j.cpc.2012.11.019)

# **Parameterization process**
In QuanEstimation, two types of parameterization processes are considered. The first one is 
the master equation of the form

\begin{align}
\partial_t\rho &=\mathcal{L}\rho \nonumber \\
&=-i[H,\rho]+\sum_i \gamma_i\left(\Gamma_i\rho\Gamma^{\dagger}_i-\frac{1}{2}
\left\{\rho,\Gamma^{\dagger}_i \Gamma_i \right\}\right),
\end{align}

where $\rho$ is the evolved density matrix, $H$ is the Hamiltonian of the system, $\Gamma_i$ 
and $\gamma_i$ are the $i\mathrm{th}$ decay operator and the corresponding decay rate. 
Numerically, the evolved state at $j$th time interval is obtained by $\rho_j=e^{\Delta t\mathcal{L}}
\rho_{j-1}$ with $\Delta t$ the time interval. The derivatives of $\rho_j$ on $\textbf{x}$ 
is calculated via
<center> $\partial_{\textbf{x}}\rho_j =\Delta t(\partial_{\textbf{x}}\mathcal{L})\rho_j
+e^{\Delta t \mathcal{L}}(\partial_{\textbf{x}}\rho_{j-1}),$ </center> <br>
where $\rho_{j-1}$ is the evolved density matrix at $(j-1)$th time interval.

The dynamics can also be solved by the ordinary differential equation (ODE) solvers, thus 
$\rho$ and $\partial_{\textbf{x}}\rho$ are obtained via directly solving the differential equations.
Here, $\partial_{\textbf{x}}\rho$ satisfies

\begin{align}
\partial_t(\partial_{\textbf{x}}\rho) =-i[\partial_{\textbf{x}}H,\rho] + \mathcal{L}(\partial_{\textbf{x}}\rho).
\end{align}

The evolved density matrix $\rho$ and its derivatives ($\partial_{\textbf{x}}\rho$) with 
respect to $\textbf{x}$ can be calculata the codes
=== "Python"
    ``` py
    dynamics = Lindblad(tspan, rho0, H0, dH, decay=[], Hc=[], ctrl=[])
    ```
    === "expm"
        ```
        rho, drho = dynamics.expm()
        ```
    === "ode"
        ```
        rho, drho = dynamics.ode()
        ```
    Here `tspan` is the time length for the evolution, `rho0` represents the density matrix of 
    the probe state, `H0` and `dH` are the free Hamiltonian and its derivatives with respect to 
    the unknown parameters to be estimated. The variable `H0` is a matrix when the free Hamiltonian 
    is time-independent and a list of matrices with the length equal to `tspan` when it is time-dependent. 
    `dH` should be input as $[\partial_a{H_0}, \partial_b{H_0}, \cdots]$. `decay` contains decay 
    operators $(\Gamma_1, \Gamma_2, \cdots)$ and the corresponding decay rates $(\gamma_1, \gamma_2, 
    \cdots)$ with the input rule decay=[[$\Gamma_1$, $\gamma_1$], [$\Gamma_2$, $\gamma_2$],...]. 
    For time-dependent decay rate, the input rule is the decay=[[$\Gamma_1$, $\gamma_1(t)$], 
    [$\Gamma_2$, $\gamma_2(t)$],...], where $\gamma_1(t)$ [$\gamma_2(t)\cdots$] is an array with 
    the length equal to `tspan`.
    `Hc` and `ctrl` are two lists represent the control Hamiltonians and the corresponding control 
    coefficients. The default values for `decay`, `Hc`, and `ctrl` are `[]` which means the 
    dynamics is unitary and only governed by the free Hamiltonian.

    The output (`rho` and `drho`) of this class by calling `dynamics.expm()` (`dynamics.ode()`) are 
    two lists with the length equal to `tspan`. Here `rho` represents the parameterized density 
    matrix and `drho` is the corresponding derivatives with respect to all the parameters, the $i$th 
    entry of `drho` is $[\partial_a{\rho},\partial_b{\rho},\cdots].$
=== "Julia"
    === "expm"
        ``` jl
        rho, drho = expm(tspan, rho0, H0, dH, decay=missing, Hc=missing, 
                         ctrl=missing)
        ```
    === "ode"
        ``` jl
        rho, drho = ode(tspan, rho0, H0, dH, decay=missing, Hc=missing, 
                        ctrl=missing)
        ```
    Here `tspan` is the time length for the evolution, `rho0` represents the density matrix of 
    the probe state, `H0` and `dH` are the free Hamiltonian and its derivatives with respect to 
    the unknown parameters to be estimated. The variable `H0` is a matrix when the free Hamiltonian 
    is time-independent and a list of matrices with the length equal to `tspan` when it is time-dependent. 
    `dH` should be input as $[\partial_a{H_0}, \partial_b{H_0}, \cdots]$. `decay` contains decay 
    operators $(\Gamma_1, \Gamma_2, \cdots)$ and the corresponding decay rates $(\gamma_1, \gamma_2, 
    \cdots)$ with the input rule decay=[[$\Gamma_1$, $\gamma_1$], [$\Gamma_2$, $\gamma_2$],...]. 
    For time-dependent decay rate, the input rule is the decay=[[$\Gamma_1$, $\gamma_1(t)$], 
    [$\Gamma_2$, $\gamma_2(t)$],...], where $\gamma_1(t)$ [$\gamma_2(t)\cdots$] is an array with 
    the length equal to `tspan`. `Hc` and `ctrl` are two lists represent the control Hamiltonians 
    and the corresponding control coefficients. The default values for `decay`, `Hc`, and `ctrl` 
    are `missing` which means the dynamics is unitary and only governed by the free Hamiltonian.

    The output (`rho` and `drho`) of this function by calling `expm()` (`ode()`) are two lists with 
    the length equal to `tspan`. Here `rho` represents the parameterized density matrix and `drho` 
    is the corresponding derivatives with respect to all the parameters, the $i$th entry of `drho` 
    is $[\partial_a{\rho},\partial_b{\rho},\cdots].$

**Example 2.1**  
In this example, the free evolution Hamiltonian of a single qubit system is $H_0=\frac{1}{2}
\omega \sigma_3$ with $\omega$ the frequency and $\sigma_3$ a Pauli matrix. 
The dynamics of the system is governed by
\begin{align}
\partial_t\rho=-i[H_0, \rho],
\end{align}

where $\rho$ is the parameterized density matrix. The probe state is taken as $|+\rangle\langle+|$ 
with $|+\rangle=\frac{1}{\sqrt{2}}(|0\rangle+|1\rangle)$. Here $|0\rangle$ $(|1\rangle)$ is the 
eigenstate of $\sigma_3$ with respect to the eigenvalue $1$ $(-1)$.

=== "Python"
    ``` py
    from quanestimation import *
    import numpy as np

    # initial state
    rho0 = 0.5*np.array([[1., 1.], [1., 1.]])
    # free Hamiltonian
    omega = 1.0
    sz = np.array([[1., 0.], [0., -1.]])
    H0 = 0.5*omega*sz
    # derivative of the free Hamiltonian on omega
    dH = [0.5*sz]
    # time length for the evolution
    tspan = np.linspace(0., 10., 2500)
    # dynamics
    dynamics = Lindblad(tspan, rho0, H0, dH)
    rho, drho = dynamics.expm()
    ```
=== "Julia"
    ``` jl
    using QuanEstimation

    # initial state
    rho0 = 0.5*ones(2, 2)
    # free Hamiltonian
    omega = 1.0
    sz = [1. 0.0im; 0. -1.]
	H0 = 0.5*omega*sz
    # derivative of the free Hamiltonian on omega
    dH = [0.5*sz]
    # time length for the evolution
    tspan = range(0., 10., length=2500)
    # dynamics
    rho, drho = QuanEstimation.expm(tspan, rho0, H0, dH)
    ```
The parameterization process can also be implemented with the Kraus operators. In this case,  
the parameterized density matrix and its derivatives with respect to the unknown parameters 
can be calculated via
\begin{align}  
\rho=\sum_i K_i\rho_0K_i^{\dagger},
\end{align}

\begin{align}
\partial_{\textbf{x}}\rho=\sum_i \partial_{\textbf{x}}K_i\rho_0K_i^{\dagger}
+ K_i\rho_0\partial_{\textbf{x}}K_i^{\dagger},
\end{align}

where $K_i$ is a Kraus operator satisfying $\sum_{i}K^{\dagger}_i K_i=I$ and $\partial_{\textbf{x}}K_i$ 
represents its derivatives with respect to $\textbf{x}$. Here $I$ is the identity 
operator and $\rho_0$ is the probe state.

In QuanEstimation, $\rho$ and $\partial_{\textbf{x}}\rho$ can be solved by
=== "Python"
    ``` py
    rho, drho = Kraus(rho0, K, dK)
    ```
=== "Julia"
    ``` jl
    Kraus = Kraus(rho0, K, dK)
    rho, drho = evolve(Kraus)
    ```
where `K` and `dK` are the Kraus operators and its derivatives with respect to the unknown parameters.

**Example 2.2**  
The Kraus operators for the amplitude damping channel are

\begin{eqnarray}
K_1 = \left(\begin{array}{cc}
1 & 0  \\
0 & \sqrt{1-\gamma}
\end{array}\right),
K_2 = \left(\begin{array}{cc}
0 & \sqrt{\gamma} \\
0 & 0
\end{array}\right), \nonumber
\end{eqnarray}

where $\gamma$ is the decay probability. In this example,
the probe state is taken as $|+\rangle\langle+|$ with $|+\rangle=\frac{1}{\sqrt{2}}(|0\rangle+
|1\rangle)$. Here $|0\rangle$ $(|1\rangle)$ is the eigenstate of $\sigma_3$ with respect to the 
eigenvalue $1$ $(-1)$.

=== "Python"
    ``` py
    from quanestimation import *
    import numpy as np

    # initial state
    rho0 = 0.5*np.array([[1., 1.], [1., 1.]])
    # Kraus operators for the amplitude damping channel
    gamma = 0.1
    K1 = np.array([[1., 0.], [0., np.sqrt(1-gamma)]])
    K2 = np.array([[0., np.sqrt(gamma)], [0., 0.]])
    K = [K1, K2]
    # derivatives of Kraus operators on gamma
    dK1 = np.array([[1., 0.], [0., -0.5/np.sqrt(1-gamma)]])
    dK2 = np.array([[0., 0.5/np.sqrt(gamma)], [0., 0.]])
    dK = [[dK1], [dK2]]
    # parameterization process
    rho, drho = Kraus(rho0, K, dK)
    ```
=== "Julia"
    ``` jl
    using QuanEstimation

    # initial state
    rho0 = 0.5*ones(2, 2)
    # Kraus operators for the amplitude damping channel
    gamma = 0.1
    K1 = [1. 0.; 0. sqrt(1-gamma)]
    K2 = [0. sqrt(gamma); 0. 0.]
    K = [K1, K2]
    # derivatives of Kraus operators on gamma
    dK1 = [1. 0.; 0. -0.5/sqrt(1-gamma)]
    dK2 = [0. 0.5/sqrt(gamma); 0. 0.]
    dK = [[dK1], [dK2]]
    # parameterization process
    Kraus = QuanEstimation.Kraus(rho0, K, dK)
    rho, drho = QuanEstimation.evolve(Kraus)
    ```

# **Comprehensive optimization**
In order to obtain the optimal parameter estimation schemes, it is necessary to
simultaneously optimize the probe state, control, and measurement. The comprehensive 
optimization for the probe state and measurement (SM), the probe state and control (SC), the 
control and measurement (CM) and the probe state, control and measurement (SCM) are proposed
in QuanEstiamtion. In the package, the comprehensive optimization algorithms are particle 
swarm optimization (PSO) [[1]](#Kennedy1995), differential evolution (DE) [[2]](#Storn1997), 
and automatic differentiation (AD) [[3]](#Baydin2018).
=== "Python"
    ``` py
    com = ComprehensiveOpt(savefile=False, method="DE", **kwargs)
    com.dynamics(tspan, H0, dH, Hc=[], ctrl=[], decay=[], ctrl_bound=[], 
                 dyn_method="expm")
    ```
    === "SM"
        ``` py
        com.SM(W=[])
        ```
    === "SC"
        ``` py
        com.SC(W=[], M=[], target="QFIM", LDtype="SLD")
        ```
    === "CM"
        ``` py
        com.CM(rho0, W=[])
        ```
    === "SCM"
        ``` py
        com.SCM(W=[])  
        ```
    Here `savefile` means whether to save all the optimized variables (probe states, control 
    coefficients and measurements). If set `True` then the optimized variables and the values 
    of the objective function obtained in all episodes will be saved during the training, 
    otherwise, the optimized variables in the final episode and the values of the objective 
    function in all episodes will be saved. `method` represents the optimization algorithm used, 
    options are: "PSO", "DE", and "AD". `**kwargs` is the keyword and the default value
    corresponding to the optimization algorithm which will be introduced in detail below.

    If the dynamics of the system can be described by the master equation, then the dynamics data 
    `tspan`, `H0`, and `dH` shoule be input. `tspan` is the time length for the evolution, `H0`
    and `dH` are the free Hamiltonian and its derivatives on the unknown parameters to be 
    estimated. `H0` is a matrix when the free Hamiltonian is time-independent and a list of matrices with the 
    length equal to `tspan` when it is time-dependent. `dH` should be input as
    $[\partial_a{H_0}, \partial_b{H_0}, \cdots]$. `Hc` and `ctrl` are two lists represent the
    control Hamiltonians and the corresponding control coefficients.`decay` contains decay 
    operators $(\Gamma_1, \Gamma_2, \cdots)$ and the corresponding decay rates $(\gamma_1, 
    \gamma_2, \cdots)$ with the input rule decay=[[$\Gamma_1$, $\gamma_1$], [$\Gamma_2$, 
    $\gamma_2$],...]. The default values for `decay`, `Hc` and `ctrl` are empty which means the 
    dynamics is unitary and only governed by the free Hamiltonian. `ctrl_bound`is an array with two 
    elements representing the lower and upper bound of the control coefficients, respectively. The 
    default value of `ctrl_bound=[]` which means the control coefficients are in the regime 
    $[-\infty,\infty]$. `dyn_method="expm"` represents the method for solving the dynamics is 
    matrix exponential, it can also be set as `dyn_method="ode"` which means the dynamics 
    (differential equation) is directly solved with the ODE solvers.

    QuanEstimation contains four comprehensive optimizations which are `com.SM()`, `com.SC()`,
    `com.CM()` and `com.SCM()`. The `target` in `com.SC()` can be set as `target="QFIM"` (default), 
    `target="CFIM` and `target="HCRB` for the corresponding objective functions are QFI 
    ($\mathrm{Tr}(W\mathcal{F}^{-1})$), CFI ($\mathrm{Tr}(W\mathcal{I}^{-1})$), and HCRB, 
    respectively. Here $\mathcal{F}$ and $\mathcal{I}$ are the QFIM and CFIM, $W$ corresponds to 
    `W` is the weight matrix which defaults to the identity matrix. If the users set `target="HCRB` 
    for single parameter scenario, the program will exit and print `"Program terminated. In the 
    single-parameter scenario, the HCRB is equivalent to the QFI. Please choose 'QFIM' as the 
    objective function"`. `LDtype` represents the types of the QFIM, it can be set as 
    `LDtype="SLD"` (default), `LDtype="RLD"`, and `LDtype="LLD"`. For the other three scenarios, 
    the objective function is CFI ($\mathrm{Tr}(W\mathcal{I}^{-1})$).
=== "Julia"
    === "SM"
        ``` jl
        opt = SMopt(psi=psi, M=M, seed=1234)
        alg = DE(kwargs...)
        dynamics = Lindblad(opt, tspan, H0, dH; Hc=missing, ctrl=missing, 
                            decay=missing, dyn_method=:Expm)  
        obj = CFIM_obj(W=missing)
        run(opt, alg, obj, dynamics; savefile=false)
        ```
    === "SC"
        ``` jl
        opt = SCopt(psi=psi, ctrl=ctrl, ctrl_bound=ctrl_bound, seed=1234)
        alg = DE(kwargs...)
        dynamics = Lindblad(opt, tspan, H0, dH, Hc; decay=missing, 
                            dyn_method=:Expm)
        ```
        === "QFIM"
            ``` jl
            obj = QFIM_obj(W=missing, LDtype=:SLD)
            ```
        === "CFIM"
            ``` jl
            obj = CFIM_obj(W=missing)
            ```
        === "HCRB"
            ``` jl
            obj = HCRB_obj(W=missing)
            ```
        ``` jl
        run(opt, alg, obj, dynamics; savefile=false)
        ```
    === "CM"
        ``` jl
        opt = CMopt(ctrl=ctrl, M=M, ctrl_bound=ctrl_bound, seed=1234)
        alg = DE(kwargs...)
        dynamics = Lindblad(opt, tspan, H0, dH, Hc; decay=missing,
                            dyn_method=:Expm)
        obj = CFIM_obj(W=missing)
        run(opt, alg, obj, dynamics; savefile=false)
        ```
    === "SCM"
        ``` jl
        opt = SCMopt(psi=psi, ctrl=ctrl, M=M, ctrl_bound=ctrl_bound, seed=1234)
        alg = DE(kwargs...)
        dynamics = Lindblad(opt, tspan, H0, dH, Hc; decay=missing, 
                            dyn_method=:Expm)
        obj = CFIM_obj(W=missing)
        run(opt, alg, obj, dynamics; savefile=false)
        ```
    QuanEstimation contains four comprehensive optimizations which are `SMopt()`, `SCopt()`,
    `CMopt()`, and `SCMopt()`. The optimization variables including initial state, control,
    and measurement can be input via `ctrl=ctrl`, `psi=psi`, and `M=M`  for constructing a 
    comprehensive optimization problem. Here, `ctrl` is a list of arrays with the length 
    equal to control Hamiltonians, `psi` is an array representing the state and `M` is
    a list of arrays with the length equal to the dimension of the system which representing 
    the projective measurement basis. Besides, the boundary value of each control 
    coefficients can be input via `ctrl_bound=ctrl_bound` when the optimized variable 
    contains control. `ctrl_bound` is an array with two elements representing the lower and 
    upper bound of the control coefficients, respectively. The default value of `ctrl_bound=
    missing` which means the control coefficients are in the regime $[-\infty,\infty]$.
    `seed` is the random seed which can ensure the reproducibility of results.
    
    The objective function of `SCopt()` can be chosen as `QFIM_obj()` (default), `CFIM_obj()`, 
    and `HCRB_obj()` for the corresponding objective functions are QFI ($\mathrm{Tr}(W\mathcal{F}^
    {-1})$), CFI ($\mathrm{Tr}(W\mathcal{I}^{-1})$), and HCRB, respectively. Here $\mathcal{F}$ 
    and $\mathcal{I}$ are the QFIM and CFIM, $W$ corresponds to `W` is the weight matrix which 
    defaults to the identity matrix. If the users set `HCRB_obj()` for single parameter scenario, 
    the program will exit and print `"Program terminated. In the single-parameter scenario, the 
    HCRB is equivalent to the QFI. Please choose 'QFIM_obj()' as the objective function"`. `LDtype` 
    represents the types of the QFIM, it can be set as `LDtype=:SLD` (default), `LDtype=:RLD`, 
    and `LDtype=:LLD`. For the other three scenarios, the objective function is `CFIM_obj()`.
    
    If the dynamics of the system can be described by the master equation, then the dynamics data 
    `tspan`, `H0`, and `dH` shoule be input. `tspan` is the time length for the evolution, `H0`
    and `dH` are the free Hamiltonian and its derivatives on the unknown parameters to be 
    estimated. `H0` is a matrix when the free Hamiltonian is time-independent and a list of matrices with the 
    length equal to `tspan` when it is time-dependent. `dH` should be input as
    $[\partial_a{H_0}, \partial_b{H_0}, \cdots]$. `Hc` and `ctrl` are two lists represent the
    control Hamiltonians and the corresponding control coefficients.`decay` contains decay 
    operators $(\Gamma_1, \Gamma_2, \cdots)$ and the corresponding decay rates $(\gamma_1, 
    \gamma_2, \cdots)$ with the input rule decay=[[$\Gamma_1$, $\gamma_1$], [$\Gamma_2$, 
    $\gamma_2$],...]. `dyn_method=:Expm` represents the method for solving the dynamics is 
    matrix exponential, it can also be set as `dyn_method=:Ode` which means the dynamics 
    (differential equation) is directly solved with the ODE solvers.

    The variable `savefile` means whether to save all the optimized variables (probe states, 
    control coefficients, and measurements). If set `true` then the optimized variables and the 
    values of the objective function obtained in all episodes will be saved during the training, 
    otherwise, the optimized variables in the final episode and the values of the objective 
    function in all episodes will be saved. The algorithm used in QuanEstimation for 
    comprehensive optimizaiton are PSO, DE, and AD. `kwargs...` is the keywords and the default 
    values corresponding to the optimization algorithm which will be introduced in detail below.

---
## **PSO**
The code for comprehensive optimization with PSO is as follows
=== "Python"
    ``` py
    com = ComprehensiveOpt(method="PSO", **kwargs)
    ```
    where `kwargs` is of the form
    ``` py
    kwargs = {"p_num":10, "psi0":[], "ctrl0":[], "measurement0":[], 
              "max_episode":[1000,100], "c0":1.0, "c1":2.0, "c2":2.0, 
              "seed":1234}
    ```
    The keywords and the default values of PSO can be seen in the following 
    table

    | $~~~~~~~~~~$**kwargs$~~~~~~~~~~$ | $~~~~$default values$~~~~$ |
    | :----------:                     | :----------:               |
    | "p_num"                   | 10                         |
    | "psi0"                           | [ ]                        |
    | "ctrl0"                          | [ ]                        |
    | "measurement0"                   | [ ]                        |
    | "max_episode"                    | [1000,100]                 |
    | "c0"                             | 1.0                        |
    | "c1"                             | 2.0                        |
    | "c2"                             | 2.0                        |
    | "seed"                           | 1234                       |

    `psi0`, `ctrl0`, and `measurement0` in the algorithms represent the initial 
    guesses of states, control coefficients and measurements, respectively, `seed` 
    is the random seed. Here `p_num` is the number of particles, `c0`, 
    `c1`, and `c2` are the PSO parameters representing the inertia weight, cognitive 
    learning factor, and social learning factor, respectively. `max_episode` accepts 
    both integers and arrays with two elements. If it is an integer, for example 
    max_episode=1000, it means the program will continuously run 1000 episodes. 
    However, if it is an array, for example max_episode=[1000,100], the program will 
    run 1000 episodes in total but replace control coefficients of all the particles 
    with global best every 100 episodes. 
=== "Julia"
    ``` jl
    alg = PSO(p_num=10, ini_particle=missing, max_episode=[1000,100], 
              c0=1.0, c1=2.0, c2=2.0)
    ```
    The keywords and the default values of PSO can be seen in the following 
    table

    | $~~~~~~~~~~$keywords$~~~~~~~~~~$ | $~~~~$default values$~~~~$ |
    | :----------:                     | :----------:               |
    | "p_num"                          | 10                         |
    | "ini_particle"                   | missing                    |
    | "max_episode"                    | [1000,100]                 |
    | "c0"                             | 1.0                        |
    | "c1"                             | 2.0                        |
    | "c2"                             | 2.0                        |

    `ini_particle`is a tuple contains `psi0`, `ctrl0`, and `measurement0`, which 
    representing the initial guesses of states, control coefficients, and measurements,
    respectively. The input rule of `ini_particle` shoule be `ini_particle=(psi0, 
    measurement0)`(SM), `ini_particle=(psi0, ctrl0)`(SC), `ini_particle=(ctrl0, 
    measurement0)`(CM) and  `ini_particle=(psi0, ctrl0, measurement0)`(SCM).
    Here `p_num` is the number of particles, `c0`, `c1`, and `c2` are the PSO parameters 
    representing the inertia weight, cognitive learning factor, and social learning 
    factor, respectively. `max_episode` accepts both integers and arrays with two 
    elements. If it is an integer, for example max_episode=1000, it means the program 
    will continuously run 1000 episodes. However, if it is an array, for example 
    max_episode=[1000,100], the program will run 1000 episodes in total but replace 
    control coefficients of all the particles with global best every 100 episodes. 

## **DE**
The code for comprehensive optimization with DE is as follows
=== "Python"
    ``` py
    com = ComprehensiveOpt(method="DE", **kwargs)
    ```
    where `kwargs` is of the form
    ``` py
    kwargs = {"p_num":10, "psi0":[], "ctrl0":[], "measurement0":[], 
              "max_episode":1000, "c":1.0, "cr":0.5, "seed":1234}
    ```
    The keywords and the default values of DE can be seen in the following 
    table

    | $~~~~~~~~~~$**kwargs$~~~~~~~~~~$ | $~~~~$default values$~~~~$ |
    | :----------:                     | :----------:               |
    | "p_num"                        | 10                         |
    | "psi0"                           | [ ]                        |
    | "ctrl0"                          | [ ]                        |
    | "measurement0"                   | [ ]                        |
    | "max_episode"                    | 1000                       |
    | "c"                              | 1.0                        |
    | "cr"                             | 0.5                        |
    | "seed"                           | 1234                       |

    `p_num` is the number of populations. Here `max_episode` is 
    an integer representing the number of episodes. `c` and `cr` are constants for 
    mutation and crossover.  
=== "Julia"
    ``` jl
    alg = DE(p_num=10, ini_population=missing, max_episode=1000, 
             c=1.0, cr=0.5)
    ```
    The keywords and the default values of DE can be seen in the following 
    table

    | $~~~~~~~~~~$keywords$~~~~~~~~~~$ | $~~~~$default values$~~~~$ |
    | :----------:                     | :----------:               |
    | "p_num"                          | 10                         |
    | "ini_population"                 | missing                    |
    | "max_episode"                    | 1000                       |
    | "c"                              | 1.0                        |
    | "cr"                             | 0.5                        |

    Here `max_episode` is an integer representing the number of episodes. `p_num` 
    represents the number of populations. `c` and `cr` are constants for mutation 
    and crossover. `ini_particle`is a tuple contains `psi0`, `ctrl0`, and `measurement0`,
    which representing the initial guesses of states, control coefficients, and 
    measurements, respectively. The input rule of `ini_particle` shoule be 
    `ini_particle=(psi0, measurement0)`(SM), `ini_particle=(psi0, ctrl0)`(SC), 
    `ini_particle=(ctrl0, measurement0)`(CM), and  
    `ini_particle=(psi0, ctrl0, measurement0)`(SCM).
## **AD**
The code for comprehensive optimization with AD is as follows
=== "Python"
    ``` py
    com = ComprehensiveOpt(method="AD", **kwargs)
    ```
    where `kwargs` is of the form
    ``` py
    kwargs = {"Adam":True, "psi0":[], "ctrl0":[], "measurement0":[],
              "max_episode":300, "epsilon":0.01, "beta1":0.90, "beta2":0.99}
    ```
    The keywords and the default values of AD can be seen in the 
    following table

    | $~~~~~~~~~~$**kwargs$~~~~~~~~~~$ | $~~~~$default values$~~~~$ |
    | :----------:                     | :----------:               |
    | "Adam"                           | False                      |
    | "psi0"                           | [ ]                        |
    | "ctrl0"                          | [ ]                        |
    | "measurement0"                   | [ ]                        |
    | "max_episode"                    | 300                        |
    | "epsilon"                        | 0.01                       |
    | "beta1"                          | 0.90                       |
    | "beta2"                          | 0.99                       |

    The optimized variables will update according to the learning rate `"epsilon"` 
    when `Adam=False`. However, If `Adam=True`, Adam algorithm will be used and the 
    Adam parameters include learning rate, the exponential decay rate for the first 
    moment estimates and the second moment estimates can be set by the user via 
    `epsilon`, `beta1` and `beta2`.
=== "Julia"
    ``` jl
    alg = AD(Adam=false, max_episode=300, epsilon=0.01, beta1=0.90, 
            beta2=0.99)
    ```
    The keywords and the default values of AD can be seen in the 
    following table

    | $~~~~~~~~~~$keywords$~~~~~~~~~~$ | $~~~~$default values$~~~~$ |
    | :----------:                     | :----------:               |
    | "Adam"                           | false                      |
    | "max_episode"                    | 300                        |
    | "epsilon"                        | 0.01                       |
    | "beta1"                          | 0.90                       |
    | "beta2"                          | 0.99                       |

    The optimized variables will update according to the learning rate `"epsilon"` 
    when `Adam=false`. However, If `Adam=true`, Adam algorithm will be used and the 
    Adam parameters include learning rate, the exponential decay rate for the first 
    moment estimates, and the second moment estimates can be set by the user via 
    `epsilon`, `beta1`, and `beta2`.

**Example 8.1**  
<a id="example8_1"></a>
A single qubit system whose free evolution Hamiltonian is $H_0 = \frac{1}{2}\omega \sigma_3$ with 
$\omega$ the frequency and $\sigma_3$ a Pauli matrix. The dynamics of the system is governed by

\begin{align}
\partial_t\rho=-i[H_0, \rho]+ \gamma_{+}\left(\sigma_{+}\rho\sigma_{-}-\frac{1}{2}\{\sigma_{-}\sigma_{+},\rho\}\right)+ \gamma_{-}\left(\sigma_{-}\rho\sigma_{+}-\frac{1}{2}\{\sigma_{+}\sigma_{-},\rho\}\right),
\end{align}

where $\gamma_{+}$, $\gamma_{-}$ are decay rates and $\sigma_{\pm}=(\sigma_1 \pm \sigma_2)/2$. The control Hamiltonian
\begin{align}
H_\mathrm{c}=u_1(t)\sigma_1+u_2(t)\sigma_2+u_3(t)\sigma_3
\end{align}

with $u_i(t)$ $(i=1,2,3)$ the control field. Here $\sigma_{1}$, $\sigma_{2}$ are also Pauli matrices.

In this case, we consider two types of comprehensive optimization, the first one is optimization of probe state and control (SC), and the other is optimization of probe state, control and measurement (SCM). QFI is taken as the target function for SC and CFI for SCM.
=== "Python"
    ``` py
    from quanestimation import *
    import numpy as np

    # initial state
    rho0 = 0.5*np.array([[1., 1.], [1., 1.]])
    # free Hamiltonian
    omega = 1.0
    sx = np.array([[0., 1.], [1., 0.]])
	sy = np.array([[0., -1.j], [1.j, 0.]]) 
	sz = np.array([[1., 0.], [0., -1.]])
    H0 = 0.5*omega*sz
    # derivative of the free Hamiltonian on omega
    dH = [0.5*sz]
    # control Hamiltonians 
    Hc = [sx,sy,sz]
    # dissipation
    sp = np.array([[0., 1.], [0., 0.]])  
	sm = np.array([[0., 0.], [1., 0.]]) 
	decay = [[sp, 0.], [sm, 0.1]]
    # measurement
    M1 = 0.5*np.array([[1., 1.], [1., 1.]])
	M2 = 0.5*np.array([[1., -1.], [-1., 1.]])
    M = [M1, M2]
    M_num = 2
    # time length for the evolution
    tspan = np.linspace(0., 10., 2500)
    ```
    === "SM"
        === "DE"
            ``` py
            # comprehensive optimization algorithm: DE
            DE_paras = {"p_num":10, "psi0":[], "ctrl0":[], "measurement0":[], \
                        "max_episode":1000, "c":1.0, "cr":0.5, "seed":1234}
            com = ComprehensiveOpt(savefile=False, method="DE", **DE_paras)
            com.dynamics(tspan, H0, dH, decay=decay, dyn_method="expm")
            com.SM()
            # convert the ".csv" file to the ".npy" file
            M_ = np.loadtxt("measurements.csv", dtype=np.complex128)
            csv2npy_measurements(M_, M_num)
            # load the measurements
            M = np.load("measurements.npy")[-1]
            ```
        === "PSO"
            ``` py
            # comprehensive optimization algorithm: PSO
            PSO_paras = {"p_num":10, "psi0":[], "ctrl0":[], \
                         "measurement0":[], "max_episode":[1000,100], "c0":1.0, \
                         "c1":2.0, "c2":2.0, "seed":1234}
            com = ComprehensiveOpt(savefile=False, method="PSO", **PSO_paras)
            com.dynamics(tspan, H0, dH, decay=decay, dyn_method="expm")
            com.SM()
            # convert the ".csv" file to the ".npy" file
            M_ = np.loadtxt("measurements.csv", dtype=np.complex128)
            csv2npy_measurements(M_, M_num)
            # load the measurements
            M = np.load("measurements.npy")[-1]
            ```
    === "SC"
        === "DE"
            ``` py
            # comprehensive optimization algorithm: DE
            DE_paras = {"p_num":10, "psi0":[], "ctrl0":[], "measurement0":[], \
                        "max_episode":1000, "c":1.0, "cr":0.5, "seed":1234}
            com = ComprehensiveOpt(savefile=False, method="DE", **DE_paras)
            com.dynamics(tspan, H0, dH, Hc=Hc, decay=decay, ctrl_bound=[-2.0,2.0], \
                         dyn_method="expm")
            ```
            === "QFIM"
                ``` py
                com.SC(W=[], target="QFIM", LDtype="SLD")
                ```
            === "CFIM"
                ``` py
                com.SC(W=[], M=M, target="CFIM")
                ```
        === "PSO"
            ``` py
            # comprehensive optimization algorithm: PSO
            PSO_paras = {"p_num":10, "psi0":[], "ctrl0":[], \
                         "measurement0":[], "max_episode":[1000,100], "c0":1.0, \
                         "c1":2.0, "c2":2.0, "seed":1234}
            com = ComprehensiveOpt(savefile=False, method="PSO", **PSO_paras)
            com.dynamics(tspan, H0, dH, Hc=Hc, decay=decay, ctrl_bound=[-2.0,2.0], \
                         dyn_method="expm")
            ```
            === "QFIM"
                ``` py
                com.SC(W=[], target="QFIM", LDtype="SLD")
                ```
            === "CFIM"
                ``` py
                com.SC(W=[], M=M, target="CFIM")
                ```
        === "AD"
            ``` py
            # comprehensive optimization algorithm: AD
            AD_paras = {"Adam":False, "psi0":[], "ctrl0":[], "measurement0":[], \
                        "max_episode":300, "epsilon":0.01, "beta1":0.90, "beta2":0.99}
            com = ComprehensiveOpt(savefile=False, method="AD", **AD_paras)
            com.dynamics(tspan, H0, dH, Hc=Hc, decay=decay, ctrl_bound=[-2.0,2.0], \
                         dyn_method="expm")
            ```
            === "QFIM"
                ``` py
                com.SC(W=[], target="QFIM", LDtype="SLD")
                ```
            === "CFIM"
                ``` py
                com.SC(W=[], M=M, target="CFIM")
                ```
    === "CM"
        === "DE"
            ``` py
            # comprehensive optimization algorithm: DE
            DE_paras = {"p_num":10, "psi0":[], "ctrl0":[], "measurement0":[], \
                        "max_episode":1000, "c":1.0, "cr":0.5, "seed":1234}
            com = ComprehensiveOpt(savefile=False, method="DE", **DE_paras)
            com.dynamics(tspan, H0, dH, Hc=Hc, decay=decay, ctrl_bound=[-2.0,2.0], \
                         dyn_method="expm")
            com.CM(rho0)
            # convert the ".csv" file to the ".npy" file
            M_ = np.loadtxt("measurements.csv", dtype=np.complex128)
            csv2npy_measurements(M_, M_num)
            # load the measurements
            M = np.load("measurements.npy")[-1]
            ```
        === "PSO"
            ``` py
            # comprehensive optimization algorithm: PSO
            PSO_paras = {"p_num":10, "psi0":[], "ctrl0":[], \
                         "measurement0":[], "max_episode":[1000,100], "c0":1.0, \
                         "c1":2.0, "c2":2.0, "seed":1234}
            com = ComprehensiveOpt(savefile=False, method="PSO", **PSO_paras)
            com.dynamics(tspan, H0, dH, Hc=Hc, decay=decay, ctrl_bound=[-2.0,2.0], \
                         dyn_method="expm")
            com.CM(rho0)
            # convert the ".csv" file to the ".npy" file
            M_ = np.loadtxt("measurements.csv", dtype=np.complex128)
            csv2npy_measurements(M_, M_num)
            # load the measurements
            M = np.load("measurements.npy")[-1]
            ```
    === "SCM"
        === "DE"
            ``` py
            # comprehensive optimization algorithm: DE
            DE_paras = {"p_num":10, "psi0":[], "ctrl0":[], "measurement0":[], \
                        "max_episode":1000, "c":1.0, "cr":0.5, "seed":1234}
            com = ComprehensiveOpt(savefile=False, method="DE", **DE_paras)
            com.dynamics(tspan, H0, dH, Hc=Hc, decay=decay, ctrl_bound=[-2.0,2.0], \
                         dyn_method="expm")
            com.SCM()
            # convert the ".csv" file to the ".npy" file
            M_ = np.loadtxt("measurements.csv", dtype=np.complex128)
            csv2npy_measurements(M_, M_num)
            # load the measurements
            M = np.load("measurements.npy")[-1]
            ```
        === "PSO"
            ``` py
            # comprehensive optimization algorithm: PSO
            PSO_paras = {"p_num":10, "psi0":[], "ctrl0":[], \
                         "measurement0":[], "max_episode":[1000,100], "c0":1.0, \
                         "c1":2.0, "c2":2.0, "seed":1234}
            com = ComprehensiveOpt(savefile=False, method="PSO", **PSO_paras)
            com.dynamics(tspan, H0, dH, Hc=Hc, decay=decay, ctrl_bound=[-2.0,2.0], \
                         dyn_method="expm")
            com.SCM()
            # convert the ".csv" file to the ".npy" file
            M_ = np.loadtxt("measurements.csv", dtype=np.complex128)
            csv2npy_measurements(M_, M_num)
            # load the measurements
            M = np.load("measurements.npy")[-1]
            ```
=== "Julia"
    ``` jl
    using QuanEstimation
    using DelimitedFiles

    # initial state
    rho0 = 0.5*ones(2, 2)
    # free Hamiltonian
    omega = 1.0
    sx = [0. 1.; 1. 0.0im]
	sy = [0. -im; im 0.]
	sz = [1. 0.0im; 0. -1.]
    H0 = 0.5*omega*sz
    # derivative of the free Hamiltonian on omega
    dH = [0.5*sz]
    # control Hamiltonians 
    Hc = [sx, sy, sz]
    # dissipation
    sp = [0. 1.; 0. 0.0im]
	sm = [0. 0.; 1. 0.0im]
    decay = [[sp, 0.0], [sm, 0.1]]
    # measurement
    M1 = 0.5*[1.0+0.0im  1.; 1.  1.]
	M2 = 0.5*[1.0+0.0im -1.; -1.  1.]
    M = [M1, M2]
    M_num = 2
    # time length for the evolution
    tspan = range(0., 10., length=2500)
    ```
    === "SM"
        ``` jl
        opt = QuanEstimation.SMopt(seed=1234)
        ```
        === "DE"
            ``` jl
            # comprehensive optimization algorithm: DE
            alg = QuanEstimation.DE(p_num=10, max_episode=1000, c=1.0, cr=0.5) 
            # objective function: CFI
            obj = QuanEstimation.CFIM_obj(M=M)
            # input the dynamics data
            dynamics = QuanEstimation.Lindblad(opt, tspan, H0, dH, decay=decay, 
                                               dyn_method=:Expm)
            # run the comprehensive optimization problem
            QuanEstimation.run(opt, alg, obj, dynamics; savefile=false)
            # convert the flattened data into a list of matrix
            M_ = readdlm("measurements.csv",'\t', Complex{Float64})
            M = [[reshape(M_[i,:], dim, dim) for i in 1:M_num] 
                for j in 1:Int(length(M_[:,1])/M_num)][end]
            ```
        === "PSO"
            ``` jl
            # comprehensive optimization algorithm: PSO
            alg = QuanEstimation.PSO(p_num=10, max_episode=[1000,100], c0=1.0, 
                                     c1=2.0, c2=2.0)
            # objective function: CFI
            obj = QuanEstimation.CFIM_obj(M=M) 
            # input the dynamics data
            dynamics = QuanEstimation.Lindblad(opt, tspan, H0, dH, decay=decay, 
                                               dyn_method=:Expm)   
            # run the comprehensive optimization problem
            QuanEstimation.run(opt, alg, obj, dynamics; savefile=false)
            # convert the flattened data into a list of matrix
            M_ = readdlm("measurements.csv",'\t', Complex{Float64})
            M = [[reshape(M_[i,:], dim, dim) for i in 1:M_num] 
                for j in 1:Int(length(M_[:,1])/M_num)][end]
            ```
    === "SC"
        ``` jl
        opt = QuanEstimation.SCopt(ctrl_bound=[-2.0,2.0], seed=1234)
        ```
        === "DE"
            ``` jl
            # comprehensive optimization algorithm: DE
            alg = QuanEstimation.DE(p_num=10, max_episode=1000, c=1.0, cr=0.5)
            ```
            === "QFIM"
                ``` jl
                # objective function: QFI
                obj = QuanEstimation.QFIM_obj()
                # input the dynamics data
                dynamics = QuanEstimation.Lindblad(opt, tspan, H0, dH, Hc, decay=decay, 
                                                   dyn_method=:Expm) 
                # run the comprehensive optimization problem
                QuanEstimation.run(opt, alg, obj, dynamics; savefile=false)
                ```
            === "CFIM"
                ``` jl
                # objective function: CFI
                obj = QuanEstimation.CFIM_obj(M=M) 
                # input the dynamics data
                dynamics = QuanEstimation.Lindblad(opt, tspan, H0, dH, Hc, decay=decay, 
                                                   dyn_method=:Expm) 
                # run the comprehensive optimization problem
                QuanEstimation.run(opt, alg, obj, dynamics; savefile=false)
                ```
        === "PSO"
            ``` jl
            # comprehensive optimization algorithm: PSO
            alg = QuanEstimation.PSO(p_num=10, max_episode=[1000,100], c0=1.0, 
                                     c1=2.0, c2=2.0)
            ```
            === "QFIM"
                ``` jl
                # objective function: QFI
                obj = QuanEstimation.QFIM_obj() 
                # input the dynamics data
                dynamics = QuanEstimation.Lindblad(opt, tspan, H0, dH, Hc, decay=decay, 
                                                   dyn_method=:Expm) 
                # run the comprehensive optimization problem
                QuanEstimation.run(opt, alg, obj, dynamics; savefile=false)
                ```
            === "CFIM"
                ``` jl
                # objective function: CFI
                obj = QuanEstimation.CFIM_obj(M=M) 
                # input the dynamics data
                dynamics = QuanEstimation.Lindblad(opt, tspan, H0, dH, Hc, decay=decay, 
                                                   dyn_method=:Expm) 
                # run the comprehensive optimization problem
                QuanEstimation.run(opt, alg, obj, dynamics; savefile=false)
                ```
        === "AD"
            ``` jl
            # comprehensive optimization algorithm: AD
            alg = QuanEstimation.AD(Adam=true, max_episode=300, epsilon=0.01, 
                                    beta1=0.90, beta2=0.99)
            ``` 
            === "QFIM"
                ``` jl
                # objective function: QFI
                obj = QuanEstimation.QFIM_obj() 
                # input the dynamics data
                dynamics = QuanEstimation.Lindblad(opt, tspan, H0, dH, Hc, decay=decay, 
                                                   dyn_method=:Expm) 
                # run the comprehensive optimization problem
                QuanEstimation.run(opt, alg, obj, dynamics; savefile=false)
                ```
            === "CFIM"
                ``` jl
                # objective function: CFI
                obj = QuanEstimation.CFIM_obj(M=M) 
                # input the dynamics data
                dynamics = QuanEstimation.Lindblad(opt, tspan, H0, dH, Hc, decay=decay, 
                                                   dyn_method=:Expm) 
                # run the comprehensive optimization problem
                QuanEstimation.run(opt, alg, obj, dynamics; savefile=false)
                ```
    === "CM"
        ``` jl
        opt = QuanEstimation.CMopt(ctrl_bound=[-2.0,2.0], seed=1234)
        ```
        === "DE"
            ``` jl
            # comprehensive optimization algorithm: DE
            alg = QuanEstimation.DE(p_num=10, max_episode=1000, c=1.0, cr=0.5)  
            # objective function: CFI
            obj = QuanEstimation.CFIM_obj(M=M) 
            # input the dynamics data
            dynamics = QuanEstimation.Lindblad(opt, tspan, rho0, H0, dH, Hc,   
                                               decay=decay, dyn_method=:Expm) 
            # run the comprehensive optimization problem
            QuanEstimation.run(opt, alg, obj, dynamics; savefile=false)
            # convert the flattened data into a list of matrix
            M_ = readdlm("measurements.csv",'\t', Complex{Float64})
            M = [[reshape(M_[i,:], dim, dim) for i in 1:M_num] 
                for j in 1:Int(length(M_[:,1])/M_num)][end]
            ```
        === "PSO"
            ``` jl
            # comprehensive optimization algorithm: PSO
            alg = QuanEstimation.PSO(p_num=10, max_episode=[1000,100], c0=1.0, 
                                     c1=2.0, c2=2.0)
            # objective function: CFI
            obj = QuanEstimation.CFIM_obj(M=M) 
            # input the dynamics data
            dynamics = QuanEstimation.Lindblad(opt, tspan, rho0, H0, dH, Hc,  
                                               decay=decay, dyn_method=:Expm)  
            # run the comprehensive optimization problem
            QuanEstimation.run(opt, alg, obj, dynamics; savefile=false)
            # convert the flattened data into a list of matrix
            M_ = readdlm("measurements.csv",'\t', Complex{Float64})
            M = [[reshape(M_[i,:], dim, dim) for i in 1:M_num] 
                for j in 1:Int(length(M_[:,1])/M_num)][end]
            ```
    === "SCM"
        ``` jl
        opt = QuanEstimation.SCMopt(ctrl_bound=[-2.0,2.0], seed=1234)
        ```
        === "DE"
            ``` jl
            # comprehensive optimization algorithm: DE
            alg = QuanEstimation.DE(p_num=10, max_episode=1000, c=1.0, cr=0.5) 
            # objective function: CFI
            obj = QuanEstimation.CFIM_obj(M=M) 
            # input the dynamics data
            dynamics = QuanEstimation.Lindblad(opt, tspan, H0, dH, Hc, decay=decay, 
                                               dyn_method=:Expm)  
            # run the comprehensive optimization problem
            QuanEstimation.run(opt, alg, obj, dynamics; savefile=false)
            # convert the flattened data into a list of matrix
            M_ = readdlm("measurements.csv",'\t', Complex{Float64})
            M = [[reshape(M_[i,:], dim, dim) for i in 1:M_num] 
                for j in 1:Int(length(M_[:,1])/M_num)][end]
            ```
        === "PSO"
            ``` jl
            # comprehensive optimization algorithm: PSO
            alg = QuanEstimation.PSO(p_num=10, max_episode=[1000,100], c0=1.0, 
                                     c1=2.0, c2=2.0) 
            # objective function: CFI
            obj = QuanEstimation.CFIM_obj(M=M)
            # input the dynamics data
            dynamics = QuanEstimation.Lindblad(opt, tspan, H0, dH, Hc, decay=decay, 
                                               dyn_method=:Expm)  
            # run the comprehensive optimization problem
            QuanEstimation.run(opt, alg, obj, dynamics; savefile=false)
            # convert the flattened data into a list of matrix
            M_ = readdlm("measurements.csv",'\t', Complex{Float64})
            M = [[reshape(M_[i,:], dim, dim) for i in 1:M_num] 
                for j in 1:Int(length(M_[:,1])/M_num)][end]
            ```
**Example 8.2**  
<a id="example8_2"></a>
The Hamiltonian of a controlled system can be written as
\begin{align}
H = H_0(\textbf{x})+\sum_{k=1}^K u_k(t) H_k,
\end{align}

where $H_0(\textbf{x})$ is the free evolution Hamiltonian with unknown parameters $\textbf{x}$ and $H_k$ 
represents the $k$th control Hamiltonian with $u_k$ the correspong control coefficient.

In the multiparameter scenario, the dynamics of electron and nuclear coupling in NV$^{-}$ can be expressed as
\begin{align}
\partial_t\rho=-i[H_0+H_{\mathrm{c}},\rho]+\frac{\gamma}{2}(S_3\rho S_3-S^2_3\rho-\rho S^2_3)
\end{align}

with $\gamma$ the dephasing rate. And
\begin{align}
H_0/\hbar=DS^2_3+g_{\mathrm{S}}\vec{B}\cdot\vec{S}+g_{\mathrm{I}}\vec{B}\cdot\vec{I}+\vec{S}^{\,\mathrm{T}}\mathcal{A}\vec{I}
\end{align}

is the free evolution Hamiltonian, where $\vec{S}=(S_1,S_2,S_3)^{\mathrm{T}}$ and $\vec{I}=(I_1,I_2,I_3)^{\mathrm{T}}$ with 
$S_i=s_i\otimes I$ and $I_i=I\otimes \sigma_i$ ($i=1,2,3$) the electron and nuclear operators. $\mathcal{A}=\mathrm{diag}
(A_1,A_1,A_2)$ is the hyperfine tensor with $A_1$ and $A_2$ the axial and transverse magnetic hyperfine coupling coefficients.
The coefficients $g_{\mathrm{S}}=g_\mathrm{e}\mu_\mathrm{B}/\hbar$ and $g_{\mathrm{I}}=g_\mathrm{n}\mu_\mathrm{n}/\hbar$, 
where $g_\mathrm{e}$ ($g_\mathrm{n}$) is the $g$ factor of the electron (nuclear), $\mu_\mathrm{B}$ ($\mu_\mathrm{n}$) is the Bohr (nuclear) magneton, and $\hbar$ is the Plank's constant. $\vec{B}$ is the magnetic field which be estimated. The control Hamiltonian is
\begin{align}
H_{\mathrm{c}}/\hbar=\sum^3_{i=1}\Omega_i(t)S_i
\end{align}

with $\Omega_i(t)$ the time-dependent Rabi frequency.

In this case, the initial state is taken as $\frac{1}{\sqrt{2}}(|1\rangle+|\!-\!1\rangle)\otimes|\!\!\uparrow\rangle$, 
where $\frac{1}{\sqrt{2}}(|1\rangle+|\!-\!1\rangle)$ is an electron state with $|1\rangle$ $(|\!-\!1\rangle)$ the 
eigenstate of $s_3$ with respect to the eigenvalue $1$ ($-1$). $|\!\!\uparrow\rangle$ is a nuclear state and 
the eigenstate of $\sigma_3$ with respect to the eigenvalue 1. $W$ is set to be identity.
=== "Python"
    ``` py
    from quanestimation import *
    import numpy as np

    # initial state
    rho0 = np.zeros((6, 6), dtype=np.complex128)
    rho0[0][0], rho0[0][4], rho0[4][0], rho0[4][4] = 0.5, 0.5, 0.5, 0.5
    # free Hamiltonian
    sx = np.array([[0., 1.],[1., 0.]])
	sy = np.array([[0., -1.j],[1.j, 0.]]) 
	sz = np.array([[1., 0.],[0., -1.]])
	ide2 = np.array([[1., 0.],[0., 1.]])
	s1 = np.array([[0., 1., 0.],[1., 0., 1.],[0., 1., 0.]])/np.sqrt(2)
	s2 = np.array([[0., -1.j, 0.],[1.j, 0., -1.j],[0., 1.j, 0.]])/np.sqrt(2)
	s3 = np.array([[1., 0., 0.],[0., 0., 0.],[0., 0., -1.]])
	ide3 = np.array([[1., 0., 0.],[0., 1., 0.],[0., 0., 1.]])
	I1, I2, I3 = np.kron(ide3, sx), np.kron(ide3, sy), np.kron(ide3, sz)
	S1, S2, S3 = np.kron(s1, ide2), np.kron(s2, ide2), np.kron(s3, ide2)
	B1, B2, B3 = 5.0e-4, 5.0e-4, 5.0e-4
    # All numbers are divided by 100 in this example 
    # for better calculation accurancy
    cons = 100
	D = (2*np.pi*2.87*1000)/cons
	gS = (2*np.pi*28.03*1000)/cons
	gI = (2*np.pi*4.32)/cons
	A1 = (2*np.pi*3.65)/cons
	A2 = (2*np.pi*3.03)/cons
	H0 = D*np.kron(np.dot(s3, s3), ide2) + gS*(B1*S1+B2*S2+B3*S3) \
		 + gI*(B1*I1+B2*I2+B3*I3) + A1*(np.kron(s1, sx) + np.kron(s2, sy)) \
		 + A2*np.kron(s3, sz)
    # derivatives of the free Hamiltonian on B1, B2, and B3
    dH = [gS*S1+gI*I1, gS*S2+gI*I2, gS*S3+gI*I3]
    # control Hamiltonians 
    Hc = [S1, S2, S3]
    # dissipation
    decay = [[S3,2*np.pi/cons]]  
    # measurement
    dim = len(rho0)
    M_num = dim
    M = [np.dot(basis(dim, i), basis(dim, i).conj().T) for i in range(dim)]
    # time length for the evolution
    tspan = np.linspace(0., 2., 4000)
    # guessed control coefficients
    cnum = 10
    ctrl0 = -0.2*np.ones((len(Hc), cnum))
    ```
    === "SM"
        === "DE"
            ``` py
            # comprehensive optimization algorithm: DE
            DE_paras = {"p_num":10, "psi0":[], "ctrl0":[], "measurement0":[], \
                        "max_episode":1000, "c":1.0, "cr":0.5, "seed":1234}
            com = ComprehensiveOpt(savefile=False, method="DE", **DE_paras)
            com.dynamics(tspan, H0, dH, decay=decay, dyn_method="expm")
            com.SM()
            # convert the ".csv" file to the ".npy" file
            M_ = np.loadtxt("measurements.csv", dtype=np.complex128)
            csv2npy_measurements(M_, M_num)
            # load the measurements
            M = np.load("measurements.npy")[-1]
            ```
        === "PSO"
            ``` py
            # comprehensive optimization algorithm: PSO
            PSO_paras = {"p_num":10, "psi0":[], "ctrl0":[], \
                         "measurement0":[], "max_episode":[1000,100], "c0":1.0, \
                         "c1":2.0, "c2":2.0, "seed":1234}
            com = ComprehensiveOpt(savefile=False, method="PSO", **PSO_paras)
            com.dynamics(tspan, H0, dH, decay=decay, dyn_method="expm")
            com.SM()
            # convert the ".csv" file to the ".npy" file
            M_ = np.loadtxt("measurements.csv", dtype=np.complex128)
            csv2npy_measurements(M_, M_num)
            # load the measurements
            M = np.load("measurements.npy")[-1]
            ```
    === "SC"
        === "DE"
            ``` py
            # comprehensive optimization algorithm: DE
            DE_paras = {"p_num":10, "psi0":[], "ctrl0":[], "measurement0":[], \
                        "max_episode":1000, "c":1.0, "cr":0.5, "seed":1234}
            com = ComprehensiveOpt(savefile=False, method="DE", **DE_paras)
            com.dynamics(tspan, H0, dH, Hc=Hc, decay=decay, ctrl=[ctrl0], \
                         ctrl_bound=[-0.2,0.2], dyn_method="expm")
            ```
            === "QFIM"
                ``` py
                # objective function: tr(WF^{-1})
                com.SC(W=[], target="QFIM", LDtype="SLD")
                ```
            === "CFIM"
                ``` py
                # objective function: tr(WI^{-1})
                com.SC(W=[], M=M, target="CFIM")
                ```
            === "HCRB"
                ``` py
                # objective function: HCRB
                com.SC(W=[], target="HCRB")
                ```
        === "PSO"
            ``` py
            # comprehensive optimization algorithm: PSO
            PSO_paras = {"p_num":10, "psi0":[], "ctrl0":[], \
                         "measurement0":[], "max_episode":[1000,100], "c0":1.0, \
                         "c1":2.0, "c2":2.0, "seed":1234}
            com = ComprehensiveOpt(savefile=False, method="PSO", **PSO_paras)
            com.dynamics(tspan, H0, dH, Hc=Hc, decay=decay, ctrl=[ctrl0], \
                         ctrl_bound=[-0.2,0.2], dyn_method="expm")
            ```
            === "QFIM"
                ``` py
                # objective function: tr(WF^{-1})
                com.SC(W=[], target="QFIM", LDtype="SLD")
                ```
            === "CFIM"
                ``` py
                # objective function: tr(WI^{-1})
                com.SC(W=[], M=M, target="CFIM")
                ```
            === "HCRB"
                ``` py
                # objective function: HCRB
                com.SC(W=[], target="HCRB")
                ```
        === "AD"
            ``` py
            # comprehensive optimization algorithm: AD
            AD_paras = {"Adam":False, "psi0":[], "ctrl0":[], "measurement0":[], \
                        "max_episode":300, "epsilon":0.01, "beta1":0.90, "beta2":0.99}
            com = ComprehensiveOpt(savefile=False, method="AD", **AD_paras)
            com.dynamics(tspan, H0, dH, Hc=Hc, decay=decay, ctrl=[ctrl0], \
                         ctrl_bound=[-0.2,0.2], dyn_method="expm")
            ```
            === "QFIM"
                ``` py
                # objective function: tr(WF^{-1})
                com.SC(W=[], target="QFIM", LDtype="SLD")
                ```
            === "CFIM"
                ``` py
                # objective function: tr(WI^{-1})
                com.SC(W=[], M=M, target="CFIM")
                ```
    === "CM"
        === "DE"
            ``` py
            # comprehensive optimization algorithm: DE
            DE_paras = {"p_num":10, "psi0":[], "ctrl0":[], "measurement0":[], \
                        "max_episode":1000, "c":1.0, "cr":0.5, "seed":1234}
            com = ComprehensiveOpt(savefile=False, method="DE", **DE_paras)
            com.dynamics(tspan, H0, dH, Hc=Hc, decay=decay, ctrl_bound=[-0.2,0.2], \
                         dyn_method="expm")
            com.CM(rho0)
            # convert the ".csv" file to the ".npy" file
            M_ = np.loadtxt("measurements.csv", dtype=np.complex128)
            csv2npy_measurements(M_, M_num)
            # load the measurements
            M = np.load("measurements.npy")[-1]
            ```
        === "PSO"
            ``` py
            # comprehensive optimization algorithm: PSO
            PSO_paras = {"p_num":10, "psi0":[], "ctrl0":[], \
                         "measurement0":[], "max_episode":[1000,100], "c0":1.0, \
                         "c1":2.0, "c2":2.0, "seed":1234}
            com = ComprehensiveOpt(savefile=False, method="PSO", **PSO_paras)
            com.dynamics(tspan, H0, dH, Hc=Hc, decay=decay, ctrl_bound=[-0.2,0.2], \  
                         dyn_method="expm")
            com.CM(rho0)
            # convert the ".csv" file to the ".npy" file
            M_ = np.loadtxt("measurements.csv", dtype=np.complex128)
            csv2npy_measurements(M_, M_num)
            # load the measurements
            M = np.load("measurements.npy")[-1]
            ```
    === "SCM"
        === "DE"
            ``` py
            # comprehensive optimization algorithm: DE
            DE_paras = {"p_num":10, "psi0":[], "ctrl0":[], "measurement0":[], \
                        "max_episode":1000, "c":1.0, "cr":0.5, "seed":1234}
            com = ComprehensiveOpt(savefile=False, method="DE", **DE_paras)
            com.dynamics(tspan, H0, dH, Hc=Hc, decay=decay, ctrl_bound=[-0.2,0.2], \
                         dyn_method="expm")
            com.SCM()
            # convert the ".csv" file to the ".npy" file
            M_ = np.loadtxt("measurements.csv", dtype=np.complex128)
            csv2npy_measurements(M_, M_num)
            # load the measurements
            M = np.load("measurements.npy")[-1]
            ```
        === "PSO"
            ``` py
            # comprehensive optimization algorithm: PSO
            PSO_paras = {"p_num":10, "psi0":[], "ctrl0":[], \
                         "measurement0":[], "max_episode":[1000,100], "c0":1.0, \
                         "c1":2.0, "c2":2.0, "seed":1234}
            com = ComprehensiveOpt(savefile=False, method="PSO", **PSO_paras)
            com.dynamics(tspan, H0, dH, Hc=Hc, decay=decay, ctrl_bound=[-0.2,0.2], \
                         dyn_method="expm")
            com.SCM()
            # convert the ".csv" file to the ".npy" file
            M_ = np.loadtxt("measurements.csv", dtype=np.complex128)
            csv2npy_measurements(M_, M_num)
            # load the measurements
            M = np.load("measurements.npy")[-1]
            ```
=== "Julia"
    ``` jl
    using QuanEstimation
    using LinearAlgebra
    using DelimitedFiles

    # initial state
    rho0 = zeros(ComplexF64, 6, 6)
    rho0[1:4:5, 1:4:5] .= 0.5
    # free Hamiltonian
    sx = [0. 1.; 1. 0.]
	sy = [0. -im; im 0.]
	sz = [1. 0.; 0. -1.]
	s1 = [0. 1. 0.; 1. 0. 1.; 0. 1. 0.]/sqrt(2)
	s2 = [0. -im 0.; im 0. -im; 0. im 0.]/sqrt(2)
	s3 = [1. 0. 0.; 0. 0. 0.; 0. 0. -1.]
	Is = I1, I2, I3 = [kron(I(3), sx), kron(I(3), sy), kron(I(3), sz)]
	S = S1, S2, S3 = [kron(s1, I(2)), kron(s2, I(2)), kron(s3, I(2))]
	B = B1, B2, B3 = [5.0e-4, 5.0e-4, 5.0e-4]
    # All numbers are divided by 100 in this example 
    # for better calculation accurancy
    cons = 100
	D = (2pi*2.87*1000)/cons
	gS = (2pi*28.03*1000)/cons
	gI = (2pi*4.32)/cons
	A1 = (2pi*3.65)/cons
	A2 = (2pi*3.03)/cons
	H0 = sum([D*kron(s3^2, I(2)), sum(gS*B.*S), sum(gI*B.*Is),
          	  A1*(kron(s1, sx) + kron(s2, sy)), A2*kron(s3, sz)])
    # derivatives of the free Hamiltonian on B1, B2 and B3
    dH = gS*S+gI*Is
    # control Hamiltonians 
    Hc = [S1, S2, S3]
    # dissipation
    decay = [[S3, 2pi/cons]]
    # measurement
    dim = size(rho0, 1)
    M_num = dim
    M = [QuanEstimation.basis(dim, i)*QuanEstimation.basis(dim, i)' 
         for i in 1:dim]
    # time length for the evolution
    tspan = range(0., 2., length=4000)
    # guessed control coefficients
    cnum = 10
    ctrl = -0.2*ones((length(Hc), cnum))
    # guessed measurements
    C = [QuanEstimation.basis(dim, i) for i in 1:dim]
    ```
    === "SM"
        ``` jl
        opt = QuanEstimation.SMopt(seed=1234)
        ```
        === "DE"
            ``` jl
            # comprehensive optimization algorithm: DE
            alg = QuanEstimation.DE(p_num=10, max_episode=1000, c=1.0, cr=0.5)
            # objective function: CFI
            obj = QuanEstimation.CFIM_obj(M=M) 
            # input the dynamics data
            dynamics = QuanEstimation.Lindblad(opt, tspan, H0, dH, decay=decay, 
                                               dyn_method=:Expm)   
            # run the comprehensive optimization problem
            QuanEstimation.run(opt, alg, obj, dynamics; savefile=false)
            # convert the flattened data into a list of matrix
            M_ = readdlm("measurements.csv",'\t', Complex{Float64})
            M = [[reshape(M_[i,:], dim, dim) for i in 1:M_num] 
                for j in 1:Int(length(M_[:,1])/M_num)][end]
            ```
        === "PSO"
            ``` jl
            # comprehensive optimization algorithm: PSO
            alg = QuanEstimation.PSO(p_num=10, max_episode=[1000,100], c0=1.0, 
                                     c1=2.0, c2=2.0) 
            # objective function: CFI
            obj = QuanEstimation.CFIM_obj(M=M) 
            # input the dynamics data
            dynamics = QuanEstimation.Lindblad(opt, tspan, H0, dH, decay=decay, 
                                               dyn_method=:Expm) 
            # run the comprehensive optimization problem
            QuanEstimation.run(opt, alg, obj, dynamics; savefile=false)
            # convert the flattened data into a list of matrix
            M_ = readdlm("measurements.csv",'\t', Complex{Float64})
            M = [[reshape(M_[i,:], dim, dim) for i in 1:M_num] 
                for j in 1:Int(length(M_[:,1])/M_num)][end]
            ```
    === "SC"
        ``` jl
        opt = QuanEstimation.SCopt(ctrl_bound=[-0.2,0.2], seed=1234)
        ```
        === "DE"
            ``` jl
            # comprehensive optimization algorithm: DE
            alg = QuanEstimation.DE(p_num=10, max_episode=1000, c=1.0, cr=0.5)
            ```
            === "QFIM"
                ``` jl
                # objective function: tr(WF^{-1})
                obj = QuanEstimation.QFIM_obj() 
                # input the dynamics data
                dynamics = QuanEstimation.Lindblad(opt, tspan, H0, dH, Hc, decay=decay, 
                                                   dyn_method=:Expm) 
                # run the comprehensive optimization problem
                QuanEstimation.run(opt, alg, obj, dynamics; savefile=false)
                ```
            === "CFIM"
                ``` jl
                # objective function: tr(WI^{-1})
                obj = QuanEstimation.CFIM_obj(M=M) 
                # input the dynamics data
                dynamics = QuanEstimation.Lindblad(opt, tspan, H0, dH, Hc, decay=decay, 
                                                   dyn_method=:Expm) 
                # run the comprehensive optimization problem
                QuanEstimation.run(opt, alg, obj, dynamics; savefile=false)
                ```
            === "HCRB"
                ``` jl
                # objective function: HCRB
                obj = QuanEstimation.HCRB_obj() 
                # input the dynamics data
                dynamics = QuanEstimation.Lindblad(opt, tspan, H0, dH, Hc, decay=decay, 
                                                   dyn_method=:Expm) 
                # run the comprehensive optimization problem
                QuanEstimation.run(opt, alg, obj, dynamics; savefile=false)
                ```
        === "PSO"
            ``` jl
            # comprehensive optimization algorithm: PSO
            alg = QuanEstimation.PSO(p_num=10, max_episode=[1000,100], c0=1.0, 
                                     c1=2.0, c2=2.0) 
            ```
            === "QFIM"
                ``` jl
                # objective function: tr(WF^{-1})
                obj = QuanEstimation.QFIM_obj() 
                # input the dynamics data
                dynamics = QuanEstimation.Lindblad(opt, tspan, H0, dH, Hc, decay=decay, 
                                                   dyn_method=:Expm)
                # run the comprehensive optimization problem
                QuanEstimation.run(opt, alg, obj, dynamics; savefile=false)
                ```
            === "CFIM"
                ``` jl
                # objective function: tr(WI^{-1})
                obj = QuanEstimation.CFIM_obj(M=M) 
                # input the dynamics data
                dynamics = QuanEstimation.Lindblad(opt, tspan, H0, dH, Hc, decay=decay, 
                                                   dyn_method=:Expm)
                # run the comprehensive optimization problem
                QuanEstimation.run(opt, alg, obj, dynamics; savefile=false)
                ```
            === "HCRB"
                ``` jl
                # objective function: HCRB
                obj = QuanEstimation.HCRB_obj() 
                # input the dynamics data
                dynamics = QuanEstimation.Lindblad(opt, tspan, H0, dH, Hc, decay=decay, 
                                                   dyn_method=:Expm)
                # run the comprehensive optimization problem
                QuanEstimation.run(opt, alg, obj, dynamics; savefile=false)
                ```
        === "AD"
            ``` jl
            # comprehensive optimization algorithm: AD
            alg = QuanEstimation.AD(Adam=true, max_episode=300, epsilon=0.01, 
                                    beta1=0.90, beta2=0.99)
            ``` 
            === "QFIM"
                ``` jl
                # objective function: tr(WF^{-1})
                obj = QuanEstimation.QFIM_obj()
                # input the dynamics data
                dynamics = QuanEstimation.Lindblad(opt, tspan, H0, dH, Hc, decay=decay, 
                                                   dyn_method=:Expm) 
                # run the comprehensive optimization problem
                QuanEstimation.run(opt, alg, obj, dynamics; savefile=false) 
                ```
            === "CFIM"
                ``` jl
                # objective function: tr(WI^{-1})
                obj = QuanEstimation.CFIM_obj(M=M) 
                # input the dynamics data
                dynamics = QuanEstimation.Lindblad(opt, tspan, H0, dH, Hc, decay=decay, 
                                                   dyn_method=:Expm) 
                # run the comprehensive optimization problem
                QuanEstimation.run(opt, alg, obj, dynamics; savefile=false)
                ```
    === "CM"
        ``` jl
        opt = QuanEstimation.CMopt(seed=1234)
        ```
        === "DE"
            ``` jl
            # comprehensive optimization algorithm: DE
            alg = QuanEstimation.DE(p_num=10, max_episode=1000, c=1.0, cr=0.5)
            # objective function: CFI
            obj = QuanEstimation.CFIM_obj()
            # input the dynamics data
            dynamics = QuanEstimation.Lindblad(opt, tspan, rho0, H0, dH, Hc,  
                                               decay=decay, dyn_method=:Expm)    
            # run the comprehensive optimization problem
            QuanEstimation.run(opt, alg, obj, dynamics; savefile=false)
            # convert the flattened data into a list of matrix
            M_ = readdlm("measurements.csv",'\t', Complex{Float64})
            M = [[reshape(M_[i,:], dim, dim) for i in 1:M_num] 
                for j in 1:Int(length(M_[:,1])/M_num)][end]
            ```
        === "PSO"
            ``` jl
            # comprehensive optimization algorithm: PSO
            alg = QuanEstimation.PSO(p_num=10, max_episode=[1000,100], c0=1.0, 
                                     c1=2.0, c2=2.0)
            # objective function: CFI
            obj = QuanEstimation.CFIM_obj() 
            # input the dynamics data
            dynamics = QuanEstimation.Lindblad(opt, tspan, rho0, H0, dH, Hc, 
                                               decay=decay, dyn_method=:Expm)  
            # run the comprehensive optimization problem
            QuanEstimation.run(opt, alg, obj, dynamics; savefile=false)
            # convert the flattened data into a list of matrix
            M_ = readdlm("measurements.csv",'\t', Complex{Float64})
            M = [[reshape(M_[i,:], dim, dim) for i in 1:M_num] 
                for j in 1:Int(length(M_[:,1])/M_num)][end]
            ```
    === "SCM"
        ``` jl
        opt = QuanEstimation.SCMopt(seed=1234)
        ```
        === "DE"
            ``` jl
            # comprehensive optimization algorithm: DE
            alg = QuanEstimation.DE(p_num=10, max_episode=1000, c=1.0, cr=0.5)
            # objective function: CFI
            obj = QuanEstimation.CFIM_obj() 
            # input the dynamics data
            dynamics = QuanEstimation.Lindblad(opt, tspan, H0, dH, Hc, decay=decay, 
                                               dyn_method=:Expm)   
            # run the comprehensive optimization problem
            QuanEstimation.run(opt, alg, obj, dynamics; savefile=false)
            # convert the flattened data into a list of matrix
            M_ = readdlm("measurements.csv",'\t', Complex{Float64})
            M = [[reshape(M_[i,:], dim, dim) for i in 1:M_num] 
                for j in 1:Int(length(M_[:,1])/M_num)][end]
            ```
        === "PSO"
            ``` jl
            # comprehensive optimization algorithm: PSO
            alg = QuanEstimation.PSO(p_num=10, max_episode=[1000,100], c0=1.0, 
                                     c1=2.0, c2=2.0)
            # objective function: CFI
            obj = QuanEstimation.CFIM_obj() 
            # input the dynamics data
            dynamics = QuanEstimation.Lindblad(opt, tspan, H0, dH, Hc, decay=decay, 
                                               dyn_method=:Expm)   
            # run the comprehensive optimization problem
            QuanEstimation.run(opt, alg, obj, dynamics; savefile=false)
            # convert the flattened data into a list of matrix
            M_ = readdlm("measurements.csv",'\t', Complex{Float64})
            M = [[reshape(M_[i,:], dim, dim) for i in 1:M_num] 
                for j in 1:Int(length(M_[:,1])/M_num)][end]
            ```
For optimization of probe state and measurement, the parameterization can also be implemented 
with the Kraus operators which can be realized by
=== "Python"
    ``` py
    com = ComprehensiveOpt(savefile=False, method="DE", **kwargs)
    com.Kraus(K, dK)
    com.SM(W=[])
    ```
=== "Julia"
    ``` jl
    opt = SMopt(psi=psi, M=M, seed=1234)
    alg = DE(kwargs...)
    dynamics = Kraus(opt, K, dK) 
    obj = CFIM_obj(W=missing)
    run(opt, alg, obj, dynamics; savefile=false)
    ```
where `K` and `dK` are the Kraus operators and its derivatives with respect to the 
unknown parameters.

**Example 8.3**  
The Kraus operators for the amplitude damping channel are

\begin{eqnarray}
K_1 = \left(\begin{array}{cc}
1 & 0  \\
0 & \sqrt{1-\gamma}
\end{array}\right),
K_2 = \left(\begin{array}{cc}
0 & \sqrt{\gamma} \\
0 & 0
\end{array}\right), \nonumber
\end{eqnarray}

where $\gamma$ is the unknown parameter to be estimated which represents the decay 
probability. In this example, the probe state is taken as $|+\rangle\langle+|$ with 
$|+\rangle=\frac{1}{\sqrt{2}}(|0\rangle+|1\rangle)$. Here $|0\rangle$ $(|1\rangle)$ is 
the eigenstate of $\sigma_3$ (Pauli matrix) with respect to the eigenvalue $1$ $(-1)$.

=== "Python"
    ``` py
    from quanestimation import *
    import numpy as np

    # initial state
    rho0 = 0.5*np.array([[1., 1.], [1., 1.]])
    # Kraus operators for the amplitude damping channel
    gamma = 0.1
    K1 = np.array([[1., 0.], [0., np.sqrt(1-gamma)]])
    K2 = np.array([[0., np.sqrt(gamma)], [0., 0.]])
    K = [K1, K2]
    # derivatives of Kraus operators on gamma
    dK1 = np.array([[1., 0.], [0., -0.5/np.sqrt(1-gamma)]])
    dK2 = np.array([[0., 0.5/np.sqrt(gamma)], [0., 0.]])
    dK = [[dK1], [dK2]]
    ```
    === "DE"
        ``` py
        # comprehensive optimization algorithm: DE
        DE_paras = {"p_num":10, "psi0":[], "ctrl0":[], "measurement0":[], \
                    "max_episode":1000, "c":1.0, "cr":0.5, "seed":1234}
        com = ComprehensiveOpt(savefile=False, method="DE", **DE_paras)
        com.Kraus(K, dK)
        com.SM()
        # convert the ".csv" file to the ".npy" file
        M_ = np.loadtxt("measurements.csv", dtype=np.complex128)
        csv2npy_measurements(M_, 2)
        # load the measurements
        M = np.load("measurements.npy")[-1]
        ```
    === "PSO"
        ``` py
        # comprehensive optimization algorithm: PSO
        PSO_paras = {"p_num":10, "psi0":[], "ctrl0":[], \
                     "measurement0":[], "max_episode":[1000,100], "c0":1.0, \
                     "c1":2.0, "c2":2.0, "seed":1234}
        com = ComprehensiveOpt(savefile=False, method="PSO", **PSO_paras)
        com.Kraus(K, dK)
        com.SM()
        # convert the ".csv" file to the ".npy" file
        M_ = np.loadtxt("measurements.csv", dtype=np.complex128)
        csv2npy_measurements(M_, 2)
        # load the measurements
        M = np.load("measurements.npy")[-1]
        ```
=== "Julia"
    ``` jl
    using QuanEstimation
    using DelimitedFiles

    # initial state
    rho0 = 0.5*ones(2, 2)
    # Kraus operators for the amplitude damping channel
    gamma = 0.1
    K1 = [1. 0.; 0. sqrt(1-gamma)]
    K2 = [0. sqrt(gamma); 0. 0.]
    K = [K1, K2]
    # derivatives of Kraus operators on gamma
    dK1 = [1. 0.; 0. -0.5/sqrt(1-gamma)]
    dK2 = [0. 0.5/sqrt(gamma); 0. 0.]
    dK = [[dK1], [dK2]]
    # comprehensive optimization 
    M_num = 2
    opt = QuanEstimation.SMopt(seed=1234)
    ```
    === "DE"
        ``` jl
        # comprehensive optimization algorithm: DE
        alg = QuanEstimation.DE(p_num=10, max_episode=1000, c=1.0, cr=0.5)
        # objective function: CFI
        obj = QuanEstimation.CFIM_obj() 
        # input the dynamics data
        dynamics = QuanEstimation.Kraus(opt, K, dK)  
        # run the comprehensive optimization problem
        QuanEstimation.run(opt, alg, obj, dynamics; savefile=false)
        # convert the flattened data into a list of matrix
        M_ = readdlm("measurements.csv",'\t', Complex{Float64})
        M = [[reshape(M_[i,:], dim, dim) for i in 1:M_num] 
            for j in 1:Int(length(M_[:,1])/M_num)][end]
        ```
    === "PSO"
        ``` jl
        # comprehensive optimization algorithm: PSO
        alg = QuanEstimation.PSO(p_num=10, max_episode=[1000,100], c0=1.0, 
                                     c1=2.0, c2=2.0)
        # objective function: CFI
        obj = QuanEstimation.CFIM_obj() 
        # input the dynamics data
        dynamics = QuanEstimation.Kraus(opt, K, dK)   
        # run the comprehensive optimization problem
        QuanEstimation.run(opt, alg, obj, dynamics; savefile=false)
        # convert the flattened data into a list of matrix
        M_ = readdlm("measurements.csv",'\t', Complex{Float64})
        M = [[reshape(M_[i,:], dim, dim) for i in 1:M_num] 
            for j in 1:Int(length(M_[:,1])/M_num)][end]
        ```
---
## **Bibliography**
<a id="Kennedy1995">[1]</a>
J. Kennedy and R. Eberhar,
Particle swarm optimization,
[Proc. 1995 IEEE International Conference on Neural Networks **4**, 1942-1948 (1995).
](https://doi.org/10.1109/ICNN.1995.488968)

<a id="Storn1997">[2]</a>
R. Storn and K. Price,
Differential Evolution-A Simple and Efficient Heuristic for global
Optimization over Continuous Spaces,
[J. Global Optim. **11**, 341 (1997).](https://doi.org/10.1023/A:1008202821328)

<a id="Baydin2018">[3]</a>
A. G. Baydin, B. A. Pearlmutter, A. A. Radul, and J. M. Siskind,
Automatic differentiation in machine learning: a survey,
[J. Mach. Learn. Res. **18**, 1-43 (2018).](http://jmlr.org/papers/v18/17-468.html)

# **Installation**
Run the command in the terminal to install QuanEstimation:  
=== "Python"
    ```
    pip install quanestimation
    ```
    The users can also run 
    ```
    git clone https://github.com/QuanEstimation/QuanEstimation.git
    ```
    to install the latest development version of QuanEstimation from Github.

=== "Julia"
    ``` jl
    import Pkg
    Pkg.add("QuanEstimation")
    ```
    If the users want to install the package via a Julia mirror, please 
    click [here](https://mirror.tuna.tsinghua.edu.cn/help/julia/) for usage.

---

# **Requirements**
QuanEstimation requires several open-source packages in Python and Julia. The versions 
of Python and Julia should be above 3.10 and 1.10, respectively.
## **Python packages**
| $~~~~~~~~~~~$Package$~~~~~~~$| Version      |
| :----------:                 | :----------: |
| numpy                        | >=1.22       |
| sympy                        | >=1.10       |
| scipy                        | >=1.8        |
| cvxpy                        | >=1.2        |
| more-itertools               | >=8.12.0     |

## **Julia packages**
| $~~~~~~~~~~~~~~~~$Package$~~~~~~~~~~~~$| Version     |$~~~~~~~~~~~~~~~~$Package$~~~~~~~~~~~~$| Version     |
| :----------:                           | :---------: |:----------:                           | :---------: |
| LinearAlgebra                          | --          |BoundaryValueDiffEq                    | 2.7.2       |
| Zygote                                 | 0.6.37      |SCS                                    | 0.8.1       |
| Convex                                 | 0.14.18     |Trapz                                  | 2.0.3       |
| ReinforcementLearning                  | 0.10.0      |Interpolations                         | 0.13.5      |
| IntervalSets                           | 0.5.4       |SparseArrays                           | --          |
| Flux                                   | 0.12.4      |DelimitedFiles                         | --          |
| StatsBase                              | 0.33.16     |Random                                 | --          |
| Printf                                 | --          |StableRNGs                             | --          |
| Distributions                          | --          |QuadGK                                 | --          |
| DifferentialEquations                          | --          |                                   |             |

The version information of the packages without the version number is the same with the 
corresponding packages in Julia 1.10. Besides, the version information of the full Julia package 
is also the same as the table above. All of these packages will be automatically installed when
the users install QuanEstimation.

# Examples 

### Calculate Fisher information and quantum Fisher information 
The example is discussed in [Example 3.1](./guide/guide_bounds.md#example3_1) 
and [Example 3.4](./guide/guide_bounds.md#example3_4) in quantum metrological tools.  
[CramerRao_bounds.ipynb](examples/Python examples/CramerRao_bounds.ipynb)  
[CramerRao_bounds.jl](examples/Julia examples/CramerRao_bounds.jl) 

### Calculate Fisher information matrix, quantum Fisher information matrix, Holevo Cramér-Rao bound and Nagaoka-Hayashi bound
The example is discussed in detail in [Example 3.7](./guide/guide_bounds.md#example3_7) 
in quantum metrological tools.  
[HCRB_NHB.ipynb](examples/Python examples/HCRB_NHB.ipynb)  
[HCRB_NHB.jl](examples/Julia examples/HCRB_NHB.jl)  

### Calculate Bayesian Cramér-Rao bounds
The example is discussed in detail in [Example 3.8](./guide/guide_bounds.md#example3_8) 
in quantum metrological tools.  
[Bayesian_CramerRao_bounds.ipynb](examples/Python examples/Bayesian_CramerRao_bounds.ipynb)  
[Bayesian_CramerRao_bounds.jl](examples/Julia examples/Bayesian_CramerRao_bounds.jl)  

### Bayesian estimation
The example is discussed in detail in [Example 3.9](./guide/guide_bounds.md#example3_9) 
in quantum metrological tools.   
[Bayesian_estimation.ipynb](examples/Python examples/Bayesian_estimation.ipynb)  
[Bayesian_estimation.jl](examples/Julia examples/Bayesian_estimation.jl)  

### Control optimization in single qubit system (single parameter)
The example is discussed in detail in [Example 5.1](./guide/guide_bounds.md#example5_1) 
in control optimization.  
[control_optimization_NV.ipynb](examples/Python examples/control_optimization_NV.ipynb)  
[control_optimization_NV.jl](examples/Julia examples/control_optimization_NV.jl)  

### Control optimization in nitrogen-vacancy center in diamond (multiparameter) 
The example is discussed in detail in [Example 5.2](./guide/guide_bounds.md#example5_2) 
in control optimization.  
[control_optimization_qubit.ipynb](examples/Python examples/control_optimization_qubit.ipynb)  
[control_optimization_qubit.jl](examples/Julia examples/control_optimization_qubit.jl)  
 
### State optimization in Lipkin–Meshkov–Glick model (single parameter) 
The example is discussed in detail in [Example 6.1](./guide/guide_bounds.md#example6_1) 
in state optimization.  
[state_optimization_LMG1.ipynb](examples/Python examples/state_optimization_LMG1.ipynb)  
[state_optimization_LMG1.jl](examples/Julia examples/state_optimization_LMG1.jl)  

### State optimization in Lipkin–Meshkov–Glick model (multiparameter) 
The example is discussed in detail in [Example 6.2](./guide/guide_bounds.md#example6_2) 
in state optimization.  
[state_optimization_LMG2.ipynb](examples/Python examples/state_optimization_LMG2.ipynb)  
[state_optimization_LMG2.jl](examples/Julia examples/state_optimization_LMG2.jl) 

### Measurement optimization in single qubit system (single parameter) 
The example is discussed in detail in [Example 7.2](./guide/guide_bounds.md#example7_2) 
in measurement optimization.  
[measurement_optimization_qubit.ipynb](examples/Python examples/measurement_optimization_qubit.ipynb)  
[measurement_optimization_qubit.jl](examples/Julia examples/measurement_optimization_projection_qubit.jl)  

### Measurement optimization in nitrogen-vacancy center in diamond (multiparameter) 
The example is discussed in detail in [Example 7.3](./guide/guide_bounds.md#example7_3) 
in measurement optimization.  
[measurement_optimization_NV.ipynb](examples/Python examples/measurement_optimization_NV.ipynb)  
[measurement_optimization_NV.jl](examples/Julia examples/measurement_optimization_projection_NV.jl)  

### Comprehensive optimization in single qubit system (single parameter) 
The example is discussed in detail in [Example 8.1](./guide/guide_bounds.md#example8_1) 
in comprehensive optimization.  
[comprehensive_optimization_qubit.ipynb](examples/Python examples/comprehensive_optimization_qubit.ipynb)  
[comprehensive_optimization_qubit.jl](examples/Julia examples/SCMopt_qubit.jl) 


### Comprehensive optimization in nitrogen-vacancy center in diamond (multiparameter) 
The example is discussed in detail in [Example 8.2](./guide/guide_bounds.md#example8_2) 
in comprehensive optimization.  
[comprehensive_optimization_NV.ipynb](examples/Python examples/comprehensive_optimization_NV.ipynb)  
[comprehensive_optimization_NV.jl](examples/Julia examples/SCMopt_NV.jl)

---

# **Measurement optimization**
In QuanEstimation, three measurement optimization scenarios are considered. The first one
is to optimize a set of rank-one projective measurement, it can be written in a specific
basis $\{|\phi_i\rangle\}$ with $|\phi_i\rangle=\sum_j C_{ij}|j\rangle$ in the Hilbert space 
as $\{|\phi_i\rangle\langle\phi_i|\}$. In this case, the goal is to search a set of optimal 
coefficients $C_{ij}$. The second scenario is to find the optimal linear combination of 
an input measurement $\{\Pi_j\}$. The third scenario is to find the optimal rotated 
measurement of an input measurement. After rotation, the new measurement is
$\{U\Pi_i U^{\dagger}\}$, where $U=\prod_k \exp(i s_k\lambda_k)$ with $\lambda_k$ a SU($N$) 
generator and $s_k$ a real number in the regime $[0,2\pi]$. In this scenario, the goal is 
to search a set of optimal coefficients $s_k$. Here different algorithms are invoked to 
search the optimal measurement include particle swarm optimization (PSO) [[1]](#Kennedy1995), 
differential evolution (DE) [[2]](#Storn1997), and automatic differentiation (AD) 
[[3]](#Baydin2018). The codes for execute measurement optimization are
=== "Python"
    ``` py
    m = MeasurementOpt(mtype="projection", minput=[], savefile=False, 
                       method="DE", **kwargs)
    m.dynamics(tspan, rho0, H0, dH, Hc=[], ctrl=[], decay=[], \
               dyn_method="expm")
    m.CFIM(W=[])
    ```
    `mtype` represents the type of measurement optimization which defaults to `"projection"`. 
    In this setting, rank-one projective measurement optimization will be performed `minput` 
    will keep empty in this scenario. For the other two measurement optimization scenarios 
    `mtype="input"`. If the users want to find the optimal linear combination of an input 
    measurement, the variable `minput` should be input as `minput=["LC", [Pi1,Pi2,...], m]` 
    with `[Pi1,Pi2,...]` a set of POVM and `m` the number of operators of the output 
    measurement. For finding the optimal linear combination of an input measurement, the 
    variable `minput` becomes `minput=["rotation", [Pi1,Pi2,...]]`. `savefile` means whether 
    to save all the measurements. If set `False` the measurements in the final episode and 
    the values of the objective function in all episodes will be saved, if `savefile=True` 
    the measurements and the values of the objective function obtained in all episodes will 
    be saved during the training. `method` represents the algorithm used to optimize the 
    measurements, options are: "PSO", "DE" and "AD". `**kwargs` is the keyword and default 
    value corresponding to the optimization algorithm which will be introduced in detail 
    below.

    If the dynamics of the system can be described by the master equation, then the dynamics data 
    `tspan`, `rho0`, `H0` and `dH` shoule be input. `tspan` is the time length for the evolution, 
    `rho0` represents the density matrix of the initial state, `H0` and `dH` are the free 
    Hamiltonian and its derivatives on the unknown parameters to be estimated. `H0` is a matrix 
    when the free Hamiltonian is time-independent and a list of matrices with the length equal to 
    `tspan` when it is time-dependent. `dH` should be input as $[\partial_a{H_0}, \partial_b{H_0}, \cdots]$. 
    `Hc` and `ctrl` are two lists represent the control Hamiltonians and the corresponding control 
    coefficients. `decay` contains decay operators $(\Gamma_1,\Gamma_2, \cdots)$ and the 
    corresponding decay rates $(\gamma_1, \gamma_2, \cdots)$ with the input rule 
    decay=[[$\Gamma_1$, $\gamma_1$], [$\Gamma_2$, $\gamma_2$],...]. The default values for `decay`, 
    `Hc` and `ctrl` are empty which means the dynamics is unitary and only governed by the free 
    Hamiltonian. `dyn_method="expm"` represents the method for solving the dynamics is 
    matrix exponential, it can also be set as `dyn_method="ode"` which means the dynamics 
    (differential equation) is directly solved with the ODE solvers.

    The objective function for measurement optimization are CFI and $\mathrm{Tr}(W\mathcal{I}^
    {-1})$ with $\mathcal{I}$ the CFIM. $W$ corresponds to `W` in the objective function is the 
    weight matrix which defaults to the identity matrix.

=== "Julia"
    ``` jl
    opt = MeasurementOpt(mtype=:Projection, seed=1234)
    alg = DE(kwargs...)
    dynamics = Lindblad(opt, tspan, rho0, H0, dH; Hc=missing, 
                        ctrl=missing, decay=missing, dyn_method=:Expm)
    obj = CFIM_obj(W=missing)
    run(opt, alg, obj, dynamics; savefile=false)
    ```
    `mtype` represents the type of measurement optimization which defaults to `"Projection"`. 
    In this setting, rank-one projective measurement optimization will be performed. For the other 
    two measurement optimization scenarios this variable becomes `mtype="LC"` and `mtype="Rotation"`. 
    If the users want to find the optimal linear combination of an input measurement, the input 
    rule of `opt` is `MeasurementOpt(mtype=:LC,POVM_basis=[Pi1,Pi2,...],M_num=m)` with 
    `[Pi1,Pi2,...]` a set of POVM and `m` the number of operators of the output measurement. 
    For finding the optimal linear combination of an input measurement, the code `opt` is 
    `MeasurementOpt(mtype=:LC,POVM_basis=[Pi1,Pi2,...])`.  `seed` is the random seed which can 
    ensure the reproducibility of results.
    
    If the dynamics of the system can be described by the master equation, then the dynamics data 
    `tspan`, `rho0`, `H0` and `dH` shoule be input. `tspan` is the time length for the evolution, 
    `rho0` represents the density matrix of the initial state, `H0` and `dH` are the free 
    Hamiltonian and its derivatives on the unknown parameters to be estimated. `H0` is a matrix 
    when the free Hamiltonian is time-independent and a list of matrices with the length equal to 
    `tspan` when it is time-dependent. `dH` should be input as $[\partial_a{H_0}, \partial_b{H_0}, \cdots]$. 
    `Hc` and `ctrl` are two lists represent the control Hamiltonians and the corresponding control 
    coefficients. `decay` contains decay operators $(\Gamma_1,\Gamma_2, \cdots)$ and the 
    corresponding decay rates $(\gamma_1, \gamma_2, \cdots)$ with the input rule 
    decay=[[$\Gamma_1$, $\gamma_1$], [$\Gamma_2$, $\gamma_2$],...]. The default values for `decay`, 
    `Hc` and `ctrl` are `missing` which means the dynamics is unitary and only governed by the free 
    Hamiltonian. `dyn_method=:Expm` represents the method for solving the dynamics is 
    matrix exponential, it can also be set as `dyn_method=:Ode` which means the dynamics 
    (differential equation) is directly solved with the ODE solvers.

    The objective function for measurement optimization are CFI and $\mathrm{Tr}(W\mathcal{I}^
    {-1})$ with $\mathcal{I}$ the CFIM. $W$ corresponds to `W` in the objective function is the 
    weight matrix which defaults to the identity matrix. The variable `savefile` means whether to 
    save all the measurements. If set `false` the measurements in the final episode and the values 
    of the objective function in all episodes will be saved, if `savefile=true` the measurements 
    and the values of the objective function obtained in all episodes will be saved during the 
    training. The algorithm used for optimizing the measurements are PSO, DE and AD. `kwargs...` 
    is the keywords and default values corresponding to the optimization algorithm which will be 
    introduced in detail below.

---
## **PSO**
The code for measurement optimization with PSO is as follows
=== "Python"
    ``` py
    m = MeasurementOpt(method="PSO", **kwargs)
    ```
    where `kwargs` is of the form
    ``` py
    kwargs = {"p_num":10, "measurement0":[], "max_episode":[1000,100], \ 
              "c0":1.0, "c1":2.0, "c2":2.0, "seed":1234}
    ```
    The keywords and the default values of PSO can be seen in the following table

    | $~~~~~~~~~~$**kwargs$~~~~~~~~~~$ | $~~~~$default values$~~~~$ |
    | :----------:                     | :----------:               |
    | "p_num"                          | 10                         |
    | "measurement0"                   | [ ]                        |
    | "max_episode"                    | [1000,100]                 |
    | "c0"                             | 1.0                        |
    | "c1"                             | 2.0                        |
    | "c2"                             | 2.0                        |
    | "seed"                           | 1234                       |

    `p_num` is the number of particles, `c0`, `c1` and `c2` are the PSO parameters 
    representing the inertia weight, cognitive learning factor and social learning factor, 
    respectively. `max_episode` accepts both integers and arrays with two elements. If it is 
    an integer, for example `max_episode=1000`, it means the program will continuously run 
    1000 episodes. However, if it is an array, for example `max_episode=[1000,100]`, the 
    program will run 1000 episodes in total but replace control coefficients of all the 
    particles with global best every 100 episodes. `seed` is the random seed which can 
    ensure the reproducibility of the results. `measurement0` in the algorithm is a list 
    representing the initial guesses of measurements. In the case of projective measurement 
    optimization, the entry of `measurement0` is a list of arrays with the length equal to 
    the dimension of the system. In the cases of finding the optimal linear combination and 
    the optimal rotation of a given set of measurement, the entry of `measurement0` is a 
    2D-array and array, respectively. Here, an example of generating `measurement0` is given 
    as follows
    
    **Example 7.1**
    === "projection"
        ``` py
        from quanestimation import *
        import numpy as np

        # the dimension of the system
        dim = 6
        # generation of the entry of `measurement0`
        C = [[] for i in range(dim)] 
        for i in range(dim):
            r_ini = 2*np.random.random(dim)-np.ones(dim)
            r = r_ini/np.linalg.norm(r_ini)
            phi = 2*np.pi*np.random.random(dim)
            C[i] = [r[j]*np.exp(1.0j*phi[j]) for j in range(dim)]
        C = np.array(gramschmidt(C))
        measurement0 = [C]
        ```
    === "LC"
        ``` py
        from quanestimation import *
        import numpy as np

        # the dimension of the system
        dim = 6
        # a given set of measurement
        POVM_basis = SIC(dim)
        # the number of operators of the output measurement
        m = 4
        # generation of the entry of `measurement0`
        B = np.array([np.random.random(len(POVM_basis)) for i in range(m)])
        measurement0 = [B]
        ```
    === "rotation"
        ``` py
        from quanestimation import *
        import numpy as np

        # the dimension of the system
        dim = 6
        # a given set of measurement
        POVM_basis = SIC(dim)
        # generation of the entry of `measurement0`
        s = np.random.random(dim**2)
        measurement0 = [s]
        ```
    In this algorithm, the length of `measurement0` should be less than or equal to `p_num`.
=== "Julia"
    ``` jl
    alg = PSO(p_num=10, ini_particle=missing, max_episode=[1000,100], 
              c0=1.0, c1=2.0, c2=2.0)
    ```
    The keywords and the default values of PSO can be seen in the following table

    | $~~~~~~~~~~$keywords$~~~~~~~~~~$ | $~~~~$default values$~~~~$ |
    | :----------:                     | :----------:               |
    | "p_num"                          | 10                         |
    | "ini_particle"                   | missing                    |
    | "max_episode"                    | [1000,100]                 |
    | "c0"                             | 1.0                        |
    | "c1"                             | 2.0                        |
    | "c2"                             | 2.0                        |

    `p_num` is the number of particles, `c0`, `c1`, and `c2` are the PSO parameters representing 
    the inertia weight, cognitive learning factor, and social learning factor, respectively. 
    `max_episode` accepts both integers and arrays with two elements. If it is an integer, 
    for example `max_episode=1000`, it means the program will continuously run 1000 episodes. 
    However, if it is an array, for example `max_episode=[1000,100]`, the program will run 1000 
    episodes in total but replace control coefficients of all the particles with global best 
    every 100 episodes. `ini_particle` in the algorithm is a list representing the initial guesses 
    of measurements, In the case of projective measurement optimization, the entry of `ini_particle` 
    is a list of arrays with the length equal to the dimension of the system. In the cases of 
    finding the optimal linear combination and the optimal rotation of a given set of measurement, 
    the entry of `ini_particle` is a 2D-array and array, respectively. Here, an example of 
    generating `ini_particle` is given as follows

    **Example 7.1**
    === "Projection"
        ``` jl
        using QuanEstimation

        # the dimension of the system
        dim = 6
        # generation of the entry of `measurement0`
        C = [ComplexF64[] for _ in 1:dim]
		for i in 1:dim
			r_ini = 2*rand(dim) - ones(dim)
			r = r_ini/norm(r_ini)
			ϕ = 2pi*rand(dim)
			C[i] = [r*exp(im*ϕ) for (r,ϕ) in zip(r,ϕ)] 
		end
        C = QuanEstimation.gramschmidt(C)
        measurement0 = ([C],)
        ```
    === "LC"
        ``` jl
        using QuanEstimation

        # the dimension of the system
        dim = 6
        # a given set of measurement
        POVM_basis = QuanEstimation.SIC(dim)
        # the number of operators of the output measurement
        m = 4
        # generation of the entry of `measurement0`
        B = [rand(length(POVM_basis)) for _ in 1:m]
        measurement0 = ([B],)
        ```
    === "Rotation"
        ``` jl
        using QuanEstimation

        # the dimension of the system
        dim = 6
        # a given set of measurement
        POVM_basis = QuanEstimation.SIC(dim)
        # generation of the entry of `measurement0`
        s = rand(dim^2)
        measurement0 = ([s],)
        ```
    In this algorithm, the length of `measurement0` should be less than or equal to `p_num`.

## **DE**
The code for measurement optimization with DE is as follows
=== "Python"
    ``` py
    m = MeasurementOpt(method="DE", **kwargs)
    ```
    where `kwargs` is of the form
    ``` py
    kwargs = {"p_num":10, "measurement0":[], "max_episode":1000, \
              "c":1.0, "cr":0.5, "seed":1234}
    ```
    The keywords and the default values of DE can be seen in the following table

    | $~~~~~~~~~~$**kwargs$~~~~~~~~~~$ | $~~~~$default values$~~~~$ |
    | :----------:                     | :----------:               |
    | "p_num"                        | 10                         |
    | "measurement0"                   | [ ]                        |
    | "max_episode"                    | 1000                       |
    | "c"                              | 1.0                        |
    | "cr"                             | 0.5                        |
    | "seed"                           | 1234                       |

    `p_num` represents the number of populations, `c` and `cr` are the mutation constant and the 
    crossover constant. Here `max_episode` is an integer representing the number of episodes, 
    the variable `measurement0` is the same with `measurement0` in PSO.
=== "Julia"
    ``` jl
    alg = DE(p_num=10, ini_population=missing, max_episode=1000, 
             c=1.0, cr=0.5)
    ```
        The keywords and the default values of DE can be seen in the following table

    | $~~~~~~~~~~$keywords$~~~~~~~~~~$ | $~~~~$default values$~~~~$ |
    | :----------:                     | :----------:               |
    | "p_num"                          | 10                         |
    | "ini_population"                 | [ ]                        |
    | "max_episode"                    | 1000                       |
    | "c"                              | 1.0                        |
    | "cr"                             | 0.5                        |

    `p_num` represents the number of populations, `c` and `cr` are the mutation constant 
    and the crossover constant. Here `max_episode` is an integer representing the number of 
    episodes, the variable `ini_population` is the same with `ini_particle` in PSO.

## **AD**
The code for measurement optimization with AD is as follows
=== "Python"
    ``` py
    com = MeasurementOpt(method="AD", **kwargs)
    ```
    where `kwargs` is of the form
    ``` py
    kwargs = {"Adam":False, "measurement0":[], "max_episode":300, \ 
              "epsilon":0.01, "beta1":0.90, "beta2":0.99}
    ```
    The keywords and the default values of AD can be seen in the following 
    table

    | $~~~~~~~~~~$**kwargs$~~~~~~~~~~$ | $~~~~$default values$~~~~$ |
    | :----------:                     | :----------:               |
    | "Adam"                           | False                      |
    | "measurement0"                   | [ ]                        |
    | "max_episode"                    | 300                        |
    | "epsilon"                        | 0.01                       |
    | "beta1"                          | 0.90                       |
    | "beta2"                          | 0.99                       |

    The measurements will update according to the learning rate `"epsilon"` for `Adam=False`, 
    However,  Adam algorithm can be introduced to update the measurements which can be realized by 
    setting `Adam=True`. In this case, the Adam parameters include learning rate, the exponential 
    decay rate for the first moment estimates, and the second moment estimates can be set by the 
    user via `epsilon`, `beta1`, and `beta2`. The input rule of `measurement0` is the same with 
    that in PSO, but the length of `measurement0` is equal to one.
=== "Julia"
    ``` jl
    alg = AD(Adam=false, max_episode=300, epsilon=0.01, beta1=0.90, 
             beta2=0.99)
    ```
    The keywords and the default values of AD can be seen in the following 
    table

    | $~~~~~~~~~~$keywords$~~~~~~~~~~$ | $~~~~$default values$~~~~$ |
    | :----------:                     | :----------:               |
    | "Adam"                           | false                      |
    | "max_episode"                    | 300                        |
    | "epsilon"                        | 0.01                       |
    | "beta1"                          | 0.90                       |
    | "beta2"                          | 0.99                       |

    The measurements will update according to the learning rate `"epsilon"` for `Adam=False`, 
    However,  Adam algorithm can be introduced to update the measurements which can be realized by 
    setting `Adam=true`. In this case, the Adam parameters include learning rate, the exponential 
    decay rate for the first moment estimates, and the second moment estimates can be set by the 
    user via `epsilon`, `beta1`, and `beta2`.

**Example 7.2**  
<a id="example7_2"></a>
A single qubit system whose dynamics is governed by

\begin{align}
\partial_t\rho=-i[H, \rho]+ \gamma_{+}\left(\sigma_{+}\rho\sigma_{-}-\frac{1}{2}\{\sigma_{-}
\sigma_{+},\rho\}\right)+ \gamma_{-}\left(\sigma_{-}\rho\sigma_{+}-\frac{1}{2}\{\sigma_{+}
\sigma_{-},\rho\}\right),
\end{align}


where $H = \frac{1}{2}\omega \sigma_3$ is the free Hamiltonian with $\omega$ the frequency, 
$\sigma_{\pm}=(\sigma_1 \pm \sigma_2)/2$ and $\gamma_{+}$, $\gamma_{-}$ are decay rates.
Here $\sigma_{i}$ for $(i=1,2,3)$ is the  Pauli matrix.

In this case, the probe state is taken as $\frac{1}{\sqrt{2}}(|0\rangle +|1\rangle)$, 
$|0\rangle$ $(|1\rangle)$ is the eigenstate of $\sigma_3$ with respect to the eigenvalue 
$1$ $(-1)$. 
=== "Python"
    ``` py
    from quanestimation import *
    import numpy as np

    # initial state
    rho0 = 0.5*np.array([[1., 1.], [1., 1.]])
    # free Hamiltonian
    omega = 1.0
    sx = np.array([[0., 1.], [1., 0.]])
	sy = np.array([[0., -1.j], [1.j, 0.]]) 
	sz = np.array([[1., 0.], [0., -1.]])
    H0 = 0.5*omega*sz
    # derivative of the free Hamiltonian on omega
    dH = [0.5*sz]
    # dissipation
    sp = np.array([[0., 1.], [0., 0.]])  
	sm = np.array([[0., 0.], [1., 0.]]) 
	decay = [[sp, 0.], [sm, 0.1]]
    # generation of a set of POVM basis
    dim = np.shape(rho0)[0]
    POVM_basis = SIC(dim)
    # time length for the evolution
    tspan = np.linspace(0., 10., 2500)
    ```
    === "projection"
        === "DE"
		    ``` py
            M_num = dim
            # measurement optimization algorithm: DE
		    DE_paras = {"p_num":10, "measurement0":[], "max_episode":1000, \
                        "c":1.0, "cr":0.5, "seed":1234}
		    m = MeasurementOpt(mtype="projection", minput=[], savefile=False, \
                               method="DE", **DE_paras)
		    ```
        === "PSO"
		    ``` py
            M_num = dim
            # measurement optimization algorithm: PSO
		    PSO_paras = {"p_num":10, "measurement0":[], \
                         "max_episode":[1000,100], "c0":1.0, \
					    "c1":2.0, "c2":2.0, "seed":1234}
		    m = MeasurementOpt(mtype="projection", minput=[], savefile=False, \
                               method="PSO", **PSO_paras)
		    ```
    === "LC"
        === "DE"
		    ``` py
            M_num = 2
            # measurement optimization algorithm: DE
		    DE_paras = {"p_num":10, "measurement0":[], "max_episode":1000, \
				        "c":1.0, "cr":0.5, "seed":1234}
		    m = MeasurementOpt(mtype="input", minput=["LC", POVM_basis, M_num], \
                               savefile=False, method="DE", **DE_paras)
		    ```
        === "PSO"
		    ``` py
            M_num = 2
            # measurement optimization algorithm: PSO
		    PSO_paras = {"p_num":10, "measurement0":[], "max_episode":[1000,100], \
					     "c0":1.0, "c1":2.0, "c2":2.0, "seed":1234}
		    m = MeasurementOpt(mtype="input", minput=["LC", POVM_basis, M_num], \
                               savefile=False, method="PSO", **PSO_paras)
		    ```
        === "AD"
		    ``` py
            M_num = 2
            # measurement optimization algorithm: AD
		    AD_paras = {"Adam":False, "measurement0":[], "max_episode":300, \
                        "epsilon":0.01, "beta1":0.90, "beta2":0.99}
            m = MeasurementOpt(mtype="input", minput=["LC", POVM_basis, M_num], \
                               savefile=False, method="AD", **AD_paras)
		    ```
    === "rotation"
        === "DE"
		    ``` py
            M_num = dim
            # measurement optimization algorithm: DE
		    DE_paras = {"p_num":10, "measurement0":[], "max_episode":1000, \
                        "c":1.0, "cr":0.5, "seed":1234}
		    m = MeasurementOpt(mtype="input", minput=["rotation", POVM_basis], \
                               savefile=False, method="DE", **DE_paras)
		    ```
        === "PSO"
		    ``` py
            M_num = dim
            # measurement optimization algorithm: PSO
		    PSO_paras = {"p_num":10, "measurement0":[], \
                         "max_episode":[1000,100], "c0":1.0, \
					     "c1":2.0, "c2":2.0, "seed":1234}
		    m = MeasurementOpt(mtype="input", minput=["rotation", POVM_basis], \
                               savefile=False, method="PSO", **PSO_paras)
		    ```
        === "AD"
		    ``` py
            M_num = dim
            # measurement optimization algorithm: AD
		    AD_paras = {"Adam":False, "measurement0":[], "max_episode":300, \
                        "epsilon":0.01, "beta1":0.90, "beta2":0.99}
            m = MeasurementOpt(mtype="input", minput=["rotation", POVM_basis], \
                               savefile=False, method="AD", **AD_paras)
		    ```
    ``` py
    # input the dynamics data
    m.dynamics(tspan, rho0, H0, dH, decay=decay, dyn_method="expm")
    # objective function: CFI
    m.CFIM()
    # convert the ".csv" file to the ".npy" file
    M_ = np.loadtxt("measurements.csv", dtype=np.complex128)
    csv2npy_measurements(M_, M_num)
    # load the measurements
    M = np.load("measurements.npy")[-1]
    ```
=== "Julia"
    ``` jl
    using QuanEstimation
    using Random
    using StableRNGs
    using LinearAlgebra
    using DelimitedFiles

    # initial state
    rho0 = 0.5*ones(2, 2)
    # free Hamiltonian
    omega = 1.0
    sx = [0. 1.; 1. 0.0im]
	sy = [0. -im; im 0.]
	sz = [1. 0.0im; 0. -1.]
    H0 = 0.5*omega*sz
    # derivative of the free Hamiltonian on omega
    dH = [0.5*sz]
    # dissipation
    sp = [0. 1.; 0. 0.0im]
	sm = [0. 0.; 1. 0.0im]
    decay = [[sp, 0.], [sm, 0.1]]
    # generation of a set of POVM basis
    dim = size(rho0, 1)
    POVM_basis = QuanEstimation.SIC(dim)
    M_num = dim
    # time length for the evolution
    tspan = range(0., 10., length=2500)
    ```
    === "Projection"
        ``` jl
        opt = QuanEstimation.MeasurementOpt(mtype=:Projection, seed=1234)
        ```
        === "DE"
            ``` jl
            # measurement optimization algorithm: DE
            alg = QuanEstimation.DE(p_num=10, ini_population=missing, 
                                    max_episode=1000, c=1.0, cr=0.5)
            ```
        === "PSO"
            ``` jl
            # measurement optimization algorithm: PSO
            alg = QuanEstimation.PSO(p_num=10, ini_particle=missing, 
                                     max_episode=[1000,100], c0=1.0, c1=2.0, 
                                     c2=2.0)
            ```
    === "LC"
        ``` jl
        opt = QuanEstimation.MeasurementOpt(mtype=:LC, 
                                            POVM_basis=POVM_basis, M_num=M_num, 
                                            seed=1234)
        ```
        === "DE"
            ``` jl
            # measurement optimization algorithm: DE
            alg = QuanEstimation.DE(p_num=10, ini_population=missing, 
                                    max_episode=1000, c=1.0, cr=0.5)
            ```
        === "PSO"
            ``` jl
            # measurement optimization algorithm: PSO
            alg = QuanEstimation.PSO(p_num=10, ini_particle=missing, 
                                     max_episode=[1000,100], c0=1.0, c1=2.0, 
                                     c2=2.0)
            ```
        === "AD"
            ``` jl
            # measurement optimization algorithm: AD
            alg = QuanEstimation.AD(Adam=true, max_episode=300, epsilon=0.01, 
                                    beta1=0.90, beta2=0.99)
            ```
    === "Rotation"
        ``` jl
        opt = QuanEstimation.MeasurementOpt(mtype=:Rotation, 
                                            POVM_basis=POVM_basis, seed=1234)
        ```
        === "DE"
            ``` jl
            # measurement optimization algorithm: DE
            alg = QuanEstimation.DE(p_num=10, ini_population=missing, 
                                    max_episode=1000, c=1.0, cr=0.5)
            ```
        === "PSO"
            ``` jl
            # measurement optimization algorithm: PSO
            alg = QuanEstimation.PSO(p_num=10, ini_particle=missing, 
                                     max_episode=[1000,100], c0=1.0, c1=2.0, 
                                     c2=2.0)
            ```
        === "AD"
            ``` jl
            # measurement optimization algorithm: AD
            alg = QuanEstimation.AD(Adam=true, max_episode=300, epsilon=0.01, 
                                    beta1=0.90, beta2=0.99)
            ```
    ``` jl
    # input the dynamics data
    dynamics = QuanEstimation.Lindblad(opt, tspan ,rho0, H0, dH, 
                                       decay=decay, dyn_method=:Expm)
    # objective function: CFI
    obj = QuanEstimation.CFIM_obj()
    # run the measurement optimization problem
    QuanEstimation.run(opt, alg, obj, dynamics; savefile=false)

    # convert the flattened data into a list of matrix
    M_ = readdlm("measurements.csv",'\t', Complex{Float64})
    M = [[reshape(M_[i,:], dim, dim) for i in 1:M_num] 
        for j in 1:Int(length(M_[:,1])/M_num)][end]
    ```

**Example 7.3**  
<a id="example7_3"></a>
In the multiparameter scenario, the dynamics of electron and nuclear coupling in NV$^{-}$ can be expressed as
\begin{align}
\partial_t\rho=-i[H_0,\rho]+\frac{\gamma}{2}(S_3\rho S_3-S^2_3\rho-\rho S^2_3)
\end{align}

with $\gamma$ the dephasing rate. And
\begin{align}
H_0/\hbar=DS^2_3+g_{\mathrm{S}}\vec{B}\cdot\vec{S}+g_{\mathrm{I}}\vec{B}\cdot\vec{I}+\vec{S}^{\,\mathrm{T}}\mathcal{A}\vec{I}
\end{align}

is the free evolution Hamiltonian, where $\vec{S}=(S_1,S_2,S_3)^{\mathrm{T}}$ and $\vec{I}=(I_1,I_2,I_3)^{\mathrm{T}}$ 
with $S_i=s_i\otimes I$ and $I_i=I\otimes \sigma_i$ $(i=1,2,3)$ the electron and nuclear operators. 
$s_1, s_2, s_3$ are spin-1 operators with 

\begin{eqnarray}
s_1 = \frac{1}{\sqrt{2}}\left(\begin{array}{ccc}
0 & 1 & 0 \\
1 & 0 & 1 \\
0 & 1 & 0
\end{array}\right),
s_2 = \frac{1}{\sqrt{2}}\left(\begin{array}{ccc}
0 & -i & 0\\
i & 0 & -i\\
0 & i & 0
\end{array}\right), \nonumber
\end{eqnarray}

and $s_3=\mathrm{diag}(1,0,-1)$ and $\sigma_i (i=1,2,3)$ is Pauli matrix. $\mathcal{A}=\mathrm{diag}
(A_1,A_1,A_2)$ is the hyperfine tensor with $A_1$ and $A_2$ the axial and transverse magnetic hyperfine coupling coefficients.
The coefficients $g_{\mathrm{S}}=g_\mathrm{e}\mu_\mathrm{B}/\hbar$ and $g_{\mathrm{I}}=g_\mathrm{n}\mu_\mathrm{n}/\hbar$, 
where $g_\mathrm{e}$ ($g_\mathrm{n}$) is the $g$ factor of the electron (nuclear), $\mu_\mathrm{B}$ ($\mu_\mathrm{n}$) is 
the Bohr (nuclear) magneton and $\hbar$ is the Plank's constant. $\vec{B}$ is the magnetic field which be estimated.

In this case,the initial state is taken as $\frac{1}{\sqrt{2}}(|1\rangle+|\!-\!1\rangle)\otimes|\!\!\uparrow\rangle$, 
where $\frac{1}{\sqrt{2}}(|1\rangle+|\!-\!1\rangle)$ is an electron state with $|1\rangle$ ($|\!-\!1\rangle$) the 
eigenstate of $s_3$ with respect to the eigenvalue $1$ ($-1$). $|\!\!\uparrow\rangle$ is a nuclear state and 
the eigenstate of $\sigma_3$ with respect to the eigenvalue 1. $W$ is set to be $I$.

Here three types of measurement optimization are considerd, projective measurement, linear combination of a given set of positive operator-valued measure (POVM) and optimal rotated measurement of an input measurement.
=== "Python"
    ``` py
    from quanestimation import *
    import numpy as np

    # initial state
    rho0 = np.zeros((6, 6), dtype=np.complex128)
    rho0[0][0], rho0[0][4], rho0[4][0], rho0[4][4] = 0.5, 0.5, 0.5, 0.5
    # free Hamiltonian
    sx = np.array([[0., 1.],[1., 0.]])
	sy = np.array([[0., -1.j],[1.j, 0.]]) 
	sz = np.array([[1., 0.],[0., -1.]])
	ide2 = np.array([[1., 0.],[0., 1.]])
	s1 = np.array([[0., 1., 0.],[1., 0., 1.],[0., 1., 0.]])/np.sqrt(2)
	s2 = np.array([[0., -1.j, 0.],[1.j, 0., -1.j],[0., 1.j, 0.]])/np.sqrt(2)
	s3 = np.array([[1., 0., 0.],[0., 0., 0.],[0., 0., -1.]])
	ide3 = np.array([[1., 0., 0.],[0., 1., 0.],[0., 0., 1.]])
	I1, I2, I3 = np.kron(ide3, sx), np.kron(ide3, sy), np.kron(ide3, sz)
	S1, S2, S3 = np.kron(s1, ide2), np.kron(s2, ide2), np.kron(s3, ide2)
	B1, B2, B3 = 5.0e-4, 5.0e-4, 5.0e-4
    # All numbers are divided by 100 in this example 
    # for better calculation accurancy
    cons = 100
	D = (2*np.pi*2.87*1000)/cons
	gS = (2*np.pi*28.03*1000)/cons
	gI = (2*np.pi*4.32)/cons
	A1 = (2*np.pi*3.65)/cons
	A2 = (2*np.pi*3.03)/cons
	H0 = D*np.kron(np.dot(s3, s3), ide2) + gS*(B1*S1+B2*S2+B3*S3) \
		 + gI*(B1*I1+B2*I2+B3*I3) + A1*(np.kron(s1, sx) + np.kron(s2, sy)) \
		 + A2*np.kron(s3, sz)
    # derivatives of the free Hamiltonian on B1, B2, and B3
    dH = [gS*S1+gI*I1, gS*S2+gI*I2, gS*S3+gI*I3]
    # control Hamiltonians 
    Hc = [S1, S2, S3]
    # dissipation
    decay = [[S3,2*np.pi/cons]]
    # generation of a set of POVM basis
    dim = len(rho0)
    POVM_basis = [np.dot(basis(dim, i), basis(dim, i).conj().T) \
                  for i in range(dim)]
    # time length for the evolution
    tspan = np.linspace(0., 2., 4000)
    ```
    === "projection"
        === "DE"
		    ``` py
            M_num = dim
            # measurement optimization algorithm: DE
		    DE_paras = {"p_num":10, "measurement0":[], "max_episode":1000, \
                        "c":1.0, "cr":0.5, "seed":1234}
		    m = MeasurementOpt(mtype="projection", minput=[], savefile=False, \
                               method="DE", **DE_paras)
		    ```
        === "PSO"
		    ``` py
            M_num = dim
            # measurement optimization algorithm: PSO
		    PSO_paras = {"p_num":10, "measurement0":[], \
                         "max_episode":[1000,100], "c0":1.0, \
					    "c1":2.0, "c2":2.0, "seed":1234}
		    m = MeasurementOpt(mtype="projection", minput=[], savefile=False, \
                               method="PSO", **PSO_paras)
		    ```
    === "LC"
        === "DE"
		    ``` py
            M_num = 4
            # measurement optimization algorithm: DE
		    DE_paras = {"p_num":10, "measurement0":[], "max_episode":1000, \
				        "c":1.0, "cr":0.5, "seed":1234}
		    m = MeasurementOpt(mtype="input", minput=["LC", POVM_basis, M_num], \
                               savefile=False, method="DE", **DE_paras)
		    ```
        === "PSO"
		    ``` py
            M_num = 4
            # measurement optimization algorithm: PSO
		    PSO_paras = {"p_num":10, "measurement0":[], "max_episode":[1000,100], \
					     "c0":1.0, "c1":2.0, "c2":2.0, "seed":1234}
		    m = MeasurementOpt(mtype="input", minput=["LC", POVM_basis, M_num], \
                               savefile=False, method="PSO", **PSO_paras)
		    ```
        === "AD"
		    ``` py
            M_num = 4
            # measurement optimization algorithm: AD
		    AD_paras = {"Adam":False, "measurement0":[], "max_episode":300, \
                        "epsilon":0.01, "beta1":0.90, "beta2":0.99}
            m = MeasurementOpt(mtype="input", minput=["LC", POVM_basis, M_num], \
                               savefile=False, method="AD", **AD_paras)
		    ```
    === "rotation"
        === "DE"
		    ``` py
            M_num = dim
            # measurement optimization algorithm: DE
		    DE_paras = {"p_num":10, "measurement0":[], "max_episode":1000, \
                        "c":1.0, "cr":0.5, "seed":1234}
		    m = MeasurementOpt(mtype="input", minput=["rotation", POVM_basis], \
                               savefile=False, method="DE", **DE_paras)
		    ```
        === "PSO"
		    ``` py
            M_num = dim
            # measurement optimization algorithm: PSO
		    PSO_paras = {"p_num":10, "measurement0":[], \
                         "max_episode":[1000,100], "c0":1.0, \
					     "c1":2.0, "c2":2.0, "seed":1234}
		    m = MeasurementOpt(mtype="input", minput=["rotation", POVM_basis], \
                               savefile=False, method="PSO", **PSO_paras)
		    ```
        === "AD"
		    ``` py
            M_num = dim
            # measurement optimization algorithm: AD
		    AD_paras = {"Adam":False, "measurement0":[], "max_episode":300, \
                        "epsilon":0.01, "beta1":0.90, "beta2":0.99}
            m = MeasurementOpt(mtype="input", minput=["rotation", POVM_basis], \
                               savefile=False, method="AD", **AD_paras)
		    ```
    ``` py
    # input the dynamics data
    m.dynamics(tspan, rho0, H0, dH, decay=decay, dyn_method="expm")
    # objective function: tr(WI^{-1})
    m.CFIM()
    # convert the ".csv" file to the ".npy" file
    M_ = np.loadtxt("measurements.csv", dtype=np.complex128)
    csv2npy_measurements(M_, M_num)
    # load the measurements
    M = np.load("measurements.npy")[-1]
    ```
=== "Julia"
    ``` jl
    using QuanEstimation
    using Random
    using LinearAlgebra
    using DelimitedFiles

    # initial state
    rho0 = zeros(ComplexF64, 6, 6)
    rho0[1:4:5, 1:4:5] .= 0.5
    # Hamiltonian
    sx = [0. 1.; 1. 0.]
	sy = [0. -im; im 0.]
	sz = [1. 0.; 0. -1.]
	s1 = [0. 1. 0.; 1. 0. 1.; 0. 1. 0.]/sqrt(2)
	s2 = [0. -im 0.; im 0. -im; 0. im 0.]/sqrt(2)
	s3 = [1. 0. 0.; 0. 0. 0.; 0. 0. -1.]
	Is = I1, I2, I3 = [kron(I(3), sx), kron(I(3), sy), kron(I(3), sz)]
	S = S1, S2, S3 = [kron(s1, I(2)), kron(s2, I(2)), kron(s3, I(2))]
	B = B1, B2, B3 = [5.0e-4, 5.0e-4, 5.0e-4]
    # All numbers are divided by 100 in this example 
    # for better calculation accurancy
    cons = 100
	D = (2pi*2.87*1000)/cons
	gS = (2pi*28.03*1000)/cons
	gI = (2pi*4.32)/cons
	A1 = (2pi*3.65)/cons
	A2 = (2pi*3.03)/cons
	H0 = sum([D*kron(s3^2, I(2)), sum(gS*B.*S), sum(gI*B.*Is),
          	  A1*(kron(s1, sx) + kron(s2, sy)), A2*kron(s3, sz)])
    # derivatives of the free Hamiltonian on B1, B2 and B3
    dH = gS*S+gI*Is
    # control Hamiltonians 
    Hc = [S1, S2, S3]
    # dissipation
    decay = [[S3, 2pi/cons]]
    # generation of a set of POVM basis
    dim = size(rho0, 1)
    POVM_basis = [QuanEstimation.basis(dim, i)*QuanEstimation.basis(dim, i)' 
                  for i in 1:dim]
    # time length for the evolution
    tspan = range(0., 2., length=4000)
    ```
    === "Projection"
        ``` jl
        M_num = dim
        opt = QuanEstimation.MeasurementOpt(mtype=:Projection, seed=1234)
        ```
        === "DE"
            ``` jl
            # measurement optimization algorithm: DE
            alg = QuanEstimation.DE(p_num=10, ini_population=missing, 
                                    max_episode=1000, c=1.0, cr=0.5)
            ```
        === "PSO"
            ``` jl
            # measurement optimization algorithm: PSO
            alg = QuanEstimation.PSO(p_num=10, ini_particle=missing, 
                                     max_episode=[1000,100], c0=1.0, c1=2.0, 
                                     c2=2.0)
            ```
    === "LC"
        ``` jl
        M_num = 4
        opt = QuanEstimation.MeasurementOpt(mtype=:LC, 
                                            POVM_basis=POVM_basis, M_num=M_num, 
                                            seed=1234)
        ```
        === "DE"
            ``` jl
            # measurement optimization algorithm: DE
            alg = QuanEstimation.DE(p_num=10, ini_population=missing, 
                                    max_episode=1000, c=1.0, cr=0.5)
            ```
        === "PSO"
            ``` jl
            # measurement optimization algorithm: PSO
            alg = QuanEstimation.PSO(p_num=10, ini_particle=missing, 
                                     max_episode=[1000,100], c0=1.0, c1=2.0, 
                                     c2=2.0)
            ```
        === "AD"
            ``` jl
            # measurement optimization algorithm: AD
            alg = QuanEstimation.AD(Adam=true, max_episode=300, epsilon=0.01, 
                                    beta1=0.90, beta2=0.99)
            ```
    === "Rotation"
        ``` jl
        M_num = dim
        opt = QuanEstimation.MeasurementOpt(mtype=:Rotation, 
                                            POVM_basis=POVM_basis, seed=1234)
        ```
        === "DE"
            ``` jl
            # measurement optimization algorithm: DE
            alg = QuanEstimation.DE(p_num=10, ini_population=missing, 
                                    max_episode=1000, c=1.0, cr=0.5)
            ```
        === "PSO"
            ``` jl
            # measurement optimization algorithm: PSO
            alg = QuanEstimation.PSO(p_num=10, ini_particle=missing, 
                                     max_episode=[1000,100], c0=1.0, c1=2.0, 
                                     c2=2.0)
            ```
        === "AD"
            ``` jl
            # measurement optimization algorithm: AD
            alg = QuanEstimation.AD(Adam=true, max_episode=300, epsilon=0.01, 
                                    beta1=0.90, beta2=0.99)
            ```
    ``` jl
    # input the dynamics data
    dynamics = QuanEstimation.Lindblad(opt, tspan ,rho0, H0, dH, 
                                       decay=decay, dyn_method=:Expm)
    # objective function: CFI
    obj = QuanEstimation.CFIM_obj()
    # run the measurement optimization problem
    QuanEstimation.run(opt, alg, obj, dynamics; savefile=false)
    M_ = readdlm("measurements.csv",'\t', Complex{Float64})
    M = [[reshape(M_[i,:], dim, dim) for i in 1:M_num] 
        for j in 1:Int(length(M_[:,1])/M_num)][end]
    ```
If the parameterization process is implemented with the Kraus operators, then the corresponding 
parameters should be input via

=== "Python"
    ``` py
    m = MeasurementOpt(mtype="projection", minput=[], savefile=False, 
                       method="DE", **kwargs)
    m.Kraus(K, dK)
    m.CFIM(W=[])
    ```
=== "Julia"
    ``` jl
    opt = MeasurementOpt(mtype=:Projection, seed=1234)
    alg = DE(kwargs...)
    dynamics = Kraus(opt, K, dK)
    obj = CFIM_obj(W=missing)
    run(opt, alg, obj, dynamics; savefile=false)
    ```
where `K` and `dK` are the Kraus operators and its derivatives with respect to the 
unknown parameters.

**Example 7.4**  
The Kraus operators for the amplitude damping channel are

\begin{eqnarray}
K_1 = \left(\begin{array}{cc}
1 & 0  \\
0 & \sqrt{1-\gamma}
\end{array}\right),
K_2 = \left(\begin{array}{cc}
0 & \sqrt{\gamma} \\
0 & 0
\end{array}\right), \nonumber
\end{eqnarray}

where $\gamma$ is the unknown parameter to be estimated which represents the decay 
probability. In this example, the probe state is taken as $|+\rangle\langle+|$ with 
$|+\rangle=\frac{1}{\sqrt{2}}(|0\rangle+|1\rangle)$. Here $|0\rangle$ $(|1\rangle)$ is 
the eigenstate of $\sigma_3$ (Pauli matrix) with respect to the eigenvalue $1$ $(-1)$.

=== "Python"
    ``` py
    from quanestimation import *
    import numpy as np

    # initial state
    rho0 = 0.5*np.array([[1., 1.], [1., 1.]])
    # Kraus operators for the amplitude damping channel
    gamma = 0.1
    K1 = np.array([[1., 0.], [0., np.sqrt(1-gamma)]])
    K2 = np.array([[0., np.sqrt(gamma)], [0., 0.]])
    K = [K1, K2]
    # derivatives of Kraus operators on gamma
    dK1 = np.array([[1., 0.], [0.0, -0.5/np.sqrt(1-gamma)]])
    dK2 = np.array([[0., 0.5/np.sqrt(gamma)], [0., 0.]])
    dK = [[dK1], [dK2]]
    # measurement
    POVM_basis = SIC(len(rho0))
    M_num = 2
    ```
    === "projection"
        === "DE"
		    ``` py
            # measurement optimization algorithm: DE
		    DE_paras = {"p_num":10, "measurement0":[], "max_episode":1000, \
                        "c":1.0, "cr":0.5, "seed":1234}
		    m = MeasurementOpt(mtype="projection", minput=[], savefile=False, \
                               method="DE", **DE_paras)
		    ```
        === "PSO"
		    ``` py
            # measurement optimization algorithm: PSO
		    PSO_paras = {"p_num":10, "measurement0":[], \
                         "max_episode":[1000,100], "c0":1.0, \
					    "c1":2.0, "c2":2.0, "seed":1234}
		    m = MeasurementOpt(mtype="projection", minput=[], savefile=False, \
                               method="PSO", **PSO_paras)
		    ```
    === "LC"
        === "DE"
		    ``` py
            # measurement optimization algorithm: DE
		    DE_paras = {"p_num":10, "measurement0":[], "max_episode":1000, \
				        "c":1.0, "cr":0.5, "seed":1234}
		    m = MeasurementOpt(mtype="input", minput=["LC", POVM_basis, 2], \
                               savefile=False, method="DE", **DE_paras)
		    ```
        === "PSO"
		    ``` py
            # measurement optimization algorithm: PSO
		    PSO_paras = {"p_num":10, "measurement0":[], "max_episode":[1000,100], \
					     "c0":1.0, "c1":2.0, "c2":2.0, "seed":1234}
		    m = MeasurementOpt(mtype="input", minput=["LC", POVM_basis, 2], \
                               savefile=False, method="PSO", **PSO_paras)
		    ```
        === "AD"
		    ``` py
            # measurement optimization algorithm: AD
		    AD_paras = {"Adam":False, "measurement0":[], "max_episode":300, \
                        "epsilon":0.01, "beta1":0.90, "beta2":0.99}
            m = MeasurementOpt(mtype="input", minput=["LC", POVM_basis, 2], \
                               savefile=False, method="AD", **AD_paras)
		    ```
    === "rotation"
        === "DE"
		    ``` py
            # measurement optimization algorithm: DE
		    DE_paras = {"p_num":10, "measurement0":[], "max_episode":1000, \
                        "c":1.0, "cr":0.5, "seed":1234}
		    m = MeasurementOpt(mtype="input", minput=["rotation", POVM_basis], \
                               savefile=False, method="DE", **DE_paras)
		    ```
        === "PSO"
		    ``` py
            # measurement optimization algorithm: PSO
		    PSO_paras = {"p_num":10, "measurement0":[], \
                         "max_episode":[1000,100], "c0":1.0, \
					     "c1":2.0, "c2":2.0, "seed":1234}
		    m = MeasurementOpt(mtype="input", minput=["rotation", POVM_basis], \
                               savefile=False, method="PSO", **PSO_paras)
		    ```
        === "AD"
		    ``` py
            # measurement optimization algorithm: AD
		    AD_paras = {"Adam":False, "measurement0":[], "max_episode":300, \
                        "epsilon":0.01, "beta1":0.90, "beta2":0.99}
            m = MeasurementOpt(mtype="input", minput=["rotation", POVM_basis], \
                               savefile=False, method="AD", **AD_paras)
		    ```
    ``` py
    # input the dynamics data
    m.Kraus(rho0, K, dK)
    # objective function: CFI
    m.CFIM()
    # convert the ".csv" file to the ".npy" file
    M_ = np.loadtxt("measurements.csv", dtype=np.complex128)
    csv2npy_measurements(M_, M_num)
    # load the measurements
    M = np.load("measurements.npy")[-1]
    ```
=== "Julia"
    ``` jl
    using QuanEstimation
    using DelimitedFiles

    # initial state
    rho0 = 0.5*ones(2, 2)
    # Kraus operators for the amplitude damping channel
    gamma = 0.1
    K1 = [1. 0.; 0. sqrt(1-gamma)]
    K2 = [0. sqrt(gamma); 0. 0.]
    K = [K1, K2]
    # derivatives of Kraus operators on gamma
    dK1 = [1. 0.; 0. -0.5/sqrt(1-gamma)]
    dK2 = [0. 0.5/sqrt(gamma); 0. 0.]
    dK = [[dK1], [dK2]]
    # measurement
    dim = size(rho0,1)
    POVM_basis = QuanEstimation.SIC(dim)
    M_num = 2
    ```
    === "Projection"
        ``` jl
        opt = QuanEstimation.MeasurementOpt(mtype=:Projection, seed=1234)
        ```
        === "DE"
            ``` jl
            # measurement optimization algorithm: DE
            alg = QuanEstimation.DE(p_num=10, ini_population=missing, 
                                    max_episode=1000, c=1.0, cr=0.5)
            ```
        === "PSO"
            ``` jl
            # measurement optimization algorithm: PSO
            alg = QuanEstimation.PSO(p_num=10, ini_particle=missing, 
                                     max_episode=[1000,100], c0=1.0, c1=2.0, 
                                     c2=2.0)
            ```
    === "LC"
        ``` jl
        opt = QuanEstimation.MeasurementOpt(mtype=:LC, 
                                            POVM_basis=POVM_basis, M_num=2, 
                                            seed=1234)
        ```
        === "DE"
            ``` jl
            # measurement optimization algorithm: DE
            alg = QuanEstimation.DE(p_num=10, ini_population=missing, 
                                    max_episode=1000, c=1.0, cr=0.5)
            ```
        === "PSO"
            ``` jl
            # measurement optimization algorithm: PSO
            alg = QuanEstimation.PSO(p_num=10, ini_particle=missing, 
                                     max_episode=[1000,100], c0=1.0, c1=2.0, 
                                     c2=2.0)
            ```
        === "AD"
            ``` jl
            # measurement optimization algorithm: AD
            alg = QuanEstimation.AD(Adam=true, max_episode=300, epsilon=0.01, 
                                    beta1=0.90, beta2=0.99)
            ```
    === "Rotation"
        ``` jl
        opt = QuanEstimation.MeasurementOpt(mtype=:Rotation, 
                                            POVM_basis=POVM_basis, seed=1234)
        ```
        === "DE"
            ``` jl
            # measurement optimization algorithm: DE
            alg = QuanEstimation.DE(p_num=10, ini_population=missing, 
                                    max_episode=1000, c=1.0, cr=0.5)
            ```
        === "PSO"
            ``` jl
            # measurement optimization algorithm: PSO
            alg = QuanEstimation.PSO(p_num=10, ini_particle=missing, 
                                     max_episode=[1000,100], c0=1.0, c1=2.0, 
                                     c2=2.0)
            ```
        === "AD"
            ``` jl
            # measurement optimization algorithm: AD
            alg = QuanEstimation.AD(Adam=true, max_episode=300, epsilon=0.01, 
                                    beta1=0.90, beta2=0.99)
            ```
    ``` jl
    # input the dynamics data
    dynamics = QuanEstimation.Kraus(opt, rho0, K, dK)
    # objective function: CFI
    obj = QuanEstimation.CFIM_obj()
    # run the measurement optimization problem
    QuanEstimation.run(opt, alg, obj, dynamics; savefile=false)
    # convert the flattened data into a list of matrix
    M_ = readdlm("measurements.csv",'\t', Complex{Float64})
    M = [[reshape(M_[i,:], dim, dim) for i in 1:M_num] 
        for j in 1:Int(length(M_[:,1])/M_num)][end]
    ```
---
## **Bibliography**
<a id="Kennedy1995">[1]</a>
J. Kennedy and R. Eberhar,
Particle swarm optimization,
[Proc. 1995 IEEE International Conference on Neural Networks **4**, 1942-1948 (1995).
](https://doi.org/10.1109/ICNN.1995.488968)

<a id="Storn1997">[2]</a>
R. Storn and K. Price,
Differential Evolution-A Simple and Efficient Heuristic for global
Optimization over Continuous Spaces,
[J. Global Optim. **11**, 341 (1997).](https://doi.org/10.1023/A:1008202821328)

<a id="Baydin2018">[3]</a>
A. G. Baydin, B. A. Pearlmutter, A. A. Radul, and J. M. Siskind,
Automatic differentiation in machine learning: a survey,
[J. Mach. Learn. Res. **18**, 1-43 (2018).](http://jmlr.org/papers/v18/17-468.html)

# **Citing QuanEstimation**

If you use QuanEstimation in your research, please cite the following papers:

[1] M. Zhang, H.-M. Yu, H. Yuan, X. Wang, R. Demkowicz-Dobrzański, and J. Liu, 
QuanEstimation: An open-source toolkit for quantum parameter estimation, 
[Phys. Rev. Res. **4**, 043057 (2022).](https://doi.org/10.1103/PhysRevResearch.4.043057)

[2] Huai-Ming Yu and Jing Liu, QuanEstimation.jl: An open-source Julia framework for quantum parameter estimation, 
[Fundam. Res. (2025).](https://doi.org/10.1016/j.fmre.2025.02.020)

---

Development of the GRAPE algorithm in quantum parameter estimation can be found in the following papers:

  * **auto-GRAPE**:

    M. Zhang, H.-M. Yu, H. Yuan, X. Wang, R. Demkowicz-Dobrzański, and J. Liu, 
    QuanEstimation: An open-source toolkit for quantum parameter estimation, 
    [Phys. Rev. Res. **4**, 043057 (2022).](https://doi.org/10.1103/PhysRevResearch.4.043057)

  * **GRAPE for single-parameter estimation**:

    Jing Liu and Haidong Yuan, Quantum parameter estimation with optimal control, 
    [Phys. Rev. A **96**, 012117 (2017).](https://doi.org/10.1103/PhysRevA.96.012117)

  * **GRAPE for multiparameter estimation**:

    Jing Liu and Haidong Yuan, Control-enhanced multiparameter quantum estimation, 
    [Phys. Rev. A **96**, 042114 (2017).](https://doi.org/10.1103/PhysRevA.96.042114)

# Developers

### **Prof. Jing Liu**
**Hainan University**  
**Email:** <liujing@hainanu.edu.cn>  
**Biography:** Prof. Liu is currently a full-time professor at the Center for Theoretical Physics 
and School of Physics and Optoelectronic Engineering, Hainan University. His main research interests 
focus on the topics in quantum metrology, quantum control, quantum information theory, and 
foundations of quantum mechanics, especially the design of high-precision measurement schemes 
using the features of quantum mechanics.

---

### **Prof. Rafał Demkowicz-Dobrzański**  
**University of Warsaw**  
**Email:** <Rafal.Demkowicz-Dobrzanski@fuw.edu.pl>  
**Biography:** Prof. Demkowicz-Dobrzański is a faculty at the Faculty of Physics, 
University of Warsaw. He is a theorist actively working in the field of quantum metrology, 
who developed methods to identify fundamental limits in quantum metrology in presence of 
decoherence.

---
### **Mr. Huai-Ming Yu**  
**Huazhong University of Science and Technology**  
**Email:** <HuaimingYuuu@gmail.com>  
**Biography:** Mr. Yu is a M.Sc. student at the School of Physics, Huazhong University of 
Science and Technology. His research interests lie primarily in the fields of quantum information,
quantum control, quantum foundations, as well as scientific programming and its applications in
quantum technology.

---

# Contributors

### **Mr. Zheng-Wei An**
**Huazhong University of Science and Technology**  

---

# Advisors

### **Prof. Haidong Yuan**  
**The Chinese University of Hong Kong**  
**Biography:** Prof. Yuan is an associate professor at the Department of Mechanical 
and Automation Engineering, The Chinese University of Hong Kong.

---

### **Prof. Xiaoguang Wang**  
**Zhejiang Sci-Tech University**  
**Biography:** Prof. Wang used to be a full-time professor at the Department of Physics, Zhejiang University and now is a full-time professor at the Department of Physics, Zhejiang Sci-Tech University.


---
# Former Developer

### **Dr. Mao Zhang**  
**Email:** <zhangmao2018@foxmail.com>  
**Biography:** Dr. Zhang is now working at the United Imaging Healthcare Co., Ltd.. She used to be a Ph.D. student in the National Precise Gravity Measurement Facility, School of Physics, Huazhong University of Science and Technology. 

# Python Functions

## Kraus 
::: quanestimation.Kraus

---

## Metrological resources
### Spin squeezing
::: quanestimation.SpinSqueezing
### Target time
::: quanestimation.TargetTime

---

## Quantum Cramér-Rao bounds
### Classical Fisher information matrix (CFIM)
::: quanestimation.CFIM
### Fisher information matrix (FIM)
::: quanestimation.FIM
### Fisher information (FI_Expt)
::: quanestimation.FI_Expt
### Symmetric logarithmic derivative (SLD)
::: quanestimation.SLD
### Right logarithmic derivative (RLD)
::: quanestimation.RLD
### Left logarithmic derivative (LLD)
::: quanestimation.LLD
### Quantum Fisher information matrix (QFIM)
::: quanestimation.QFIM
### Quantum Fisher information matrix with Kraus operators
::: quanestimation.QFIM_Kraus
### Quantum Fisher information matrix in Bloch representation
::: quanestimation.QFIM_Bloch
### Quantum Fisher information matrix with Gaussian states
::: quanestimation.QFIM_Gauss

---

## Holevo Cramér-Rao bound
::: quanestimation.HCRB

---

## Nagaoka-Hayashi bound
::: quanestimation.NHB

---

## Bayesian Cramér-Rao bounds
### Bayesian classical Fisher information matrix (BCFIM)
::: quanestimation.BCFIM
### Bayesian quantum Fisher information matrix (BQFIM)
::: quanestimation.BQFIM
### Bayesian Cramér-Rao bound (BCRB)
::: quanestimation.BCRB
### Bayesian quantum Cramér-Rao bound (BQCRB)
::: quanestimation.BQCRB
### Optimal biased bound (OBB)
::: quanestimation.OBB
### Van Trees bound (VTB)
::: quanestimation.VTB
### Quantum Van Trees bound (QVTB)
::: quanestimation.QVTB

---

## Quantum Ziv-Zakai bound
::: quanestimation.QZZB

---

## Bayesian estimation
### Maximum a posteriori probability (MAP)
::: quanestimation.Bayes
### Maximum likelihood estimation (MLE)
::: quanestimation.MLE
### Average Bayesian cost (BayesCost)
::: quanestimation.BayesCost
### Bayesian cost bound (BCB)
::: quanestimation.BCB

---

## Common utilities
### Bayes input
::: quanestimation.BayesInput
### SIC-POVM
::: quanestimation.SIC
### SU($N$) generators
::: quanestimation.suN_generator

# **Welcome to the QuanEstimation**
QuanEstimation is a Python-Julia-based open-source toolkit for quantum parameter estimation, which consist in the calculation of 
the quantum metrological tools and quantum resources, and the optimizations with respect to the probe states, the controls or 
the measurements, as well as comprehensive optimizations in quantum metrology. Futhermore, QuanEstimation can generate not only 
optimal quantum parameter estimation schemes, but also adaptive measurement schemes.The package structure of QuanEstimation can 
be seen in the following figure:

<figure markdown>
  ![Image title](Fig_schematic.png){ width="800" }
  <figcaption>The package structure of QuanEstimation. The blue boxes and the light blue boxes reprsent
  the folders and the python files. The orange boxes and the gray boxes represent the classes and the 
  functions. In the figure, the functions which are circled by dotted lines represent the wrapped Julia 
  methods that are calculated in Julia.
  </figcaption>
</figure>

The package contains several well-used metrological tools, such as quantum (classical) 
Cramér-Rao bounds, Hevolo Cramér-Rao bound and Bayesian versions of quantum (classical) 
Cramér-Rao bounds, quantum Ziv-Zakai bound, and Bayesian estimation. The users can use these
bounds as the objective functions to optimize the probe state, control, measurement and 
simultaneous optimizations among them. The optimization methods include the gradient-based 
algorithms such as the gradient ascent pulse engineering (GRAPE), GRAPE algorithm based on the 
automatic differentiation (auto-GRAPE), automatic differentiation (AD) and the 
gradient-free algorithms such as particle swarm optimization (PSO), differential evolution (DE), 
and reverse iterative (RI) algorithm.

The interface of QuanEstimation is written in Python, but the most calculation processes are
executed in Julia for the computational efficiency. Therefore, QuanEstimation also has a full
Julia version apart from the Python-Julia version. 

---

This part contains the methods and structs in Julia that are called by the Python-Julia packagea and the full Julia package.

##  **`QuanEstimation.AD`** &mdash; *Method*.



```julia
AD(;max_episode=300, epsilon=0.01, beta1=0.90, beta2=0.99, Adam::Bool=true)
```

Optimization algorithm: AD.

  * `max_episode`: The number of episodes.
  * `epsilon`: Learning rate.
  * `beta1`: The exponential decay rate for the first moment estimates.
  * `beta2`: The exponential decay rate for the second moment estimates.
  * `Adam`: Whether or not to use Adam for updating control coefficients.


<a target='_blank' href='https://github.com/QuanEstimation/QuanEstimation.jl/blob/5f47a686c13b059023de2abe67017d7c9564bc9d/src/Algorithm/Algorithm.jl#L75-L85' class='documenter-source'>source</a><br>

##  **`QuanEstimation.CFIM_obj`** &mdash; *Method*.



```julia
CFIM_obj(;M=missing, W=missing, eps=GLOBAL_EPS)
```

Choose CFI [$\mathrm{Tr}(WI^{-1})$] as the objective function with $W$ the weight matrix and $I$ the CFIM.

  * `M`: A set of positive operator-valued measure (POVM). The default measurement is a set of rank-one symmetric informationally complete POVM (SIC-POVM).
  * `W`: Weight matrix.
  * `eps`: Machine epsilon.


<a target='_blank' href='https://github.com/QuanEstimation/QuanEstimation.jl/blob/5f47a686c13b059023de2abe67017d7c9564bc9d/src/ObjectiveFunc/AsymptoticBound/AsymptoticBound.jl#L34-L42' class='documenter-source'>source</a><br>

##  **`QuanEstimation.CMopt`** &mdash; *Type*.



```julia
CMopt(ctrl=missing, M=missing, ctrl_bound=[-Inf, Inf], seed=1234)
```

Control and measurement optimization.

  * `ctrl`: Guessed control coefficients.
  * `M`: Guessed projective measurement (a set of basis)
  * `ctrl_bound`: Lower and upper bounds of the control coefficients.
  * `seed`: Random seed.


<a target='_blank' href='https://github.com/QuanEstimation/QuanEstimation.jl/blob/5f47a686c13b059023de2abe67017d7c9564bc9d/src/OptScenario/OptScenario.jl#L127-L136' class='documenter-source'>source</a><br>

##  **`QuanEstimation.ControlOpt`** &mdash; *Method*.



```julia
ControlOpt(ctrl=missing, ctrl_bound=[-Inf, Inf], seed=1234)
```

Control optimization.

  * `ctrl`: Guessed control coefficients.
  * `ctrl_bound`: Lower and upper bounds of the control coefficients.
  * `seed`: Random seed.


<a target='_blank' href='https://github.com/QuanEstimation/QuanEstimation.jl/blob/5f47a686c13b059023de2abe67017d7c9564bc9d/src/OptScenario/OptScenario.jl#L16-L24' class='documenter-source'>source</a><br>

<!-- ##  **`QuanEstimation.DDPG`** &mdash; *Method*.



```julia
DDPG(;max_episode::Int=500, layer_num::Int=3, layer_dim::Int=200, seed::Number=1234)
``` -->

Optimization algorithm: DE.

  * `max_episode`: The number of populations.
  * `layer_num`: The number of layers (include the input and output layer).
  * `layer_dim`: The number of neurons in the hidden layer.
  * `seed`: Random seed.


<a target='_blank' href='https://github.com/QuanEstimation/QuanEstimation.jl/blob/5f47a686c13b059023de2abe67017d7c9564bc9d/src/Algorithm/Algorithm.jl#L146-L155' class='documenter-source'>source</a><br>

##  **`QuanEstimation.DE`** &mdash; *Method*.



```julia
DE(;max_episode::Number=1000, p_num::Number=10, ini_population=missing, c::Number=1.0, cr::Number=0.5, seed::Number=1234)
```

Optimization algorithm: DE.

  * `max_episode`: The number of populations.
  * `p_num`: The number of particles.
  * `ini_population`: Initial guesses of the optimization variables.
  * `c`: Mutation constant.
  * `cr`: Crossover constant.


<a target='_blank' href='https://github.com/QuanEstimation/QuanEstimation.jl/blob/5f47a686c13b059023de2abe67017d7c9564bc9d/src/Algorithm/Algorithm.jl#L122-L132' class='documenter-source'>source</a><br>

##  **`QuanEstimation.GRAPE`** &mdash; *Method*.



```julia
GRAPE(;max_episode=300, epsilon=0.01, beta1=0.90, beta2=0.99, Adam::Bool=true)
```

Control optimization algorithm: GRAPE.

  * `max_episode`: The number of episodes.
  * `epsilon`: Learning rate.
  * `beta1`: The exponential decay rate for the first moment estimates.
  * `beta2`: The exponential decay rate for the second moment estimates.
  * `Adam`: Whether or not to use Adam for updating control coefficients.


<a target='_blank' href='https://github.com/QuanEstimation/QuanEstimation.jl/blob/5f47a686c13b059023de2abe67017d7c9564bc9d/src/Algorithm/Algorithm.jl#L20-L30' class='documenter-source'>source</a><br>

##  **`QuanEstimation.HCRB_obj`** &mdash; *Method*.



```julia
HCRB_obj(;W=missing, eps=GLOBAL_EPS)
```

Choose HCRB as the objective function. 

  * `W`: Weight matrix.
  * `eps`: Machine epsilon.


<a target='_blank' href='https://github.com/QuanEstimation/QuanEstimation.jl/blob/5f47a686c13b059023de2abe67017d7c9564bc9d/src/ObjectiveFunc/AsymptoticBound/AsymptoticBound.jl#L45-L52' class='documenter-source'>source</a><br>

##  **`QuanEstimation.Kraus`** &mdash; *Method*.



```julia
Kraus(ρ0::AbstractMatrix, K::AbstractVector, dK::AbstractVector)
```

The parameterization of a state is $\rho=\sum_i K_i\rho_0K_i^{\dagger}$ with $\rho$ the evolved density matrix and $K_i$ the Kraus operator.

  * `ρ0`: Initial state (density matrix).
  * `K`: Kraus operators.
  * `dK`: Derivatives of the Kraus operators with respect to the unknown parameters to be estimated. For example, dK[0] is the derivative vector on the first parameter.


<a target='_blank' href='https://github.com/QuanEstimation/QuanEstimation.jl/blob/5f47a686c13b059023de2abe67017d7c9564bc9d/src/Parameterization/Kraus/KrausData.jl#L16-L24' class='documenter-source'>source</a><br>

##  **`QuanEstimation.Kraus`** &mdash; *Method*.



```julia
Kraus(ψ0::AbstractMatrix, K::AbstractVector, dK::AbstractVector)
```

The parameterization of a state is $\psi\rangle=\sum_i K_i|\psi_0\rangle$ with $\psi$ the evolved state and $K_i$ the Kraus operator.

  * `ψ0`: Initial state (ket).
  * `K`: Kraus operators.
  * `dK`: Derivatives of the Kraus operators with respect to the unknown parameters to be estimated. For example, dK[0] is the derivative vector on the first parameter.


<a target='_blank' href='https://github.com/QuanEstimation/QuanEstimation.jl/blob/5f47a686c13b059023de2abe67017d7c9564bc9d/src/Parameterization/Kraus/KrausData.jl#L27-L35' class='documenter-source'>source</a><br>

##  **`QuanEstimation.Kraus`** &mdash; *Method*.



```julia
Kraus(opt::AbstractMopt, ρ₀::AbstractMatrix, K, dK; eps=GLOBAL_EPS)
```

Initialize the parameterization described by the Kraus operators for the measurement optimization. 


<a target='_blank' href='https://github.com/QuanEstimation/QuanEstimation.jl/blob/5f47a686c13b059023de2abe67017d7c9564bc9d/src/Parameterization/Kraus/KrausWrapper.jl#L25-L30' class='documenter-source'>source</a><br>

##  **`QuanEstimation.Kraus`** &mdash; *Method*.



```julia
Kraus(opt::CompOpt, K, dK; eps=GLOBAL_EPS)
```

Initialize the parameterization described by the Kraus operators for the comprehensive optimization. 


<a target='_blank' href='https://github.com/QuanEstimation/QuanEstimation.jl/blob/5f47a686c13b059023de2abe67017d7c9564bc9d/src/Parameterization/Kraus/KrausWrapper.jl#L41-L46' class='documenter-source'>source</a><br>

##  **`QuanEstimation.LLD`** &mdash; *Method*.



```julia
LLD(ρ::Matrix{T}, dρ::Vector{Matrix{T}}; rep="original", eps=GLOBAL_EPS) where {T<:Complex}
```

Calculate the left logarrithmic derivatives (LLDs). The LLD operator is defined as $\partial_{a}\rho=\mathcal{R}_a^{\dagger}\rho$, where ρ is the parameterized density matrix.    

  * `ρ`: Density matrix.
  * `dρ`: Derivatives of the density matrix with respect to the unknown parameters to be estimated. For example, drho[1] is the derivative vector with respect to the first parameter.
  * `rep`: Representation of the LLD operator. Options can be: "original" (default) and "eigen".
  * `eps`: Machine epsilon.


<a target='_blank' href='https://github.com/QuanEstimation/QuanEstimation.jl/blob/5f47a686c13b059023de2abe67017d7c9564bc9d/src/ObjectiveFunc/AsymptoticBound/CramerRao.jl#L146-L155' class='documenter-source'>source</a><br>

##  **`QuanEstimation.LLD`** &mdash; *Method*.



```julia
LLD(ρ::Matrix{T}, dρ::Matrix{T}; rep="original", eps=GLOBAL_EPS) where {T<:Complex}
```

When applied to the case of single parameter.


<a target='_blank' href='https://github.com/QuanEstimation/QuanEstimation.jl/blob/5f47a686c13b059023de2abe67017d7c9564bc9d/src/ObjectiveFunc/AsymptoticBound/CramerRao.jl#L160-L165' class='documenter-source'>source</a><br>

##  **`QuanEstimation.Lindblad`** &mdash; *Method*.



```julia
Lindblad(opt::AbstractMopt, tspan, ρ₀, H0, dH; Hc=missing, ctrl=missing, decay=missing, dyn_method=:Expm, eps=GLOBAL_EPS)
```

Initialize the parameterization described by the Lindblad master equation governed dynamics for the measurement optimization.


<a target='_blank' href='https://github.com/QuanEstimation/QuanEstimation.jl/blob/5f47a686c13b059023de2abe67017d7c9564bc9d/src/Parameterization/Lindblad/LindbladWrapper.jl#L203-L208' class='documenter-source'>source</a><br>

##  **`QuanEstimation.Lindblad`** &mdash; *Method*.



```julia
Lindblad(opt::ControlMeasurementOpt, tspan, ρ₀, H0, dH, Hc; decay=missing, dyn_method=:Expm, eps=GLOBAL_EPS)
```

Initialize the parameterization described by the Lindblad master equation governed dynamics for the comprehensive optimization on control and measurement.


<a target='_blank' href='https://github.com/QuanEstimation/QuanEstimation.jl/blob/5f47a686c13b059023de2abe67017d7c9564bc9d/src/Parameterization/Lindblad/LindbladWrapper.jl#L361-L366' class='documenter-source'>source</a><br>

##  **`QuanEstimation.Lindblad`** &mdash; *Method*.



```julia
Lindblad(opt::ControlOpt, tspan, ρ₀, H0, dH, Hc; decay=missing, dyn_method=:Expm, eps=GLOBAL_EPS)
```

Initialize the parameterization described by the Lindblad master equation governed dynamics for the control optimization.


<a target='_blank' href='https://github.com/QuanEstimation/QuanEstimation.jl/blob/5f47a686c13b059023de2abe67017d7c9564bc9d/src/Parameterization/Lindblad/LindbladWrapper.jl#L2-L7' class='documenter-source'>source</a><br>

##  **`QuanEstimation.Lindblad`** &mdash; *Method*.



```julia
Lindblad(opt::StateControlMeasurementOpt, tspan, H0, dH, Hc; decay=missing, dyn_method=:Expm, eps=GLOBAL_EPS)
```

Initialize the parameterization described by the Lindblad master equation governed dynamics for the comprehensive optimization on state, control and measurement.


<a target='_blank' href='https://github.com/QuanEstimation/QuanEstimation.jl/blob/5f47a686c13b059023de2abe67017d7c9564bc9d/src/Parameterization/Lindblad/LindbladWrapper.jl#L507-L512' class='documenter-source'>source</a><br>

##  **`QuanEstimation.Lindblad`** &mdash; *Method*.



```julia
Lindblad(opt::StateControlOpt, tspan, H0, dH, Hc; decay=missing, dyn_method=:Expm, eps=GLOBAL_EPS)
```

Initialize the parameterization described by the Lindblad master equation governed dynamics for the comprehensive optimization on state and control.


<a target='_blank' href='https://github.com/QuanEstimation/QuanEstimation.jl/blob/5f47a686c13b059023de2abe67017d7c9564bc9d/src/Parameterization/Lindblad/LindbladWrapper.jl#L298-L303' class='documenter-source'>source</a><br>

##  **`QuanEstimation.Lindblad`** &mdash; *Method*.



```julia
Lindblad(opt::StateMeasurementOpt, tspan, H0, dH; Hc=missing, ctrl=missing, decay=missing, dyn_method=:Expm)
```

Initialize the parameterization described by the Lindblad master equation governed dynamics for the comprehensive optimization on state and measurement.


<a target='_blank' href='https://github.com/QuanEstimation/QuanEstimation.jl/blob/5f47a686c13b059023de2abe67017d7c9564bc9d/src/Parameterization/Lindblad/LindbladWrapper.jl#L419-L424' class='documenter-source'>source</a><br>

##  **`QuanEstimation.Lindblad`** &mdash; *Method*.



```julia
Lindblad(opt::StateOpt, tspan, H0, dH; Hc=missing, ctrl=missing, decay=missing, dyn_method=:Expm, eps=GLOBAL_EPS)
```

Initialize the parameterization described by the Lindblad master equation governed dynamics for the state optimization.


<a target='_blank' href='https://github.com/QuanEstimation/QuanEstimation.jl/blob/5f47a686c13b059023de2abe67017d7c9564bc9d/src/Parameterization/Lindblad/LindbladWrapper.jl#L59-L64' class='documenter-source'>source</a><br>

##  **`QuanEstimation.NM`** &mdash; *Method*.



```julia
NM(;max_episode::Int=1000, p_num::Int=10, nelder_mead=missing, ar::Number=1.0, ae::Number=2.0, ac::Number=0.5, as0::Number=0.5, seed::Number=1234)
```

State optimization algorithm: NM.

  * `max_episode`: The number of populations.
  * `p_num`: The number of the input states.
  * `nelder_mead`: Initial guesses of the optimization variables.
  * `ar`: Reflection constant.
  * `ae`: Expansion constant.
  * `ac`: Constraction constant.
  * `as0`: Shrink constant.


<a target='_blank' href='https://github.com/QuanEstimation/QuanEstimation.jl/blob/5f47a686c13b059023de2abe67017d7c9564bc9d/src/Algorithm/Algorithm.jl#L169-L181' class='documenter-source'>source</a><br>

##  **`QuanEstimation.PSO`** &mdash; *Method*.



```julia
PSO(;max_episode::Union{T,Vector{T}} where {T<:Int}=[1000, 100], p_num::Number=10, ini_particle=missing, c0::Number=1.0, c1::Number=2.0, c2::Number=2.0, seed::Number=1234)
```

Optimization algorithm: PSO.

  * `max_episode`: The number of episodes, it accepts both integer and array with two elements.
  * `p_num`: The number of particles.
  * `ini_particle`: Initial guesses of the optimization variables.
  * `c0`: The damping factor that assists convergence, also known as inertia weight.
  * `c1`: The exploitation weight that attracts the particle to its best previous position, also known as cognitive learning factor.
  * `c2`: The exploitation weight that attracts the particle to the best position in the neighborhood, also known as social learning factor.


<a target='_blank' href='https://github.com/QuanEstimation/QuanEstimation.jl/blob/5f47a686c13b059023de2abe67017d7c9564bc9d/src/Algorithm/Algorithm.jl#L99-L110' class='documenter-source'>source</a><br>

##  **`QuanEstimation.QFIM_obj`** &mdash; *Method*.



```julia
QFIM_obj(;W=missing, eps=GLOBAL_EPS, LDtype::Symbol=:SLD)
```

Choose QFI [$\mathrm{Tr}(WF^{-1})$] as the objective function with $W$ the weight matrix and $F$ the QFIM.

  * `W`: Weight matrix.
  * `eps`: Machine epsilon.
  * `LDtype`: Types of QFI (QFIM) can be set as the objective function. Options are `:SLD` (default), `:RLD` and `:LLD`.


<a target='_blank' href='https://github.com/QuanEstimation/QuanEstimation.jl/blob/5f47a686c13b059023de2abe67017d7c9564bc9d/src/ObjectiveFunc/AsymptoticBound/AsymptoticBound.jl#L23-L31' class='documenter-source'>source</a><br>

##  **`QuanEstimation.RI`** &mdash; *Method*.



```julia
RI(;max_episode::Int=300, seed::Number=1234)
```

State optimization algorithm: RI.

  * `max_episode`: The number of episodes.


<a target='_blank' href='https://github.com/QuanEstimation/QuanEstimation.jl/blob/5f47a686c13b059023de2abe67017d7c9564bc9d/src/Algorithm/Algorithm.jl#L188-L194' class='documenter-source'>source</a><br>

##  **`QuanEstimation.RLD`** &mdash; *Method*.



```julia
RLD(ρ::Matrix{T}, dρ::Vector{Matrix{T}}; rep="original", eps=GLOBAL_EPS) where {T<:Complex}
```

Calculate the right logarrithmic derivatives (RLDs). The RLD operator is defined as  $\partial_{a}\rho=\rho \mathcal{R}_a$, where $\rho$ is the parameterized density matrix.  

  * `ρ`: Density matrix.
  * `dρ`: Derivatives of the density matrix with respect to the unknown parameters to be estimated. For example, drho[1] is the derivative vector with respect to the first parameter.
  * `rep`: Representation of the RLD operator. Options can be: "original" (default) and "eigen".
  * `eps`: Machine epsilon.


<a target='_blank' href='https://github.com/QuanEstimation/QuanEstimation.jl/blob/5f47a686c13b059023de2abe67017d7c9564bc9d/src/ObjectiveFunc/AsymptoticBound/CramerRao.jl#L89-L99' class='documenter-source'>source</a><br>

##  **`QuanEstimation.RLD`** &mdash; *Method*.



```julia
RLD(ρ::Matrix{T}, dρ::Matrix{T}; rep="original", eps=GLOBAL_EPS) where {T<:Complex}
```

When applied to the case of single parameter.


<a target='_blank' href='https://github.com/QuanEstimation/QuanEstimation.jl/blob/5f47a686c13b059023de2abe67017d7c9564bc9d/src/ObjectiveFunc/AsymptoticBound/CramerRao.jl#L104-L109' class='documenter-source'>source</a><br>

##  **`QuanEstimation.SCMopt`** &mdash; *Type*.



```julia
SCMopt(psi=missing, ctrl=missing, M=missing, ctrl_bound=[-Inf, Inf], seed=1234)
```

State, control and measurement optimization.

  * `psi`: Guessed probe state.
  * `ctrl`: Guessed control coefficients.
  * `M`: Guessed projective measurement (a set of basis).
  * `ctrl_bound`:  Lower and upper bounds of the control coefficients.
  * `seed`: Random seed.


<a target='_blank' href='https://github.com/QuanEstimation/QuanEstimation.jl/blob/5f47a686c13b059023de2abe67017d7c9564bc9d/src/OptScenario/OptScenario.jl#L167-L177' class='documenter-source'>source</a><br>

##  **`QuanEstimation.SCopt`** &mdash; *Type*.



```julia
SCopt(psi=missing, ctrl=missing, ctrl_bound=[-Inf, Inf], seed=1234)
```

State and control optimization.

  * `psi`: Guessed probe state.
  * `ctrl`: Guessed control coefficients.
  * `ctrl_bound`: Lower and upper bounds of the control coefficients.
  * `seed`: Random seed.


<a target='_blank' href='https://github.com/QuanEstimation/QuanEstimation.jl/blob/5f47a686c13b059023de2abe67017d7c9564bc9d/src/OptScenario/OptScenario.jl#L106-L115' class='documenter-source'>source</a><br>

##  **`QuanEstimation.SLD`** &mdash; *Method*.



```julia
SLD(ρ::Matrix{T}, dρ::Vector{Matrix{T}}; rep="original", eps=GLOBAL_EPS) where {T<:Complex}
```

Calculate the symmetric logarrithmic derivatives (SLDs). The SLD operator $L_a$ is defined  as$\partial_{a}\rho=\frac{1}{2}(\rho L_{a}+L_{a}\rho)$, where $\rho$ is the parameterized density matrix. 

  * `ρ`: Density matrix.
  * `dρ`: Derivatives of the density matrix with respect to the unknown parameters to be estimated. For example, drho[1] is the derivative vector with respect to the first parameter.
  * `rep`: Representation of the SLD operator. Options can be: "original" (default) and "eigen" .
  * `eps`: Machine epsilon.


<a target='_blank' href='https://github.com/QuanEstimation/QuanEstimation.jl/blob/5f47a686c13b059023de2abe67017d7c9564bc9d/src/ObjectiveFunc/AsymptoticBound/CramerRao.jl#L7-L17' class='documenter-source'>source</a><br>

##  **`QuanEstimation.SLD`** &mdash; *Method*.



```julia
SLD(ρ::Matrix{T}, dρ::Matrix{T}; rep="original", eps=GLOBAL_EPS) where {T<:Complex}
```

When applied to the case of single parameter.


<a target='_blank' href='https://github.com/QuanEstimation/QuanEstimation.jl/blob/5f47a686c13b059023de2abe67017d7c9564bc9d/src/ObjectiveFunc/AsymptoticBound/CramerRao.jl#L22-L27' class='documenter-source'>source</a><br>

##  **`QuanEstimation.SMopt`** &mdash; *Type*.



```julia
SMopt(psi=missing, M=missing, seed=1234)
```

State and control optimization.

  * `psi`: Guessed probe state.
  * `M`: Guessed projective measurement (a set of basis).
  * `seed`: Random seed.


<a target='_blank' href='https://github.com/QuanEstimation/QuanEstimation.jl/blob/5f47a686c13b059023de2abe67017d7c9564bc9d/src/OptScenario/OptScenario.jl#L146-L154' class='documenter-source'>source</a><br>

##  **`QuanEstimation.StateOpt`** &mdash; *Method*.



```julia
StateOpt(psi=missing, seed=1234)
```

State optimization.

  * `psi`: Guessed probe state.
  * `seed`: Random seed.


<a target='_blank' href='https://github.com/QuanEstimation/QuanEstimation.jl/blob/5f47a686c13b059023de2abe67017d7c9564bc9d/src/OptScenario/OptScenario.jl#L35-L42' class='documenter-source'>source</a><br>

##  **`QuanEstimation.autoGRAPE`** &mdash; *Method*.



```julia
autoGRAPE(;max_episode=300, epsilon=0.01, beta1=0.90, beta2=0.99, Adam::Bool=true)
```

Control optimization algorithm: auto-GRAPE.

  * `max_episode`: The number of episodes.
  * `epsilon`: Learning rate.
  * `beta1`: The exponential decay rate for the first moment estimates.
  * `beta2`: The exponential decay rate for the second moment estimates.
  * `Adam`: Whether or not to use Adam for updating control coefficients.


<a target='_blank' href='https://github.com/QuanEstimation/QuanEstimation.jl/blob/5f47a686c13b059023de2abe67017d7c9564bc9d/src/Algorithm/Algorithm.jl#L48-L58' class='documenter-source'>source</a><br>

##  **`QuanEstimation.Adapt`** &mdash; *Method*.



```julia
Adapt(x::AbstractVector, p, rho0::AbstractMatrix, tspan, H, dH; dyn_method=:Expm, method="FOP", savefile=false, max_episode::Int=1000, eps::Float64=1e-8, Hc=missing, ctrl=missing, decay=missing, M=missing, W=missing)
```

In QuanEstimation, the Hamiltonian of the adaptive system should be written as $H(\textbf{x}+\textbf{u})$ with $\textbf{x}$ the unknown parameters and $\textbf{u}$ the tunable parameters. The tunable parameters $\textbf{u}$ are used to let the  Hamiltonian work at the optimal point $\textbf{x}_{\mathrm{opt}}$. 

  * `x`: The regimes of the parameters for the integral.
  * `p`: The prior distribution.
  * `rho0`: Density matrix.
  * `tspan`: The experimental results obtained in practice.
  * `H`: Free Hamiltonian with respect to the values in x.
  * `dH`: Derivatives of the free Hamiltonian with respect to the unknown parameters to be estimated.
  * `dyn_method`: Setting the method for solving the Lindblad dynamics. Options are: "expm" and "ode".
  * `method`: Choose the method for updating the tunable parameters (u). Options are: "FOP" and "MI".
  * `savefile`: Whether or not to save all the posterior distributions.
  * `max_episode`: The number of episodes.
  * `eps`: Machine epsilon.
  * `Hc`: Control Hamiltonians.
  * `ctrl`: Control coefficients.
  * `decay`: Decay operators and the corresponding decay rates.
  * `M`: A set of positive operator-valued measure (POVM). The default measurement is a set of rank-one symmetric informationally complete POVM (SIC-POVM).
  * `W`: Whether or not to save all the posterior distributions.


<a target='_blank' href='https://github.com/QuanEstimation/QuanEstimation.jl/blob/5f47a686c13b059023de2abe67017d7c9564bc9d/src/Common/AdaptiveScheme.jl#L1-L25' class='documenter-source'>source</a><br>

##  **`QuanEstimation.Adapt`** &mdash; *Method*.



```julia
Adapt(x::AbstractVector, p, rho0::AbstractMatrix, K, dK; method="FOP", savefile=false, max_episode::Int=1000, eps::Float64=1e-8, M=missing, W=missing)
```

In QuanEstimation, the Hamiltonian of the adaptive system should be written as $H(\textbf{x}+\textbf{u})$ with $\textbf{x}$ the unknown parameters and $\textbf{u}$ the tunable parameters. The tunable parameters $\textbf{u}$ are used to let the  Hamiltonian work at the optimal point $\textbf{x}_{\mathrm{opt}}$. 

  * `x`: The regimes of the parameters for the integral.
  * `p`: The prior distribution.
  * `rho0`: Density matrix.
  * `K`: Kraus operator(s) with respect to the values in x.
  * `dK`: Derivatives of the Kraus operator(s) with respect to the unknown parameters to be estimated.
  * `method`: Choose the method for updating the tunable parameters (u). Options are: "FOP" and "MI".
  * `savefile`: Whether or not to save all the posterior distributions.
  * `max_episode`: The number of episodes.
  * `eps`: Machine epsilon.
  * `M`: A set of positive operator-valued measure (POVM). The default measurement is a set of rank-one symmetric informationally complete POVM (SIC-POVM).
  * `W`: Whether or not to save all the posterior distributions.


<a target='_blank' href='https://github.com/QuanEstimation/QuanEstimation.jl/blob/5f47a686c13b059023de2abe67017d7c9564bc9d/src/Common/AdaptiveScheme.jl#L169-L188' class='documenter-source'>source</a><br>

##  **`QuanEstimation.BCB`** &mdash; *Method*.



```julia
BCB(x, p, rho; W=missing, eps=GLOBAL_EPS)
```

Calculation of the minimum Bayesian cost with a quadratic cost function.

  * `x`: The regimes of the parameters for the integral.
  * `p`: The prior distribution.
  * `rho`: Parameterized density matrix.
  * `W`: Weight matrix.
  * `eps`: Machine epsilon.


<a target='_blank' href='https://github.com/QuanEstimation/QuanEstimation.jl/blob/5f47a686c13b059023de2abe67017d7c9564bc9d/src/Common/BayesEstimation.jl#L363-L373' class='documenter-source'>source</a><br>

##  **`QuanEstimation.BCFIM`** &mdash; *Method*.



```julia
BCFIM(x::AbstractVector, p, rho, drho; M=missing, eps=GLOBAL_EPS)
```

Calculation of the Bayesian classical Fisher information (BCFI) and the Bayesian classical Fisher information matrix (BCFIM) of the form $\mathcal{I}_{\mathrm{Bayes}}=\int p(\textbf{x})\mathcal{I}\mathrm{d}\textbf{x}$ with $\mathcal{I}$ the CFIM and $p(\textbf{x})$ the prior distribution.

  * `x`: The regimes of the parameters for the integral.
  * `p`: The prior distribution.
  * `rho`: Parameterized density matrix.
  * `drho`: Derivatives of the parameterized density matrix (rho) with respect to the unknown parameters to be estimated.
  * `M`: A set of positive operator-valued measure (POVM). The default measurement is a set of rank-one symmetric informationally complete POVM (SIC-POVM).
  * `eps`: Machine epsilon.


<a target='_blank' href='https://github.com/QuanEstimation/QuanEstimation.jl/blob/5f47a686c13b059023de2abe67017d7c9564bc9d/src/ObjectiveFunc/BayesianBound/BayesianCramerRao.jl#L2-L14' class='documenter-source'>source</a><br>

##  **`QuanEstimation.BCRB`** &mdash; *Method*.



```julia
BCRB(x::AbstractVector, p, dp, rho, drho; M=missing, b=missing, db=missing, btype=1, eps=GLOBAL_EPS)
```

Calculation of the Bayesian Cramer-Rao bound (BCRB).

  * `x`: The regimes of the parameters for the integral.
  * `p`: The prior distribution.
  * `dp`: Derivatives of the prior distribution with respect to the unknown parameters to be estimated. For example, dp[0] is the derivative vector on the first parameter.
  * `rho`: Parameterized density matrix.
  * `drho`: Derivatives of the parameterized density matrix (rho) with respect to the unknown parameters to be estimated.
  * `M`: A set of positive operator-valued measure (POVM). The default measurement is a set of rank-one symmetric informationally complete POVM (SIC-POVM).
  * `b`: Vector of biases of the form $\textbf{b}=(b(x_0),b(x_1),\dots)^{\mathrm{T}}$.
  * `db`: Derivatives of b on the unknown parameters to be estimated, It should be expressed as $\textbf{b}'=(\partial_0 b(x_0),\partial_1 b(x_1),\dots)^{\mathrm{T}}$.
  * `btype`: Types of the BCRB. Options are 1, 2 and 3.
  * `eps`: Machine epsilon.


<a target='_blank' href='https://github.com/QuanEstimation/QuanEstimation.jl/blob/5f47a686c13b059023de2abe67017d7c9564bc9d/src/ObjectiveFunc/BayesianBound/BayesianCramerRao.jl#L176-L191' class='documenter-source'>source</a><br>

##  **`QuanEstimation.BQCRB`** &mdash; *Method*.



```julia
BQCRB(x::AbstractVector, p, dp, rho, drho; b=missing, db=missing, LDtype=:SLD, btype=1, eps=GLOBAL_EPS)
```

Calculation of the Bayesian quantum Cramer-Rao bound (BQCRB).

  * `x`: The regimes of the parameters for the integral.
  * `p`: The prior distribution.
  * `dp`: Derivatives of the prior distribution with respect to the unknown parameters to be estimated. For example, dp[0] is the derivative vector on the first parameter.
  * `rho`: Parameterized density matrix.
  * `drho`: Derivatives of the parameterized density matrix (rho) with respect to the unknown parameters to be estimated.
  * `b`: Vector of biases of the form $\textbf{b}=(b(x_0),b(x_1),\dots)^{\mathrm{T}}$.
  * `db`: Derivatives of b on the unknown parameters to be estimated, It should be expressed as $\textbf{b}'=(\partial_0 b(x_0),\partial_1 b(x_1),\dots)^{\mathrm{T}}$.
  * `LDtype`: Types of QFI (QFIM) can be set as the objective function. Options are "SLD" (default), "RLD" and "LLD".
  * `btype`: Types of the BCRB. Options are 1, 2 and 3.
  * `eps`: Machine epsilon.


<a target='_blank' href='https://github.com/QuanEstimation/QuanEstimation.jl/blob/5f47a686c13b059023de2abe67017d7c9564bc9d/src/ObjectiveFunc/BayesianBound/BayesianCramerRao.jl#L79-L94' class='documenter-source'>source</a><br>

##  **`QuanEstimation.BQFIM`** &mdash; *Method*.



```julia
BQFIM(x::AbstractVector, p, rho, drho; LDtype=:SLD, eps=GLOBAL_EPS)
```

Calculation of the Bayesian quantum Fisher information (BQFI) and the Bayesian quantum Fisher information matrix (BQFIM) of the form $\mathcal{F}_{\mathrm{Bayes}}=\int p(\textbf{x})\mathcal{F}\mathrm{d}\textbf{x}$ with $\mathcal{F}$ the QFIM of all types and $p(\textbf{x})$ the prior distribution.

  * `x`: The regimes of the parameters for the integral.
  * `p`: The prior distribution.
  * `rho`: Parameterized density matrix.
  * `drho`: Derivatives of the parameterized density matrix (rho) with respect to the unknown parameters to be estimated.
  * `LDtype`: Types of QFI (QFIM) can be set as the objective function. Options are "SLD" (default), "RLD" and "LLD".
  * `eps`: Machine epsilon.


<a target='_blank' href='https://github.com/QuanEstimation/QuanEstimation.jl/blob/5f47a686c13b059023de2abe67017d7c9564bc9d/src/ObjectiveFunc/BayesianBound/BayesianCramerRao.jl#L44-L56' class='documenter-source'>source</a><br>

##  **`QuanEstimation.Bayes`** &mdash; *Method*.



```julia
Bayes(x, p, rho, y; M=missing, savefile=false)
```

Bayesian estimation. The prior distribution is updated via the posterior distribution obtained by the Bayes' rule and the estimated value of parameters obtained via the maximum a posteriori probability (MAP).

  * `x`: The regimes of the parameters for the integral.
  * `p`: The prior distribution.
  * `rho`: Parameterized density matrix.
  * `y`: The experimental results obtained in practice.
  * `M`: A set of positive operator-valued measure (POVM). The default measurement is a set of rank-one symmetric informationally complete POVM (SIC-POVM).
  * `savefile`: Whether or not to save all the posterior distributions.


<a target='_blank' href='https://github.com/QuanEstimation/QuanEstimation.jl/blob/5f47a686c13b059023de2abe67017d7c9564bc9d/src/Common/BayesEstimation.jl#L1-L12' class='documenter-source'>source</a><br>

##  **`QuanEstimation.BayesCost`** &mdash; *Method*.



```julia
BayesCost(x, p, xest, rho, M; W=missing, eps=GLOBAL_EPS)
```

Calculation of the average Bayesian cost with a quadratic cost function.

  * `x`: The regimes of the parameters for the integral.
  * `p`: The prior distribution.
  * `xest`: The estimators.
  * `rho`: Parameterized density matrix.
  * `M`: A set of POVM.
  * `W`: Weight matrix.
  * `eps`: Machine epsilon.


<a target='_blank' href='https://github.com/QuanEstimation/QuanEstimation.jl/blob/5f47a686c13b059023de2abe67017d7c9564bc9d/src/Common/BayesEstimation.jl#L314-L326' class='documenter-source'>source</a><br>

##  **`QuanEstimation.CFIM`** &mdash; *Method*.



```julia
CFIM(ρ::Matrix{T}, dρ::Vector{Matrix{T}}, M; eps=GLOBAL_EPS) where {T<:Complex}
```

Calculate the classical Fisher information matrix (CFIM). 

  * `ρ`: Density matrix.
  * `dρ`: Derivatives of the density matrix with respect to the unknown parameters to be estimated. For example, drho[1] is the derivative vector with respect to the first parameter.
  * `M`: A set of positive operator-valued measure (POVM). The default measurement is a set of rank-one symmetric informationally complete POVM (SIC-POVM).
  * `eps`: Machine epsilon.


<a target='_blank' href='https://github.com/QuanEstimation/QuanEstimation.jl/blob/5f47a686c13b059023de2abe67017d7c9564bc9d/src/ObjectiveFunc/AsymptoticBound/CramerRao.jl#L278-L287' class='documenter-source'>source</a><br>

##  **`QuanEstimation.CFIM`** &mdash; *Method*.



```julia
CFIM(ρ::Matrix{T}, dρ::Vector{Matrix{T}}; M=nothing, eps=GLOBAL_EPS) where {T<:Complex}
```

When the set of POVM is not given. Calculate the CFIM with SIC-POVM. The SIC-POVM is generated from the Weyl-Heisenberg covariant SIC-POVM fiducial state which can be downloaded from [here](http://www.physics.umb.edu/Research/QBism/solutions.html).


<a target='_blank' href='https://github.com/QuanEstimation/QuanEstimation.jl/blob/5f47a686c13b059023de2abe67017d7c9564bc9d/src/ObjectiveFunc/AsymptoticBound/CramerRao.jl#L322-L327' class='documenter-source'>source</a><br>

##  **`QuanEstimation.CFIM`** &mdash; *Method*.



```julia
CFIM(ρ::Matrix{T}, dρ::Matrix{T}, M; eps=GLOBAL_EPS) where {T<:Complex}
```

When applied to the case of single parameter. Calculate the classical Fisher information (CFI). 


<a target='_blank' href='https://github.com/QuanEstimation/QuanEstimation.jl/blob/5f47a686c13b059023de2abe67017d7c9564bc9d/src/ObjectiveFunc/AsymptoticBound/CramerRao.jl#L300-L305' class='documenter-source'>source</a><br>

##  **`QuanEstimation.CFIM`** &mdash; *Method*.



```julia
CFIM(ρ::Matrix{T}, dρ::Matrix{T}; eps=GLOBAL_EPS) where {T<:Complex}
```

When applied to the case of single parameter and the set of POVM is not given. Calculate the CFI with SIC-POVM. 


<a target='_blank' href='https://github.com/QuanEstimation/QuanEstimation.jl/blob/5f47a686c13b059023de2abe67017d7c9564bc9d/src/ObjectiveFunc/AsymptoticBound/CramerRao.jl#L341-L346' class='documenter-source'>source</a><br>

##  **`QuanEstimation.FIM`** &mdash; *Method*.



```julia
FIM(p::Vector{R}, dp::Vector{R}; eps=GLOBAL_EPS) where {R<:Real}
```

Calculation of the classical Fisher information matrix for classical scenarios. 

  * `p`: The probability distribution.
  * `dp`: Derivatives of the probability distribution on the unknown parameters to be estimated. For example, dp[0] is the derivative vector on the first parameter.
  * `eps`: Machine epsilon.


<a target='_blank' href='https://github.com/QuanEstimation/QuanEstimation.jl/blob/5f47a686c13b059023de2abe67017d7c9564bc9d/src/ObjectiveFunc/AsymptoticBound/CramerRao.jl#L529-L537' class='documenter-source'>source</a><br>

##  **`QuanEstimation.FIM`** &mdash; *Method*.



```julia
FIM(p::Vector{R}, dp::Vector{R}; eps=GLOBAL_EPS) where {R<:Real}
```

When applied to the case of single parameter and the set of POVM is not given. Calculate the classical Fisher information for classical scenarios. 


<a target='_blank' href='https://github.com/QuanEstimation/QuanEstimation.jl/blob/5f47a686c13b059023de2abe67017d7c9564bc9d/src/ObjectiveFunc/AsymptoticBound/CramerRao.jl#L508-L513' class='documenter-source'>source</a><br>

##  **`QuanEstimation.FI_Expt`** &mdash; *Method*.



```julia
FI_Expt(y1, y2, dx; ftype=:norm)
```

Calculate the classical Fisher information (CFI) based on the experiment data.

  * `y1`: Experimental data obtained at the truth value (x).
  * `y1`: Experimental data obtained at x+dx.
  * `dx`: A known small drift of the parameter.
  * `ftype`: The distribution the data follows. Options are: norm, gamma, rayleigh, and poisson.


<a target='_blank' href='https://github.com/QuanEstimation/QuanEstimation.jl/blob/5f47a686c13b059023de2abe67017d7c9564bc9d/src/ObjectiveFunc/AsymptoticBound/CramerRao.jl#L568-L577' class='documenter-source'>source</a><br>

##  **`QuanEstimation.HCRB`** &mdash; *Method*.



```julia
HCRB(ρ::AbstractMatrix, dρ::AbstractVector, C::AbstractMatrix; eps=GLOBAL_EPS)
```

Caltulate the Holevo Cramer-Rao bound (HCRB) via the semidefinite program (SDP).

  * `ρ`: Density matrix.
  * `dρ`: Derivatives of the density matrix on the unknown parameters to be estimated. For example, drho[0] is the derivative vector on the first parameter.
  * `W`: Weight matrix.
  * `eps`: Machine epsilon.


<a target='_blank' href='https://github.com/QuanEstimation/QuanEstimation.jl/blob/5f47a686c13b059023de2abe67017d7c9564bc9d/src/ObjectiveFunc/AsymptoticBound/AnalogCramerRao.jl#L7-L16' class='documenter-source'>source</a><br>

##  **`QuanEstimation.MLE`** &mdash; *Method*.



```julia
MLE(x, rho, y; M=missing, savefile=false)
```

Bayesian estimation. The estimated value of parameters obtained via the maximum likelihood estimation (MLE).

  * `x`: The regimes of the parameters for the integral.
  * `rho`: Parameterized density matrix.
  * `y`: The experimental results obtained in practice.
  * `M`: A set of positive operator-valued measure (POVM). The default measurement is a set of rank-one symmetric informationally complete POVM (SIC-POVM).
  * `savefile`: Whether or not to save all the posterior distributions.


<a target='_blank' href='https://github.com/QuanEstimation/QuanEstimation.jl/blob/5f47a686c13b059023de2abe67017d7c9564bc9d/src/Common/BayesEstimation.jl#L180-L190' class='documenter-source'>source</a><br>

##  **`QuanEstimation.MeasurementOpt`** &mdash; *Method*.



```julia
MeasurementOpt(mtype=:Projection, kwargs...)
```

Measurement optimization.

  * `mtype`: The type of scenarios for the measurement optimization. Options are `:Projection` (default), `:LC` and `:Rotation`.
  * `kwargs...`: keywords and the correponding default vaules. `mtype=:Projection`, `mtype=:LC` and `mtype=:Rotation`, the `kwargs...` are `M=missing`, `B=missing, POVM_basis=missing`, and `s=missing, POVM_basis=missing`, respectively.


<a target='_blank' href='https://github.com/QuanEstimation/QuanEstimation.jl/blob/5f47a686c13b059023de2abe67017d7c9564bc9d/src/OptScenario/OptScenario.jl#L75-L82' class='documenter-source'>source</a><br>

##  **`QuanEstimation.NHB`** &mdash; *Method*.



```julia
NHB(ρ::AbstractMatrix, dρ::AbstractVector, W::AbstractMatrix)
```

Nagaoka-Hayashi bound (NHB) via the semidefinite program (SDP).

  * `ρ`: Density matrix.
  * `dρ`: Derivatives of the density matrix on the unknown parameters to be estimated. For example, drho[0] is the derivative vector on the first parameter.
  * `W`: Weight matrix.


<a target='_blank' href='https://github.com/QuanEstimation/QuanEstimation.jl/blob/5f47a686c13b059023de2abe67017d7c9564bc9d/src/ObjectiveFunc/AsymptoticBound/AnalogCramerRao.jl#L98-L106' class='documenter-source'>source</a><br>

##  **`QuanEstimation.OBB`** &mdash; *Method*.



```julia
OBB(x::AbstractVector, p, dp, rho, drho, d2rho; LDtype=:SLD, eps=GLOBAL_EPS)
```

Calculation of the Bayesian version of Cramer-Rao bound introduced by Van Trees (VTB).

  * `x`: The regimes of the parameters for the integral.
  * `p`: The prior distribution.
  * `dp`: Derivatives of the prior distribution with respect to the unknown parameters to be estimated. For example, dp[0] is the derivative vector on the first parameter.
  * `rho`: Parameterized density matrix.
  * `drho`: Derivatives of the parameterized density matrix (rho) with respect to the unknown parameters to be estimated.
  * `d2rho`: Second order Derivatives of the parameterized density matrix (rho) with respect to the unknown parameters to be estimated.
  * `LDtype`: Types of QFI (QFIM) can be set as the objective function. Options are "SLD" (default), "RLD" and "LLD".
  * `eps`: Machine epsilon.


<a target='_blank' href='https://github.com/QuanEstimation/QuanEstimation.jl/blob/5f47a686c13b059023de2abe67017d7c9564bc9d/src/ObjectiveFunc/BayesianBound/BayesianCramerRao.jl#L423-L436' class='documenter-source'>source</a><br>

##  **`QuanEstimation.QFIM`** &mdash; *Method*.



```julia
QFIM(ρ::Matrix{T}, dρ::Vector{Matrix{T}}; LDtype=:SLD, exportLD::Bool= false, eps=GLOBAL_EPS) where {T<:Complex}
```

When applied to the case of single parameter. Calculation of the quantum Fisher information (QFI) for all types.


<a target='_blank' href='https://github.com/QuanEstimation/QuanEstimation.jl/blob/5f47a686c13b059023de2abe67017d7c9564bc9d/src/ObjectiveFunc/AsymptoticBound/CramerRao.jl#L393-L398' class='documenter-source'>source</a><br>

##  **`QuanEstimation.QFIM`** &mdash; *Method*.



```julia
QFIM(ρ::Matrix{T}, dρ::Matrix{T}; LDtype=:SLD, exportLD::Bool= false, eps=GLOBAL_EPS) where {T<:Complex}
```

Calculation of the quantum Fisher information (QFI) for all types. 

  * `ρ`: Density matrix.
  * `dρ`: Derivatives of the density matrix with respect to the unknown parameters to be estimated. For example, drho[1] is the derivative vector with respect to the first parameter.
  * `LDtype`: Types of QFI (QFIM) can be set as the objective function. Options are `:SLD` (default), `:RLD` and `:LLD`.
  * `exportLD`: export logarithmic derivatives apart from F.
  * `eps`: Machine epsilon.


<a target='_blank' href='https://github.com/QuanEstimation/QuanEstimation.jl/blob/5f47a686c13b059023de2abe67017d7c9564bc9d/src/ObjectiveFunc/AsymptoticBound/CramerRao.jl#L365-L375' class='documenter-source'>source</a><br>

##  **`QuanEstimation.QFIM_Gauss`** &mdash; *Method*.



```julia
QFIM_Gauss(R̄::V, dR̄::VV, D::M, dD::VM) where {V,VV,M,VM<:AbstractVecOrMat}
```

Calculate the SLD based quantum Fisher information matrix (QFIM) with gaussian states.  

  * `R̄` : First-order moment.
  * `dR̄`: Derivatives of the first-order moment with respect to the unknown parameters to be estimated. For example, dR[1] is the derivative vector on the first parameter.
  * `D`: Second-order moment.
  * `dD`: Derivatives of the second-order moment with respect to the unknown parameters to be estimated.
  * `eps`: Machine epsilon.


<a target='_blank' href='https://github.com/QuanEstimation/QuanEstimation.jl/blob/5f47a686c13b059023de2abe67017d7c9564bc9d/src/ObjectiveFunc/AsymptoticBound/CramerRao.jl#L661-L671' class='documenter-source'>source</a><br>

##  **`QuanEstimation.QFIM_Kraus`** &mdash; *Method*.



```julia
QFIM_Kraus(ρ0::AbstractMatrix, K::AbstractVector, dK::AbstractVector; LDtype=:SLD, exportLD::Bool=false, eps=GLOBAL_EPS)
```

Calculation of the quantum Fisher information (QFI) and quantum Fisher information matrix (QFIM) with Kraus operator(s) for all types.

  * `ρ0`: Density matrix.
  * `K`: Kraus operator(s).
  * `dK`: Derivatives of the Kraus operator(s) on the unknown parameters to be estimated. For example, dK[0] is the derivative vector on the first parameter.
  * `LDtype`: Types of QFI (QFIM) can be set as the objective function. Options are `:SLD` (default), `:RLD` and `:LLD`.
  * `exportLD`: Whether or not to export the values of logarithmic derivatives. If set True then the the values of logarithmic derivatives will be exported.
  * `eps`: Machine epsilon.


<a target='_blank' href='https://github.com/QuanEstimation/QuanEstimation.jl/blob/5f47a686c13b059023de2abe67017d7c9564bc9d/src/ObjectiveFunc/AsymptoticBound/CramerRao.jl#L418-L429' class='documenter-source'>source</a><br>

##  **`QuanEstimation.QVTB`** &mdash; *Method*.



```julia
QVTB(x::AbstractVector, p, dp, rho, drho; LDtype=:SLD, eps=GLOBAL_EPS)
```

Calculation of the Bayesian version of Cramer-Rao bound in troduced by Van Trees (VTB).

  * `x`: The regimes of the parameters for the integral.
  * `p`: The prior distribution.
  * `dp`: Derivatives of the prior distribution with respect to the unknown parameters to be estimated. For example, dp[0] is the derivative vector on the first parameter.
  * `rho`: Parameterized density matrix.
  * `drho`: Derivatives of the parameterized density matrix (rho) with respect to the unknown parameters to be estimated.
  * `LDtype`: Types of QFI (QFIM) can be set as the objective function. Options are "SLD" (default), "RLD" and "LLD".
  * `eps`: Machine epsilon.


<a target='_blank' href='https://github.com/QuanEstimation/QuanEstimation.jl/blob/5f47a686c13b059023de2abe67017d7c9564bc9d/src/ObjectiveFunc/BayesianBound/BayesianCramerRao.jl#L294-L306' class='documenter-source'>source</a><br>

##  **`QuanEstimation.QZZB`** &mdash; *Method*.



```julia
QZZB(x::AbstractVector, p::AbstractVector, rho::AbstractVecOrMat; eps=GLOBAL_EPS)
```

Calculation of the quantum Ziv-Zakai bound (QZZB).

  * `x`: The regimes of the parameters for the integral.
  * `p`: The prior distribution.
  * `rho`: Parameterized density matrix.
  * `eps`: Machine epsilon.


<a target='_blank' href='https://github.com/QuanEstimation/QuanEstimation.jl/blob/5f47a686c13b059023de2abe67017d7c9564bc9d/src/ObjectiveFunc/BayesianBound/ZivZakai.jl#L25-L34' class='documenter-source'>source</a><br>

##  **`QuanEstimation.SIC`** &mdash; *Method*.



```julia
SIC(dim::Int64)
```

Generation of a set of rank-one symmetric informationally complete positive operator-valued measure (SIC-POVM).

  * `dim`: The dimension of the system.

Note: SIC-POVM is calculated by the Weyl-Heisenberg covariant SIC-POVM fiducial state which can be downloaded from [here](http://www.physics.umb.edu/Research/QBism/solutions.html).


<a target='_blank' href='https://github.com/QuanEstimation/QuanEstimation.jl/blob/5f47a686c13b059023de2abe67017d7c9564bc9d/src/Common/Common.jl#L146-L153' class='documenter-source'>source</a><br>

##  **`QuanEstimation.SpinSqueezing`** &mdash; *Method*.



```julia
SpinSqueezing(ρ::AbstractMatrix; basis="Dicke", output="KU")
```

Calculate the spin squeezing parameter for the input density matrix. The `basis` can be `"Dicke"` for the Dicke basis, or `"Pauli"` for the Pauli basis. The `output` can be both `"KU"`(for spin squeezing defined by Kitagawa and Ueda) and `"WBIMH"`(for spin squeezing defined by Wineland et al.).


<a target='_blank' href='https://github.com/QuanEstimation/QuanEstimation.jl/blob/5f47a686c13b059023de2abe67017d7c9564bc9d/src/Resource/Resource.jl#L23-L29' class='documenter-source'>source</a><br>

##  **`QuanEstimation.TargetTime`** &mdash; *Method*.



```julia
TargetTime(f::Number, tspan::AbstractVector, func::Function, args...; kwargs...)
```

Calculate the minimum time to reach a precision limit of given level. The `func` can be any objective function during the control optimization, e.g. QFIM, CFIM, HCRB, etc.


<a target='_blank' href='https://github.com/QuanEstimation/QuanEstimation.jl/blob/5f47a686c13b059023de2abe67017d7c9564bc9d/src/Resource/Resource.jl#L73-L78' class='documenter-source'>source</a><br>

##  **`QuanEstimation.VTB`** &mdash; *Method*.



```julia
VTB(x::AbstractVector, p, dp, rho, drho; M=missing, eps=GLOBAL_EPS)
```

Calculation of the Bayesian version of Cramer-Rao bound introduced by Van Trees (VTB).

  * `x`: The regimes of the parameters for the integral.
  * `p`: The prior distribution.
  * `dp`: Derivatives of the prior distribution with respect to the unknown parameters to be estimated. For example, dp[0] is the derivative vector on the first parameter.
  * `rho`: Parameterized density matrix.
  * `drho`: Derivatives of the parameterized density matrix (rho) with respect to the unknown parameters to be estimated.
  * `M`: A set of positive operator-valued measure (POVM). The default measurement is a set of rank-one symmetric informationally complete POVM (SIC-POVM).
  * `eps`: Machine epsilon.


<a target='_blank' href='https://github.com/QuanEstimation/QuanEstimation.jl/blob/5f47a686c13b059023de2abe67017d7c9564bc9d/src/ObjectiveFunc/BayesianBound/BayesianCramerRao.jl#L344-L356' class='documenter-source'>source</a><br>

##  **`QuanEstimation.evolve`** &mdash; *Method*.



```julia
evolve(dynamics::Kraus{dm})
```

Evolution of density matrix under time-independent Hamiltonian without noise and controls.


<a target='_blank' href='https://github.com/QuanEstimation/QuanEstimation.jl/blob/5f47a686c13b059023de2abe67017d7c9564bc9d/src/Parameterization/Kraus/KrausDynamics.jl#L20-L25' class='documenter-source'>source</a><br>

##  **`QuanEstimation.evolve`** &mdash; *Method*.



```julia
evolve(dynamics::Kraus{ket})
```

Evolution of pure states under time-independent Hamiltonian without noise and controls


<a target='_blank' href='https://github.com/QuanEstimation/QuanEstimation.jl/blob/5f47a686c13b059023de2abe67017d7c9564bc9d/src/Parameterization/Kraus/KrausDynamics.jl#L2-L7' class='documenter-source'>source</a><br>

##  **`QuanEstimation.expm`** &mdash; *Method*.



```julia
expm(tspan::AbstractVector, ρ0::AbstractMatrix, H0::AbstractMatrix, dH::AbstractMatrix; decay::Union{AbstractVector, Missing}=missing, Hc::Union{AbstractVector, Missing}=missing, ctrl::Union{AbstractVector, Missing}=missing)
```

When applied to the case of single parameter. 


<a target='_blank' href='https://github.com/QuanEstimation/QuanEstimation.jl/blob/5f47a686c13b059023de2abe67017d7c9564bc9d/src/Parameterization/Lindblad/LindbladDynamics.jl#L112-L117' class='documenter-source'>source</a><br>

##  **`QuanEstimation.expm`** &mdash; *Method*.



```julia
expm(tspan::AbstractVector, ρ0::AbstractMatrix, H0::AbstractMatrix, dH::AbstractVector; decay::Union{AbstractVector, Missing}=missing, Hc::Union{AbstractVector, Missing}=missing, ctrl::Union{AbstractVector, Missing}=missing)
```

The dynamics of a density matrix is of the form  $\partial_t\rho=-i[H,\rho]+\sum_i \gamma_i\left(\Gamma_i\rho\Gamma^{\dagger}_i-\frac{1}{2}\left\{\rho,\Gamma^{\dagger}_i \Gamma_i \right\}\right)$, where $\rho$ is the evolved density matrix, $H$ is the Hamiltonian of the system, $\Gamma_i$ and $\gamma_i$ are the $i\mathrm{th}$ decay operator and the corresponding decay rate.

  * `tspan`: Time length for the evolution.
  * `ρ0`: Initial state (density matrix).
  * `H0`: Free Hamiltonian.
  * `dH`: Derivatives of the free Hamiltonian with respect to the unknown parameters to be estimated. For example, dH[0] is the derivative vector on the first parameter.
  * `decay`: Decay operators and the corresponding decay rates. Its input rule is decay=[[$\Gamma_1$, $\gamma_1$], [$\Gamma_2$, $\gamma_2$],...], where $\Gamma_1$ $(\Gamma_2)$ represents the decay operator and $\gamma_1$ $(\gamma_2)$ is the corresponding decay rate.
  * `Hc`: Control Hamiltonians.
  * `ctrl`: Control coefficients.


<a target='_blank' href='https://github.com/QuanEstimation/QuanEstimation.jl/blob/5f47a686c13b059023de2abe67017d7c9564bc9d/src/Parameterization/Lindblad/LindbladDynamics.jl#L184-L196' class='documenter-source'>source</a><br>

##  **`QuanEstimation.mintime`** &mdash; *Method*.



```julia
mintime(f::Number, opt::ControlOpt, alg::AbstractAlgorithm, obj::AbstractObj, dynamics::AbstractDynamics; savefile::Bool=false, method::String="binary")
```

Search of the minimum time to reach a given value of the objective function.

  * `f`: The given value of the objective function.
  * `opt`: Control Optimization.
  * `alg`: Optimization algorithms, options are `auto-GRAPE`, `GRAPE`, `PSO`, `DE` and `DDPG`.
  * `obj`: Objective function, options are `QFIM_obj`, `CFIM_obj` and `HCRB_obj`.
  * `dynamics`: Lindblad dynamics.
  * `savefile`: Whether or not to save all the control coeffients.
  * `method`: Methods for searching the minimum time to reach the given value of the objective function. Options are `binary` and `forward`.
  * `system`: control system.


<a target='_blank' href='https://github.com/QuanEstimation/QuanEstimation.jl/blob/5f47a686c13b059023de2abe67017d7c9564bc9d/src/run.jl#L57-L71' class='documenter-source'>source</a><br>

##  **`QuanEstimation.ode`** &mdash; *Method*.



```julia
ode(tspan::AbstractVector, ρ0::AbstractMatrix, H0::AbstractMatrix, dH::AbstractMatrix; decay::Union{AbstractVector, Missing}=missing, Hc::Union{AbstractVector, Missing}=missing, ctrl::Union{AbstractVector, Missing}=missing)
```

When applied to the case of single parameter. 


<a target='_blank' href='https://github.com/QuanEstimation/QuanEstimation.jl/blob/5f47a686c13b059023de2abe67017d7c9564bc9d/src/Parameterization/Lindblad/LindbladDynamics.jl#L393-L398' class='documenter-source'>source</a><br>

##  **`QuanEstimation.ode`** &mdash; *Method*.



```julia
ode(tspan::AbstractVector, ρ0::AbstractMatrix, H0::AbstractVector, dH::AbstractVector; decay::Union{AbstractVector, Missing}=missing, Hc::Union{AbstractVector, Missing}=missing, ctrl::Union{AbstractVector, Missing}=missing)
```

The dynamics of a density matrix is of the form  $\partial_t\rho=-i[H,\rho]+\sum_i \gamma_i\left(\Gamma_i\rho\Gamma^{\dagger}_i-\frac{1}{2}\left\{\rho,\Gamma^{\dagger}_i \Gamma_i \right\}\right)$, where $\rho$ is the evolved density matrix, $H$ is the Hamiltonian of the system, $\Gamma_i$ and $\gamma_i$ are the $i\mathrm{th}$ decay operator and the corresponding decay rate.

  * `tspan`: Time length for the evolution.
  * `ρ0`: Initial state (density matrix).
  * `H0`: Free Hamiltonian.
  * `dH`: Derivatives of the free Hamiltonian with respect to the unknown parameters to be estimated. For example, dH[0] is the derivative vector on the first parameter.
  * `decay`: Decay operators and the corresponding decay rates. Its input rule is decay=[[$\Gamma_1$, $\gamma_1$], [$\Gamma_2$, $\gamma_2$],...], where $\Gamma_1$ $(\Gamma_2)$ represents the decay operator and $\gamma_1$ $(\gamma_2)$ is the corresponding decay rate.
  * `Hc`: Control Hamiltonians.
  * `ctrl`: Control coefficients.


<a target='_blank' href='https://github.com/QuanEstimation/QuanEstimation.jl/blob/5f47a686c13b059023de2abe67017d7c9564bc9d/src/Parameterization/Lindblad/LindbladDynamics.jl#L467-L479' class='documenter-source'>source</a><br>

##  **`QuanEstimation.offline`** &mdash; *Method*.



```julia
offline(apt::Adapt_MZI, alg; target::Symbol=:sharpness, eps = GLOBAL_EPS, seed=1234)
```

Offline adaptive phase estimation in the MZI.

  * `apt`: Adaptive MZI struct which contains `x`, `p`, and `rho0`.
  * `alg`: The algorithms for searching the optimal tunable phase. Here, DE and PSO are available.
  * `target`: Setting the target function for calculating the tunable phase. Options are: "sharpness" and "MI".
  * `eps`: Machine epsilon.
  * `seed`: Random seed.


<a target='_blank' href='https://github.com/QuanEstimation/QuanEstimation.jl/blob/5f47a686c13b059023de2abe67017d7c9564bc9d/src/Common/AdaptiveScheme.jl#L691-L701' class='documenter-source'>source</a><br>

##  **`QuanEstimation.online`** &mdash; *Method*.



```julia
online(apt::Adapt_MZI; target::Symbol=:sharpness, output::String="phi")
```

Online adaptive phase estimation in the MZI.

  * `apt`: Adaptive MZI struct which contains x, p, and rho0.
  * `target`: Setting the target function for calculating the tunable phase. Options are: "sharpness" and "MI".
  * `output`: Choose the output variables. Options are: "phi" and "dphi".


<a target='_blank' href='https://github.com/QuanEstimation/QuanEstimation.jl/blob/5f47a686c13b059023de2abe67017d7c9564bc9d/src/Common/AdaptiveScheme.jl#L568-L576' class='documenter-source'>source</a><br>

##  **`QuanEstimation.run`** &mdash; *Method*.



```julia
run(opt::AbstractOpt, alg::AbstractAlgorithm, obj::AbstractObj, dynamics::AbstractDynamics; savefile::Bool=false)
```

Run the optimization problem.

  * `opt`: Types of optimization, options are `ControlOpt`, `StateOpt`, `MeasurementOpt`, `SMopt`, `SCopt`, `CMopt` and `SCMopt`.
  * `alg`: Optimization algorithms, options are `auto-GRAPE`, `GRAPE`, `AD`, `PSO`, `DE`, 'NM' and `DDPG`.
  * `obj`: Objective function, options are `QFIM_obj`, `CFIM_obj` and `HCRB_obj`.
  * `dynamics`: Lindblad or Kraus parameterization process.
  * `savefile`: Whether or not to save all the control coeffients.


<a target='_blank' href='https://github.com/QuanEstimation/QuanEstimation.jl/blob/5f47a686c13b059023de2abe67017d7c9564bc9d/src/run.jl#L24-L35' class='documenter-source'>source</a><br>

##  **`QuanEstimation.suN_generator`** &mdash; *Method*.



```julia
suN_generator(n::Int64)
```

Generation of the SU($N$) generators with $N$ the dimension of the system.

  * `N`: The dimension of the system.


<a target='_blank' href='https://github.com/QuanEstimation/QuanEstimation.jl/blob/5f47a686c13b059023de2abe67017d7c9564bc9d/src/Common/Common.jl#L73-L79' class='documenter-source'>source</a><br>

---
header-includes:
  - \usepackage{caption}
---

# **Control optimization**
The Hamiltonian of a controlled system can be written as
\begin{align}
H = H_0(\textbf{x})+\sum_{k=1}^K u_k(t) H_k,
\end{align}

where $H_0(\textbf{x})$ is the free evolution Hamiltonian with unknown parameters $\textbf{x}$ 
and $H_k$ represents the $k$th control Hamiltonian with $u_k$ the corresponding control 
coefficients. In QuanEstimation, different algorithms are invoked to update the control 
coefficients. The control optimization algorithms are the gradient ascent pulse engineering 
(GRAPE) [[1,2,3]](#Khaneja2005), GRAPE algorithm based on the automatic differentiation 
(auto-GRAPE) [[4]](#Baydin2018), particle swarm optimization (PSO) [[5]](#Kennedy1995), 
and differential evolution (DE) [[6]](#Storn1997). The codes for control optimization are
=== "Python"
	```py
	control = ControlOpt(savefile=False, method="auto-GRAPE", **kwargs)
	control.dynamics(tspan, rho0, H0, dH, Hc, decay=[], ctrl_bound=[], 
	                 dyn_method="expm")
	```
	=== "QFIM"
		``` py
		control.QFIM(W=[], LDtype="SLD")
		```
	=== "CFIM"
		``` py
		control.CFIM(M=[], W=[])
		```
	=== "HCRB"
		``` py
		control.HCRB(W=[])
		```
	In QuanEstimation, the optimization codes are executed in Julia and the data will be saved in
	the `.csv` file. The variable `savefile` indicates whether to save all the control 
	coefficients and its default value is `False` which means the control coefficients for the 
	final episode and the values of the objective function in all episodes will be saved in 
	"controls.csv" and "f.csv", respectively. If set `True` then the control coefficients and the 
	values of the objective function in all episodes will be saved during the training. The package
	contains five control optimization algorithms which can be set via `method`, `**kwargs` is 
	the corresponding keyword and default value.

	After calling `control = ControlOpt()`, the dynamics parameters shoule be input. Here `tspan` 
	is the time length for the evolution and `rho0` represents the density matrix of the initial 
	state. `H0` and `dH` are the free Hamiltonian and its derivatives with respect to the unknown 
	parameters to be estimated. `H0` is a matrix when the free Hamiltonian is time-independent and 
	a list of matrices with the length equal to `tspan` when it is time-dependent. `dH` should be input as 
	$[\partial_a{H_0}, \partial_b{H_0}, \cdots]$. `Hc` is a list representing the control 
	Hamiltonians. `decay` contains decay operators $(\Gamma_1, \Gamma_2, \cdots)$ and the 
	corresponding decay rates $(\gamma_1, \gamma_2, \cdots)$, its input rule is
	decay=[[$\Gamma_1$, $\gamma_1$], [$\Gamma_2$, $\gamma_2$],...]. The default value for 
	`decay` is empty which means the dynamics is unitary. The package can be used to optimize 
	bounded control problems by setting lower and upper bounds of the control coefficients via 
	`ctrl_bound`, which is an array with two elements representing the lower and upper bound of 
	each control coefficient, respectively. The default value of `ctrl_bound=[]` which means the 
	control coefficients are in the regime $[-\infty,\infty]$. `dyn_method="expm"` represents 
	the method for solving the dynamics is matrix exponential, it can also be set as `dyn_method="ode"`
	which means the dynamics (differential equation) is directly solved with the ODE solvers.

	The objective functions for control optimization can be set as QFI $\left[\mathrm{Tr}(W
	\mathcal{F}^{-1})\right]$, CFI $\left[\mathrm{Tr}(W\mathcal{I}^{-1})\right]$, and HCRB, the 
	corresponding codes for them are `control.QFIM()` (default), `control.CFIM()`, and `control.HCRB()`. 
	Here $\mathcal{F}$ and $\mathcal{I}$ are the QFIM and CFIM, $W$ corresponds to `W` is the weight 
	matrix which defaults to the identity matrix. If the users call `control.HCRB()` for single 
	parameter scenario, the program will exit and print `"Program terminated. In the single-parameter 
	scenario, the HCRB is equivalent to the QFI. Please choose 'QFIM' as the objective function"`. 
	`LDtype` in `control.QFIM()` represents the types of the QFIM, it can be set as `LDtype="SLD"` 
	(default), `LDtype="RLD"`, and `LDtype="LLD"`. `M` in `control.CFIM()` represents a set of 
	positive operator-valued measure (POVM) with default value `[]` which means a set of rank-one 
	symmetric informationally complete POVM (SIC-POVM) is used in the calculation.

=== "Julia"
	``` jl
	opt = ControlOpt(ctrl=ctrl, ctrl_bound=ctrl_bound, seed=1234)
	alg = autoGRAPE(kwargs...)
	dynamics = Lindblad(opt, tspan, rho0, H0, dH, Hc, decay=mising, 
	                    dyn_method=:Expm) 
	```
	=== "QFIM"
		``` jl
		obj = QFIM_obj(W=missing, LDtype=:SLD)
		```
	=== "CFIM"
		``` jl
		obj = CFIM_obj(M=missing, W=missing)
		```
	=== "HCRB"
		``` jl
		obj = HCRB_obj(W=missing)
		```	
	``` jl
	run(opt, alg, obj, dynamics; savefile=false)
	```
	In control optimization, a set of control coefficients (optimization variable) and its boundary 
	value can be input via `ctrl=ctrl` and `ctrl_bound=ctrl_bound` in `ControlOpt()`.
	`ctrl` is a list of arrays with the length equal to control Hamiltonians, 
	`ctrl_bound` is an array with two elements representing the lower and upper bound of the 
	control coefficients, respectively. The default value of `ctrl_bound=missing` which means 
	the control coefficients are in the regime $[-\infty,\infty]$. `seed` is the random seed 
	which can ensure the reproducibility of results.
	
	The package can deal with the parameterization process in the form of master equation, the 
	dynamics parameters shoule be input via `Lindblad()`. Here `tspan` is the time length for 
	the evolution and `rho0` represents the density matrix of the initial state. `H0` and `dH` 
	are the free Hamiltonian and its derivatives with respect to the unknown parameters to be 
	estimated. `H0` is a matrix when the free Hamiltonian is time-independent and a list of matrices
	with the length equal to `tspan` when it is time-dependent. `dH` should be input as $[\partial_a{H_0}, 
	\partial_b{H_0}, \cdots]$. `Hc` is a list representing the control Hamiltonians. `decay` 
	contains decay operators $(\Gamma_1, \Gamma_2, \cdots)$ and the corresponding decay rates 
	$(\gamma_1, \gamma_2, \cdots)$ with the input rule decay=[[$\Gamma_1$, $\gamma_1$], 
	[$\Gamma_2$, $\gamma_2$],...]. The default value `decay` is `missing` which means the 
	dynamics is unitary. `dyn_method=:Expm` represents the method for solving the dynamics is 
    matrix exponential, it can also be set as `dyn_method=:Ode` which means the dynamics 
    (differential equation) is directly solved with the ODE solvers.

	The objective functions for control optimization can be set as QFI $\left[\mathrm{Tr}(W
	\mathcal{F}^{-1})\right]$, CFI $\left[\mathrm{Tr}(W\mathcal{I}^{-1})\right]$, and HCRB, the 
	corresponding codes for them are `QFIM_obj()` (default), `CFIM_obj()`, and `HCRB_obj()`. Here 
	$\mathcal{F}$ and $\mathcal{I}$ are the QFIM and CFIM, $W$ corresponds to `W` is the weight 
	matrix which defaults to the identity matrix. If the users call `HCRB_obj()` for single parameter 
	scenario, the program will exit and print `"Program terminated. In the single-parameter scenario, 
	the HCRB is equivalent to the QFI. Please choose 'QFIM_obj' as the objective function"`. 
	`LDtype` in `QFIM_obj()` represents the types of the QFIM, it can be set as `LDtype=:SLD` 
	(default), `LDtype=:RLD`, and `LDtype=:LLD`. `M` in `CFIM_obj()` represents a set of positive 
	operator-valued measure (POVM) with default value `missing` which means a set of rank-one 
	symmetric informationally complete POVM (SIC-POVM) is used in the calculation.

	The variable `savefile` indicates whether to save all the control coefficients and its default 
	value is `false` which means the control coefficients for the final episode and the values of 
	the objective function in all episodes will be saved in "controls.csv" and "f.csv", respectively.
	If set `true` then the control coefficients and the values of the objective function in all 
	episodes will be saved during the training. The algorithm used for optimizing the control
	coefficients in QuanEstimation are GRAPE, auto-GRAPE, PSO, DE, and DDPG. `kwargs...` contains 
	the keywords and defaults value corresponding to the optimization algorithm which will be 
	introduced in detail below.

---
## **GRAPE and auto-GRAPE**
The codes for control optimization with GRAPE and auto-GRAPE are as follows
=== "Python"
	``` py
	control = ControlOpt(method="GRAPE", **kwargs)
	```
	``` py
	control = ControlOpt(method="auto-GRAPE", **kwargs)
	```
	where `kwargs` is of the form
	``` py
	kwargs = {"Adam":True, "ctrl0":[], "max_episode":300, "epsilon":0.01, \
          	  "beta1":0.90, "beta2":0.99}
	```
	The keywords and the default values of GRAPE and auto-GRAPE can be seen in the following table

	| $~~~~~~~~~~$**kwargs$~~~~~~~~~~$ | $~~~~$default values$~~~~$ |
	| :----------:                     | :----------:               |
	| "Adam"                           | True                       |
	| "ctrl0"                          | [ ]                        |
	| "max_episode"                    | 300                        |
	| "epsilon"                        | 0.01                       |
	| "beta1"                          | 0.90                       |
	| "beta2"                          | 0.99                       |

	Adam algorithm can be introduced to update the control coefficients when using GRAPE and 
	auto-GRAPE for control optimization, which can be realized by setting `Adam=True`. In this 
	case, the Adam parameters include learning rate, the exponential decay rate for the first 
	moment estimates and the second moment estimates can be set by the users via `epsilon`, `beta1`,
	and `beta2`, respectively. If `Adam=False`, the control coefficients will update according to 
	the learning rate `"epsilon"`. `ctrl0` is a list representing the initial guesses of control 
	coefficients and `max_episode` is the number of episodes.

=== "Julia"
	``` jl
	alg = GRAPE(Adam=true, max_episode=300, epsilon=0.01, beta1=0.90, 
	            beta2=0.99)
	```
	``` jl
	alg = autoGRAPE(Adam=true, max_episode=300, epsilon=0.01, beta1=0.90, 
	                beta2=0.99)
	```
	The keywords and the default values of GRAPE and auto-GRAPE can be seen in the following table

	| $~~~~~~~~~~$keywords$~~~~~~~~~~$ | $~~~~$default values$~~~~$ |
	| :----------:                     | :----------:               |
	| "Adam"                           | true                       |
	| "max_episode"                    | 300                        |
	| "epsilon"                        | 0.01                       |
	| "beta1"                          | 0.90                       |
	| "beta2"                          | 0.99                       |

	Adam algorithm can be introduced to update the control coefficients when using GRAPE and 
	auto-GRAPE for control optimization, which can be realized by setting `Adam=true`. In this 
	case, the Adam parameters include learning rate, the exponential decay rate for the first 
	moment estimates and the second moment estimates can be set by the users via `epsilon`, `beta1`,
	and `beta2`, respectively. If `Adam=false`, the control coefficients will update according to 
	the learning rate `"epsilon"`.

## **PSO**
The code for control optimization with PSO is as follows
=== "Python"
	``` py
	control = ControlOpt(method="PSO", **kwargs)
	```
	where `kwargs` is of the form
	``` py
	kwargs = {"p_num":10, "ctrl0":[], "max_episode":[1000,100], \
              "c0":1.0, "c1":2.0, "c2":2.0, "seed":1234}
	```
	The keywords and the default values of PSO can be seen in the following table

	| $~~~~~~~~~~$**kwargs$~~~~~~~~~~$ | $~~~~$default values$~~~~$ |
	| :----------:                     | :----------:               |
	| "p_num"                   | 10                         |
	| "ctrl0"                          | [ ]                        |
	| "max_episode"                    | [1000,100]                 |
	| "c0"                             | 1.0                        |
	| "c1"                             | 2.0                        |
	| "c2"                             | 2.0                        |
	| "seed"                           | 1234                       |

	Here `p_num` is the number of particles. `c0`, `c1`, and `c2` are the PSO parameters 
	representing the inertia weight, cognitive learning factor, and social learning factor, 
	respectively. `max_episode` accepts both integer and array with two elements. If it is an 
	integer, for example `max_episode=1000`, it means the program will continuously run 1000 
	episodes. However, if it is an array, for example `max_episode=[1000,100]`, the program will 
	run 1000 episodes in total but replace control coefficients of all the particles with global 
	best every 100 episodes. `seed` is the random seed which can ensure the reproducibility of 
	the results.

=== "Julia"
	``` jl
	alg = PSO(p_num=10, ini_particle=missing, max_episode=[1000,100], 
			  c0=1.0, c1=2.0, c2=2.0)
	```

	The keywords and the default values of PSO can be seen in the following table

	| $~~~~~~~~~~$keywords$~~~~~~~~~~$ | $~~~~$default values$~~~~$ |
	| :----------:                     | :----------:               |
	| "p_num"                          | 10                         |
	| "ini_particle"                   | missing                    |
	| "max_episode"                    | [1000,100]                 |
	| "c0"                             | 1.0                        |
	| "c1"                             | 2.0                        |
	| "c2"                             | 2.0                        |

	Here `p_num` is the number of particles. `c0`, `c1`, and `c2` are the PSO parameters 
	representing the inertia weight, cognitive learning factor, and social learning factor, 
	respectively. `max_episode` accepts both integer and array with two elements. If it is an 
	integer, for example `max_episode=1000`, it means the program will continuously run 1000 
	episodes. However, if it is an array, for example `max_episode=[1000,100]`, the program will 
	run 1000 episodes in total but replace control coefficients of all the particles with global 
	best every 100 episodes. `ini_particle` is a tuple representing the initial guesses of control 
	coefficients.

## **DE**
The code for control optimization with DE is as follows
=== "Python"
	``` py
	control = ControlOpt(method="DE", **kwargs)
	```
	where `kwargs` is of the form
	``` py
	kwargs = {"p_num":10, "ctrl0":[], "max_episode":1000, "c":1.0, \
          	  "cr":0.5, "seed":1234}
	```
	The keywords and the default values of DE can be seen in the following table

	| $~~~~~~~~~~$**kwargs$~~~~~~~~~~$ | $~~~~$default values$~~~~$ |
	| :----------:                     | :----------:               |
	| "p_num"                        | 10                         |
	| "ctrl0"                          | [ ]                        |
	| "max_episode"                    | 1000                       |
	| "c"                              | 1.0                        |
	| "cr"                             | 0.5                        |
	| "seed"                           | 1234                       |

	`p_num` and `max_episode` represent the number of populations and episodes. `c` and `cr` 
	are the mutation constant and the crossover constant.

=== "Julia"
	``` jl
	alg = DE(p_num=10, ini_population=missing, max_episode=1000, 
	         c=1.0, cr=0.5)
	```
	The keywords and the default values of DE can be seen in the following table

	| $~~~~~~~~~~$keywords$~~~~~~~~~~$ | $~~~~$default values$~~~~$ |
	| :----------:                     | :----------:               |
	| "p_num"                          | 10                         |
	| "ini_population"                 | missing                    |
	| "max_episode"                    | 1000                       |
	| "c"                              | 1.0                        |
	| "cr"                             | 0.5                        |

	`ini_population` is a tuple representing the initial guesses of control and `max_episode` 
	represents the number of populations and episodes. `c` and `cr` are the mutation constant 
	and the crossover constant.

**Example 5.1**  
<a id="example5_1"></a>
In this example, the free evolution Hamiltonian of a single qubit system is $H_0=\frac{1}{2}\omega 
\sigma_3$ with $\omega$ the frequency and $\sigma_3$ a Pauli matrix. The dynamics of the system 
is governed by

\begin{align}
\partial_t\rho=-i[H_0, \rho]+ \gamma_{+}\left(\sigma_{+}\rho\sigma_{-}-\frac{1}{2}\{\sigma_{-}
\sigma_{+},\rho\}\right)+ \gamma_{-}\left(\sigma_{-}\rho\sigma_{+}-\frac{1}{2}\{\sigma_{+}\sigma_{-},
\rho\}\right),
\end{align}

where $\gamma_{+}$, $\gamma_{-}$ are decay rates and $\sigma_{\pm}=(\sigma_1 \pm \sigma_2)/2$. 
The control Hamiltonian 
\begin{align}
H_\mathrm{c}=u_1(t)\sigma_1+u_2(t)\sigma_2+u_3(t)\sigma_3.
\end{align}

Here $\sigma_{1}$, $\sigma_{2}$ are also Pauli matrices. The probe state is taken as $|+\rangle$ and 
the measurement for CFI is $\{|+\rangle\langle+|, |-\rangle\langle-|\}$ with
$|\pm\rangle:=\frac{1}{\sqrt{2}}(|0\rangle\pm|1\rangle)$. $|0\rangle$ $(|1\rangle)$ is the eigenstate 
of $\sigma_3$ with respect to the eigenvalue $1$ $(-1)$.
=== "Python"
	``` py
	from quanestimation import *
	import numpy as np

	# initial state
	rho0 = 0.5*np.array([[1., 1.], [1., 1.]])
	# free Hamiltonian
	omega = 1.0
	sx = np.array([[0., 1.], [1., 0.]])
	sy = np.array([[0., -1.j], [1.j, 0.]]) 
	sz = np.array([[1., 0.], [0., -1.]])
	H0 = 0.5*omega*sz
	# derivative of the free Hamiltonian on omega
	dH = [0.5*sz]
	# control Hamiltonians 
	Hc = [sx, sy, sz]
	# dissipation
	sp = np.array([[0., 1.], [0., 0.]])  
	sm = np.array([[0., 0.], [1., 0.]]) 
	decay = [[sp, 0.], [sm, 0.1]]
	# measurement
	M1 = 0.5*np.array([[1., 1.], [1., 1.]])
	M2 = 0.5*np.array([[1., -1.], [-1., 1.]])
	M = [M1, M2]
	# time length for the evolution
	tspan = np.linspace(0., 10., 2500)
	# guessed control coefficients
	cnum = len(tspan)-1
	ctrl0 = [np.array([np.zeros(cnum), np.zeros(cnum), np.zeros(cnum)])]
	```
	=== "auto-GRAPE"
		``` py
		# control algorithm: auto-GRAPE
		GRAPE_paras = {"Adam":True, "ctrl0":ctrl0, "max_episode":300, \
					   "epsilon":0.01, "beta1":0.90, "beta2":0.99}
		control = ControlOpt(savefile=False, method="auto-GRAPE", **GRAPE_paras)
		```
	=== "GRAPE"
		``` py
		# control algorithm: GRAPE
		GRAPE_paras = {"Adam":True, "ctrl0":ctrl0, "max_episode":300, \
					   "epsilon":0.01, "beta1":0.90, "beta2":0.99}
		control = ControlOpt(savefile=False, method="GRAPE", **GRAPE_paras)
		```
	=== "PSO"
		``` py
		# control algorithm: PSO
		PSO_paras = {"p_num":10, "ctrl0":ctrl0, "max_episode":[1000,100], \
					 "c0":1.0, "c1":2.0, "c2":2.0, "seed":1234}
		control = ControlOpt(savefile=False, method="PSO", **PSO_paras)
		```
	=== "DE"
		``` py
		# control algorithm: DE
		DE_paras = {"p_num":10, "ctrl0":ctrl0, "max_episode":1000, "c":1.0, \
				    "cr":0.5, "seed":1234}
		control = ControlOpt(savefile=False, method="DE", **DE_paras)
		```
	<!-- === "DDPG"
		``` py
		# control algorithm: DDPG
		DDPG_paras = {"layer_num":4, "layer_dim":220, "max_episode":500, \
		              "seed":1234}
		control = ControlOpt(savefile=False, method="DDPG", **DDPG_paras)
		``` -->
	``` py
	# input the dynamics data
	control.dynamics(tspan, rho0, H0, dH, Hc, decay=decay, \
	                 ctrl_bound=[-2.0, 2.0], dyn_method="expm")
	```
	=== "QFIM"
		``` py
		# objective function: QFI
		control.QFIM()
		```
	=== "CFIM"
		``` py
		# objective function: CFI
		control.CFIM(M=M)
		```
=== "Julia"
	``` jl
	using QuanEstimation
	using Random

	# initial state
	rho0 = 0.5*ones(2, 2)
	# free Hamiltonian
	omega = 1.0
	sx = [0. 1.; 1. 0.0im]
	sy = [0. -im; im 0.]
	sz = [1. 0.0im; 0. -1.]
	H0 = 0.5*omega*sz
	# derivative of the free Hamiltonian on omega
	dH = [0.5*sz]
	# control Hamiltonians 
	Hc = [sx, sy, sz]
	# dissipation
	sp = [0. 1.; 0. 0.0im]
	sm = [0. 0.; 1. 0.0im]
	decay = [[sp, 0.], [sm, 0.1]]
	# measurement
	M1 = 0.5*[1.0+0.0im  1.; 1.  1.]
	M2 = 0.5*[1.0+0.0im -1.; -1.  1.]
	M = [M1, M2]
	# time length for the evolution
	tspan = range(0., 10., length=2500)
	# guessed control coefficients
	cnum = length(tspan)-1
	ctrl = [zeros(cnum) for _ in 1:length(Hc)]
	ctrl_bound = [-2., 2.]
	# set the optimization type
	opt = QuanEstimation.ControlOpt(ctrl=ctrl, ctrl_bound=ctrl_bound, seed=1234)
	```
	=== "auto-GRAPE"
		``` jl
		# control algorithm: auto-GRAPE
		alg = QuanEstimation.autoGRAPE(Adam=true, max_episode=300, epsilon=0.01, 
		                               beta1=0.90, beta2=0.99)
		```
		=== "QFIM"
			``` jl
			# objective function: QFI
			obj = QuanEstimation.QFIM_obj()
			```
		=== "CFIM"
			``` jl
			# objective function: CFI
			obj = QuanEstimation.CFIM_obj(M=M)
			```
	=== "GRAPE"
		``` jl
		# control algorithm: GRAPE
		alg = QuanEstimation.GRAPE(Adam=true, max_episode=300, epsilon=0.01, 
		                           beta1=0.90, beta2=0.99)
		```
		=== "QFIM"
			``` jl
			# objective function: QFI
			obj = QuanEstimation.QFIM_obj()
			```
		=== "CFIM"
			``` jl
			# objective function: CFI
			obj = QuanEstimation.CFIM_obj(M=M)
			```
	=== "PSO"
		``` jl
		# control algorithm: PSO
		alg = QuanEstimation.PSO(p_num=10, ini_particle=([ctrl],), 
								 max_episode=[1000,100], c0=1.0, 
                         	     c1=2.0, c2=2.0)
		```
		=== "QFIM"
			``` jl
			# objective function: QFI
			obj = QuanEstimation.QFIM_obj()
			```
		=== "CFIM"
			``` jl
			# objective function: CFI
			obj = QuanEstimation.CFIM_obj(M=M)
			```
	=== "DE"
		``` jl
		# control algorithm: DE
		alg = QuanEstimation.DE(p_num=10, ini_population=([ctrl],), 
		                        max_episode=1000, c=1.0, cr=0.5)
		```
		=== "QFIM"
			``` jl
			# objective function: QFI
			obj = QuanEstimation.QFIM_obj()
			```
		=== "CFIM"
			``` jl
			# objective function: CFI
			obj = QuanEstimation.CFIM_obj(M=M)
			```
	<!-- === "DDPG"
		``` jl
		# control algorithm: DDPG
		alg = QuanEstimation.DDPG(max_episode=500, layer_num=4, layer_dim=220)
		```
		=== "QFIM"
			``` jl
			# objective function: QFI
			obj = QuanEstimation.QFIM_obj()
			```
		=== "CFIM"
			``` jl
			# objective function: CFI
			obj = QuanEstimation.CFIM_obj(M=M) -->
			```
	``` jl
	# input the dynamics data
	dynamics = QuanEstimation.Lindblad(opt, tspan, rho0, H0, dH, Hc, decay, 
	                                   dyn_method=:Expm)  
	# run the control optimization problem
	QuanEstimation.run(opt, alg, obj, dynamics; savefile=false)
	```

**Example 5.2**  
<a id="example5_2"></a>
In the multiparameter scenario, the dynamics of electron and nuclear coupling in NV$^{-}$ can 
be expressed as
\begin{align}
\partial_t\rho=-i[H_0,\rho]+\frac{\gamma}{2}(S_3\rho S_3-S^2_3\rho-\rho S^2_3)
\end{align}

with $\gamma$ the dephasing rate. And
\begin{align}
H_0/\hbar=DS^2_3+g_{\mathrm{S}}\vec{B}\cdot\vec{S}+g_{\mathrm{I}}\vec{B}\cdot\vec{I}+\vec{S}^
{\,\mathrm{T}}\mathcal{A}\vec{I}
\end{align}

is the free evolution Hamiltonian, where $\vec{S}=(S_1,S_2,S_3)^{\mathrm{T}}$ and 
$\vec{I}=(I_1,I_2,I_3)^{\mathrm{T}}$ with $S_i=s_i\otimes I$ and $I_i=I\otimes \sigma_i$ 
$(i=1,2,3)$ the electron and nuclear operators. $s_1, s_2, and s_3$ are spin-1 operators with 

\begin{eqnarray}
s_1 = \frac{1}{\sqrt{2}}\left(\begin{array}{ccc}
0 & 1 & 0 \\
1 & 0 & 1 \\
0 & 1 & 0
\end{array}\right),
s_2 = \frac{1}{\sqrt{2}}\left(\begin{array}{ccc}
0 & -i & 0\\
i & 0 & -i\\
0 & i & 0
\end{array}\right), \nonumber
\end{eqnarray}

and $s_3=\mathrm{diag}(1,0,-1)$ and $\sigma_i (i=1,2,3)$ is Pauli matrix. $\mathcal{A}=\mathrm{diag}
(A_1,A_1,A_2)$ is the hyperfine tensor with $A_1$ and $A_2$ the axial and transverse magnetic 
hyperfine coupling coefficients. The coefficients $g_{\mathrm{S}}=g_\mathrm{e}\mu_\mathrm{B}/\hbar$ 
and $g_{\mathrm{I}}=g_\mathrm{n}\mu_\mathrm{n}/\hbar$, where $g_\mathrm{e}$ ($g_\mathrm{n}$) is 
the $g$ factor of the electron (nuclear), $\mu_\mathrm{B}$ ($\mu_\mathrm{n}$) is the Bohr (nuclear) 
magneton, and $\hbar$ is the Plank's constant. $\vec{B}$ is the magnetic field which be estimated.

In this case, the initial state is taken as $\frac{1}{\sqrt{2}}(|1\rangle+|\!-\!1\rangle)\otimes
|\!\!\uparrow\rangle$, where $\frac{1}{\sqrt{2}}(|1\rangle+|\!-\!1\rangle)$ is an electron state 
with $|1\rangle$ $\left(|-\!1\rangle\right)$ the eigenstate of $s_3$ with respect to the eigenvalue $1$ 
($-1$). $|\uparrow\rangle$ is a nuclear state and the eigenstate of $\sigma_3$ with respect 
to the eigenvalue 1. $W$ is set to be identity.

Here three types of measurement optimization are considerd, projective measurement, linear combination of a given set of positive operator-valued measure (POVM) and optimal rotated measurement of an input measurement.
=== "Python"
	``` py
	from quanestimation import *
	import numpy as np
	from numpy.random import random

	# initial state
	rho0 = np.zeros((6, 6), dtype=np.complex128)
	rho0[0][0], rho0[0][4], rho0[4][0], rho0[4][4] = 0.5, 0.5, 0.5, 0.5
	# free Hamiltonian
	sx = np.array([[0., 1.],[1., 0.]])
	sy = np.array([[0., -1.j],[1.j, 0.]]) 
	sz = np.array([[1., 0.],[0., -1.]])
	ide2 = np.array([[1., 0.],[0., 1.]])
	s1 = np.array([[0., 1., 0.],[1., 0., 1.],[0., 1., 0.]])/np.sqrt(2)
	s2 = np.array([[0., -1.j, 0.],[1.j, 0., -1.j],[0., 1.j, 0.]])/np.sqrt(2)
	s3 = np.array([[1., 0., 0.],[0., 0., 0.],[0., 0., -1.]])
	ide3 = np.array([[1., 0., 0.],[0., 1., 0.],[0., 0., 1.]])
	I1, I2, I3 = np.kron(ide3, sx), np.kron(ide3, sy), np.kron(ide3, sz)
	S1, S2, S3 = np.kron(s1, ide2), np.kron(s2, ide2), np.kron(s3, ide2)
	B1, B2, B3 = 5.0e-4, 5.0e-4, 5.0e-4
	# All numbers are divided by 100 in this example 
    # for better calculation accurancy
	cons = 100
	D = (2*np.pi*2.87*1000)/cons
	gS = (2*np.pi*28.03*1000)/cons
	gI = (2*np.pi*4.32)/cons
	A1 = (2*np.pi*3.65)/cons
	A2 = (2*np.pi*3.03)/cons
	H0 = D*np.kron(np.dot(s3, s3), ide2) + gS*(B1*S1+B2*S2+B3*S3) \
		 + gI*(B1*I1+B2*I2+B3*I3) + A1*(np.kron(s1, sx) + np.kron(s2, sy)) \
		 + A2*np.kron(s3, sz)
	# derivatives of the free Hamiltonian on B1, B2 and B3
	dH = [gS*S1+gI*I1, gS*S2+gI*I2, gS*S3+gI*I3]
	# control Hamiltonians 
	Hc = [S1, S2, S3]
	# dissipation
	decay = [[S3, 2*np.pi/cons]]
	# measurement
	dim = len(rho0)
    M = [np.dot(basis(dim, i), basis(dim, i).conj().T) for i in range(dim)]
	# time length for the evolution
	tspan = np.linspace(0., 2., 4000)
	# guessed control coefficients
	cnum = 10
	np.random.seed(1234)
	ini_1 = np.zeros((len(Hc),cnum))
	ini_2 = 0.2*np.ones((len(Hc),cnum))
	ini_3 = -0.2*np.ones((len(Hc),cnum))
	ini_4 = np.array([np.linspace(-0.2,0.2,cnum) for i in range(len(Hc))])
	ini_5 = np.array([np.linspace(-0.2,0.0,cnum) for i in range(len(Hc))])
	ini_6 = np.array([np.linspace(0,0.2,cnum) for i in range(len(Hc))])
	ini_7 = -0.2*np.ones((len(Hc),cnum))+0.01*random((len(Hc),cnum))
	ini_8 = -0.2*np.ones((len(Hc),cnum))+0.01*random((len(Hc),cnum))
	ini_9 = -0.2*np.ones((len(Hc),cnum))+0.05*random((len(Hc),cnum))
	ini_10 = -0.2*np.ones((len(Hc),cnum))+0.05*random((len(Hc),cnum))
	ctrl0 = [ini_1, ini_2, ini_3, ini_4, ini_5, \
		     ini_6, ini_7, ini_8, ini_9, ini_10]
	```
	=== "auto-GRAPE"
		``` py
		# control algorithm: auto-GRAPE
		GRAPE_paras = {"Adam":True, "ctrl0":ctrl0, "max_episode":300, \
					   "epsilon":0.01, "beta1":0.90, "beta2":0.99}
		control = ControlOpt(savefile=False, method="auto-GRAPE", **GRAPE_paras)
		```
		``` py
		# input the dynamics data
		control.dynamics(tspan, rho0, H0, dH, Hc, decay=decay, \
	                     ctrl_bound=[-0.2, 0.2], dyn_method="expm")
		```
		=== "QFIM"
			``` py
			# objective function: tr(WF^{-1})
			control.QFIM()
			```
		=== "CFIM"
			``` py
			# objective function: tr(WI^{-1})
			control.CFIM(M=M)
			```
	=== "PSO"
		``` py
		# control algorithm: PSO
		PSO_paras = {"p_num":10, "ctrl0":ctrl0, "max_episode":[1000,100], \
					 "c0":1.0, "c1":2.0, "c2":2.0, "seed":1234}
		control = ControlOpt(savefile=False, method="PSO", **PSO_paras)
		```
		``` py
		# input the dynamics data
		control.dynamics(tspan, rho0, H0, dH, Hc, decay=decay, \
	                     ctrl_bound=[-0.2, 0.2], dyn_method="expm")
		```
		=== "QFIM"
			``` py
			# objective function: tr(WF^{-1})
			control.QFIM()
			```
		=== "CFIM"
			``` py
			# objective function: tr(WI^{-1})
			control.CFIM(M=M)
			```
		=== "HCRB"
			``` py
			# objective function: HCRB
			control.HCRB()
			```
	=== "DE"
		``` py
		# control algorithm: DE
		DE_paras = {"p_num":10, "ctrl0":ctrl0, "max_episode":1000, "c":1.0, \
				    "cr":0.5, "seed":1234}
		control = ControlOpt(savefile=False, method="DE", **DE_paras)
		```
		``` py
		# input the dynamics data
		control.dynamics(tspan, rho0, H0, dH, Hc, decay=decay, \
	                     ctrl_bound=[-0.2, 0.2], dyn_method="expm")
		```
		=== "QFIM"
			``` py
			# objective function: tr(WF^{-1})
			control.QFIM()
			```
		=== "CFIM"
			``` py
			# objective function: tr(WI^{-1})
			control.CFIM(M=M)
			```
		=== "HCRB"
			``` py
			# objective function: HCRB
			control.HCRB()
			```
	<!-- === "DDPG"
		``` py
		# control algorithm: DDPG
		DDPG_paras = {"layer_num":4, "layer_dim":220, "max_episode":500, \
		              "seed":1234}
		control = ControlOpt(savefile=False, method="DDPG", **DDPG_paras)
		```
		``` py
		# input the dynamics data
		control.dynamics(tspan, rho0, H0, dH, Hc, decay=decay, \
	                     ctrl_bound=[-0.2, 0.2], dyn_method="expm")
		```
		=== "QFIM"
			``` py
			# objective function: tr(WF^{-1})
			control.QFIM()
			```
		=== "CFIM"
			``` py
			# objective function: tr(WI^{-1})
			control.CFIM(M=M)
			``` -->
=== "Julia"
	``` jl
	using QuanEstimation
	using Random
	using LinearAlgebra

	# initial state
	rho0 = zeros(ComplexF64, 6, 6)
	rho0[1:4:5, 1:4:5] .= 0.5
	dim = size(rho0, 1)
	# Hamiltonian
	sx = [0. 1.; 1. 0.]
	sy = [0. -im; im 0.]
	sz = [1. 0.; 0. -1.]
	s1 = [0. 1. 0.; 1. 0. 1.; 0. 1. 0.]/sqrt(2)
	s2 = [0. -im 0.; im 0. -im; 0. im 0.]/sqrt(2)
	s3 = [1. 0. 0.; 0. 0. 0.; 0. 0. -1.]
	Is = I1, I2, I3 = [kron(I(3), sx), kron(I(3), sy), kron(I(3), sz)]
	S = S1, S2, S3 = [kron(s1, I(2)), kron(s2, I(2)), kron(s3, I(2))]
	B = B1, B2, B3 = [5.0e-4, 5.0e-4, 5.0e-4]
	# All numbers are divided by 100 in this example 
	# for better calculation accurancy
	cons = 100
	D = (2pi*2.87*1000)/cons
	gS = (2pi*28.03*1000)/cons
	gI = (2pi*4.32)/cons
	A1 = (2pi*3.65)/cons
	A2 = (2pi*3.03)/cons
	H0 = sum([D*kron(s3^2, I(2)), sum(gS*B.*S), sum(gI*B.*Is),
          	  A1*(kron(s1, sx) + kron(s2, sy)), A2*kron(s3, sz)])
	# derivatives of the free Hamiltonian on B1, B2 and B3
	dH = gS*S+gI*Is
	# control Hamiltonians 
	Hc = [S1, S2, S3]
	# dissipation
	decay = [[S3, 2*pi/cons]]
	# measurement
	M = [QuanEstimation.basis(dim, i)*QuanEstimation.basis(dim, i)' 
	     for i in 1:dim]
	# time length for the evolution 
	tspan = range(0., 2., length=4000)
	# guessed control coefficients
	cnum = 10
	rng = MersenneTwister(1234)
	ini_1 = [zeros(cnum) for _ in 1:length(Hc)]
	ini_2 = 0.2.*[ones(cnum) for _ in 1:length(Hc)]
	ini_3 = -0.2.*[ones(cnum) for _ in 1:length(Hc)]
	ini_4 = [[range(-0.2, 0.2, length=cnum)...] for _ in 1:length(Hc)]
	ini_5 = [[range(-0.2, 0., length=cnum)...] for _ in 1:length(Hc)]
	ini_6 = [[range(0., 0.2, length=cnum)...] for _ in 1:length(Hc)]
	ini_7 = [-0.2*ones(cnum)+0.01*rand(rng,cnum) for _ in 1:length(Hc)]
	ini_8 = [-0.2*ones(cnum)+0.01*rand(rng,cnum) for _ in 1:length(Hc)]
	ini_9 = [-0.2*ones(cnum)+0.05*rand(rng,cnum) for _ in 1:length(Hc)]
	ini_10 = [-0.2*ones(cnum)+0.05*rand(rng,cnum) for _ in 1:length(Hc)]
	ctrl0 = [Symbol("ini_", i)|>eval for i in 1:10]
	# set the optimization type
	opt = QuanEstimation.ControlOpt(ctrl=ini_1, ctrl_bound=[-0.2, 0.2], seed=1234)
	```
	=== "auto-GRAPE"
		``` jl
		# control algorithm: auto-GRAPE
		alg = QuanEstimation.autoGRAPE(Adam=true, max_episode=300, epsilon=0.01, 
		                               beta1=0.90, beta2=0.99)
		```
		=== "QFIM"
			``` jl
			# objective function: tr(WF^{-1})
			obj = QuanEstimation.QFIM_obj()
			```
		=== "CFIM"
			``` jl
			# objective function: tr(WI^{-1})
			obj = QuanEstimation.CFIM_obj(M=M)
			```
	=== "PSO"
		``` jl
		# control algorithm: PSO
		alg = QuanEstimation.PSO(p_num=10, ini_particle=(ctrl0,), 
								 max_episode=[1000,100], c0=1.0, 
                         	     c1=2.0, c2=2.0)
		```
		=== "QFIM"
			``` jl
			# objective function: tr(WF^{-1})
			obj = QuanEstimation.QFIM_obj()
			```
		=== "CFIM"
			``` jl
			# objective function: tr(WI^{-1})
			obj = QuanEstimation.CFIM_obj(M=M)
			```
		=== "HCRB"
			``` jl
			# objective function: HCRB
			obj = QuanEstimation.HCRB_obj()
			```
	=== "DE"
		``` jl
		# control algorithm: DE
		alg = QuanEstimation.DE(p_num=10, ini_population=(ctrl0,), 
		                        max_episode=1000, c=1.0, cr=0.5)
		```
		=== "QFIM"
			``` jl
			# objective function: tr(WF^{-1})
			obj = QuanEstimation.QFIM_obj()
			```
		=== "CFIM"
			``` jl
			# objective function: tr(WI^{-1})
			obj = QuanEstimation.CFIM_obj(M=M)
			```
		=== "HCRB"
			``` jl
			# objective function: HCRB
			obj = QuanEstimation.HCRB_obj()
			```
	<!-- === "DDPG"
		``` jl
		# control algorithm: DDPG
		alg = QuanEstimation.DDPG(max_episode=500, layer_num=4, layer_dim=220)
		```
		=== "QFIM"
			``` jl
			# objective function: tr(WF^{-1})
			obj = QuanEstimation.QFIM_obj()
			```
		=== "CFIM"
			``` jl
			# objective function: tr(WI^{-1})
			obj = QuanEstimation.CFIM_obj(M=M)
			``` -->
	``` jl
	# input the dynamics data
	dynamics = QuanEstimation.Lindblad(opt, tspan, rho0, H0, dH, Hc, decay, 
	                                   dyn_method=:Expm)  
	# run the control optimization problem
	QuanEstimation.run(opt, alg, obj, dynamics; savefile=false)
	```
---
## **Minimum parameterization time optimization**
Search of the minimum time to reach a given value of the objective function.
=== "Python"
	``` py
	control.mintime(f, W=[], M=[], method="binary", target="QFIM", 
				    LDtype="SLD")
	```
=== "Julia"
	``` jl
	mintime(f, opt, alg, obj, dynamics; method="binary", savefile=false)
	```
`f` is the given value of the objective function. In the package, two methods for searching 
the minimum time are provided which are logarithmic search and forward search from the 
beginning of time. It can be realized by setting `method=binary` (default) and 
`method=forward`. `target` represents the objective function for searching the minimum time, 
the users can choose QFI $\left[\mathrm{Tr}(WF^{-1})\right]$, CFI $\left[\mathrm{Tr}(WI^{-1})\right]$, 
and HCRB for the objective functions. If `target="QFIM"`, the types for the logarithmic derivatives 
can be set via `LDtype`.

---
## **Bibliography**
<a id="Khaneja2005">[1]</a>
N. Khaneja, T. Reiss, C. Hehlet, T. Schulte-Herbruggen, and S. J. Glaser,
Optimal control of coupled spin dynamics: Design of NMR pulse sequences by gradient 
ascent algorithms,
[J. Magn. Reson. **172**, 296 (2005).](https://doi.org/10.1016/j.jmr.2004.11.004)

<a id="Liu2017a">[2]</a>
J. Liu and H. Yuan,
Quantum parameter estimation with optimal control,
[Phys. Rev. A **96**, 012117 (2017).](https://doi.org/10.1103/PhysRevA.96.012117)

<a id="Liu2017b">[3]</a>
J. Liu and H. Yuan,
Control-enhanced multiparameter quantum estimation,
[Phys. Rev. A **96**, 042114 (2017).](https://doi.org/10.1103/PhysRevA.96.042114)

<a id="Baydin2018">[4]</a>
A. G. Baydin, B. A. Pearlmutter, A. A. Radul, and J. M. Siskind,
Automatic differentiation in machine learning: a survey,
[J. Mach. Learn. Res. **18**, 1-43 (2018).](http://jmlr.org/papers/v18/17-468.html)

<a id="Kennedy1995">[5]</a>
J. Kennedy and R. Eberhar,
Particle swarm optimization,
[Proc. 1995 IEEE International Conference on Neural Networks **4**, 1942-1948 (1995).
](https://doi.org/10.1109/ICNN.1995.488968)

<a id="Storn1997">[6]</a>
R. Storn and K. Price,
Differential Evolution-A Simple and Efficient Heuristic for global
Optimization over Continuous Spaces,
[J. Global Optim. **11**, 341 (1997).](https://doi.org/10.1023/A:1008202821328)

# **Quantum metrological tools**
QuanEstimation can be used to calculate several well-used metrological tools including 
Quantum Cramér-Rao bounds, Holevo Cramér-Rao bound, Bayesian Cramér-Rao bounds, Quantum 
Ziv-Zakai bound and perform Bayesian estimation.

Notes: When calculating with Python and Julia (i.e., calcute the inverse and eigenvalues 
of matrices), the results may vary due to the inconsistency of the retained effective digits. 
This difference has no effect on optimization. If users want to get consistent results, the same number of significant digits for calculation should be input, 
(i.e., keep 8 decimal places).

## **Quantum Cramér-Rao bounds**
In quantum metrology, quantum Cramér-Rao bounds are well used metrological tools for 
parameter estimation. It can be expressed as [[1,2,3]](#Helstrom1976)
\begin{align}
\mathrm{cov}\left(\hat{\textbf{x}}, \{\Pi_y\}\right) \geq \frac{1}{n}\mathcal{I}^{-1}
\left(\{\Pi_y\}\right) \geq \frac{1}{n} \mathcal{F}^{-1},
\end{align}

where $\mathrm{cov}(\hat{\textbf{x}},\{\Pi_y\})=\sum_y\mathrm{Tr}(\rho\Pi_y)(\hat{\textbf{x}}
-\textbf{x})(\hat{\textbf{x}}-\textbf{x})^{\mathrm{T}}$ is the covariance matrix for the 
unknown parameters $\hat{\textbf{x}}=(\hat{x}_0,\hat{x}_1,\dots)^{\mathrm{T}}$ to be estimated. 
$\{\Pi_y\}$ is a set of positive operator-valued measure (POVM) and $\rho$ represents the 
parameterized density matrix. $n$ is the repetition of the experiment, $\mathcal{I}$ and 
$\mathcal{F}$ are the classical Fisher information matrix (CFIM) and quantum Fisher information 
matrix (QFIM), respectively. The $ab$th entry of CFIM is defined as
\begin{align}
\mathcal{I}_{ab}=\sum_y\frac{1}{p(y|\textbf{x})}[\partial_a p(y|\textbf{x})][\partial_b 
p(y|\textbf{x})]
\end{align}

with $p(y|\textbf{x})=\mathrm{Tr}(\rho\Pi_y)$. The most well-used type of the QFIM is 
SLD-based QFIM of the form
\begin{align}
\mathcal{F}_{ab}=\frac{1}{2}\mathrm{Tr}[\rho (L_aL_b+ L_bL_a)]
\end{align}

with $\mathcal{F}_{ab}$ the $ab$th entry of $\mathcal{F}$ and $L_{a}(L_{b})$ the symmetric 
logarithmic derivative (SLD) operator for $x_{a}(x_b)$. The SLD operator is determined by
\begin{align}
\partial_{a}\rho=\frac{1}{2}(\rho L_{a}+L_{a}\rho).
\end{align}

The $ij$th entry of SLD can be calculated by
\begin{align}
\langle\lambda_i|L_{a}|\lambda_j\rangle=\frac{2\langle\lambda_i| \partial_{a}\rho 
|\lambda_j\rangle}
{\lambda_i+\lambda_j}, ~~\lambda_i (\lambda_j)\neq 0 .
\end{align}

For $\lambda_i (\lambda_j)=0$, the above equation is set to be zero.

Besides, there are right logarithmic derivative (RLD) and left logarithmic derivative (LLD) 
defined by $\partial_{a}\rho=\rho \mathcal{R}_a$ and $\partial_{a}\rho=\mathcal{R}_a^{\dagger}
\rho$ with the  corresponding QFIM  $\mathcal{F}_{ab}=\mathrm{Tr}(\rho \mathcal{R}_a 
\mathcal{R}^{\dagger}_b)$. The RLD and LLD operators are calculated via

\begin{align}
\langle\lambda_i| \mathcal{R}_{a} |\lambda_j\rangle
&= \frac{1}{\lambda_i}\langle\lambda_i| \partial_{a}\rho |\lambda_j\rangle,~~\lambda_i\neq 0, \\
\langle\lambda_i| \mathcal{R}_{a}^{\dagger} |\lambda_j\rangle
&= \frac{1}{\lambda_j}\langle\lambda_i| \partial_{a}\rho |\lambda_j\rangle,~~\lambda_j\neq 0.
\end{align}

In QuanEstimation, three types of the logarithmic derivatives can be solved by calling the 
codes
=== "Python"
    ``` py
    SLD(rho, drho, rep="original", eps=1e-8)
    ```
    ``` py
    RLD(rho, drho, rep="original", eps=1e-8)
    ```
    ``` py
    LLD(rho, drho, rep="original", eps=1e-8)
    ```
=== "Julia"
    ``` jl
    SLD(rho, drho; rep="original", eps=1e-8)
    ```
    ``` jl
    RLD(rho, drho; rep="original", eps=1e-8)
    ```
    ``` jl
    LLD(rho, drho; rep="original", eps=1e-8)
    ```
where `rho` and `drho` are the density matrix of the state and its derivatives with respect to
the unknown parameters to be estimated. `drho` should be input as $[\partial_a{\rho}, 
\partial_b{\rho}, \cdots]$. For single parameter estimation (the length of `drho` is equal to 
one), the output is a matrix and for multiparameter estimation (the length of `drho` is more 
than one), it returns a list. There are two output choices for the logarithmic derivatives 
basis which can be setting through `rep`. The default basis (`rep="original"`) of the logarithmic 
derivatives is the same with `rho` and the users can also request the logarithmic derivatives 
written in the eigenspace of `rho` by `rep="eigen"`. `eps` represents the machine epsilon which 
defaults to $10^{-8}$.

In QuanEstimation, the QFI and QFIM can be calculated via the following function
=== "Python"
    ``` py
    QFIM(rho, drho, LDtype="SLD", exportLD=False, eps=1e-8)
    ```
    `LDtype` represents the types of QFI (QFIM) can be set. Options are `LDtype=SLD` (default), 
    `LDtype=RLD` and `LDtype=LLD`. This function will return QFI (QFIM) if `exportLD=False`,
    however, if the users set `exportLD=True`, it will return logarithmic derivatives apart 
    from QFI (QFIM).
=== "Julia"
    ``` jl
    QFIM(rho, drho; LDtype=:SLD, exportLD=false, eps=1e-8)
    ```
    `LDtype` represents the types of QFI (QFIM) can be set. Options are `LDtype=SLD` (default), 
    `LDtype=RLD` and `LDtype=LLD`. This function will return QFI (QFIM) if `exportLD=false`,
    however, if the users set `exportLD=true`, it will return logarithmic derivatives apart 
    from QFI (QFIM).

**Example 3.1**  
<a id="example3_1"></a>
The Hamiltonian of a single qubit system is $H=\frac{1}{2}\omega \sigma_3$ with $\omega$ 
the frequency and $\sigma_3$ a Pauli matrix. The dynamics of the system is governed by

\begin{align}
\partial_t\rho=-i[H, \rho]+ \gamma_{+}\left(\sigma_{+}\rho\sigma_{-}-\frac{1}{2}\{\sigma_{-}
\sigma_{+},\rho\}\right)+ \gamma_{-}\left(\sigma_{-}\rho\sigma_{+}-\frac{1}{2}\{\sigma_{+}
\sigma_{-},\rho\}\right),
\end{align}

where $\sigma_{\pm}=\frac{1}{2}(\sigma_1 \pm \sigma_2)$ with $\sigma_{1}$, $\sigma_{2}$ Pauli 
matrices and $\gamma_{+}$, $\gamma_{-}$ are decay rates. The probe state is taken as $|+\rangle$ 
with $|+\rangle=\frac{1}{\sqrt{2}}(|0\rangle+|1\rangle)$. Here $|0\rangle$ and $|1\rangle$ are 
the eigenstates of $\sigma_3$ with respect to the eigenvalues $1$ and $-1$.
=== "Python"
    ``` py
    from quanestimation import *
    import numpy as np

    # initial state
    rho0 = 0.5*np.array([[1., 1.], [1., 1.]])
    # free Hamiltonian
    omega = 1.0
    sz = np.array([[1., 0.], [0., -1.]])
    H0 = 0.5*omega*sz
    # derivative of the free Hamiltonian on omega
    dH = [0.5*sz]
    # dissipation
    sp = np.array([[0., 1.], [0., 0.]])  
	sm = np.array([[0., 0.], [1., 0.]]) 
    decay = [[sp, 0.0], [sm, 0.1]]
    # time length for the evolution
    tspan = np.linspace(0., 50., 2000)
    # dynamics
    dynamics = Lindblad(tspan, rho0, H0, dH, decay)
    rho, drho = dynamics.expm()
    # calculation of the QFI
    F = []
    for ti in range(1,2000):
        # QFI
        F_tp = QFIM(rho[ti], drho[ti])
        F.append(F_tp)
    ```
=== "Julia"
    ``` jl
    using QuanEstimation

    # initial state
    rho0 = 0.5*ones(2, 2)
    # free Hamiltonian
    omega = 1.0
    sx = [0. 1.; 1. 0.0im]
	sy = [0. -im; im 0.]
	sz = [1. 0.0im; 0. -1.]
    H0 = 0.5*omega*sz
    # derivative of the free Hamiltonian on omega
    dH = [0.5*sz]
    # dissipation
    sp = [0. 1.; 0. 0.0im]
	sm = [0. 0.; 1. 0.0im]
    decay = [[sp, 0.0], [sm, 0.1]]
    # time length for the evolution
    tspan = range(0., 50., length=2000)
    # dynamics
    rho, drho = QuanEstimation.expm(tspan, rho0, H0, dH, decay)
    # calculation of the QFI
    F = Float64[]
    for ti in 2:length(tspan)
        # QFI
        F_tp = QuanEstimation.QFIM(rho[ti], drho[ti])
        append!(F, F_tp)
    end
    ```
If the parameterization process is excuted via the Kraus operators, the QFI (QFIM) can be 
calculated by calling the function
=== "Python"
    ``` py
    QFIM_Kraus(rho0, K, dK, LDtype="SLD", exportLD=False, eps=1e-8)
    ```
=== "Julia"
    ``` jl
    QFIM_Kraus(rho0, K, dK; LDtype=:SLD, exportLD=false, eps=1e-8)
    ```
where `K` and `dK` are the Kraus operators and the derivatives with respect to the unknown 
parameters to be estimated.

**Example 3.2**  
The Kraus operators for the amplitude damping channel are

\begin{eqnarray}
K_1 = \left(\begin{array}{cc}
1 & 0  \\
0 & \sqrt{1-\gamma}
\end{array}\right),
K_2 = \left(\begin{array}{cc}
0 & \sqrt{\gamma} \\
0 & 0
\end{array}\right), \nonumber
\end{eqnarray}

where $\gamma$ is unknown parameter to be estimated which represents the decay probability. 
In this example, the probe state is taken as $|+\rangle\langle+|$ with $|+\rangle:=\frac{1}
{\sqrt{2}}(|0\rangle+|1\rangle)$. $|0\rangle$ $(|1\rangle)$ is the eigenstate of $\sigma_3$ 
(Pauli matrix) with respect to the eigenvalue $1$ $(-1)$.
=== "Python"
    ``` py
    from quanestimation import *
    import numpy as np

    # initial state
    rho0 = 0.5*np.array([[1., 1.], [1., 1.]])
    # Kraus operators for the amplitude damping channel
    gamma = 0.1
    K1 = np.array([[1., 0.], [0., np.sqrt(1-gamma)]])
    K2 = np.array([[0., np.sqrt(gamma)], [0., 0.]])
    K = [K1, K2]
    # derivatives of Kraus operators on gamma
    dK1 = np.array([[1., 0.], [0., -0.5/np.sqrt(1-gamma)]])
    dK2 = np.array([[0., 0.5/np.sqrt(gamma)], [0., 0.]])
    dK = [[dK1], [dK2]]
    F = QFIM_Kraus(rho0, K, dK)
    ```
=== "Julia"
    ``` jl
    using QuanEstimation

    # initial state
    rho0 = [0.5+0im 0.5; 0.5 0.5]
    # Kraus operators for the amplitude damping channel
    gamma = 0.1
    K1 = [1. 0.; 0. sqrt(1-gamma)]
    K2 = [0. sqrt(gamma); 0. 0.]
    K = [K1, K2]
    # derivatives of Kraus operators on gamma
    dK1 = [1. 0.; 0. -0.5/sqrt(1-gamma)]
    dK2 = [0. 0.5/sqrt(gamma); 0. 0.]
    dK = [[dK1], [dK2]]
    F = QuanEstimation.QFIM_Kraus(rho0, K, dK)
    ```

The FI (FIM) for a set of the probabilities `p` can be calculated by
=== "Python"
    ``` py
    FIM(p, dp, eps=1e-8)
    ```
=== "Julia"
    ``` jl
    FIM(p, dp; eps=1e-8)
    ```
where `dp` is a list representing the derivatives of the probabilities `p` with respect to 
the unknown parameters.

**Example 3.3**  
=== "Python"
    ``` py
    from quanestimation import *

    p = [0.54, 0.46]
    dp = [[0.54], [-0.54]]
    F = FIM(p, dp)
    ```
=== "Julia"
    ``` jl
    using QuanEstimation

    p = [0.54, 0.46]
    dp = [[0.54], [-0.54]]
    F = QuanEstimation.FIM(p, dp)
    ```

The FI can also be calculated based on the experiment data
=== "Python"
    ``` py
    FI_Expt(y1, y2, dx, ftype="norm")
    ```
=== "Julia"
    ``` jl
    FI_Expt(y1, y2, dx; ftype=:norm)
    ```
`y1` and `y2` are two arrays representing the experimental data obtained at $x$ and $x+\delta x$, respectively.  $\delta x$ is a known small drift corresponds to `dx`. 
`ftype` represents the distribution that the data follows, which can be choosen in "norm", 
"gamma", "rayleigh", and "poisson".  `ftype="norm"` represents the normal (Gaussian) distribution
with the probability density function
\begin{align}
f(x)=\frac{1}{\sigma\sqrt{2\pi}}e^{-(x-\mu)^2/2\sigma^2}
\end{align}
for distribution fitting, where $\mu$ and $\sigma$ are the mean and variance of the distribution, 
respectively. 

`ftype="gamma"` represents the gamma distribution of the form
\begin{align}
f(x)=\frac{x^{\alpha-1}e^{-\beta x}\beta^\alpha}{\Gamma(\alpha)}
\end{align}
with $\alpha$ the shape and $\beta$ the rate of the distribution. $\Gamma(\alpha)$ is the gamma function.

If the data follows a rayleigh distribution, the data can be fit through setting 
`ftype="rayleigh"`. The probability density function of the rayleigh distribution is
\begin{align}
f(x)=\frac{x-\mu}{\sigma^2}e^{-(x-\mu)^2/2\sigma^2}
\end{align}
with $\mu$ and $\sigma$ the mean and variance of the distribution.

`ftype="poisson"` represents a discrete Poisson distribution with the probability mass function
\begin{align}
f(k)=\frac{\lambda^k e^{-\lambda}}{k!},
\end{align}
where $k=0,1,2,\cdots$ represents the number of occurrences, $\lambda$ represents the variance
of the data, $!$ is the factorial function. 

In quantum metrology, the CFI (CFIM) are solved by
=== "Python"
    ``` py
    CFIM(rho, drho, M=[], eps=1e-8)
    ```
    Here `M` represents a set of positive operator-valued measure (POVM) with default value `[]`. 
    In this function, a set of rank-one symmetric informationally complete POVM (SIC-POVM) is used 
    when `M=[]`. SIC-POVM is calculated by the Weyl-Heisenberg covariant SIC-POVM fiducial state 
    which can be downloaded from [here](http://www.physics.umb.edu/Research/QBism/solutions.html). 
=== "Julia"
    ``` jl
    CFIM(rho, drho; M=missing, eps=1e-8)
    ```
    Here `M` represents a set of positive operator-valued measure (POVM) with default value `missing`. 
    In this function, a set of rank-one symmetric informationally complete POVM (SIC-POVM) is used 
    when `M=missing`. SIC-POVM is calculated by the Weyl-Heisenberg covariant SIC-POVM fiducial state 
    which can be downloaded from [here](http://www.physics.umb.edu/Research/QBism/solutions.html). 

**Example 3.4**  
<a id="example2_4"></a>
The Hamiltonian of a single qubit system is $H=\frac{1}{2}\omega \sigma_3$ with $\omega$ 
the frequency and $\sigma_3$ a Pauli matrix. The dynamics of the system is governed by
\begin{align}
\partial_t\rho=-i[H, \rho]+ \gamma_{+}\left(\sigma_{+}\rho\sigma_{-}-\frac{1}{2}\{\sigma_{-}
\sigma_{+}, \rho\}\right)+ \gamma_{-}\left(\sigma_{-}\rho\sigma_{+}-\frac{1}{2}\{\sigma_{+}
\sigma_{-},\rho\}\right),
\end{align}

where $\sigma_{\pm}=\frac{1}{2}(\sigma_1 \pm \sigma_2)$ with $\sigma_{1}$, $\sigma_{2}$ Pauli 
matrices and $\gamma_{+}$, $\gamma_{-}$ are decay rates. The probe state is taken as $|+\rangle$ 
and the measurement for CFI is $\{|+\rangle\langle+|, |-\rangle\langle-|\}$ with
$|\pm\rangle=\frac{1}{\sqrt{2}}(|0\rangle\pm|1\rangle)$. Here $|0\rangle$ and $|1\rangle$ are 
the eigenstates of $\sigma_3$ with respect to the eigenvalues $1$ and $-1$.
=== "Python"
    ``` py
    from quanestimation import *
    import numpy as np

    # initial state
    rho0 = 0.5*np.array([[1., 1.], [1., 1.]])
    # free Hamiltonian
    omega = 1.0
    sz = np.array([[1., 0.], [0., -1.]])
    H0 = 0.5*omega*sz
    # derivative of the free Hamiltonian on omega
    dH = [0.5*sz]
    # dissipation
    sp = np.array([[0., 1.], [0., 0.]])  
	sm = np.array([[0., 0.], [1., 0.]]) 
    decay = [[sp, 0.0], [sm, 0.1]]
    # measurement
    M1 = 0.5*np.array([[1., 1.], [1., 1.]])
	M2 = 0.5*np.array([[1., -1.], [-1., 1.]])
    M = [M1, M2]
    # time length for the evolution
    tspan = np.linspace(0., 50., 2000)
    # dynamics
    dynamics = Lindblad(tspan, rho0, H0, dH, decay)
    rho, drho = dynamics.expm()
    # calculation of the CFI
    I = []
    for ti in range(1,2000):
        # CFI
        I_tp = CFIM(rho[ti], drho[ti], M=M)
        I.append(I_tp)
    ```
=== "Julia"
    ``` jl
    using QuanEstimation

    # initial state
    rho0 = 0.5*ones(2, 2)
    # free Hamiltonian
    omega = 1.0
    sx = [0. 1.; 1. 0.0im]
	sy = [0. -im; im 0.]
	sz = [1. 0.0im; 0. -1.]
    H0 = 0.5*omega*sz
    # derivative of the free Hamiltonian on omega
    dH = [0.5*sz]
    # dissipation
    sp = [0. 1.; 0. 0.0im]
	sm = [0. 0.; 1. 0.0im]
    decay = [[sp, 0.0], [sm, 0.1]]
    # measurement
    M1 = 0.5*[1.0+0.0im  1.; 1.  1.]
	M2 = 0.5*[1.0+0.0im -1.; -1.  1.]
    M = [M1, M2]
    # time length for the evolution
    tspan = range(0., 50., length=2000)
    # dynamics
    rho, drho = QuanEstimation.expm(tspan, rho0, H0, dH, decay)
    # calculation of the CFI
    Im = Float64[]
    for ti in 2:length(tspan)
        # CFI
        I_tp = QuanEstimation.CFIM(rho[ti], drho[ti], M)
        append!(Im, I_tp)
    end
    ```

In Bloch representation, the SLD based QFI (QFIM) is calculated by
=== "Python"
    ``` py
    QFIM_Bloch(r, dr, eps=1e-8)
    ```
=== "Julia"
    ``` jl
    QFIM_Bloch(r, dr; eps=1e-8)
    ```
`r` and `dr` are the parameterized Bloch vector and its derivatives of with respect to the 
unknown parameters to be estimated.

**Example 3.5**  
The arbitrary single-qubit state can be written as 
\begin{align}
|\psi\rangle=\cos\frac{\theta}{2}|0\rangle+e^{i\phi}\sin\frac{\theta}{2}|1\rangle
\end{align}

with $\theta$ and $\phi$ the parameters to be estimated. The Bloch vector for this state is
$r=(\sin\theta\cos\phi, \sin\theta\sin\phi, \cos\theta)^{\mathrm{T}}$ and the derivatives 
with respect to $\theta$ and $\phi$ are 
$\partial_\theta r=(\cos\theta\cos\phi, \cos\theta\sin\phi, -\sin\theta)^{\mathrm{T}}$ and 
$\partial_\phi r=(-\sin\theta\sin\phi, \sin\theta\cos\phi, 0)^{\mathrm{T}}$
=== "Python"
    ``` py
    from quanestimation import *
    import numpy as np

    theta, phi = 0.25*np.pi, 0.25*np.pi
    r = np.array([np.sin(theta)*np.cos(phi), \
                  np.sin(theta)*np.sin(phi), \
                  np.cos(theta)])
    dr_theta = np.array([np.cos(theta)*np.cos(phi), \
                         np.cos(theta)*np.sin(phi), \
                         -np.sin(theta)])
    dr_phi = np.array([-np.sin(theta)*np.sin(phi), \
                       np.sin(theta)*np.cos(phi), \
                       0.])
    dr = [dr_theta, dr_phi]
    F = QFIM_Bloch(r, dr)
    ```
=== "Julia"
    ``` jl
    using QuanEstimation
    using LinearAlgebra

    theta, phi = 0.25*pi, 0.25*pi
    r = [sin(theta)*cos(phi), sin(theta)*sin(phi), cos(theta)]
    dr_theta = [cos(theta)*cos(phi), cos(theta)*sin(phi), -sin(theta)]
    dr_phi = [-sin(theta)*sin(phi), sin(theta)*cos(phi), 0.]
    dr = [dr_theta, dr_phi]
    F = QuanEstimation.QFIM_Bloch(r, dr)
    ```

The package can also calculte the SLD based QFI (QFIM) with Gaussian states. 
=== "Python"
    ``` py
    QFIM_Gauss(R, dR, D, dD)
    ```
=== "Julia"
    ``` jl
    QFIM_Gauss(R, dR, D, dD)
    ```
The variable `R` is the expected value $\left(\langle[\textbf{R}]_i\rangle\right)$ of 
$\textbf{R}$ with respect to $\rho$, it is an array representing the first-order moment. 
Here $\textbf{R}=(q_1,p_1,q_2,p_2,\dots)^{\mathrm{T}}$ with $q_i=\frac{1}{\sqrt{2}}
(a_i+a^{\dagger}_i)$ and $p_i=\frac{1}{i\sqrt{2}}(a_i-a^{\dagger}_i)$ represents a vector 
of quadrature operators. `dR` is a list of derivatives of `R` with respect to the unknown 
parameters. The $i$th entry of `dR` is $\partial_{\textbf{x}} \langle[\textbf{R}]_i\rangle$. 
`D` and `dD` represent the second-order moment matrix with the $ij$th entry $D_{ij}=\langle 
[\textbf{R}]_i [\textbf{R}]_j+[\textbf{R}]_j [\textbf{R}]_i\rangle/2$ and its derivatives with 
respect tp the unknown parameters.

**Example 3.6**  
The first and second moments [[13]](#Safranek2019) are

\begin{eqnarray}
\langle[\textbf{R}]_i\rangle = \left(\begin{array}{cc}
0   \\
0  
\end{array}\right),
D = \lambda\left(\begin{array}{cc}
\cosh 2r & -\sinh 2r \\
-\sinh 2r & -\sinh 2r
\end{array}\right), \nonumber
\end{eqnarray}

where $\lambda=\coth\frac{\beta}{2}$.  $r$ and $\beta$ are the parameters to be estimated.
=== "Python"
    ``` py
    from quanestimation import *
    import numpy as np

    dim = 2
    r, beta = 0.2, 1.0
    Lambda = np.cosh(0.5*beta)/np.sinh(0.5*beta)
    # the first-order moment
    R = np.zeros(dim)
    dR = [np.zeros(dim), np.zeros(dim)]
    # the second-order moment
    D = Lambda*np.array([[np.cosh(2*r), -np.sinh(2*r)], \
                         [-np.sinh(2*r), np.cosh(2*r)]])
    dD_r = 2*Lambda*np.array([[np.sinh(2*r), -np.cosh(2*r)], \
                              [-np.cosh(2*r), np.sinh(2*r)]])
    dD_Lambda = 0.5*(Lambda**2-1)*np.array([[-np.cosh(2*r), np.sinh(2*r)], \
                                            [np.sinh(2*r), -np.cosh(2*r)]])
    dD = np.array([dD_r, dD_Lambda])
    F = QFIM_Gauss(R, dR, D, dD)
    ```
=== "Julia"
    ``` jl
    using QuanEstimation

    dim = 2
    r, beta = 0.2, 1.0
    Lambda = coth(0.5*beta)
    # the first-order moment
    R = zeros(dim)
    dR = [zeros(dim), zeros(dim)]
    D = Lambda*[cosh(2*r) -sinh(2*r); -sinh(2*r) cosh(2*r)]
    dD_r = 2*Lambda*[sinh(2*r) -cosh(2*r); -cosh(2*r) sinh(2*r)]
    dD_Lambda = 0.5*(Lambda^2-1)*[-cosh(2*r) sinh(2*r); sinh(2*r) -cosh(2*r)]
    dD = [dD_r, dD_Lambda]
    F = QuanEstimation.QFIM_Gauss(R, dR, D, dD)
    ```
---
## **Holevo Cramér-Rao bound**
Holevo Cramér-Rao bound (HCRB) is of the form [[4,5]](#Holevo1973)
\begin{align}
\mathrm{Tr}(W\mathrm{cov}(\hat{\textbf{x}},\{\Pi_y\}))\geq \min_{\textbf{X},V} \mathrm{Tr}(WV),
\end{align}
where $W$ is the weight matrix and $V\geq Z(\textbf{X})$ with $[Z(\textbf{X})]_{ab}=\mathrm{Tr}
(\rho X_a X_b)$. $\textbf{X}=[X_0,X_1,\cdots]$ with $X_i:=\sum_y (\hat{x}_i(y)-x_i)\Pi_y$. 
The HCRB can be calculated via semidefinite programming as 

\begin{align}
& \min_{\textbf{X},V}~\mathrm{Tr}(WV),  \nonumber \\
& \mathrm{subject}~\mathrm{to}
\begin{cases}
\left(\begin{array}{cc}
V & \Lambda^{\mathrm{T}}R^{\dagger} \\
R\Lambda & I\\
\end{array}\right)\geq 0, \\
\sum_i[\Lambda]_{ai}\mathrm{Tr}(\lambda_i\partial_b\rho)=\delta_{ab}.
\end{cases}
\end{align}

Here $X_i$ is expanded in a specific basis $\{\lambda_i\}$ as $X_i=\sum_j [\Lambda]_{ij}\lambda_j$, 
the Hermitian matrix $Z(\textbf{X})$ satisfies $Z(\textbf{X})=\Lambda^{\mathrm{T}}R^{\dagger}
R\Lambda$. In QuanEstimation, the HCRB can be solved by
=== "Python"
    ``` py
    HCRB(rho, drho, W, eps=1e-8)
    ```
=== "Julia"
    ``` jl
    HCRB(rho, drho, W; eps=1e-8) 
    ```
where `rho` and `drho` are the density matrix of the state and its derivatives with respect to
the unknown parameters to be estimated, respectively. `W` represents the weight matrix defaults 
to identity matrix and `eps` is the machine epsilon with default value $10^{-8}$.

## **Nagaoka-Hayashi bound**
Nagaoka-Hayashi bound (NHB) is another available bound in quantum parameter estimation and 
it is tighter than HCRB in general. The NHB can be expressed as [[6-8]](#Conlon2021)
\begin{equation}
\mathrm{Tr}(W\mathrm{cov}(\hat{\textbf{x}},\{\Pi_y\}))\geq \min_{\textbf{X},\mathcal{Q}} \mathrm{Tr}\left((W\otimes\rho)\mathcal{Q}\right)
\end{equation}

with $W$ the weight matrix and $\mathcal{Q}$ a matrix satisfying $\mathcal{Q}\geq\textbf{X}^{\mathrm{T}}\textbf{X}$. 
The NHB can be solved by the semidefinite programming as

\begin{align}
& \min_{\textbf{X},\mathcal{Q}}~\mathrm{Tr}\left((W\otimes\rho)\mathcal{Q}\right),  \nonumber \\
& \mathrm{subject}~\mathrm{to}~
\begin{cases}
\left(\begin{array}{cc}
\mathcal{Q} & \textbf{X}^{\mathrm{T}} \\
\textbf{X} & I\\
\end{array}\right)\geq 0, \\
\mathrm{Tr}(\rho X_a)=0,\,\forall a, \\
\mathrm{Tr}(X_a\partial_b\rho)=\delta_{ab},\,\forall a, b.\\
\end{cases}
\end{align}

In QuanEstimation, the NHB can be solved by
=== "Python"
    ``` py
    NHB(rho, drho, W)
    ```
=== "Julia"
    ``` jl
    NHB(rho, drho, W) 
    ```

---

**Example 3.7**  
<a id="example3_7"></a>
The Hamiltonian of a two-qubit system with $XX$ coupling is 
\begin{align}
H=\omega_1\sigma_3^{(1)}+\omega_2\sigma_3^{(2)}+g\sigma_1^{(1)}\sigma_1^{(2)},
\end{align}

where $\omega_1$, $\omega_2$ are the frequencies of the first and second qubit, $\sigma_i^{(1)}
=\sigma_i\otimes I$ and $\sigma_i^{(2)}=I\otimes\sigma_i$ for $i=1,2,3$. $\sigma_1$, 
$\sigma_2$, $\sigma_3$ are Pauli matrices and $I$ denotes the identity matrix. The dynamics 
is described by the master equation 
\begin{align}
\partial_t\rho=-i[H, \rho]+\sum_{i=1,2}\gamma_i\left(\sigma_3^{(i)}\rho\sigma_3^{(i)}-\rho\right)
\end{align}

with $\gamma_i$ the decay rate for the $i$th qubit.

The probe state is taken as $\frac{1}{\sqrt{2}}(|00\rangle+|11\rangle)$ and the weight matrix 
is set to be identity. The measurement for $\mathrm{Tr}(W\mathcal{I^{-1}})$ is $\{\Pi_1$, 
$\Pi_2$, $I-\Pi_1-\Pi_2\}$ with $\Pi_1=0.85|00\rangle\langle 00|$ and $\Pi_2=0.4|\!+
\!+\rangle\langle+\!+\!|$. Here $|\pm\rangle:=\frac{1}{\sqrt{2}}(|0\rangle\pm|1\rangle)$ with 
$|0\rangle$ $(|1\rangle)$ the eigenstate of $\sigma_3$ with respect to the eigenvalue $1$ ($-1$).
=== "Python"
    ``` py 
    from quanestimation import *
    import numpy as np

    # initial state
    psi0 = np.array([1., 0., 0., 1.])/np.sqrt(2)
    rho0 = np.dot(psi0.reshape(-1,1), psi0.reshape(1,-1).conj())
    # free Hamiltonian
    omega1, omega2, g = 1.0, 1.0, 0.1
    sx = np.array([[0., 1.], [1., 0.]])
	sy = np.array([[0., -1.j], [1.j, 0.]]) 
	sz = np.array([[1., 0.], [0., -1.]])
    ide = np.array([[1., 0.], [0., 1.]])   
    H0 = omega1*np.kron(sz, ide)+omega2*np.kron(ide, sz)+g*np.kron(sx, sx)
    # derivatives of the free Hamiltonian on omega2 and g
    dH = [np.kron(ide, sz), np.kron(sx, sx)] 
    # dissipation
    decay = [[np.kron(sz,ide), 0.05], [np.kron(ide,sz), 0.05]]
    # measurement
    m1 = np.array([1., 0., 0., 0.])
    M1 = 0.85*np.dot(m1.reshape(-1,1), m1.reshape(1,-1).conj())
    M2 = 0.1*np.ones((4, 4))
    M = [M1, M2, np.identity(4)-M1-M2]
    # weight matrix
    W = np.identity(2)
    # time length for the evolution
    tspan = np.linspace(0., 5., 200)
    # dynamics
    dynamics = Lindblad(tspan, rho0, H0, dH, decay)
    rho, drho = dynamics.expm()
    # calculation of the HCRB and NHB
    f_HCRB, f_NHB = [], []
    for ti in range(len(tspan)):
        # HCRB
        f_tp1 = HCRB(rho[ti], drho[ti], W, eps=1e-7)
        f_HCRB.append(f_tp1)
        # NHB
        f_tp2 = NHB(rho[ti], drho[ti], W)
        f_NHB.append(f_tp2)
    ```
=== "Julia"
    ``` jl
    using QuanEstimation
    using LinearAlgebra

    # initial state
    psi0 = [1., 0., 0., 1.]/sqrt(2)
    rho0 = psi0*psi0'
    # free Hamiltonian
    omega1, omega2, g = 1.0, 1.0, 0.1
    sx = [0. 1.; 1. 0.0im]
	sy = [0. -im; im 0.]
	sz = [1. 0.0im; 0. -1.]
    H0 = omega1*kron(sz, I(2)) + omega2*kron(I(2), sz) + g*kron(sx, sx)
    # derivatives of the free Hamiltonian with respect to omega2 and g
    dH = [kron(I(2), sz), kron(sx, sx)]
    # dissipation
    decay = [[kron(sz, I(2)), 0.05], [kron(I(2), sz), 0.05]]
    # measurement
    m1 = [1., 0., 0., 0.]
    M1 = 0.85*m1*m1'
    M2 = 0.1*ones(4, 4)
    M = [M1, M2, I(4)-M1-M2]
    # time length for the evolution
    tspan = range(0., 5., length=200)
    # dynamics
    rho, drho = QuanEstimation.expm(tspan, rho0, H0, dH, decay)
    # weight matrix
    W = one(zeros(2, 2))
    # calculation of the HCRB and NHB
    f_HCRB, f_NHB = [], []
    for ti in 2:length(tspan)
        # HCRB
        f_tp1 = QuanEstimation.HCRB(rho[ti], drho[ti], W)
        append!(f_HCRB, f_tp1)
        # NHB
        f_tp2 = QuanEstimation.NHB(rho[ti], drho[ti], W)
        append!(f_NHB, f_tp2)
    end
    ```
---

## **Bayesian Cramér-Rao bounds**
The Bayesion version of the classical Fisher information (matrix) and quantum Fisher information 
(matrix) can be calculated by <br>
<center> $\mathcal{I}_{\mathrm{Bayes}}=\int p(\textbf{x})\mathcal{I}\mathrm{d}\textbf{x}$ </center> <br>
and <br>
<center> $\mathcal{F}_{\mathrm{Bayes}}=\int p(\textbf{x})\mathcal{F}\mathrm{d}\textbf{x},$</center> <br>
where $p(\textbf{x})$ is the prior distribution, $\mathcal{I}$ and $\mathcal{F}$ are CFI (CFIM) 
and QFI (QFIM) of all types, respectively.

In QuanEstimation, BCFI (BCFIM) and BQFI (BQFIM) can be solved via
=== "Python"
    ``` py
    BCFIM(x, p, rho, drho, M=[], eps=1e-8)
    ```
    ``` py
    BQFIM(x, p, rho, drho, LDtype="SLD", eps=1e-8)
    ```
    where `x` represents the regimes of the parameters for the integral, it should be input as a 
    list of arrays. `p` is an array representing the prior distribution. The input varibles `rho` 
    and `drho` are two multidimensional lists with the dimensions as `x`. For example, for three 
    parameter ($x_0, x_1, x_2$) estimation, the $ijk$th entry of `rho` and `drho` are $\rho$ and 
    $[\partial_0\rho, \partial_1\rho, \partial_2\rho]$ with respect to the values $[x_0]_i$, 
    $[x_1]_j$ and $[x_2]_k$, respectively.`LDtype` represents the types of QFI (QFIM) can be set,
    options are `LDtype=SLD` (default), `LDtype=RLD` and `LDtype=LLD`. `M` represents a set of 
    positive operator-valued measure (POVM) with default value `[]`. In QuanEstimation, a set of 
    rank-one symmetric informationally complete POVM (SIC-POVM) is load when `M=[]`. SIC-POVM is 
    calculated by the Weyl-Heisenberg covariant SIC-POVM fiducial state which can be downloaded 
    from [here](http://www.physics.umb.edu/Research/QBism/solutions.html).
=== "Julia"
    ``` jl
    BCFIM(x, p, rho, drho; M=missing, eps=1e-8)
    ```
    ``` jl
    BQFIM(x, p, rho, drho; LDtype=:SLD, eps=1e-8)
    ```
    where `x` represents the regimes of the parameters for the integral, it should be input as a 
    list of arrays. `p` is an array representing the prior distribution. The input varibles `rho` 
    and `drho` are two multidimensional lists with the dimensions as `x`. For example, for three 
    parameter ($x_0, x_1, x_2$) estimation, the $ijk$th entry of `rho` and `drho` are $\rho$ and 
    $[\partial_0\rho, \partial_1\rho, \partial_2\rho]$ with respect to the values $[x_0]_i$, 
    $[x_1]_j$ and $[x_2]_k$, respectively.`LDtype` represents the types of QFI (QFIM) can be set,
    options are `LDtype=SLD` (default), `LDtype=RLD` and `LDtype=LLD`. `M` represents a set of 
    positive operator-valued measure (POVM) with default value `missing`. In QuanEstimation, a set of 
    rank-one symmetric informationally complete POVM (SIC-POVM) is load when `M=missing`. SIC-POVM is 
    calculated by the Weyl-Heisenberg covariant SIC-POVM fiducial state which can be downloaded 
    from [here](http://www.physics.umb.edu/Research/QBism/solutions.html).

In the Bayesian scenarios, the covariance matrix with a prior distribution $p(\textbf{x})$ is 
defined as
\begin{align}
\mathrm{cov}(\hat{\textbf{x}},\{\Pi_y\})=\int p(\textbf{x})\sum_y\mathrm{Tr}(\rho\Pi_y)
(\hat{\textbf{x}}-\textbf{x})(\hat{\textbf{x}}-\textbf{x})^{\mathrm{T}}\mathrm{d}\textbf{x},
\end{align}

where $\textbf{x}=(x_0,x_1,\dots)^{\mathrm{T}}$ are the unknown parameters to be estimated and 
the integral $\int\mathrm{d}\textbf{x}:=\int\mathrm{d}x_0\int\mathrm{d}x_1\cdots$. $\{\Pi_y\}$ is 
a set of POVM and $\rho$ represents the parameterized density matrix. Two types of Bayesian 
Cramér-Rao bound (BCRB) are calculated in this package, the first one is 
\begin{align}
\mathrm{cov}(\hat{\textbf{x}},\{\Pi_y\})\geq \int p(\textbf{x})\left(B\mathcal{I}^{-1}B
+\textbf{b}\textbf{b}^{\mathrm{T}}\right)\mathrm{d}\textbf{x},
\end{align}

where $\textbf{b}$ and $\textbf{b}'$ are the vectors of biase and its derivatives with respect to 
$\textbf{x}$. $B$ is a diagonal matrix with the $i$th entry $B_{ii}=1+[\textbf{b}']_{i}$ and 
$\mathcal{I}$ is the CFIM. The second one is
\begin{align}
\mathrm{cov}(\hat{\textbf{x}},\{\Pi_y\})\geq \mathcal{B}\,\mathcal{I}_{\mathrm{Bayes}}^{-1}\,
\mathcal{B}+\int p(\textbf{x})\textbf{b}\textbf{b}^{\mathrm{T}}\mathrm{d}\textbf{x},
\end{align}

where $\mathcal{B}=\int p(\textbf{x})B\mathrm{d}\textbf{x}$ is the average of $B$ and 
$\mathcal{I}_{\mathrm{Bayes}}$ is the average of the CFIM.

The third one is 
\begin{align}
\mathrm{cov}(\hat{\textbf{x}},\{\Pi_y\})\geq \int p(\textbf{x})
\mathcal{G}\left(\mathcal{I}_p+\mathcal{I}\right)^{-1}\mathcal{G}^{\mathrm{T}}\mathrm{d}\textbf{x}
\end{align}

with $[\mathcal{I}_{p}]_{ab}:=[\partial_a \ln p(\textbf{x})][\partial_b \ln p(\textbf{x})]$ and
$\mathcal{G}_{ab}:=[\partial_b\ln p(\textbf{x})][\textbf{b}]_a+B_{aa}\delta_{ab}$.

Three types of Bayesian Quantum Cramér-Rao bound (BCRB) are calculated, the first one is 
\begin{align}
\mathrm{cov}(\hat{\textbf{x}},\{\Pi_y\})\geq\int p(\textbf{x})\left(B\mathcal{F}^{-1}B
+\textbf{b}\textbf{b}^{\mathrm{T}}\right)\mathrm{d}\textbf{x}
\end{align}
        
with $\mathcal{F}$ the QFIM for all types. The second one is
\begin{align}
\mathrm{cov}(\hat{\textbf{x}},\{\Pi_y\})\geq \mathcal{B}\,\mathcal{F}_{\mathrm{Bayes}}^{-1}\,
\mathcal{B}+\int p(\textbf{x})\textbf{b}\textbf{b}^{\mathrm{T}}\mathrm{d}\textbf{x}
\end{align}

with $\mathcal{F}_{\mathrm{Bayes}}$ the average of the QFIM.

The third one is 
\begin{align}
\mathrm{cov}(\hat{\textbf{x}},\{\Pi_y\})\geq \int p(\textbf{x})
\mathcal{G}\left(\mathcal{I}_p+\mathcal{F}\right)^{-1}\mathcal{G}^{\mathrm{T}}\mathrm{d}\textbf{x}.
\end{align}

In QuanEstimation, the BCRB and BQCRB are calculated via
=== "Python"
    ``` py
    BCRB(x, p, dp, rho, drho, M=[], b=[], db=[], btype=1, eps=1e-8)
    ```
    ``` py
    BQCRB(x, p, dp, rho, drho, b=[], db=[], btype=1, LDtype="SLD", eps=1e-8)
    ```
    where `b` and `db` are the vectors of biases and its derivatives on the unknown parameters. 
    For unbiased estimates, `b=[]` and `db=[]`. In QuanEstimation, the users can set the types of 
    BCRB and BQCRB via the variable `btype`. 
=== "Julia"
    ``` jl
    BCRB(x, p, dp, rho, drho; M=missing, b=missing, db=missing, 
         btype=1, eps=1e-8)
    ```
    ``` jl
    BQCRB(x, p, dp, rho, drho; b=missing, db=missing, btype=1, 
          LDtype=:SLD, eps=1e-8)
    ```
    where `b` and `db` are the vectors of biases and its derivatives on the unknown parameters. 
    For unbiased estimates, `b=missing` and `db=missing`. In QuanEstimation, the users can set 
    the types of BCRB and BQCRB via the variable `btype`. 

For single parameter estimation, Ref [[9]](#Liu2016) calculates the optimal biased bound based 
on the first type of the BQCRB, it can be realized numerically via
=== "Python"
    ``` py
    OBB(x, p, dp, rho, drho, d2rho, LDtype="SLD", eps=1e-8)
    ```
=== "Julia"
    ``` jl
    OBB(x, p, dp, rho, drho, d2rho; LDtype=:SLD, eps=1e-8)
    ```
`d2rho` is a list representing the second order derivatives of `rho` on `x`.

Van Trees in 1968 [[10]](#vanTrees1968) provides a well used Bayesian version of Cramér-Rao 
bound known as Van Trees bound (VTB). 
<center> $\mathrm{cov}(\hat{\textbf{x}},\{\Pi_y\})\geq \left(\mathcal{I}_{\mathrm{prior}}
+\mathcal{I}_{\mathrm{Bayes}}\right)^{-1},$ </center>  

where $\mathcal{I}_{\mathrm{prior}}=\int p(\textbf{x})\mathcal{I}_{p}\mathrm{d}\textbf{x}$ 
is the CFIM for $p(\textbf{x})$ and $\mathcal{I}_{\mathrm{Bayes}}$ is the average of the CFIM.

The quantum version (QVTB) provided by Tsang, Wiseman 
and Caves [[12]](#Tsang2011). 
<center> $\mathrm{cov}(\hat{\textbf{x}},\{\Pi_y\})\geq \left(\mathcal{I}_{\mathrm{prior}}
+\mathcal{F}_{\mathrm{Bayes}}\right)^{-1}$ </center>  

with $\mathcal{F}_{\mathrm{Bayes}}$ the average of the QFIM of all types.

The functions to calculate the VTB and QVTB are
=== "Python"
    ``` py
    VTB(x, p, dp, rho, drho, M=[], eps=1e-8)
    ```
    ``` py
    QVTB(x, p, dp, rho, drho, LDtype="SLD", eps=1e-8)
    ```
=== "Julia"
    ``` jl
    VTB(x, p, dp, rho, drho; M=missing,eps=1e-8)
    ```
    ``` jl
    QVTB(x, p, dp, rho, drho; LDtype=:SLD, eps=1e-8)
    ```
Here the variables in the codes are the same with `BCRB` and `BQCRB`.

## **Quantum Ziv-Zakai bound**
The expression of Quantum Ziv-Zakai bound (QZZB) with a prior distribution $p(x)$ in a finite 
regime $[\alpha,\beta]$ is

\begin{eqnarray}
\mathrm{var}(\hat{x},\{\Pi_y\}) &\geq & \frac{1}{2}\int_0^\infty \mathrm{d}\tau\tau
\mathcal{V}\int_{-\infty}^{\infty} \mathrm{d}x\min\!\left\{p(x), p(x+\tau)\right\} \nonumber \\
& & \times\left(1-\frac{1}{2}||\rho(x)-\rho(x+\tau)||\right),
\end{eqnarray}

where $||\cdot||$ represents the trace norm and $\mathcal{V}$ is the "valley-filling" 
operator satisfying $\mathcal{V}f(\tau)=\max_{h\geq 0}f(\tau+h)$. $\rho(x)$ is the 
parameterized density matrix. 

In QuanEstimation, the QZZB can be calculated via the function:
=== "Python"
    ``` py
    QZZB(x, p, rho, eps=1e-8)
    ```
=== "Julia"
    ``` py
    QZZB(x, p, rho; eps=1e-8)
    ```
where `x` is a list of array representing the regime of the parameter for the integral, `p` is 
an array representing the prior distribution and `rho` is a multidimensional list representing 
the density matrix. `eps` is the machine epsilon with default value $10^{-8}$.

---
**Example 3.8**  
<a id="example3_8"></a>
The Hamiltonian of a qubit system under a magnetic field $B$ in the XZ plane is
\begin{align}
H=\frac{B\omega_0}{2}(\sigma_1\cos{x}+\sigma_3\sin{x})
\end{align}

with $x$ the unknown parameter and $\sigma_{1}$, $\sigma_{3}$ Pauli matrices. The probe state 
is taken as $\frac{1}{\sqrt{2}}(|0\rangle+|1\rangle)$ with $|0\rangle$ ($|1\rangle$) the 
eigenvstates of $\sigma_3$ with respect to the eigenvalues $1$ ($-1$). The measurement 
for classical bounds is a set of rank-one symmetric informationally complete positive 
operator-valued measure (SIC-POVM).

Take the Gaussian prior distribution $p(x)=\frac{1}{c\eta\sqrt{2\pi}}\exp\left({-\frac{(x-\mu)^2}
{2\eta^2}}\right)$ on $[-\pi/2, \pi/2]$ with $\mu$ and $\eta$ the expectation and standard 
deviation, respectively. Here $c=\frac{1}{2}\big[\mathrm{erf}(\frac{\pi-2\mu}{2\sqrt{2}\eta})
+\mathrm{erf}(\frac{\pi+2\mu}{2\sqrt{2}\eta})\big]$ is the normalized coefficient with 
$\mathrm{erf}(x):=\frac{2}{\sqrt{\pi}}\int^x_0 e^{-t^2}\mathrm{d}t$ the error function.
=== "Python"
    ``` py
    from quanestimation import *
    import numpy as np
    from scipy.integrate import simps

    # initial state
    rho0 = 0.5*np.array([[1., 1.], [1., 1.]])
    # free Hamiltonian
    B, omega0 = 0.5*np.pi, 1.0
    sx = np.array([[0., 1.], [1., 0.]])
    sy = np.array([[0., -1.j], [1.j, 0.]]) 
    sz = np.array([[1., 0.], [0., -1.]])
    H0_func = lambda x: 0.5*B*omega0*(sx*np.cos(x)+sz*np.sin(x))
    # derivative of the free Hamiltonian on x
    dH_func = lambda x: [0.5*B*omega0*(-sx*np.sin(x)+sz*np.cos(x))]
    # prior distribution
    x = np.linspace(-0.5*np.pi, 0.5*np.pi, 100)
    mu, eta = 0.0, 0.2
    p_func = lambda x, mu, eta: np.exp(-(x-mu)**2/(2*eta**2)) \
                                /(eta*np.sqrt(2*np.pi))
    dp_func = lambda x, mu, eta: -(x-mu)*np.exp(-(x-mu)**2/(2*eta**2)) \
                                  /(eta**3*np.sqrt(2*np.pi))
    p_tp = [p_func(x[i], mu, eta) for i in range(len(x))]
    dp_tp = [dp_func(x[i], mu, eta) for i in range(len(x))]
    # normalization of the distribution
    c = simps(p_tp, x)
    p, dp = p_tp/c, dp_tp/c
    # time length for the evolution
    tspan = np.linspace(0., 1., 1000)
    # dynamics
    rho = [np.zeros((len(rho0), len(rho0)), dtype=np.complex128) \
           for i in range(len(x))]
    drho = [[np.zeros((len(rho0), len(rho0)), dtype=np.complex128)] \
             for i in range(len(x))]
    for i in range(len(x)):
        H0_tp = H0_func(x[i])
        dH_tp = dH_func(x[i])
        dynamics = Lindblad(tspan, rho0, H0_tp, dH_tp)
        rho_tp, drho_tp = dynamics.expm()
        rho[i] = rho_tp[-1]
        drho[i] = drho_tp[-1]
    ```
    ``` py
    # Classical Bayesian bounds
    f_BCRB1 = BCRB([x], p, [], rho, drho, M=[], btype=1)
    f_BCRB2 = BCRB([x], p, [], rho, drho, M=[], btype=2)
    f_BCRB3 = BCRB([x], p, dp, rho, drho, M=[], btype=3)
    f_VTB = VTB([x], p, dp, rho, drho, M=[])
    ```
    ``` py
    # Quantum Bayesian bounds
    f_BQCRB1 = BQCRB([x], p, [], rho, drho, btype=1)
    f_BQCRB2 = BQCRB([x], p, [], rho, drho, btype=2)
    f_BQCRB3 = BQCRB([x], p, dp, rho, drho, btype=3)
    f_QVTB = QVTB([x], p, dp, rho, drho)
    f_QZZB = QZZB([x], p, rho)
    ```
=== "Julia"
    ``` jl
    using QuanEstimation
    using Trapz

    # free Hamiltonian
    function H0_func(x)
        return 0.5*B*omega0*(sx*cos(x)+sz*sin(x))
    end
    # derivative of the free Hamiltonian on x
    function dH_func(x)
        return [0.5*B*omega0*(-sx*sin(x)+sz*cos(x))]
    end
    # prior distribution
    function p_func(x, mu, eta)
        return exp(-(x-mu)^2/(2*eta^2))/(eta*sqrt(2*pi))
    end
    function dp_func(x, mu, eta)
        return -(x-mu)*exp(-(x-mu)^2/(2*eta^2))/(eta^3*sqrt(2*pi))
    end

    B, omega0 = 0.5*pi, 1.0
    sx = [0. 1.; 1. 0.0im]
	sy = [0. -im; im 0.]
	sz = [1. 0.0im; 0. -1.]
    # initial state
    rho0 = 0.5*ones(2, 2)
    # prior distribution
    x = range(-0.5*pi, stop=0.5*pi, length=100) |>Vector
    mu, eta = 0.0, 0.2
    p_tp = [p_func(x[i], mu, eta) for i in 1:length(x)]
    dp_tp = [dp_func(x[i], mu, eta) for i in 1:length(x)]
    # normalization of the distribution
    c = trapz(x, p_tp)
    p = p_tp/c
    dp = dp_tp/c
    # time length for the evolution
    tspan = range(0., stop=1., length=1000)
    # dynamics
    rho = Vector{Matrix{ComplexF64}}(undef, length(x))
    drho = Vector{Vector{Matrix{ComplexF64}}}(undef, length(x))
    for i = 1:length(x) 
        H0_tp = H0_func(x[i])
        dH_tp = dH_func(x[i])
        rho_tp, drho_tp = QuanEstimation.expm(tspan, rho0, H0_tp, dH_tp)
        rho[i], drho[i] = rho_tp[end], drho_tp[end]
    end
    ```
    ``` jl
    # Classical Bayesian bounds
    f_BCRB1 = QuanEstimation.BCRB([x], p, dp, rho, drho; btype=1)
    f_BCRB2 = QuanEstimation.BCRB([x], p, dp, rho, drho; btype=2)
    f_BCRB3 = QuanEstimation.BCRB([x], p, dp, rho, drho; btype=3)
    f_VTB = QuanEstimation.VTB([x], p, dp, rho, drho)
    ```
    ``` jl
    # Quantum Bayesian bounds
    f_BQCRB1 = QuanEstimation.BQCRB([x], p, dp, rho, drho, btype=1)
    f_BQCRB2 = QuanEstimation.BQCRB([x], p, dp, rho, drho, btype=2)
    f_BQCRB3 = QuanEstimation.BQCRB([x], p, dp, rho, drho, btype=3)
    f_QVTB = QuanEstimation.QVTB([x], p, dp, rho, drho)
    f_QZZB = QuanEstimation.QZZB([x], p, rho)
    ```
---
## **Bayesian estimation**
In QuanEstimation, two types of Bayesian estimation are considered including maximum a 
posteriori estimation (MAP) and maximum likelihood estimation (MLE). In Bayesian estimation, 
the prior distribution 
is updated as
\begin{align}
p(\textbf{x}|y)=\frac{p(y|\textbf{x})p(\textbf{x})}{\int p(y|\textbf{x})p(\textbf{x})
\mathrm{d}\textbf{x}}
\end{align}

with $p(\textbf{x})$ the current prior distribution and $y$ the outcome of the experiment. 
In practice, the prior distribution is replaced with $p(\textbf{x}|y)$ and the estimated 
value of $\textbf{x}$ can be evaluated by
=== "Python"
    ``` py
    Bayes(x, p, rho, y, M=[], estimator="mean", savefile=False)
    ```
    ``` py
    MLE(x, rho, y, M=[], savefile=False)
    ```
    where `x` is a list of arrays representing the regimes of the parameters for the integral and 
    `p` is an array representing the prior distribution. For multiparameter estimation, `p` is 
    multidimensional. The input varible `rho` is a multidimensional list with the dimensions as `x` 
    representing the parameterized density matrix. `M` contains a set of positive operator-valued 
    measure (POVM). In QuanEstimation, a set of rank-one symmetric informationally complete POVM 
    (SIC-POVM) is used when `M=[]`. SIC-POVM is calculated by the Weyl-Heisenberg covariant SIC-POVM 
    fiducial state which can be downloaded from [here](http://www.physics.umb.edu/Research/QBism/solutions.html). 
        `eatimator` in `Bayes()` representing the estimators which is defaulted by the mean value of the 
    paramters. Also, it can be set as `MAP`. The posterior distributions (likelihood function) in the 
    final iteration and the estimated values in all iterations will be saved in "pout.npy" ("Lout.npy") 
    and "xout.npy" if `savefile=False`. However, if the users want to save all the posterior 
    distributions (likelihood function) and the estimated values in all iterations, the variable 
    `savefile` needs to be set to `True`.
=== "Julia"
    ``` jl
    Bayes(x, p, rho, y; M=missing, estimator="mean", savefile=false)
    ```
    ``` jl
    MLE(x, rho, y; M=missing, savefile=false)
    ```
    where `x` is a list of arrays representing the regimes of the parameters for the integral and 
    `p` is an array representing the prior distribution. For multiparameter estimation, `p` is 
    multidimensional. The input varible `rho` is a multidimensional list with the dimensions as `x` 
    representing the parameterized density matrix. `M` contains a set of positive operator-valued 
    measure (POVM). In QuanEstimation, a set of rank-one symmetric informationally complete POVM 
    (SIC-POVM) is used when `M=missing`. SIC-POVM is calculated by the Weyl-Heisenberg covariant SIC-POVM 
    fiducial state which can be downloaded from [here](http://www.physics.umb.edu/Research/QBism/solutions.html). 
        `eatimator` in `Bayes()` representing the estimators which is defaulted by the mean value of the 
    paramters. Also, it can be set as `MAP`. The posterior distributions (likelihood function) in the 
    final iteration and the estimated values in all iterations will be saved in "pout.csv" ("Lout.csv") 
    and "xout.csv" if `savefile=false`. However, if the users want to save all the posterior 
    distributions (likelihood function) and the estimated values in all iterations, the variable 
    `savefile` needs to be set to `true`.

**Example 3.9**  
<a id="example3_9"></a>
The Hamiltonian of a qubit system is 
\begin{align}
H=\frac{B\omega_0}{2}(\sigma_1\cos{x}+\sigma_3\sin{x}),
\end{align}

where $B$ is the magnetic field in the XZ plane, $x$ is the unknown parameter and $\sigma_{1}$, 
$\sigma_{3}$ are the Pauli matrices. The probe state is taken as $|\pm\rangle$. The measurement 
is $\{|\!+\rangle\langle+\!|,|\!-\rangle\langle-\!|\}$. Here $|\pm\rangle:=\frac{1}{\sqrt{2}}
(|0\rangle\pm|1\rangle)$ with $|0\rangle$ $(|1\rangle)$ the eigenstate of $\sigma_3$ with respect 
to the eigenvalue $1$ $(-1)$. In this example, the prior distribution $p(x)$ is uniform on 
$[0, \pi/2]$.
=== "Python"
    ``` py
    from quanestimation import *
    import numpy as np
    import random

    # initial state
    rho0 = 0.5*np.array([[1., 1.], [1., 1.]])
    # free Hamiltonian
    B, omega0 = np.pi/2.0, 1.0
    sx = np.array([[0., 1.], [1., 0.]])
    sy = np.array([[0., -1.j], [1.j, 0.]]) 
    sz = np.array([[1., 0.], [0., -1.]])
    H0_func = lambda x: 0.5*B*omega0*(sx*np.cos(x)+sz*np.sin(x))
    # derivative of the free Hamiltonian on x
    dH_func = lambda x: [0.5*B*omega0*(-sx*np.sin(x)+sz*np.cos(x))]
    # measurement
    M1 = 0.5*np.array([[1., 1.], [1., 1.]])
    M2 = 0.5*np.array([[1.,-1.], [-1., 1.]])
    M = [M1, M2]
    # prior distribution
    x = np.linspace(0., 0.5*np.pi, 1000)
    p = (1.0/(x[-1]-x[0]))*np.ones(len(x))
    # time length for the evolution
    tspan = np.linspace(0., 1., 1000)
    # dynamics
    rho = [np.zeros((len(rho0), len(rho0)), dtype=np.complex128) \
           for i in range(len(x))]
    for i in range(len(x)):
        H0 = H0_func(x[i])
        dH = dH_func(x[i])
        dynamics = Lindblad(tspan, rho0, H0, dH)
        rho_tp, drho_tp = dynamics.expm()
        rho[i] = rho_tp[-1]
    ```
    ``` py
    # Generation of the experimental results
    y = [0 for i in range(500)]
    res_rand = random.sample(range(0, len(y)), 125)
    for i in range(len(res_rand)):
        y[res_rand[i]] = 1
    ```
    ``` py
    # Maximum a posteriori estimation
    pout, xout = Bayes([x], p, rho, y, M=M, estimator="MAP", \
                       savefile=False)
    ```
    ``` py
    # Maximum likelihood estimation
    Lout, xout = MLE([x], rho, y, M=M, savefile=False)
    ```
=== "Julia"
    ``` jl
    using QuanEstimation
    using Random
    using StatsBase

    # free Hamiltonian
    function H0_func(x)
        return 0.5*B*omega0*(sx*cos(x)+sz*sin(x))
    end
    # derivative of the free Hamiltonian on x
    function dH_func(x)
        return [0.5*B*omega0*(-sx*sin(x)+sz*cos(x))]
    end

    B, omega0 = pi/2.0, 1.0
    sx = [0. 1.; 1. 0.0im]
	sy = [0. -im; im 0.]
	sz = [1. 0.0im; 0. -1.]
    # initial state
    rho0 = 0.5*ones(2, 2)
    # measurement 
    M1 = 0.5*[1.0+0.0im  1.; 1.  1.]
	M2 = 0.5*[1.0+0.0im -1.; -1.  1.]
    M = [M1, M2]
    # prior distribution
    x = range(0., stop=0.5*pi, length=100) |>Vector
    p = (1.0/(x[end]-x[1]))*ones(length(x))
    # time length for the evolution
    tspan = range(0., stop=1., length=1000)
    # dynamics
    rho = Vector{Matrix{ComplexF64}}(undef, length(x))
    for i = 1:length(x) 
        H0_tp = H0_func(x[i])
        dH_tp = dH_func(x[i])
        rho_tp, drho_tp = QuanEstimation.expm(tspan, rho0, H0_tp, dH_tp)
        rho[i] = rho_tp[end]
    end
    ```
    ``` jl
    # Generation of the experimental results
    Random.seed!(1234)
    y = [0 for i in 1:500]
    res_rand = sample(1:length(y), 125, replace=false)
    for i in 1:length(res_rand)
        y[res_rand[i]] = 1
    end
    ```
    ``` jl
    # Maximum a posteriori estimation
    pout, xout = QuanEstimation.Bayes([x], p, rho, y; M=M, estimator="MAP",
                                      savefile=false)
    ```
    ``` jl
    # Maximum likelihood estimation
    Lout, xout = QuanEstimation.MLE([x], rho, y, M=M; savefile=false)
    ```

The average Bayesian cost [[14]](#Robert2007) for a quadratic cost function can be 
calculated via
\begin{equation}
\bar{C}:=\int p(\textbf{x})\sum_y p(y|\textbf{x})(\textbf{x}-\hat{\textbf{x}})^{\mathrm{T}}
W(\textbf{x}-\hat{\textbf{x}})\,\mathrm{d}\textbf{x}
\end{equation}

In QuanEstimation, this can be realized by calling
=== "Python"
    ``` py
    BayesCost(x, p, xest, rho, y, M, W=[], eps=1e-8)
    ```
=== "Julia"
    ``` jl
    BayesCost(x, p, xest, rho, y, M; W=missing, eps=1e-8)
    ```
`xest` represents the estimators for the parameters.

Besides, the average Bayesian cost bounded by [[5]](#Rafal2020) 
\begin{equation}
\bar{C}\geq\int p(\textbf{x})\left(\textbf{x}^{\mathrm{T}}W\textbf{x}\right)\mathrm{d}\textbf{x}
-\sum_{ab}W_{ab}\mathrm{Tr}\left(\bar{\rho}\bar{L}_a \bar{L}_b\right),  
\label{eq:BCB}
\end{equation}

and for single-parameter scenario, this inequality reduces to
\begin{equation}
\bar{C}\geq \int p(x) x^2\,\mathrm{d}x-\mathrm{Tr}(\bar{\rho}\bar{L}^2). 
\end{equation}

The function for calculating the Bayesian cost bound (BCB) is
=== "Python"
    ``` py
    BCB(x, p, rho, W=[], eps=1e-8)
    ```
=== "Julia"
    ``` jl
    BCB(x, p, rho; W=missing, eps=1e-8)
    ```
**Example 3.10**  
<a id="example3_10"></a>
The Hamiltonian of a qubit system is 
\begin{align}
H=\frac{B\omega_0}{2}(\sigma_1\cos{x}+\sigma_3\sin{x}),
\end{align}

where $B$ is the magnetic field in the XZ plane, $x$ is the unknown parameter and $\sigma_{1}$, 
$\sigma_{3}$ are the Pauli matrices. The probe state is taken as $|\pm\rangle$. The measurement 
is $\{|\!+\rangle\langle+\!|,|\!-\rangle\langle-\!|\}$. Here $|\pm\rangle:=\frac{1}{\sqrt{2}}
(|0\rangle\pm|1\rangle)$ with $|0\rangle$ $(|1\rangle)$ the eigenstate of $\sigma_3$ with respect 
to the eigenvalue $1$ $(-1)$. In this example, the prior distribution $p(x)$ is uniform on 
$[0, \pi/2]$.
=== "Python"
    ``` py
    from quanestimation import *
    import numpy as np
    import random

    # initial state
    rho0 = 0.5*np.array([[1., 1.], [1., 1.]])
    # free Hamiltonian
    B, omega0 = np.pi/2.0, 1.0
    sx = np.array([[0., 1.], [1., 0.]])
    sy = np.array([[0., -1.j], [1.j, 0.]]) 
    sz = np.array([[1., 0.], [0., -1.]])
    H0_func = lambda x: 0.5*B*omega0*(sx*np.cos(x)+sz*np.sin(x))
    # derivative of the free Hamiltonian on x
    dH_func = lambda x: [0.5*B*omega0*(-sx*np.sin(x)+sz*np.cos(x))]
    # measurement
    M1 = 0.5*np.array([[1., 1.], [1., 1.]])
    M2 = 0.5*np.array([[1.,-1.], [-1., 1.]])
    M = [M1, M2]
    # prior distribution
    x = np.linspace(0., 0.5*np.pi, 1000)
    p = (1.0/(x[-1]-x[0]))*np.ones(len(x))
    # time length for the evolution
    tspan = np.linspace(0., 1., 1000)
    # dynamics
    rho = [np.zeros((len(rho0), len(rho0)), dtype=np.complex128) \
           for i in range(len(x))]
    for i in range(len(x)):
        H0 = H0_func(x[i])
        dH = dH_func(x[i])
        dynamics = Lindblad(tspan, rho0, H0, dH)
        rho_tp, drho_tp = dynamics.expm()
        rho[i] = rho_tp[-1]
    ```
    ``` py
    # average Bayesian cost
    M = SIC(2)
    xest = [np.array([0.8]), np.array([0.9]),np.array([1.0]),np.array([1.2])]
    C = BayesCost([x], p, xest, rho, M, eps=1e-8)
    ```
    ``` py
    # Bayesian cost Bound
    C = BCB([x], p, rho, eps=1e-8)
    ```
=== "Julia"
    ``` jl
    using QuanEstimation
    using Random
    using StatsBase

    # free Hamiltonian
    function H0_func(x)
        return 0.5*B*omega0*(sx*cos(x)+sz*sin(x))
    end
    # derivative of the free Hamiltonian on x
    function dH_func(x)
        return [0.5*B*omega0*(-sx*sin(x)+sz*cos(x))]
    end

    B, omega0 = pi/2.0, 1.0
    sx = [0. 1.; 1. 0.0im]
	sy = [0. -im; im 0.]
	sz = [1. 0.0im; 0. -1.]
    # initial state
    rho0 = 0.5*ones(2, 2)
    # measurement 
    M1 = 0.5*[1.0+0.0im  1.; 1.  1.]
	M2 = 0.5*[1.0+0.0im -1.; -1.  1.]
    M = [M1, M2]
    # prior distribution
    x = range(0., stop=0.5*pi, length=100) |>Vector
    p = (1.0/(x[end]-x[1]))*ones(length(x))
    # time length for the evolution
    tspan = range(0., stop=1., length=1000)
    # dynamics
    rho = Vector{Matrix{ComplexF64}}(undef, length(x))
    for i = 1:length(x) 
        H0_tp = H0_func(x[i])
        dH_tp = dH_func(x[i])
        rho_tp, drho_tp = QuanEstimation.expm(tspan, rho0, H0_tp, dH_tp)
        rho[i] = rho_tp[end]
    end
    ```
    ``` py
    # average Bayesian cost
    M = QuanEstimation.SIC(2)
    xest = [[0.8], [0.9], [1.0], [1.2]]
    C = QuanEstimation.BayesCost([x], p, xest, rho, M, eps=1e-8)
    ```
    ``` py
    # Bayesian cost Bound
    C = QuanEstimation.BCB([x], p, rho, eps=1e-8)
    ```
---
## **Bibliography**
<a id="Helstrom1976">[1]</a>
C. W. Helstrom, 
*Quantum Detection and Estimation Theory*
(New York: Academic, 1976).

<a id="Holevo1982">[2]</a> 
A. S. Holevo, 
*Probabilistic and Statistical Aspects of Quantum Theory*
(Amsterdam: North-Holland, 1982).

<a id="Liu2020">[3]</a> 
J. Liu, H. Yuan, X.-M. Lu, and X. Wang,
Quantum Fisher information matrix and multiparameter estimation,
[J. Phys. A: Math. Theor. **53**, 023001 (2020).](https://doi.org/10.1088/1751-8121/ab5d4d)

<a id="Holevo1973">[4]</a> 
A. S Holevo,
Statistical decision theory for quantum systems,
[J. Multivariate Anal. **3**, 337-394 (1973).](https://doi.org/10.1016/0047-259X(73)90028-6)

<a id="Rafal2020">[5]</a> 
R. Demkowicz-Dobrzański, W. Górecki, and M. Guţă,
Multi-parameter estimation beyond Quantum Fisher Information,
[J. Phys. A: Math. Theor. **53**, 363001 (2020).](https://doi.org/10.1088/1751-8121/ab8ef3)

<a id="Nagaoka1989">[6]</a> 
H. Nagaoka,
A New Approach to Cra ´ mer–Rao Bounds for Quantum State Estimation,
Tech. Rep. IT89-42, 9 (1989).

<a id="Hayashi1999">[7]</a> 
M. Hayashi,
On simultaneous measurement of noncommutative observables. In Development of 
Infinite-Dimensional Non-Commutative Anaysis,
96–188 (Kyoto Univ., 1999).

<a id="Conlon2021">[8]</a> 
L. O. Conlon, J. Suzuki, P. K. Lam, and S. M. Assad,
Efficient computation of the Nagaoka–Hayashi bound for multiparameter estimation with separable measurements,
[npj Quantum Inf.  **7**, 110 (2021).](https://doi.org/10.1038/s41534-021-00414-1)

<a id="Liu2016">[9]</a>
J. Liu and H. Yuan, 
Valid lower bound for all estimators in quantum parameter estimation, 
[New J. Phys. **18**, 093009 (2016).](https://doi.org/10.1088/1367-2630/18/9/093009)

<a id="vanTrees1968">[10]</a> 
H. L. Van Trees, 
*Detection, estimation, and modulation theory: Part I*
(Wiley, New York, 1968).

<a id="Zhong2013">[11]</a> 
W. Zhong, Z. Sun, J. Ma, X. Wang, and F. Nori,
Fisher information under decoherence in Bloch representation, 
[Phys. Rev. A **87**, 022337 (2013).](https://doi.org/10.1103/PhysRevA.87.022337)

<a id="Tsang2011">[12]</a> 
M. Tsang, H. M. Wiseman, and C. M. Caves, 
Fundamental quantum limit to waveform estimation, 
[Phys. Rev. Lett. **106**, 090401 (2011).](https://doi.org/10.1103/PhysRevLett.106.090401)

<a id="Safranek2019">[13]</a> 
D. Šafránek,
Estimation of Gaussian quantum states,
[J. Phys. A: Math. Theor. **52**, 035304 (2019).](https://doi.org/10.1088/1751-8121/aaf068)

<a id="Robert2007">[14]</a> 
C. P. Robert,
*The Bayesian Choice* (Berlin: Springer, 2007).

# **Adaptive measurement schemes**
In QuanEstimation, the Hamiltonian of the adaptive system should be written as
$H(\textbf{x}+\textbf{u})$ with $\textbf{x}$ the unknown parameters and $\textbf{u}$ 
the tunable parameters. The tunable parameters $\textbf{u}$ are used to let the 
Hamiltonian work at the optimal point $\textbf{x}_{\mathrm{opt}}$. In this scenario,
the adaptive estimation can be excuted through
=== "Python"
    ``` py
    apt = Adapt(x, p, rho0, method="FOP", savefile=False, 
                max_episode=1000, eps=1e-8)
    apt.dynamics(tspan, H, dH, Hc=[], ctrl=[], decay=[], 
                 dyn_method="expm")               
    apt.CFIM(M=[], W=[]) 
    ```
    where `x` is a list of arrays representing the regime of the parameters for the integral, 
    `p` is an array representing the prior distribution, it is multidimensional for multiparameter
    estimation.`rho0` is the density matrix of the probe state. The number of iterations can be 
    set via `max_episode` with the default value 1000. `eps` represents the machine epsilon which 
    defaults to $10^{-8}$. At the end of the program, three files "pout.npy", "xout.npy", and "y.npy"  
    including the posterior distributions, the estimated values and the experimental results will be 
    generated. The package contains two mothods for updating the tunable parameters. The first one is 
    updating the tunable parameters with a fix optimal point (`mtheod="FOP"`), which is the default 
    method in QuanEstimation. The other is `method="MI"` which means updating the tunable parameters 
    by maximizing the mutual information which is defined as
    
    \begin{equation}
    I(\textbf{u})=\int\mathrm{p}(\textbf{x}) \sum_{y}\mathrm{p}(y|\textbf{x},\textbf{u})\mathrm{log}_2 
    \left[\frac{\mathrm{p}(y|\textbf{x},\textbf{u})}{\int\mathrm{p}(\textbf{x})\mathrm{p}(y|\textbf{x},\textbf{u})\mathrm{d}\textbf{x}}\right]\mathrm{d}\textbf{x}.
    \end{equation}

    If `savefile=True`, these files will be generated during the 
    training and "pout.npy" will save all the posterior distributions, otherwise, the posterior 
    distribution in the final iteration will be saved. 
=== "Julia"
    ``` jl
    Adapt(x, p, rho0, tspan, H, dH; dyn_method=:Expm, method="FOP", 
          savefile=false, max_episode=1000, eps=1e-8, Hc=missing, 
          ctrl=missing, decay=missing, M=missing, W=missing)
    ```
    where `x` is a list of arrays representing the regime of the parameters for the integral, 
    `p` is an array representing the prior distribution, it is multidimensional for multiparameter
    estimation.`rho0` is the density matrix of the probe state. The number of iterations can be 
    set via `max_episode` with the default value 1000. `eps` represents the machine epsilon which 
    defaults to $10^{-8}$. At the end of the program, three files "pout.csv", "xout.csv", and "y.csv"  
    including the posterior distributions, the estimated values and the experimental results will be 
    generated. The package contains two mothods for updating the tunable parameters. The first one is 
    updating the tunable parameters with a fix optimal point (`mtheod="FOP"`), which is the default 
    method in QuanEstimation. The other is `method="MI"` which means updating the tunable parameters 
    by maximizing the mutual information which is defined as
    
    \begin{equation}
    I(\textbf{u})=\int\mathrm{p}(\textbf{x}) \sum_{y}\mathrm{p}(y|\textbf{x},\textbf{u})\mathrm{log}_2 
    \left[\frac{\mathrm{p}(y|\textbf{x},\textbf{u})}{\int\mathrm{p}(\textbf{x})\mathrm{p}(y|\textbf{x},\textbf{u})\mathrm{d}\textbf{x}}\right]\mathrm{d}\textbf{x}.
    \end{equation}
    
    If `savefile=true`, these files will be generated during the training and "pout.csv" 
    will save all the posterior distributions, otherwise, the posterior distribution in the final 
    iteration will be saved. 
If the dynamics of the system can be described by the master equation, then the dynamics data 
`tspan`, `H`, and `dH` shoule be input. `tspan` is the time length for the evolution, `H` and 
`dH` are multidimensional lists representing the Hamiltonian and its derivatives with respect to
the unknown parameters to be estimated, they can be generated via
=== "Python"
    ``` py
    H, dH = BayesInput(x, func, dfunc, channel="dynamics")
    ```
=== "Julia"
    ``` jl
    H, dH = BayesInput(x, func, dfunc; channel="dynamics")
    ```
Here `func` and `dfunc` are the functions defined by the users which return `H` and `dH`, 
respectively. Futhermore, for the systems with noise and controls, the variables `decay`, 
`Hc` and `ctrl` should be input. Here `Hc` and `ctrl` are two lists representing the control 
Hamiltonians and the corresponding control coefficients. `decay` contains decay operators 
$(\Gamma_1, \Gamma_2, \cdots)$ and the corresponding decay rates $(\gamma_1, \gamma_2, \cdots)$
with the input rule decay=[[$\Gamma_1$, $\gamma_1$], [$\Gamma_2$, $\gamma_2$],...].  

The objective function for adaptive measurement are CFI and $\mathrm{Tr}(W\mathcal{I}^
{-1})$ with $\mathcal{I}$ the CFIM. `W` is the weight matrix which defaults to the identity matrix.

If the parameterization is implemented with the Kraus operators, the codes become
=== "Python"
    ``` py
    apt = Adapt(x, p, rho0, method="FOP", savefile=False,  
                max_episode=1000, eps=1e-8)
    apt.Kraus(K, dK)               
    apt.CFIM(M=[], W=[]) 
    ```
=== "Julia"
    ``` jl
    Adapt(x, p, rho0, K, dK; method="FOP", savefile=false, 
          max_episode=1000, eps=1e-8, Hc=missing, ctrl=missing, 
          decay=missing, M=missing, W=missing)
    ```
and 
=== "Python"
    ``` py
    K, dK = BayesInput(x, func, dfunc, channel="Kraus")
    ```
=== "Julia"
    ``` jl
    K, dK = BayesInput(x, func, dfunc; channel="Kraus")
    ```
where `K` and `dK` are the Kraus operators and its derivatives with respect to the unknown parameters.

**Example 9.1**  
The Hamiltonian of a qubit system is
\begin{align}
H=\frac{B\omega_0}{2}(\sigma_1\cos{x}+\sigma_3\sin{x}),
\end{align}

where $B$ is the magnetic field in the XZ plane, $x$ is the unknown parameter and $\sigma_{1}$, $\sigma_{3}$ are the Pauli matrices.

The probe state is taken as $|\pm\rangle$. The measurement is 
$\{|\!+\rangle\langle+\!|,|\!-\rangle\langle-\!|\}$. Here $|\pm\rangle:=\frac{1}{\sqrt{2}}(|0\rangle\pm|1\rangle)$ with $|0\rangle$ $(|1\rangle)$ the eigenstate of $\sigma_3$ with respect to the eigenvalue $1$ $(-1)$. In this example, the prior distribution $p(x)$ is uniform.
=== "Python"
    ``` py
    from quanestimation import *
    import numpy as np
    import random

    # initial state
    rho0 = 0.5 * np.array([[1., 1.], [1., 1.]])
    # free Hamiltonian
    B, omega0 = 0.5 * np.pi, 1.0
    sx = np.array([[0., 1.], [1., 0.]])
	sy = np.array([[0., -1.j], [1.j, 0.]]) 
	sz = np.array([[1., 0.], [0., -1.]])
    H0_func = lambda x: 0.5*B*omega0*(sx*np.cos(x[0])+sz*np.sin(x[0]))
    # derivative of free Hamiltonian in x
    dH_func = lambda x: [0.5*B*omega0*(-sx*np.sin(x[0])+sz*np.cos(x[0]))]
    # measurement
    M1 = 0.5*np.array([[1., 1.], [1., 1.]])
	M2 = 0.5*np.array([[1., -1.], [-1., 1.]])
    M = [M1, M2]
    # time length for the evolution
    tspan = np.linspace(0., 1., 1000)
    # prior distribution
    x = np.linspace(-0.25*np.pi+0.1, 3.0*np.pi/4.0-0.1, 1000)
    p = (1.0/(x[-1]-x[0]))*np.ones(len(x))
    # dynamics
    rho = [np.zeros((len(rho0), len(rho0)), dtype=np.complex128) for \
           i in range(len(x))]
    for xi in range(len(x)):
        H_tp = H0_func([x[xi]])
        dH_tp = dH_func([x[xi]])
        dynamics = Lindblad(tspan, rho0, H_tp, dH_tp)
        rho_tp, drho_tp = dynamics.expm()
        rho[xi] = rho_tp[-1]
    # Bayesian estimation
    np.random.seed(1234)
    y = [0 for i in range(500)]
    res_rand = random.sample(range(0, len(y)), 125)
    for i in range(len(res_rand)):
        y[res_rand[i]] = 1
    pout, xout = Bayes([x], p, rho, y, M=M, estimator="MAP", savefile=False)
    # generation of H and dH
    H, dH = BayesInput([x], H0_func, dH_func, channel="dynamics")
    # adaptive measurement
    apt = Adapt([x], pout, rho0, method="FOP", savefile=False, 
                max_episode=100, eps=1e-8)
    apt.dynamics(tspan, H, dH, dyn_method="expm")
    apt.CFIM(M=M, W=[])
    ```
=== "Julia"
    ``` jl
    using QuanEstimation
    using Random
    using StatsBase

    # free Hamiltonian
    function H0_func(x)
        return 0.5*B*omega0*(sx*cos(x[1])+sz*sin(x[1]))
    end
    # derivative of free Hamiltonian in x
    function dH_func(x)
        return [0.5*B*omega0*(-sx*sin(x[1])+sz*cos(x[1]))]
    end

    B, omega0 = pi/2.0, 1.0
    sx = [0. 1.; 1. 0.0im]
	sy = [0. -im; im 0.]
	sz = [1. 0.0im; 0. -1.]
    # initial state
    rho0 = 0.5*ones(2, 2)
    # measurement 
    M1 = 0.5*[1.0+0.0im  1.; 1.  1.]
	M2 = 0.5*[1.0+0.0im -1.; -1.  1.]
    M = [M1, M2]
    # time length for the evolution
    tspan = range(0., stop=1., length=1000) |>Vector
    # prior distribution
    x = range(-0.25*pi+0.1, stop=3.0*pi/4.0-0.1, length=1000) |>Vector
    p = (1.0/(x[end]-x[1]))*ones(length(x))
    # dynamics
    rho = Vector{Matrix{ComplexF64}}(undef, length(x))
    for i = 1:length(x) 
        H0_tp = H0_func(x[i])
        dH_tp = dH_func(x[i])
        rho_tp, drho_tp = QuanEstimation.expm(tspan, rho0, H0_tp, dH_tp)
        rho[i] = rho_tp[end]
    end
    # Bayesian estimation
    Random.seed!(1234)
    y = [0 for i in 1:500]
    res_rand = sample(1:length(y), 125, replace=false)
    for i in 1:length(res_rand)
        y[res_rand[i]] = 1
    end
    pout, xout = QuanEstimation.Bayes([x], p, rho, y, M=M, estimator="MAP", savefile=false)
    # generation of H and dH
    H, dH = QuanEstimation.BayesInput([x], H0_func, dH_func; 
                                      channel="dynamics")
    # adaptive measurement
    QuanEstimation.Adapt([x], pout, rho0, tspan, H, dH; M=M, dyn_method=:Expm, 
                         method="FOP", max_episode=100)
    ```
---
Berry et al. [[1,2]](#Berry2000) introduced a famous adaptive scheme in phase estimation. The 
phase for the $(n+1)$th round is updated via $\Phi_{n+1}=\Phi_{n}-(-1)^{y^{(n)}}\Delta
\Phi_{n+1}$ with $y^{(n)}$ the experimental result in the $n$th round and $\Delta\Phi_{n+1}$ 
the phase difference generated by the proper algorithms. This adaptive scheme can be performed
in QuanEstimation via
=== "Python"
    ``` py
    apt = Adapt_MZI(x, p, rho0)
    apt.general()
    apt.online(target="sharpness", output="phi")
    ```
    Here `x`, `p`, and `rho0` are the same with `Adapt`. `target="sharpness"` represents the
    target function for calculating the tunable phase is sharpness, and it can also be set as 
    `target="MI"` which means the target function is mutual information. The output can be set 
    through `output="phi"` (default) and `output="dphi"` representing the phase and phase 
    difference, respectively. Online and offline strategies are both available in the package 
    and the code for calling offline stratege becomes `apt.offline(method="DE", **kwargs)` or 
    `apt.offline(method="PSO", **kwargs)`. 
=== "Julia"
    ``` jl
    apt = Adapt_MZI(x, p, rho0)
    online(apt, target=:sharpness, output="phi")
    ```
    Here `x`, `p`, and `rho0` are the same with `Adapt`. `target=:sharpness` represents the
    target function for calculating the tunable phase is sharpness, and it can also be set as 
    `target=:MI` which means the target function is mutual information. The output can be set 
    through `output="phi"` (default) and `output="dphi"` representing the phase and phase 
    difference, respectively. Online and offline strategies are both available in the package 
    and the code for calling offline stratege becomes `alg = QuanEstimation.DE(kwargs...)` 
    (`alg = QuanEstimation.PSO(kwargs...)`) and `offline(apt, alg, seed=seed)`. 
    `seed` is the random seed which can ensure the reproducibility of results.

If the optimization algorithm is PSO, the keywords and the default values are
=== "Python"
    ``` py
    kwargs = {"p_num":10, "deltaphi0":[], "max_episode":[1000,100], 
              "c0":1.0, "c1":2.0, "c2":2.0, "seed":1234}
    ```
    The keywords and the default values of PSO can be seen in the following table

    | $~~~~~~~~~~$**kwargs$~~~~~~~~~~$ | $~~~~$default values$~~~~$ |
    | :----------:                     | :----------:               |
    | "p_num"                   | 10                         |
    | "deltaphi0"                      | [ ]                        |
    | "max_episode"                    | [1000,100]                 |
    | "c0"                             | 1.0                        |
    | "c1"                             | 2.0                        |
    | "c2"                             | 2.0                        |
    | "seed"                           | 1234                       |

    Here `p_num` is the number of particles, `deltaphi0` represents the initial 
    guesses of phase difference. `max_episode` accepts both integer and array with two 
    elements. If it is an integer, for example `max_episode=1000`, it means the 
    program will continuously run 1000 episodes. However, if it is an array, for example 
    `max_episode=[1000,100]`, the program will run 1000 episodes in total but replace the data 
    of all the particles with global best every 100 episodes. `c0`, `c1` and `c2` are the PSO 
    parameters representing the inertia weight, cognitive learning factor and social 
    learning factor, respectively. 
=== "Julia"
    ``` jl
    alg = PSO(p_num=10, ini_particle=missing, max_episode=[1000,100], 
              c0=1.0, c1=2.0, c2=2.0)
    ```
    The keywords and the default values of PSO can be seen in the following table

    | $~~~~~~~~~~$keywords$~~~~~~~~~~$ | $~~~~$default values$~~~~$ |
    | :----------:                     | :----------:               |
    | "p_num"                          | 10                         |
    | "ini_particle"                   | missing                    |
    | "max_episode"                    | [1000,100]                 |
    | "c0"                             | 1.0                        |
    | "c1"                             | 2.0                        |
    | "c2"                             | 2.0                        |

    Here `p_num` is the number of particles, `ini_particle` represents the initial guesses 
    of phase difference. `max_episode` accepts both integer and array with two elements. 
    If it is an integer, for example `max_episode=1000`, it means the program will 
    continuously run 1000 episodes. However, if it is an array, for example 
    `max_episode=[1000,100]`, the program will run 1000 episodes in total but replace the 
    data of all the particles with global best every 100 episodes. `c0`, `c1` and `c2` are 
    the PSO parameters representing the inertia weight, cognitive learning factor and 
    social learning factor, respectively. 

If the optimization algorithm is DE, the keywords and the default values are
=== "Python"
    ``` py
    kwargs = {"p_num":10, "deltaphi0":[], "max_episode":1000, "c":1.0, 
              "cr":0.5, "seed":1234}
    ```
    The keywords and the default values of DE can be seen in the following table

    | $~~~~~~~~~~$**kwargs$~~~~~~~~~~$ | $~~~~$default values$~~~~$ |
    | :----------:                     | :----------:               |
    | "p_num"                        | 10                         |
    | "deltaphi0"                      | [ ]                        |
    | "max_episode"                    | 1000                       |
    | "c"                              | 1.0                        |
    | "cr"                             | 0.5                        |
    | "seed"                           | 1234                       |

    `p_num` and `max_episode` are the number of populations and training episodes. 
    `c` and `cr` are DE parameters representing the mutation and crossover constants, 
    `seed` is the random seed which can ensure the reproducibility of results.
=== "Julia"
    ```jl
    alg = DE(p_num=10, ini_population=missing, max_episode=1000, 
             c=1.0, cr=0.5)
    ``` 
    The keywords and the default values of DE can be seen in the following table

    | $~~~~~~~~~~$keywords$~~~~~~~~~~$ | $~~~~$default values$~~~~$ |
    | :----------:                     | :----------:               |
    | "p_num"                          | 10                         |
    | "ini_population"                 | missing                    |
    | "max_episode"                    | 1000                       |
    | "c"                              | 1.0                        |
    | "cr"                             | 0.5                        |

    `ini_population` represents the initial guesses of phase difference. `p_num` and 
    `max_episode` are the number of populations and training episodes. `c` and `cr` are 
    DE parameters representing the mutation and crossover constants.

**Example 9.2**  
In this example, the adaptive measurement shceme is design for the MZI [[3,4]](#Hentschel2010). 
The input state is 
\begin{align}
\sqrt{\frac{2}{N+2}}\sum^{N/2}_{m=-N/2}\sin\left(\frac{(2m+N+2)\pi}{2(N+2)}\right)|m\rangle,
\end{align}

where $N$ is the number of photon, $|m\rangle$ is the eigenstate of $J_y$ with the eigenvalue 
$m$.
=== "Python"
    ``` py
    from quanestimation import *
    import numpy as np

    # the number of photons
    N = 8
    # probe state
    psi = np.zeros((N+1)**2).reshape(-1, 1)
    for k in range(N+1):
        psi += np.sin((k+1)*np.pi/(N+2))* \
               np.kron(basis(N+1, k), basis(N+1, N-k))
    psi = np.sqrt(2/(2+N))*psi
    rho0 = np.dot(psi, psi.conj().T)
    # prior distribution
    x = np.linspace(-np.pi, np.pi, 100)
    p = (1.0/(x[-1]-x[0]))*np.ones(len(x))
    apt = Adapt_MZI(x, p, rho0)
    apt.general()
    ```
    === "online"
        ``` py
        apt.online(target="sharpness", output="phi")
        ```
    === "offline"
        === "DE"
            ``` py
            DE_para = {"p_num":10, "deltaphi0":[], "max_episode":1000, "c":1.0, 
                       "cr":0.5, "seed":1234}
            apt.offline(target="sharpness", method="DE", **DE_para)
            ```
        === "PSO"
            ``` py
            PSO_para = {"p_num":10, "deltaphi0":[], "max_episode":[1000,100], 
                        "c0":1.0, "c1":2.0, "c2":2.0, "seed":1234}
            apt.offline(target="sharpness", method="PSO", **PSO_para)
            ```
=== "Julia"
    ``` jl
    using QuanEstimation
    using SparseArrays

    # the number of photons
    N = 8
    # probe state
    psi = sum([sin(k*pi/(N+2))*kron(QuanEstimation.basis(N+1,k), 
          QuanEstimation.basis(N+1, N-k+2)) for k in 1:(N+1)]) |> sparse
    psi = psi*sqrt(2/(2+N))
    rho0 = psi*psi'
    # prior distribution
    x = range(-pi, pi, length=100)
    p = (1.0/(x[end]-x[1]))*ones(length(x))
    apt = QuanEstimation.Adapt_MZI(x, p, rho0)
    ```
    === "online"
        ``` py
        QuanEstimation.online(apt, target=:sharpness, output="phi")
        ```
    === "offline"
        === "DE"
            ``` jl
            alg = QuanEstimation.DE(p_num=10, ini_population=missing, 
                                    max_episode=1000, c=1.0, cr=0.5)
            QuanEstimation.offline(apt, alg, target=:sharpness, seed=1234)
            ```
        === "PSO"
            ``` jl
            alg = QuanEstimation.PSO(p_num=10, ini_particle=missing,  
                                     max_episode=[1000,100], c0=1.0, 
                                     c1=2.0, c2=2.0)
            QuanEstimation.offline(apt, alg, target=:sharpness, seed=1234)
            ```
---

## **Bibliography**
<a id="Berry2000">[1]</a>
D. W. Berry and H. M. Wiseman, 
Optimal States and Almost Optimal Adaptive Measurements for Quantum Interferometry, 
[Phys. Rev. Lett. **85**, 5098 (2000).](https://doi.org/10.1103/PhysRevLett.85.5098)

<a id="Berry2001">[2]</a>
D. W. Berry, H. M. Wiseman, and J. K. Breslin, 
Optimal input states and feedback for interferometric phase estimation, 
[Phys. Rev. A **63**, 053804 (2001).](https://doi.org/10.1103/PhysRevA.63.053804)

<a id="Hentschel2010">[3]</a>
A. Hentschel and B. C. Sanders,
Machine Learning for Precise Quantum Measurement,
[Phys. Rev. Lett. **104**, 063603 (2010).](https://doi.org/10.1103/PhysRevLett.104.063603)

<a id="Hentschel2011">[4]</a>
A. Hentschel and B. C. Sanders,
Efficient Algorithm for Optimizing Adaptive Quantum Metrology Processes,
[Phys. Rev. Lett. **104**, 063603 (2011).](https://doi.org/10.1103/PhysRevLett.107.233601)

This part is the classes of the Python-Julia package which written in Python.

## **Dynamics**
::: quanestimation.Lindblad

## **Control Optimization**
The Hamiltonian of a controlled system can be written as
\begin{align}
H = H_0(\textbf{x})+\sum_{k=1}^K u_k(t) H_k,
\end{align}

where $H_0(\textbf{x})$ is the free evolution Hamiltonian with unknown parameters 
$\textbf{x}$ and $H_k$ represents the $k$th control Hamiltonian with $u_k$ the 
corresponding control coefficient. In QuanEstimation, different algorithms are invoked to 
update the optimal control coefficients. The control optimization algorithms are  
gradient ascent pulse engineering (GRAPE), GRAPE algorithm based on the automatic 
differentiation (auto-GRAPE), particle swarm optimization (PSO), 
differential evolution (DE) and deep deterministic policy gradients (DDPG).

### **Base**
::: quanestimation.ControlSystem

### **Control optimization with GRAPE and auto-GRAPE**
::: quanestimation.GRAPE_Copt

### **Control Optimization with PSO**
::: quanestimation.PSO_Copt

### **Control Optimization DE**
::: quanestimation.DE_Copt

---

## **State Optimization**
The probe state is expanded as $|\psi\rangle=\sum_i c_i|i\rangle$ in a specific
basis, i.e., $\{|i\rangle\}$. In state optimization, the search of the
optimal probe states is equal to search of the normalized complex coefficients
$\{c_i\}$. In QuanEstimation, the state optimization algorithms are 
automatic differentiation (AD), reverse iterative (RI) algorithm, particle swarm 
optimization (PSO), differential evolution (DE), deep deterministic policy gradients 
(DDPG) and Nelder-Mead (NM).

### **Base**
::: quanestimation.StateSystem

### **State optimization with AD**
::: quanestimation.AD_Sopt

### **State optimization with RI**
::: quanestimation.RI_Sopt

### **State Optimization with PSO**
::: quanestimation.PSO_Sopt

### **State Optimization DE**
::: quanestimation.DE_Sopt
<!-- 
### **State Optimization with DDPG**
::: quanestimation.DDPG_Sopt -->

---

## **Measurement Optimization**
In QuanEstimation, three measurement optimization scenarios are considered. The first one
is to optimize a set of rank-one projective measurement, it can be written in a specific
basis $\{|\phi_i\rangle\}$ with $|\phi_i\rangle=\sum_j C_{ij}|j\rangle$ in the Hilbert space 
as $\{|\phi_i\rangle\langle\phi_i|\}$. In this case, the goal is to search a set of optimal 
coefficients $C_{ij}$. The second scenario is to find the optimal linear combination of 
an input measurement $\{\Pi_j\}$. The third scenario is to find the optimal rotated 
measurement of an input measurement. After rotation, the new measurement is
$\{U\Pi_i U^{\dagger}\}$, where $U=\prod_k \exp(i s_k\lambda_k)$ with $\lambda_k$ a SU($N$) 
generator and $s_k$ a real number in the regime $[0,2\pi]$. In this scenario, the goal is 
to search a set of optimal coefficients $s_k$. Here different algorithms are invoked to 
search the optimal measurement include particle swarm optimization (PSO) [[1]](#Kennedy1995), 
differential evolution (DE) [[2]](#Storn1997), and automatic differentiation (AD) [[3]]
(#Baydin2018).

### **Base**
::: quanestimation.MeasurementSystem

### **Measurement optimization with AD**
::: quanestimation.AD_Mopt

## **Measurement Optimization with PSO**
::: quanestimation.PSO_Mopt

### **Measurement Optimization with DE**
::: quanestimation.DE_Mopt

---

## **Comprehensive Optimization**
In order to obtain the optimal parameter estimation schemes, it is necessary to
simultaneously optimize the probe state, control and measurement. The
comprehensive optimization for the probe state and measurement (SM), the probe
state and control (SC), the control and measurement (CM) and the probe state, 
control and measurement (SCM) are proposed for this. In QuanEstimation, the 
comprehensive optimization algorithms are particle swarm optimization (PSO), 
differential evolution (DE), and automatic differentiation (AD).

### **Base**
::: quanestimation.ComprehensiveSystem

### **Comprehensive optimization with AD**
::: quanestimation.AD_Compopt

### **Comprehensive Optimization with PSO**
::: quanestimation.PSO_Compopt

### **Comprehensive Optimization with DE**
::: quanestimation.DE_Compopt

---

## **Adaptive measurement schemes**
In QuanEstimation, the Hamiltonian of the adaptive system should be written as
$H(\textbf{x}+\textbf{u})$ with $\textbf{x}$ the unknown parameters and $\textbf{u}$ 
the tunable parameters. The tunable parameters $\textbf{u}$ are used to let the 
Hamiltonian work at the optimal point $\textbf{x}_{\mathrm{opt}}$. 
### **Adaptive measurement**
::: quanestimation.Adapt
::: quanestimation.Adapt_MZI
